/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 32 "parser.y"

/** @endcond */

// local
#include "pjl_config.h"                 /* must go first */
#include "c_ast.h"
#include "c_ast_check.h"
#include "c_ast_util.h"
#include "c_keyword.h"
#include "c_lang.h"
#include "c_operator.h"
#include "c_sglob.h"
#include "c_sname.h"
#include "c_type.h"
#include "c_typedef.h"
#include "cdecl.h"
#include "cdecl_keyword.h"
#include "color.h"
#include "dump.h"
#include "did_you_mean.h"
#include "english.h"
#include "gibberish.h"
#include "help.h"
#include "lexer.h"
#include "literals.h"
#include "options.h"
#include "p_macro.h"
#include "p_token.h"
#include "print.h"
#include "set_options.h"
#include "show.h"
#include "slist.h"
#include "types.h"
#include "util.h"

/// @cond DOXYGEN_IGNORE

// standard
#include <assert.h>
#include <ctype.h>
#include <stdarg.h>
#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>

// Silence these warnings for Bison-generated code.
#ifdef __GNUC__
# pragma GCC diagnostic push
# pragma GCC diagnostic ignored "-Wconversion"
# pragma GCC diagnostic ignored "-Wredundant-decls"
# pragma GCC diagnostic ignored "-Wunreachable-code"
#endif /* __GNUC__ */

// Developer aid for tracing when Bison %destructors are called.
#if 0
#define DTRACE                    EPRINTF( "%d: destructor\n", __LINE__ )
#else
#define DTRACE                    NO_OP
#endif

/// @endcond

///////////////////////////////////////////////////////////////////////////////

/**
 * Checks whether \a AST is a #K_NAME and therefore an error (if \ref
 * opt_permissive_types is `false`) or merely a warning (if \ref
 * opt_permissive_types is `true`).
 *
 * @param AST The AST to check.
 * @return Returns `true` only if \a ast is a #K_NAME and therefore an error.
 */
#define c_ast_is_name_error(AST)  l_c_ast_is_name_error( __LINE__, (AST) )

/**
 * Checks whether \a SNAME is a type.
 *
 * @param SNAME The scoped name to check.
 * @param LOC The location of \a SNAME.
 * @return Returns `true` only if \a SNAME is a type (and prints an error
 * message); otherwise `false` (and does nothing).
 */
#define c_sname_is_type(SNAME,LOC) \
  fl_c_sname_is_type( __FILE__, __LINE__, (SNAME), (LOC) )

/**
 * @defgroup parser-group Parser
 * Helper macros, data structures, variables, functions, and the grammar for
 * C/C++ declarations.
 * @{
 */

/**
 * Calls #elaborate_error_dym() with #DYM_NONE.
 *
 * @param ... Arguments passed to l_elaborate_error().
 *
 * @note This must be used _only_ after an `error` token, e.g.:
 * ```
 *  | Y_define error
 *    {
 *      elaborate_error( "name expected" );
 *    }
 * ```
 * @note A newline _is_ printed.
 *
 * @sa elaborate_error_dym()
 * @sa keyword_expected()
 * @sa punct_expected()
 */
#define elaborate_error(...) \
  elaborate_error_dym( DYM_NONE, __VA_ARGS__ )

/**
 * Calls l_elaborate_error() followed by #PARSE_ABORT().
 *
 * @param DYM_KINDS The bitwise-or of \ref dym_kind_t things possibly meant.
 * @param ... Arguments passed to l_elaborate_error().
 *
 * @note This must be used _only_ after an `error` token, e.g.:
 * ```
 *  | error
 *    {
 *      elaborate_error_dym( DYM_COMMANDS, "unexpected token" );
 *    }
 * ```
 * @note A newline _is_ printed.
 *
 * @sa elaborate_error()
 * @sa keyword_expected()
 * @sa punct_expected()
 */
#define elaborate_error_dym(DYM_KINDS,...) BLOCK( \
  l_elaborate_error( __LINE__, (DYM_KINDS), __VA_ARGS__ ); PARSE_ABORT(); )

/**
 * Executes the given statements only if \ref opt_cdecl_debug `!=`
 * #CDECL_DEBUG_NO.
 *
 * @param ... The statement(s) to execute.
 */
#define IF_CDECL_DEBUG(...) \
  BLOCK( if ( opt_cdecl_debug != CDECL_DEBUG_NO ) { __VA_ARGS__ } )

/**
 * Prints that a particular language feature is not supported by **cdecl** and
 * will be ignored.
 *
 * @param LOC The location of what's being ignored.
 * @param WHAT The string literal of what is being ignored.  It may contain a
 * `printf()` format string.
 * @param ... The `printf()` arguments, if any.
 *
 * @sa #UNSUPPORTED()
 */
#define IGNORING(LOC,WHAT,...)                      \
  print_warning( (LOC),                             \
    WHAT " not supported by " CDECL " (ignoring)\n" \
    VA_OPT( (,), __VA_ARGS__ )                      \
  )

/**
 * Checks whether the type currently being declared (`enum`, `struct`,
 * `typedef`, or `union`) is nested within some other type (`struct` or
 * `union`) and whether the current language is C: if not, prints an error
 * message.
 *
 * @remarks In debug mode, also includes the file & line where the function was
 * called from in the error message.
 *
 * @param TYPE_LOC The location of the type declaration.
 * @return Returns `true` only if the type currently being declared is either
 * not nested or the current language is C++.
 *
 * @sa l_is_nested_type_ok()
 */
#define is_nested_type_ok(TYPE_LOC) \
  l_is_nested_type_ok( __LINE__, (TYPE_LOC) )

/**
 * Checks whether \ref opt_lang_id is among the bitwise-or of languages
 * specified by \a LANG_MACRO, i.e., \a LANG_MACRO is supported by \ref
 * opt_lang_id.
 *
 * @param LANG_MACRO A `LANG_*` macro without the `LANG_` prefix.
 * @return Returns `true` only if either **cdecl** is \ref cdecl_is_initialized
 * is `false` or \ref opt_lang_id is among the bitwise-or of languages
 * specified by \a LANG_MACRO.
 *
 * @sa #OPT_LANG_IS()
 */
#define IS_SUPPORTED(LANG_MACRO) \
  ( !cdecl_is_initialized || OPT_LANG_IS( LANG_MACRO ) )

/**
 * Calls l_keyword_expected() followed by #PARSE_ABORT().
 *
 * @param KEYWORD A keyword literal.
 *
 * @note This must be used _only_ after an `error` token, e.g.:
 * ```
 *  : Y_virtual
 *  | error
 *    {
 *      keyword_expected( L_virtual );
 *    }
 * ```
 *
 * @sa elaborate_error()
 * @sa elaborate_error_dym()
 * @sa punct_expected()
 */
#define keyword_expected(KEYWORD) BLOCK ( \
  l_keyword_expected( __LINE__, (KEYWORD) ); PARSE_ABORT(); )

/**
 * Aborts the current parse after an error message has been printed.
 *
 * @sa #PARSE_ASSERT()
 */
#define PARSE_ABORT() \
  BLOCK( parse_cleanup( /*fatal_error=*/true ); YYABORT; )

/**
 * Evaluates \a EXPR: if `false`, calls #PARSE_ABORT().
 *
 * @param EXPR The expression to evalulate.
 */
#define PARSE_ASSERT(EXPR)        BLOCK( if ( !(EXPR) ) PARSE_ABORT(); )

/**
 * Calls l_punct_expected() followed by #PARSE_ABORT().
 *
 * @param PUNCT The punctuation character that was expected.
 *
 * @note This must be used _only_ after an `error` token, e.g.:
 * ```
 *  : ','
 *  | error
 *    {
 *      punct_expected( ',' );
 *    }
 * ```
 *
 * @sa elaborate_error()
 * @sa elaborate_error_dym()
 * @sa keyword_expected()
 */
#define punct_expected(PUNCT) BLOCK( \
  l_punct_expected( __LINE__, (PUNCT) ); PARSE_ABORT(); )

/**
 * Prints that a particular language feature is not supported by **cdecl** and
 * therefore an error followed by #PARSE_ABORT().
 *
 * @param LOC The location of what's not supported.
 * @param WHAT The string literal of what is being ignored.  It may contain a
 * `printf()` format string.
 * @param ... The `printf()` arguments, if any.
 *
 * @sa #IGNORING()
 */
#define UNSUPPORTED(LOC,WHAT,...) BLOCK(  \
  print_error( (LOC),                     \
    WHAT " not supported by " CDECL "\n"  \
    VA_OPT( (,), __VA_ARGS__ )            \
  );                                      \
  PARSE_ABORT(); )

/** @} */

///////////////////////////////////////////////////////////////////////////////

/**
 * @defgroup parser-dump-group Debugging Macros
 * Macros that are used to dump a trace during parsing when \ref
 * opt_cdecl_debug is set.
 * @ingroup parser-group
 * @{
 */

/**
 * Dumps \a ALIGN.
 *
 * @param KEY The key name to print.
 * @param ALIGN The \ref c_alignas to dump.
 */
#define DUMP_ALIGN(KEY,ALIGN) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_alignas_dump( &(ALIGN), stdout ); )

/**
 * Dumps an AST.
 *
 * @param KEY The key name to print.
 * @param AST The AST to dump.
 *
 * @sa #DUMP_AST_LIST()
 * @sa #DUMP_AST_PAIR()
 */
#define DUMP_AST(KEY,AST) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_ast_dump( (AST), stdout ); )

/**
 * Dumps an s_list of AST.
 *
 * @param KEY The key name to print.
 * @param AST_LIST The \ref slist of AST to dump.
 *
 * @sa #DUMP_AST()
 * @sa #DUMP_AST_PAIR()
 */
#define DUMP_AST_LIST(KEY,AST_LIST) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_ast_list_dump( &(AST_LIST), stdout ); )

/**
 * Dump a \ref c_ast_pair.
 *
 * @param KEY The key name to print.
 * @param ASTP The \ref c_ast_pair to dump.
 *
 * @sa #DUMP_AST()
 */
#define DUMP_AST_PAIR(KEY,ASTP) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_ast_pair_dump( &(ASTP), stdout ); )

/**
 * Dumps a `bool`.
 *
 * @param KEY The key name to print.
 * @param BOOL The `bool` to dump.
 */
#define DUMP_BOOL(KEY,BOOL)  IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); bool_dump( (BOOL), stdout ); )

/**
 * Ends a dump block.
 *
 * @sa #DUMP_START()
 */
#define DUMP_END()                IF_CDECL_DEBUG( PUTS( "\n}\n\n" ); )

/**
 * Possibly dumps a comma and a newline followed by the `printf()` arguments
 * --- used for printing a key followed by a value.
 *
 * @param ... The `printf()` arguments.
 *
 * @warning This _must_ only be called inside #IF_CDECL_DEBUG().
 */
#define DUMP_KEY_IMPL(...) BLOCK(         \
  fput_sep( ",\n", &dump_comma, stdout ); \
  PRINTF( "  " __VA_ARGS__ ); )

/**
 * Dumps an integer.
 *
 * @param KEY The key name to print.
 * @param NUM The integer to dump.
 *
 * @sa #DUMP_STR()
 */
#define DUMP_INT(KEY,NUM) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": %d", STATIC_CAST( int, (NUM) ) ); )

/**
 * Dumps a \ref p_macro.
 *
 * @param KEY The key name to print.
 * @param MACRO The \ref p_macro to dump.
 */
#define DUMP_MACRO(KEY,MACRO) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); p_macro_dump( (MACRO), stdout ); )

/**
 * Dumps a list of macro arguments.
 *
 * @param KEY The key name to print.
 * @param ARG_LIST The list of arguments to dump.
 */
#define DUMP_MACRO_ARG_LIST(KEY,ARG_LIST) IF_CDECL_DEBUG( \
  if ( (ARG_LIST) != NULL ) {                             \
    DUMP_KEY_IMPL( KEY ": " );                            \
    p_arg_list_dump( (ARG_LIST), /*indent=*/1, stdout );  \
  } )

/**
 * Dumps a list of \ref p_param.
 *
 * @param KEY The key name to print.
 * @param PARAM_LIST The list of \ref p_param to dump.
 */
#define DUMP_MACRO_PARAM_LIST(KEY,PARAM_LIST) IF_CDECL_DEBUG( \
  if ( (PARAM_LIST) != NULL ) {                               \
    DUMP_KEY_IMPL( KEY ": " );                                \
    p_param_list_dump( (PARAM_LIST), /*indent=*/1, stdout );  \
  } )

/**
 * Dumps a list of \ref p_token.
 *
 * @param KEY The key name to print.
 * @param TOKEN_LIST The list of \ref p_token to dump.
 */
#define DUMP_MACRO_TOKEN_LIST(KEY,TOKEN_LIST) IF_CDECL_DEBUG( \
  if ( (TOKEN_LIST) != NULL ) {                               \
    DUMP_KEY_IMPL( KEY ": " );                                \
    p_token_list_dump( (TOKEN_LIST), /*indent=*/1, stdout );  \
  } )

/**
 * Starts a dump block.
 *
 * @remarks If a production has a result, it should be dumped as the final
 * thing before the #DUMP_END() with the KEY of `$$_` followed by a suffix
 * denoting the type, e.g., `ast`.  For example:
 * ```
 *  DUMP_START( "rule",
 *              "subrule_1 subrule_2 ..." );
 *  DUMP_AST( "subrule_1", $1 );
 *  DUMP_STR( "name", $2 );
 *  DUMP_AST( "subrule_2", $3 );
 *  // ...
 *  DUMP_AST( "$$_ast", $$ );
 *  DUMP_END();
 * ```
 *
 * @param NAME The grammar production name.
 * @param RULE The grammar production rule.
 *
 * @note The dump block _must_ end with #DUMP_END().
 *
 * @sa #DUMP_END()
 */
#define DUMP_START(NAME,RULE) \
  bool dump_comma = false;    \
  IF_CDECL_DEBUG( PUTS( "{\n  rule: {\n    lhs: \"" NAME "\",\n    rhs: \"" RULE "\"\n  },\n" ); )

/**
 * Dumps a scoped name.
 *
 * @param KEY The key name to print.
 * @param SNAME The scoped name to dump.
 *
 * @sa #DUMP_SNAME_LIST()
 * @sa #DUMP_STR()
 */
#define DUMP_SNAME(KEY,SNAME) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_sname_dump( &(SNAME), stdout ); )

/**
 * Dumps a list of scoped names.
 *
 * @param KEY The key name to print.
 * @param LIST The list of scoped names to dump.
 *
 * @sa #DUMP_SNAME()
 */
#define DUMP_SNAME_LIST(KEY,LIST) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_sname_list_dump( &(LIST), stdout ); )

/**
 * Dumps a C string.
 *
 * @param KEY The key name to print.
 * @param STR The C string to dump.
 *
 * @sa #DUMP_INT()
 * @sa #DUMP_SNAME()
 */
#define DUMP_STR(KEY,STR) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); fputs_quoted( (STR), '"', stdout ); )

/**
 * Dumps a \ref c_tid_t.
 *
 * @param KEY The key name to print.
 * @param TID The \ref c_tid_t to dump.
 *
 * @sa #DUMP_TYPE()
 */
#define DUMP_TID(KEY,TID) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_tid_dump( (TID), stdout ); )

/**
 * Dumps a \ref c_type.
 *
 * @param KEY The key name to print.
 * @param TYPE The \ref c_type to dump.
 *
 * @sa #DUMP_TID()
 */
#define DUMP_TYPE(KEY,TYPE) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_type_dump( &(TYPE), stdout ); )

/** @} */

///////////////////////////////////////////////////////////////////////////////

/**
 * @addtogroup parser-group
 * @{
 */

/**
 * Inherited attributes.
 *
 * @remarks These are grouped into a `struct` (rather than having them as
 * separate global variables) so that they can all be reset (mostly) via a
 * single assignment from `{0}`.
 *
 * @sa ia_cleanup()
 */
struct in_attr {
  c_alignas_t     align;            ///< Alignment, if any.
  unsigned        ast_depth;        ///< Parentheses nesting depth.
  bool            is_typename;      ///< C++ only: is `typename` specified?
  c_sname_t       scope_sname;      ///< C++ only: current scope name, if any.

  /**
   * Type AST stack.
   *
   * @sa ia_type_ast_peek()
   * @sa ia_type_ast_pop()
   * @sa ia_type_ast_push()
   */
  c_ast_list_t    type_ast_stack;

  /**
   * Declaration type specifier AST.
   *
   * @remarks A C/C++ declaration is of the form:
   *
   *      type-specifier declarator+
   *
   * where one or more declarators all have the same base type, e.g.:
   *
   *      int i, *p, a[2], f(double);
   *
   * This is a pointer to the base type AST (above, `int`) that is duplicated
   * for each declarator.  It's set by the first call to ia_type_ast_push().
   *
   * @sa ia_type_spec_ast()
   */
  c_ast_t const  *type_spec_ast;

  /**
   * Red-black node for temporary `typedef`.
   *
   * @remarks This is used only in the `pc99_func_or_constructor_declaration_c`
   * grammar production. It's needed because a temporary `typedef` needs to be
   * created in a mid-rule action then removed in the end-rule action and
   * there's no way to pass local variables between Bison actions, so it's
   * passed via an inherited attribute.
   */
  rb_node_t      *tdef_rb;
};
typedef struct in_attr in_attr_t;

// local functions
PJL_PRINTF_LIKE_FUNC(3)
static void l_elaborate_error( int, dym_kind_t, char const*, ... );

PJL_DISCARD
static bool print_error_token( char const* );

// local variables
static c_ast_list_t   gc_ast_list;      ///< c_ast nodes freed after parse.
static in_attr_t      in_attr;          ///< Inherited attributes.
static c_ast_list_t   typedef_ast_list; ///< List of ASTs for `typedef`s.

////////// inline functions ///////////////////////////////////////////////////

/**
 * Duplicates \a ast and adds it to \ref gc_ast_list.
 *
 * @param ast The AST to duplicate.
 * @return Returns the duplicated AST.
 *
 * @sa c_ast_new_gc()
 */
static inline c_ast_t* c_ast_dup_gc( c_ast_t const *ast ) {
  return c_ast_dup( ast, &gc_ast_list );
}

/**
 * Garbage-collects the AST nodes on \a ast_list but does _not_ free \a
 * ast_list itself.
 *
 * @param ast_list The AST list to free the nodes of.
 *
 * @sa c_ast_list_cleanup()
 * @sa c_ast_dup_gc()
 * @sa c_ast_new_gc()
 * @sa c_ast_pair_new_gc()
 */
static inline void c_ast_list_cleanup_gc( c_ast_list_t *ast_list ) {
  slist_cleanup( ast_list, POINTER_CAST( slist_free_fn_t, &c_ast_free ) );
}

/**
 * Creates a new AST and adds it to \ref gc_ast_list.
 *
 * @param kind The kind of AST to create.
 * @param loc A pointer to the token location data.
 * @return Returns a pointer to a new AST.
 *
 * @sa c_ast_dup_gc()
 * @sa c_ast_pair_new_gc()
 */
NODISCARD
static inline c_ast_t* c_ast_new_gc( c_ast_kind_t kind, c_loc_t const *loc ) {
  return c_ast_new( kind, in_attr.ast_depth, loc, &gc_ast_list );
}

/**
 * Set our mode to deciphering gibberish into English.
 */
static inline void gibberish_to_english( void ) {
  lexer_find &= ~LEXER_FIND_CDECL_KEYWORDS;
}

/**
 * Peeks at the type AST at the top of the
 * \ref in_attr.type_ast_stack "type AST inherited attribute stack".
 *
 * @return Returns said AST.
 *
 * @sa ia_type_ast_pop()
 * @sa ia_type_ast_push()
 */
NODISCARD
static inline c_ast_t* ia_type_ast_peek( void ) {
  return slist_front( &in_attr.type_ast_stack );
}

/**
 * Pops a type AST from the
 * \ref in_attr.type_ast_stack "type AST inherited attribute stack".
 *
 * @return Returns said AST.
 *
 * @sa ia_type_ast_peek()
 * @sa ia_type_ast_push()
 */
PJL_DISCARD
static inline c_ast_t* ia_type_ast_pop( void ) {
  c_ast_t *const ast = slist_pop_front( &in_attr.type_ast_stack );
  assert( ast != NULL );
  return ast;
}

/**
 * Given an AST for a type that is the "of type", return type, or "to type" of
 * a declaration, returns a duplicate of \a type_ast if necessary.
 *
 * @param type_ast The AST of a type.
 * @return If \a type_ast `==` \ref in_attr::type_spec_ast "type_spec_ast",
 * returns a duplicate of \a type_ast; otherwise returns \a type_ast.
 *
 * @sa \ref in_attr::type_spec_ast
 */
NODISCARD
static inline c_ast_t* ia_type_spec_ast( c_ast_t *type_ast ) {
  assert( type_ast != NULL );
  // Yes, == is correct here: we mean the same AST node.
  return type_ast == in_attr.type_spec_ast ?
    c_ast_dup_gc( type_ast ) : type_ast;
}

////////// local functions ////////////////////////////////////////////////////

/**
 * Prints a warning that the attribute \a keyword syntax is not supported (and
 * ignored).
 *
 * @param keyword The attribute syntax keyword, e.g., `__attribute__` or
 * `__declspec`.
 * @param keyword_loc The source location of \a keyword.
 */
static void attr_syntax_not_supported( char const *keyword,
                                       c_loc_t const *keyword_loc ) {
  assert( keyword != NULL );
  assert( keyword_loc != NULL );

  print_warning( keyword_loc,
    "\"%s\" not supported by " CDECL " (ignoring)", keyword
  );
  if ( OPT_LANG_IS( ATTRIBUTES ) )
    print_hint( "%s...%s", other_token_c( "[[" ), other_token_c( "]]" ) );
  else
    EPUTC( '\n' );
}

/**
 * A predicate function for slist_free_if() that checks whether \a ast is one
 * that can be garbage collected: if so, c_ast_free()s it.
 *
 * @param ast_node The \ref slist_node pointing to the AST to check.
 * @param data Contains the AST of the type being declared.
 * @return Returns `true` only if \a ast should be removed from the list.
 */
NODISCARD
static bool c_ast_free_if_garbage( slist_node_t *ast_node, void *data ) {
  assert( ast_node != NULL );
  c_ast_t *const ast = ast_node->data;
  assert( ast != NULL );
  c_ast_t const *const type_ast = data;
  assert( type_ast != NULL );

  if ( ast == type_ast || !c_ast_is_orphan( ast ) ) {
    assert( ast->kind != K_PLACEHOLDER );
    return false;
  }

  // We also need to ensure the AST isn't in the type_ast_stack.
  FOREACH_SLIST_NODE( type_node, &in_attr.type_ast_stack ) {
    if ( ast == type_node->data )
      return false;
  } // for

  c_ast_free( ast );
  return true;
}

/**
 * Checks whether `typename` is OK since the type's name is a qualified name.
 *
 * @param ast The AST to check.
 * @return Returns `true` only upon success.
 */
NODISCARD
bool c_ast_is_typename_ok( c_ast_t const *ast ) {
  c_ast_t const *const raw_ast = c_ast_untypedef( ast );
  if ( c_sname_count( &raw_ast->sname ) < 2 ) {
    print_error( &ast->loc, "qualified name expected after \"typename\"\n" );
    return false;
  }
  return true;
}

/**
 * If \a bit_width is &gt; 0 and \a ast is an integral type, sets \a ast's \ref
 * c_bit_field_ast::bit_width "bit_width" to \a bit_width.
 *
 * @remarks This check has to be done now in the parser rather than later in
 * the AST since we need to use the \ref c_ast::bit_field `union` member now.
 *
 * @param ast The AST whose \ref c_bit_field_ast::bit_width "bit_width" to
 * possibly set.
 * @param bit_width The bit-field width.
 * @return Returns `true` only if \a bit_width is &gt; 0 and \a ast if an
 * integral type.
 */
NODISCARD
static bool c_ast_set_bit_field_width( c_ast_t *ast, unsigned bit_width ) {
  assert( ast != NULL );

  if ( bit_width > 0 ) {
    if ( !c_ast_is_integral( ast ) ) {
      print_error( &ast->loc, "invalid bit-field type " );
      print_ast_type_aka( ast, stderr );
      EPRINTF( "; must be an integral %stype\n",
        OPT_LANG_IS( enum_BITFIELDS ) ? "or enumeration " : ""
      );
      return false;
    }
    ast->bit_field.bit_width = bit_width;
  }

  return true;
}

/**
 * Defines a type by adding it to the global set.
 *
 * @param type_ast The AST of the type to define.
 * @param decl_flags The declaration flags to use; must only be one of
 * #C_ENG_DECL, #C_GIB_TYPEDEF, or #C_GIB_USING.
 * @return Returns `true` either if the type was defined or it's equivalent to
 * an existing type; `false` if a different type already exists having the same
 * name.
 */
NODISCARD
static bool define_type( c_ast_t const *type_ast, decl_flags_t decl_flags ) {
  assert( type_ast != NULL );
  assert( is_1_bit_only_in_set( decl_flags, C_TYPE_DECL_ANY ) );

  if ( !c_ast_check_typedef( type_ast ) )
    return false;

  c_typedef_t *const tdef = c_typedef_add( type_ast, decl_flags )->data;

  if ( tdef->ast == type_ast ) {
    //
    // Type was added: we have to move the AST from the gc_ast_list so it won't
    // be garbage collected at the end of the parse to a separate
    // typedef_ast_list that's freed only at program termination.
    //
    // But first, garbage collect all orphaned AST nodes.  (For a non-type-
    // defining parse, this step isn't necessary since all nodes are freed at
    // the end of the parse anyway.)
    //
    slist_free_if(
      &gc_ast_list,
      &c_ast_free_if_garbage,
      CONST_CAST( void*, type_ast )
    );
    slist_push_list_back( &typedef_ast_list, &gc_ast_list );
    return true;
  }

  //
  // Type was NOT added because a previously declared type having the same name
  // was returned: check if the types are equal.
  //
  // In C, multiple typedef declarations having the same name are allowed only
  // if the types are equivalent:
  //
  //      typedef int T;
  //      typedef int T;                // OK
  //      typedef double T;             // error: types aren't equivalent
  //
  if ( c_ast_equal( type_ast, tdef->ast ) ) {
    // Update the language(s) the type is available in to include opt_lang_id.
    if ( opt_lang_id < c_lang_oldest( tdef->lang_ids ) )
      tdef->lang_ids = c_lang_and_newer( opt_lang_id );
    return true;
  }

  if ( tdef->is_predefined ) {
    print_error( &type_ast->loc,
      "\"%s\" is a predefined type starting in %s\n",
      c_sname_gibberish( &type_ast->sname ),
      c_lang_name( c_lang_oldest( tdef->lang_ids ) )
    );
  } else {
    print_error( &type_ast->loc, "type " );
    print_ast_type_aka( type_ast, stderr );
    EPUTS( " redefinition incompatible with original type \"" );
    print_type_ast( tdef, stderr );
    EPUTS( "\"\n" );
  }

  return false;
}

/**
 * Checks whether \a sname is a type.
 *
 * @param file The name of the file where this function was called from.
 * @param line The line number within \a file where this function was called
 * from.
 * @param sname The scoped name to check.
 * @param loc The location of \a sname.
 * @return Returns `true` only if \a sname is a type (and prints an error
 * message); otherwise `false` (and does nothing).
 */
NODISCARD
static bool fl_c_sname_is_type( char const *file, int line,
                                c_sname_t const *sname, c_loc_t const *loc ) {
  assert( sname != NULL );
  assert( loc != NULL );

  c_typedef_t const *const tdef = c_typedef_find_sname( sname );
  if ( tdef == NULL )
    return false;

  if ( tdef->is_predefined ) {
    fl_print_error( file, line, loc,
      "\"%s\" is a predefined type starting in %s\n",
      c_sname_gibberish( sname ),
      c_lang_name( c_lang_oldest( tdef->lang_ids ) )
    );
  } else {
    fl_print_error( file, line, loc,
      "\"%s\": previously declared as type \"",
      c_sname_gibberish( sname )
    );
    print_type_ast( tdef, stderr );
    EPUTS( "\"\n" );
  }

  return true;
}

/**
 * Cleans-up all resources used by \ref in_attr "inherited attributes".
 */
static void ia_cleanup( void ) {
  c_sname_cleanup( &in_attr.scope_sname );
  // Do _not_ pass &c_ast_free for the 2nd argument! All AST nodes were already
  // free'd from the gc_ast_list in parse_cleanup(). Just free the slist nodes.
  slist_cleanup( &in_attr.type_ast_stack, /*free_fn=*/NULL );
  in_attr = (in_attr_t){ 0 };
}

/**
 * Pushes a type AST onto the
 * \ref in_attr.type_ast_stack "type AST inherited attribute  stack".
 *
 * @remarks Additionally, if \a ast is #K_ANY_TYPE_SPECIFIER and \ref
 * in_attr::type_spec_ast "type_spec_ast" is NULL, sets \ref
 * in_attr::type_spec_ast "type_spec_ast" to \a ast.
 *
 * @param ast The AST to push.
 *
 * @sa ia_type_ast_peek()
 * @sa ia_type_ast_pop()
 */
static void ia_type_ast_push( c_ast_t *ast ) {
  assert( ast != NULL );
  slist_push_front( &in_attr.type_ast_stack, ast );
  if ( in_attr.type_spec_ast != NULL )
    return;
  if ( (ast->kind & K_ANY_TYPE_SPECIFIER) != 0 )
    in_attr.type_spec_ast = ast;
}

/**
 * Joins \a type_ast and \a decl_ast into a single AST.
 *
 * @param type_ast The type AST.
 * @param decl_ast The declaration AST.
 * @return Returns the joined AST on success or NULL on error.
 */
NODISCARD
c_ast_t* join_type_decl( c_ast_t *type_ast, c_ast_t *decl_ast ) {
  assert( type_ast != NULL );
  assert( decl_ast != NULL );

  if ( in_attr.is_typename && !c_ast_is_typename_ok( type_ast ) )
    return NULL;

  type_ast = ia_type_spec_ast( type_ast );
  c_type_t type = c_ast_take_type_any( type_ast, &T_TS_typedef );

  //
  // This is for a case like:
  //
  //      explain typedef ...
  //
  bool const is_explain_typedef = c_tid_is_any( type.stids, TS_typedef );

  if ( !is_explain_typedef &&
       type_ast->kind == K_BUILTIN && decl_ast->kind == K_BUILTIN &&
       c_sname_is_type( &decl_ast->sname, &decl_ast->loc ) ) {
    //
    // This checks for a case like:
    //
    //      typedef int T
    //      explain unsigned T          // error
    //
    // This check has to be done now in the parser rather than later in the
    // AST because once type_ast and decl_ast are joined, the fact that
    // decl_ast was a typedef is lost.
    //
    return NULL;
  }

  if ( is_explain_typedef && decl_ast->kind == K_TYPEDEF ) {
    //
    // This is for a case like:
    //
    //      explain typedef int int32_t;
    //
    // that is: explaining an existing typedef.  In order to do that, we have
    // to un-typedef it so we explain the type that it's a typedef for.
    //
    c_ast_t const *const raw_decl_ast = c_ast_untypedef( decl_ast );

    //
    // However, we also have to check whether the typedef being explained is
    // not equivalent to the existing typedef.  This is for a case like:
    //
    //      explain typedef char int32_t;
    //
    if ( !c_ast_equal( type_ast, raw_decl_ast ) ) {
      print_error( &decl_ast->loc, "type " );
      print_ast_type_aka( type_ast, stderr );
      EPUTS( " redefinition incompatible with original type " );
      print_ast_type_aka( decl_ast, stderr );
      EPUTC( '\n' );
      return NULL;
    }

    //
    // Because the raw_decl_ast for the existing type is about to be combined
    // with type_ast, duplicate raw_decl_ast first.
    //
    c_loc_t const *const orig_loc = &decl_ast->loc;
    decl_ast = c_ast_dup_gc( raw_decl_ast );
    decl_ast->loc = *orig_loc;
  }

  c_ast_t *const ast = c_ast_patch_placeholder( type_ast, decl_ast );
  c_type_t const tdef_type = c_ast_take_type_any( ast, &T_TS_typedef );
  c_type_or_eq( &type, &tdef_type );
  c_type_or_eq( &ast->type, &type );

  if ( in_attr.align.kind != C_ALIGNAS_NONE ) {
    ast->align = in_attr.align;
    if ( c_tid_is_any( type.stids, TS_typedef ) ) {
      //
      // We check for illegal aligned typedef here rather than in c_ast_check.c
      // because the "typedef-ness" needed to be removed previously before the
      // eventual call to c_ast_check().
      //
      print_error( &ast->align.loc, "typedef can not be aligned\n" );
      return NULL;
    }
  }

  if ( ast->kind == K_UDEF_CONV &&
       c_sname_local_type( &ast->sname )->btids == TB_SCOPE ) {
    //
    // User-defined conversions don't have names, but they can still have a
    // scope.  Since only classes can have them, if the scope is still
    // TB_SCOPE, change it to TB_class.
    //
    c_sname_local_data( &ast->sname )->type = C_TYPE_LIT_B( TB_class );
  }

  return ast;
}

/**
 * Checks whether \a ast is of kind #K_NAME and an error if:
 *
 *  + \ref opt_permissive_types is `false`; and:
 *  + \ref c_ast::sname is a C or C++ keyword.
 *
 * @note This function isn't normally called directly; use the
 * #c_ast_is_name_error() macro instead.
 *
 * @param line The line number within this file where this function was called
 * from.
 * @param ast The AST to check.
 * @return Returns `true` only if \a ast is a #K_NAME, \ref
 * opt_permissive_types is `false`, and \ref c_ast::sname is a C or C++
 * keyword.
 */
NODISCARD
static bool l_c_ast_is_name_error( int line, c_ast_t const *ast ) {
  assert( ast != NULL );
  if ( ast->kind != K_NAME || opt_permissive_types )
    return false;

  c_keyword_t const *const ck = c_keyword_find(
    c_sname_gibberish( &ast->sname ), LANG_ANY, C_KW_CTX_DEFAULT
  );
  if ( ck == NULL )
    return false;

  assert( !c_sname_empty( &ast->sname ) );
  fl_print_error_unknown_name( __FILE__, line, &ast->loc, &ast->sname );
  return true;
}

/**
 * A special case of l_elaborate_error() that prevents oddly worded error
 * messages where a C/C++ keyword is expected, but that keyword isn't a keyword
 * either until a later version of the language or in a different language;
 * hence, the lexer will return the keyword as the `Y_NAME` token instead of
 * the keyword token.
 *
 * For example, if l_elaborate_error() were used for the following \b cdecl
 * command when the current language is C, you'd get the following:
 * ```
 * declare f as virtual function returning void
 *              ^
 * 14: syntax error: "virtual": "virtual" expected; not a keyword until C++98
 * ```
 * because it's really this:
 * ```
 * ... "virtual" [the name]": "virtual" [the token] expected ...
 * ```
 * and that looks odd.
 *
 * @note This function isn't normally called directly; use the
 * #keyword_expected() macro instead.
 *
 * @param line The line number within this file where this function was called
 * from.
 * @param keyword A keyword literal.
 *
 * @sa l_elaborate_error()
 * @sa l_punct_expected()
 * @sa yyerror()
 */
static void l_keyword_expected( int line, char const *keyword ) {
  assert( keyword != NULL );

  dym_kind_t dym_kinds = DYM_NONE;

  char const *const error_token = printable_yytext();
  if ( error_token != NULL ) {
    if ( strcmp( error_token, keyword ) == 0 ) {
      //
      // The error token is the expected keyword which means the lexer returned
      // it as a name and not the token which likely means it's not a C/C++
      // keyword until a later version of the current language.
      //
      c_keyword_t const *const ck =
        c_keyword_find( keyword, LANG_ANY, C_KW_CTX_DEFAULT );
      if ( ck != NULL ) {
        char const *const which_lang = c_lang_which( ck->lang_ids );
        if ( which_lang[0] != '\0' ) {
          EPUTS( ": " );
          print_debug_file_line( __FILE__, line );
          EPRINTF( "\"%s\" not supported%s\n", keyword, which_lang );
          return;
        }
      }
    }

    dym_kinds = is_english_to_gibberish() ? DYM_CDECL_KEYWORDS : DYM_C_KEYWORDS;
  }

  l_elaborate_error( line, dym_kinds, "\"%s\" expected", keyword );
}

/**
 * Checks whether the type currently being declared (`enum`, `struct`,
 * `typedef`, or `union`) is nested within some other type (`struct` or
 * `union`) and whether the current language is C: if not, prints an error
 * message.
 *
 * @note It is unnecessary to check either when a `class` is being declared or
 * when a type is being declared within a `namespace` since those are not legal
 * in C anyway.
 *
 * @note This function isn't normally called directly; use the
 * #is_nested_type_ok() macro instead.
 *
 * @param line The line number within this file where this function was called
 * from.
 * @param type_loc The location of the type declaration.
 * @return Returns `true` only if the type currently being declared is either
 * not nested or the current language is C++.
 */
NODISCARD
static bool l_is_nested_type_ok( int line, c_loc_t const *type_loc ) {
  assert( type_loc != NULL );
  if ( !c_sname_empty( &in_attr.scope_sname ) &&
       !OPT_LANG_IS( NESTED_TYPES ) ) {
    fl_print_error( __FILE__, line, type_loc,
      "nested types not supported%s\n",
      C_LANG_WHICH( NESTED_TYPES )
    );
    return false;
  }
  return true;
}

/**
 * A special case of l_elaborate_error() that prevents oddly worded error
 * messages when a punctuation character is expected by not doing keyword look-
 * ups of the error token.
 *
 * For example, if l_elaborate_error() were used for the following \b cdecl
 * command, you'd get the following:
 * ```
 * explain void f(int g const)
 *                      ^
 * 29: syntax error: "const": ',' expected ("const" is a keyword)
 * ```
 * and that looks odd since, if a punctuation character was expected, it seems
 * silly to point out that the encountered token is a keyword.
 *
 * @note This function isn't normally called directly; use the
 * #punct_expected() macro instead.
 *
 * @param line The line number within this file where this function was called
 * from.
 * @param punct The punctuation character that was expected.
 *
 * @sa l_elaborate_error()
 * @sa l_keyword_expected()
 * @sa yyerror()
 */
static void l_punct_expected( int line, char punct ) {
  EPUTS( ": " );
  print_debug_file_line( __FILE__, line );
  if ( print_error_token( printable_yytext() ) )
    EPUTS( ": " );
  EPRINTF( "'%c' expected\n", punct );
}

/**
 * Cleans up individial parse data after each parse.
 *
 * @param fatal_error Must be `true` only if a fatal semantic error has
 * occurred and `YYABORT` is about to be called to bail out of parsing by
 * returning from yyparse().
 */
static void parse_cleanup( bool fatal_error ) {
  //
  // We need to reset the lexer differently depending on whether we completed a
  // parse with a fatal error.  If so, do a "hard" reset that also resets the
  // EOF flag of the lexer.
  //
  lexer_reset( /*hard_reset=*/fatal_error );

  if ( fatal_error && yytext[0] != '\n' ) {
    //
    // Generally, PARSE_ABORT() was called before getting to the '\n' at the
    // end of the line, so Flex will not have incremented yylineno: manually
    // increment yylineno here to compensate.
    //
    ++yylineno;
  }

  c_ast_list_cleanup_gc( &gc_ast_list );
  ia_cleanup();
}

/**
 * Creates a new \ref p_token_list_t containing a single #P_PLACEMARKER token.
 *
 * @return Returns said list.
 */
NODISCARD
static p_token_list_t* p_token_list_new_placemarker( void ) {
  p_token_list_t *const rv_tokens = MALLOC( p_token_list_t, 1 );
  slist_init( rv_tokens );
  slist_push_back( rv_tokens, p_token_new( P_PLACEMARKER, /*literal=*/NULL ) );
  return rv_tokens;
}

/**
 * Called by Bison to print a parsing error message to standard error.
 *
 * @remarks A custom error printing function via `%%define parse.error custom`
 * and
 * [`yyreport_syntax_error()`](https://www.gnu.org/software/bison/manual/html_node/Syntax-Error-Reporting-Function.html)
 * is not done because printing a (perhaps long) list of all the possible
 * expected tokens isn't helpful.
 * @par
 * It's also more flexible to be able to call one of #elaborate_error(),
 * #keyword_expected(), or #punct_expected() at the point of the error rather
 * than having a single function try to figure out the best type of error
 * message to print.
 *
 * @note A newline is _not_ printed since the error message will be appended to
 * by l_elaborate_error().  For example, the parts of an error message are
 * printed by the functions shown:
 *
 *      42: syntax error: "int": "into" expected
 *      |--||----------||----------------------|
 *      |   |           |
 *      |   yyerror()   l_elaborate_error()
 *      |
 *      print_loc()
 *
 * @param msg The error message to print.  Bison invariably passes `syntax
 * error`.
 *
 * @sa l_elaborate_error()
 * @sa l_keyword_expected()
 * @sa l_punct_expected()
 * @sa print_loc()
 */
static void yyerror( char const *msg ) {
  assert( msg != NULL );

  c_loc_t const loc = lexer_loc();
  print_loc( &loc );

  color_start( stderr, sgr_error );
  EPUTS( msg );                         // no newline
  color_end( stderr, sgr_error );

  //
  // A syntax error has occurred, but syntax errors aren't fatal since Bison
  // tries to recover.  We'll clean-up the current parse, but YYABORT won't be
  // called so we won't bail out of parsing by returning from yyparse(); hence,
  // parsing will continue.
  //
  parse_cleanup( /*fatal_error=*/false );
}

/** @} */

///////////////////////////////////////////////////////////////////////////////

/// @cond DOXYGEN_IGNORE


#line 1360 "parser.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include  "parser.h" 
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_Y_cast = 3,                     /* Y_cast  */
  YYSYMBOL_Y_constant = 4,                 /* Y_constant  */
  YYSYMBOL_Y_declare = 5,                  /* Y_declare  */
  YYSYMBOL_Y_define = 6,                   /* Y_define  */
  YYSYMBOL_Y_dynamic = 7,                  /* Y_dynamic  */
  YYSYMBOL_Y_explain = 8,                  /* Y_explain  */
  YYSYMBOL_Y_no = 9,                       /* Y_no  */
  YYSYMBOL_Y_quit = 10,                    /* Y_quit  */
  YYSYMBOL_Y_reinterpret = 11,             /* Y_reinterpret  */
  YYSYMBOL_Y_set = 12,                     /* Y_set  */
  YYSYMBOL_Y_show = 13,                    /* Y_show  */
  YYSYMBOL_Y_aligned = 14,                 /* Y_aligned  */
  YYSYMBOL_Y_all = 15,                     /* Y_all  */
  YYSYMBOL_Y_array = 16,                   /* Y_array  */
  YYSYMBOL_Y_as = 17,                      /* Y_as  */
  YYSYMBOL_Y_binding = 18,                 /* Y_binding  */
  YYSYMBOL_Y_bit = 19,                     /* Y_bit  */
  YYSYMBOL_Y_bit_precise = 20,             /* Y_bit_precise  */
  YYSYMBOL_Y_bits = 21,                    /* Y_bits  */
  YYSYMBOL_Y_by = 22,                      /* Y_by  */
  YYSYMBOL_Y_bytes = 23,                   /* Y_bytes  */
  YYSYMBOL_Y_capturing = 24,               /* Y_capturing  */
  YYSYMBOL_Y_commands = 25,                /* Y_commands  */
  YYSYMBOL_Y_constructor = 26,             /* Y_constructor  */
  YYSYMBOL_Y_conversion = 27,              /* Y_conversion  */
  YYSYMBOL_Y_copy = 28,                    /* Y_copy  */
  YYSYMBOL_Y_defined = 29,                 /* Y_defined  */
  YYSYMBOL_Y_destructor = 30,              /* Y_destructor  */
  YYSYMBOL_Y_english = 31,                 /* Y_english  */
  YYSYMBOL_Y_evaluation = 32,              /* Y_evaluation  */
  YYSYMBOL_Y_expand = 33,                  /* Y_expand  */
  YYSYMBOL_Y_expression = 34,              /* Y_expression  */
  YYSYMBOL_Y_floating = 35,                /* Y_floating  */
  YYSYMBOL_Y_function = 36,                /* Y_function  */
  YYSYMBOL_Y_initialization = 37,          /* Y_initialization  */
  YYSYMBOL_Y_into = 38,                    /* Y_into  */
  YYSYMBOL_Y_lambda = 39,                  /* Y_lambda  */
  YYSYMBOL_Y_length = 40,                  /* Y_length  */
  YYSYMBOL_Y_linkage = 41,                 /* Y_linkage  */
  YYSYMBOL_Y_literal = 42,                 /* Y_literal  */
  YYSYMBOL_Y_macros = 43,                  /* Y_macros  */
  YYSYMBOL_Y_member = 44,                  /* Y_member  */
  YYSYMBOL_Y_non_empty = 45,               /* Y_non_empty  */
  YYSYMBOL_Y_non_member = 46,              /* Y_non_member  */
  YYSYMBOL_Y_of = 47,                      /* Y_of  */
  YYSYMBOL_Y_options = 48,                 /* Y_options  */
  YYSYMBOL_Y_point = 49,                   /* Y_point  */
  YYSYMBOL_Y_pointer = 50,                 /* Y_pointer  */
  YYSYMBOL_Y_precise = 51,                 /* Y_precise  */
  YYSYMBOL_Y_precision = 52,               /* Y_precision  */
  YYSYMBOL_Y_predefined = 53,              /* Y_predefined  */
  YYSYMBOL_Y_pure = 54,                    /* Y_pure  */
  YYSYMBOL_Y_reference = 55,               /* Y_reference  */
  YYSYMBOL_Y_returning = 56,               /* Y_returning  */
  YYSYMBOL_Y_rvalue = 57,                  /* Y_rvalue  */
  YYSYMBOL_Y_scope = 58,                   /* Y_scope  */
  YYSYMBOL_Y_structured = 59,              /* Y_structured  */
  YYSYMBOL_Y_to = 60,                      /* Y_to  */
  YYSYMBOL_Y_user = 61,                    /* Y_user  */
  YYSYMBOL_Y_user_defined = 62,            /* Y_user_defined  */
  YYSYMBOL_Y_variable = 63,                /* Y_variable  */
  YYSYMBOL_Y_wide = 64,                    /* Y_wide  */
  YYSYMBOL_Y_width = 65,                   /* Y_width  */
  YYSYMBOL_Y_PREC_LESS_THAN_upc_layout_qualifier = 66, /* Y_PREC_LESS_THAN_upc_layout_qualifier  */
  YYSYMBOL_Y_COLON_COLON = 67,             /* Y_COLON_COLON  */
  YYSYMBOL_68_ = 68,                       /* "::"  */
  YYSYMBOL_Y_COLON_COLON_STAR = 69,        /* Y_COLON_COLON_STAR  */
  YYSYMBOL_Y_PLUS_PLUS = 70,               /* "++"  */
  YYSYMBOL_Y_MINUS_MINUS = 71,             /* "--"  */
  YYSYMBOL_72_ = 72,                       /* '('  */
  YYSYMBOL_73_ = 73,                       /* ')'  */
  YYSYMBOL_74_ = 74,                       /* '['  */
  YYSYMBOL_75_ = 75,                       /* ']'  */
  YYSYMBOL_76_ = 76,                       /* '.'  */
  YYSYMBOL_Y_MINUS_GREATER = 77,           /* Y_MINUS_GREATER  */
  YYSYMBOL_78_ = 78,                       /* "->"  */
  YYSYMBOL_79_ = 79,                       /* '&'  */
  YYSYMBOL_80_ = 80,                       /* '*'  */
  YYSYMBOL_81_ = 81,                       /* '!'  */
  YYSYMBOL_Y_sizeof = 82,                  /* Y_sizeof  */
  YYSYMBOL_83_ = 83,                       /* '~'  */
  YYSYMBOL_Y_DOT_STAR = 84,                /* Y_DOT_STAR  */
  YYSYMBOL_85_ = 85,                       /* ".*"  */
  YYSYMBOL_Y_MINUS_GREATER_STAR = 86,      /* Y_MINUS_GREATER_STAR  */
  YYSYMBOL_87_ = 87,                       /* "->*"  */
  YYSYMBOL_88_ = 88,                       /* '/'  */
  YYSYMBOL_89_ = 89,                       /* '%'  */
  YYSYMBOL_90_ = 90,                       /* '-'  */
  YYSYMBOL_91_ = 91,                       /* '+'  */
  YYSYMBOL_Y_LESS_LESS = 92,               /* Y_LESS_LESS  */
  YYSYMBOL_93_ = 93,                       /* "<<"  */
  YYSYMBOL_Y_GREATER_GREATER = 94,         /* Y_GREATER_GREATER  */
  YYSYMBOL_95_ = 95,                       /* ">>"  */
  YYSYMBOL_Y_LESS_EQUAL_GREATER = 96,      /* Y_LESS_EQUAL_GREATER  */
  YYSYMBOL_97_ = 97,                       /* "<=>"  */
  YYSYMBOL_98_ = 98,                       /* '<'  */
  YYSYMBOL_99_ = 99,                       /* '>'  */
  YYSYMBOL_Y_LESS_EQUAL = 100,             /* Y_LESS_EQUAL  */
  YYSYMBOL_101_ = 101,                     /* "<="  */
  YYSYMBOL_Y_GREATER_EQUAL = 102,          /* Y_GREATER_EQUAL  */
  YYSYMBOL_103_ = 103,                     /* ">="  */
  YYSYMBOL_Y_EQUAL_EQUAL = 104,            /* Y_EQUAL_EQUAL  */
  YYSYMBOL_105_ = 105,                     /* "=="  */
  YYSYMBOL_Y_EXCLAM_EQUAL = 106,           /* Y_EXCLAM_EQUAL  */
  YYSYMBOL_Y_bit_and = 107,                /* Y_bit_and  */
  YYSYMBOL_108_ = 108,                     /* '^'  */
  YYSYMBOL_109_ = 109,                     /* '|'  */
  YYSYMBOL_Y_AMPER_AMPER = 110,            /* Y_AMPER_AMPER  */
  YYSYMBOL_Y_PIPE_PIPE = 111,              /* Y_PIPE_PIPE  */
  YYSYMBOL_Y_QMARK_COLON = 112,            /* Y_QMARK_COLON  */
  YYSYMBOL_113_ = 113,                     /* "?:"  */
  YYSYMBOL_114_ = 114,                     /* '='  */
  YYSYMBOL_Y_PERCENT_EQUAL = 115,          /* Y_PERCENT_EQUAL  */
  YYSYMBOL_116_ = 116,                     /* "%="  */
  YYSYMBOL_Y_AMPER_EQUAL = 117,            /* Y_AMPER_EQUAL  */
  YYSYMBOL_Y_STAR_EQUAL = 118,             /* Y_STAR_EQUAL  */
  YYSYMBOL_119_ = 119,                     /* "*="  */
  YYSYMBOL_Y_PLUS_EQUAL = 120,             /* Y_PLUS_EQUAL  */
  YYSYMBOL_121_ = 121,                     /* "+="  */
  YYSYMBOL_Y_MINUS_EQUAL = 122,            /* Y_MINUS_EQUAL  */
  YYSYMBOL_123_ = 123,                     /* "-="  */
  YYSYMBOL_Y_SLASH_EQUAL = 124,            /* Y_SLASH_EQUAL  */
  YYSYMBOL_125_ = 125,                     /* "/="  */
  YYSYMBOL_Y_LESS_LESS_EQUAL = 126,        /* Y_LESS_LESS_EQUAL  */
  YYSYMBOL_127_ = 127,                     /* "<<="  */
  YYSYMBOL_Y_GREATER_GREATER_EQUAL = 128,  /* Y_GREATER_GREATER_EQUAL  */
  YYSYMBOL_129_ = 129,                     /* ">>="  */
  YYSYMBOL_Y_CARET_EQUAL = 130,            /* Y_CARET_EQUAL  */
  YYSYMBOL_Y_PIPE_EQUAL = 131,             /* Y_PIPE_EQUAL  */
  YYSYMBOL_132_ = 132,                     /* ','  */
  YYSYMBOL_Y_auto_STORAGE = 133,           /* Y_auto_STORAGE  */
  YYSYMBOL_Y_break = 134,                  /* Y_break  */
  YYSYMBOL_Y_case = 135,                   /* Y_case  */
  YYSYMBOL_Y_char = 136,                   /* Y_char  */
  YYSYMBOL_Y_continue = 137,               /* Y_continue  */
  YYSYMBOL_Y_default = 138,                /* Y_default  */
  YYSYMBOL_Y_do = 139,                     /* Y_do  */
  YYSYMBOL_Y_double = 140,                 /* Y_double  */
  YYSYMBOL_Y_else = 141,                   /* Y_else  */
  YYSYMBOL_Y_extern = 142,                 /* Y_extern  */
  YYSYMBOL_Y_float = 143,                  /* Y_float  */
  YYSYMBOL_Y_for = 144,                    /* Y_for  */
  YYSYMBOL_Y_goto = 145,                   /* Y_goto  */
  YYSYMBOL_Y_if = 146,                     /* Y_if  */
  YYSYMBOL_Y_int = 147,                    /* Y_int  */
  YYSYMBOL_Y_long = 148,                   /* Y_long  */
  YYSYMBOL_Y_register = 149,               /* Y_register  */
  YYSYMBOL_Y_return = 150,                 /* Y_return  */
  YYSYMBOL_Y_short = 151,                  /* Y_short  */
  YYSYMBOL_Y_static = 152,                 /* Y_static  */
  YYSYMBOL_Y_struct = 153,                 /* Y_struct  */
  YYSYMBOL_Y_switch = 154,                 /* Y_switch  */
  YYSYMBOL_Y_typedef = 155,                /* Y_typedef  */
  YYSYMBOL_Y_union = 156,                  /* Y_union  */
  YYSYMBOL_Y_unsigned = 157,               /* Y_unsigned  */
  YYSYMBOL_Y_while = 158,                  /* Y_while  */
  YYSYMBOL_159_ = 159,                     /* '#'  */
  YYSYMBOL_Y_PRE_CONCAT = 160,             /* "##"  */
  YYSYMBOL_Y_PRE_SPACE = 161,              /* Y_PRE_SPACE  */
  YYSYMBOL_Y_PRE_define = 162,             /* Y_PRE_define  */
  YYSYMBOL_Y_PRE_elif = 163,               /* Y_PRE_elif  */
  YYSYMBOL_Y_PRE_else = 164,               /* Y_PRE_else  */
  YYSYMBOL_Y_PRE_error = 165,              /* Y_PRE_error  */
  YYSYMBOL_Y_PRE_if = 166,                 /* Y_PRE_if  */
  YYSYMBOL_Y_PRE_ifdef = 167,              /* Y_PRE_ifdef  */
  YYSYMBOL_Y_PRE_ifndef = 168,             /* Y_PRE_ifndef  */
  YYSYMBOL_Y_PRE_line = 169,               /* Y_PRE_line  */
  YYSYMBOL_Y_PRE_undef = 170,              /* Y_PRE_undef  */
  YYSYMBOL_Y_PRE___VA_ARGS__ = 171,        /* Y_PRE___VA_ARGS__  */
  YYSYMBOL_Y_PRE___VA_OPT__ = 172,         /* Y_PRE___VA_OPT__  */
  YYSYMBOL_Y_PRE_pragma = 173,             /* Y_PRE_pragma  */
  YYSYMBOL_Y_PRE_elifdef = 174,            /* Y_PRE_elifdef  */
  YYSYMBOL_Y_PRE_elifndef = 175,           /* Y_PRE_elifndef  */
  YYSYMBOL_Y_PRE_embed = 176,              /* Y_PRE_embed  */
  YYSYMBOL_Y_PRE_warning = 177,            /* Y_PRE_warning  */
  YYSYMBOL_Y_asm = 178,                    /* Y_asm  */
  YYSYMBOL_Y_const = 179,                  /* Y_const  */
  YYSYMBOL_Y_ELLIPSIS = 180,               /* "..."  */
  YYSYMBOL_Y_enum = 181,                   /* Y_enum  */
  YYSYMBOL_Y_signed = 182,                 /* Y_signed  */
  YYSYMBOL_Y_void = 183,                   /* Y_void  */
  YYSYMBOL_Y_volatile = 184,               /* Y_volatile  */
  YYSYMBOL_Y_wchar_t = 185,                /* Y_wchar_t  */
  YYSYMBOL_Y__Bool = 186,                  /* Y__Bool  */
  YYSYMBOL_Y__Complex = 187,               /* Y__Complex  */
  YYSYMBOL_Y__Imaginary = 188,             /* Y__Imaginary  */
  YYSYMBOL_Y_inline = 189,                 /* Y_inline  */
  YYSYMBOL_Y_restrict = 190,               /* Y_restrict  */
  YYSYMBOL_Y__Alignas = 191,               /* Y__Alignas  */
  YYSYMBOL_Y__Alignof = 192,               /* Y__Alignof  */
  YYSYMBOL_Y__Atomic_QUAL = 193,           /* Y__Atomic_QUAL  */
  YYSYMBOL_Y__Atomic_SPEC = 194,           /* Y__Atomic_SPEC  */
  YYSYMBOL_Y__Generic = 195,               /* Y__Generic  */
  YYSYMBOL_Y__Noreturn = 196,              /* Y__Noreturn  */
  YYSYMBOL_Y__Static_assert = 197,         /* Y__Static_assert  */
  YYSYMBOL_Y__Thread_local = 198,          /* Y__Thread_local  */
  YYSYMBOL_Y_thread = 199,                 /* Y_thread  */
  YYSYMBOL_Y_local = 200,                  /* Y_local  */
  YYSYMBOL_Y_bool = 201,                   /* Y_bool  */
  YYSYMBOL_Y_catch = 202,                  /* Y_catch  */
  YYSYMBOL_Y_class = 203,                  /* Y_class  */
  YYSYMBOL_Y_const_cast = 204,             /* Y_const_cast  */
  YYSYMBOL_Y_CONSTRUCTOR_SNAME = 205,      /* Y_CONSTRUCTOR_SNAME  */
  YYSYMBOL_Y_delete = 206,                 /* Y_delete  */
  YYSYMBOL_Y_DESTRUCTOR_SNAME = 207,       /* Y_DESTRUCTOR_SNAME  */
  YYSYMBOL_Y_dynamic_cast = 208,           /* Y_dynamic_cast  */
  YYSYMBOL_Y_explicit = 209,               /* Y_explicit  */
  YYSYMBOL_Y_false = 210,                  /* Y_false  */
  YYSYMBOL_Y_friend = 211,                 /* Y_friend  */
  YYSYMBOL_Y_mutable = 212,                /* Y_mutable  */
  YYSYMBOL_Y_namespace = 213,              /* Y_namespace  */
  YYSYMBOL_Y_new = 214,                    /* Y_new  */
  YYSYMBOL_Y_operator = 215,               /* Y_operator  */
  YYSYMBOL_Y_OPERATOR_SNAME = 216,         /* Y_OPERATOR_SNAME  */
  YYSYMBOL_Y_private = 217,                /* Y_private  */
  YYSYMBOL_Y_protected = 218,              /* Y_protected  */
  YYSYMBOL_Y_public = 219,                 /* Y_public  */
  YYSYMBOL_Y_reinterpret_cast = 220,       /* Y_reinterpret_cast  */
  YYSYMBOL_Y_static_cast = 221,            /* Y_static_cast  */
  YYSYMBOL_Y_template = 222,               /* Y_template  */
  YYSYMBOL_Y_this = 223,                   /* Y_this  */
  YYSYMBOL_Y_throw = 224,                  /* Y_throw  */
  YYSYMBOL_Y_true = 225,                   /* Y_true  */
  YYSYMBOL_Y_try = 226,                    /* Y_try  */
  YYSYMBOL_Y_typeid = 227,                 /* Y_typeid  */
  YYSYMBOL_Y_typename = 228,               /* Y_typename  */
  YYSYMBOL_Y_using = 229,                  /* Y_using  */
  YYSYMBOL_Y_virtual = 230,                /* Y_virtual  */
  YYSYMBOL_Y_char16_t = 231,               /* Y_char16_t  */
  YYSYMBOL_Y_char32_t = 232,               /* Y_char32_t  */
  YYSYMBOL_Y__BitInt = 233,                /* Y__BitInt  */
  YYSYMBOL_Y_reproducible = 234,           /* Y_reproducible  */
  YYSYMBOL_Y_typeof = 235,                 /* Y_typeof  */
  YYSYMBOL_Y_typeof_unqual = 236,          /* Y_typeof_unqual  */
  YYSYMBOL_Y_unsequenced = 237,            /* Y_unsequenced  */
  YYSYMBOL_Y_ATTR_BEGIN = 238,             /* Y_ATTR_BEGIN  */
  YYSYMBOL_Y_auto_TYPE = 239,              /* Y_auto_TYPE  */
  YYSYMBOL_Y_alignas = 240,                /* Y_alignas  */
  YYSYMBOL_Y_alignof = 241,                /* Y_alignof  */
  YYSYMBOL_Y_carries = 242,                /* Y_carries  */
  YYSYMBOL_Y_dependency = 243,             /* Y_dependency  */
  YYSYMBOL_Y_carries_dependency = 244,     /* Y_carries_dependency  */
  YYSYMBOL_Y_constexpr = 245,              /* Y_constexpr  */
  YYSYMBOL_Y_decltype = 246,               /* Y_decltype  */
  YYSYMBOL_Y_except = 247,                 /* Y_except  */
  YYSYMBOL_Y_final = 248,                  /* Y_final  */
  YYSYMBOL_Y_noexcept = 249,               /* Y_noexcept  */
  YYSYMBOL_Y_nullptr = 250,                /* Y_nullptr  */
  YYSYMBOL_Y_override = 251,               /* Y_override  */
  YYSYMBOL_Y_static_assert = 252,          /* Y_static_assert  */
  YYSYMBOL_Y_thread_local = 253,           /* Y_thread_local  */
  YYSYMBOL_Y_deprecated = 254,             /* Y_deprecated  */
  YYSYMBOL_Y_auto_STRUCTURED_BINDING = 255, /* Y_auto_STRUCTURED_BINDING  */
  YYSYMBOL_Y_discard = 256,                /* Y_discard  */
  YYSYMBOL_Y_maybe_unused = 257,           /* Y_maybe_unused  */
  YYSYMBOL_Y_maybe = 258,                  /* Y_maybe  */
  YYSYMBOL_Y_unused = 259,                 /* Y_unused  */
  YYSYMBOL_Y_nodiscard = 260,              /* Y_nodiscard  */
  YYSYMBOL_Y_noreturn = 261,               /* Y_noreturn  */
  YYSYMBOL_Y_char8_t = 262,                /* Y_char8_t  */
  YYSYMBOL_Y_concept = 263,                /* Y_concept  */
  YYSYMBOL_Y_consteval = 264,              /* Y_consteval  */
  YYSYMBOL_Y_constinit = 265,              /* Y_constinit  */
  YYSYMBOL_Y_co_await = 266,               /* Y_co_await  */
  YYSYMBOL_Y_co_return = 267,              /* Y_co_return  */
  YYSYMBOL_Y_co_yield = 268,               /* Y_co_yield  */
  YYSYMBOL_Y_export = 269,                 /* Y_export  */
  YYSYMBOL_Y_no_unique_address = 270,      /* Y_no_unique_address  */
  YYSYMBOL_Y_parameter = 271,              /* Y_parameter  */
  YYSYMBOL_Y_pack = 272,                   /* Y_pack  */
  YYSYMBOL_Y_requires = 273,               /* Y_requires  */
  YYSYMBOL_Y_unique = 274,                 /* Y_unique  */
  YYSYMBOL_Y_address = 275,                /* Y_address  */
  YYSYMBOL_Y_EMC__Accum = 276,             /* Y_EMC__Accum  */
  YYSYMBOL_Y_EMC__Fract = 277,             /* Y_EMC__Fract  */
  YYSYMBOL_Y_EMC__Sat = 278,               /* Y_EMC__Sat  */
  YYSYMBOL_Y_UPC_relaxed = 279,            /* Y_UPC_relaxed  */
  YYSYMBOL_Y_UPC_shared = 280,             /* Y_UPC_shared  */
  YYSYMBOL_Y_UPC_strict = 281,             /* Y_UPC_strict  */
  YYSYMBOL_Y_GNU___attribute__ = 282,      /* Y_GNU___attribute__  */
  YYSYMBOL_Y_GNU___restrict = 283,         /* Y_GNU___restrict  */
  YYSYMBOL_Y_Apple___block = 284,          /* Y_Apple___block  */
  YYSYMBOL_Y_Apple_block = 285,            /* Y_Apple_block  */
  YYSYMBOL_Y_MSC___cdecl = 286,            /* Y_MSC___cdecl  */
  YYSYMBOL_Y_MSC___clrcall = 287,          /* Y_MSC___clrcall  */
  YYSYMBOL_Y_MSC___declspec = 288,         /* Y_MSC___declspec  */
  YYSYMBOL_Y_MSC___fastcall = 289,         /* Y_MSC___fastcall  */
  YYSYMBOL_Y_MSC___stdcall = 290,          /* Y_MSC___stdcall  */
  YYSYMBOL_Y_MSC___thiscall = 291,         /* Y_MSC___thiscall  */
  YYSYMBOL_Y_MSC___vectorcall = 292,       /* Y_MSC___vectorcall  */
  YYSYMBOL_293_ = 293,                     /* ':'  */
  YYSYMBOL_294_ = 294,                     /* ';'  */
  YYSYMBOL_295_ = 295,                     /* '{'  */
  YYSYMBOL_296_ = 296,                     /* '}'  */
  YYSYMBOL_Y_CHAR_LIT = 297,               /* Y_CHAR_LIT  */
  YYSYMBOL_Y_CONCEPT_SNAME = 298,          /* Y_CONCEPT_SNAME  */
  YYSYMBOL_Y_END = 299,                    /* Y_END  */
  YYSYMBOL_Y_ERROR = 300,                  /* Y_ERROR  */
  YYSYMBOL_Y_FLOAT_LIT = 301,              /* Y_FLOAT_LIT  */
  YYSYMBOL_Y_GLOB = 302,                   /* Y_GLOB  */
  YYSYMBOL_Y_INT_LIT = 303,                /* Y_INT_LIT  */
  YYSYMBOL_Y_NAME = 304,                   /* Y_NAME  */
  YYSYMBOL_Y_SET_OPTION = 305,             /* Y_SET_OPTION  */
  YYSYMBOL_Y_STR_LIT = 306,                /* Y_STR_LIT  */
  YYSYMBOL_Y_TYPEDEF_NAME_TDEF = 307,      /* Y_TYPEDEF_NAME_TDEF  */
  YYSYMBOL_Y_TYPEDEF_SNAME_TDEF = 308,     /* Y_TYPEDEF_SNAME_TDEF  */
  YYSYMBOL_Y_LEXER_ERROR = 309,            /* Y_LEXER_ERROR  */
  YYSYMBOL_310_ = 310,                     /* '$'  */
  YYSYMBOL_311_ = 311,                     /* '@'  */
  YYSYMBOL_312_ = 312,                     /* '`'  */
  YYSYMBOL_313_ = 313,                     /* '?'  */
  YYSYMBOL_YYACCEPT = 314,                 /* $accept  */
  YYSYMBOL_command_list = 315,             /* command_list  */
  YYSYMBOL_command = 316,                  /* command  */
  YYSYMBOL_cast_command = 317,             /* cast_command  */
  YYSYMBOL_new_style_cast_english = 318,   /* new_style_cast_english  */
  YYSYMBOL_declare_command = 319,          /* declare_command  */
  YYSYMBOL_320_1 = 320,                    /* $@1  */
  YYSYMBOL_alignas_or_width_decl_english_ast = 321, /* alignas_or_width_decl_english_ast  */
  YYSYMBOL_alignas_specifier_english = 322, /* alignas_specifier_english  */
  YYSYMBOL_aligned_english = 323,          /* aligned_english  */
  YYSYMBOL_capturing_paren_capture_decl_list_english_opt = 324, /* capturing_paren_capture_decl_list_english_opt  */
  YYSYMBOL_paren_capture_decl_list_english = 325, /* paren_capture_decl_list_english  */
  YYSYMBOL_capture_decl_list_english_opt = 326, /* capture_decl_list_english_opt  */
  YYSYMBOL_capture_decl_list_english = 327, /* capture_decl_list_english  */
  YYSYMBOL_capture_decl_english_ast = 328, /* capture_decl_english_ast  */
  YYSYMBOL_capture_default_opt = 329,      /* capture_default_opt  */
  YYSYMBOL_width_specifier_english_uint = 330, /* width_specifier_english_uint  */
  YYSYMBOL_storage_class_subset_english_type_opt = 331, /* storage_class_subset_english_type_opt  */
  YYSYMBOL_storage_class_subset_english_type = 332, /* storage_class_subset_english_type  */
  YYSYMBOL_storage_class_subset_english_stid = 333, /* storage_class_subset_english_stid  */
  YYSYMBOL_define_command = 334,           /* define_command  */
  YYSYMBOL_expand_command = 335,           /* expand_command  */
  YYSYMBOL_expand_command2 = 336,          /* expand_command2  */
  YYSYMBOL_p_extra_token_except_lparen = 337, /* p_extra_token_except_lparen  */
  YYSYMBOL_p_extra_tokens_opt = 338,       /* p_extra_tokens_opt  */
  YYSYMBOL_p_extra_tokens = 339,           /* p_extra_tokens  */
  YYSYMBOL_p_extra_token = 340,            /* p_extra_token  */
  YYSYMBOL_p_arg_list_opt = 341,           /* p_arg_list_opt  */
  YYSYMBOL_p_comma_arg_list = 342,         /* p_comma_arg_list  */
  YYSYMBOL_p_arg_list = 343,               /* p_arg_list  */
  YYSYMBOL_p_arg_tokens = 344,             /* p_arg_tokens  */
  YYSYMBOL_p_arg_token_as_list = 345,      /* p_arg_token_as_list  */
  YYSYMBOL_p_arg_token = 346,              /* p_arg_token  */
  YYSYMBOL_p_num_lit = 347,                /* p_num_lit  */
  YYSYMBOL_p_other = 348,                  /* p_other  */
  YYSYMBOL_p_punctuator = 349,             /* p_punctuator  */
  YYSYMBOL_p_arg_tokens_with_comma_opt = 350, /* p_arg_tokens_with_comma_opt  */
  YYSYMBOL_p_arg_tokens_with_comma = 351,  /* p_arg_tokens_with_comma  */
  YYSYMBOL_p_arg_token_with_comma_as_list = 352, /* p_arg_token_with_comma_as_list  */
  YYSYMBOL_p_arg_token_with_comma = 353,   /* p_arg_token_with_comma  */
  YYSYMBOL_explain_command = 354,          /* explain_command  */
  YYSYMBOL_355_2 = 355,                    /* $@2  */
  YYSYMBOL_explain = 356,                  /* explain  */
  YYSYMBOL_help_command = 357,             /* help_command  */
  YYSYMBOL_358_3 = 358,                    /* $@3  */
  YYSYMBOL_help_what_opt = 359,            /* help_what_opt  */
  YYSYMBOL_preprocessor_command = 360,     /* preprocessor_command  */
  YYSYMBOL_p_define = 361,                 /* p_define  */
  YYSYMBOL_p_paren_param_list_opt = 362,   /* p_paren_param_list_opt  */
  YYSYMBOL_p_param_list_opt = 363,         /* p_param_list_opt  */
  YYSYMBOL_p_param_list = 364,             /* p_param_list  */
  YYSYMBOL_p_param = 365,                  /* p_param  */
  YYSYMBOL_p_replace_list_opt = 366,       /* p_replace_list_opt  */
  YYSYMBOL_p_replace_list = 367,           /* p_replace_list  */
  YYSYMBOL_p_replace_token = 368,          /* p_replace_token  */
  YYSYMBOL_p_undef = 369,                  /* p_undef  */
  YYSYMBOL_quit_command = 370,             /* quit_command  */
  YYSYMBOL_scoped_command = 371,           /* scoped_command  */
  YYSYMBOL_set_command = 372,              /* set_command  */
  YYSYMBOL_set_option_list = 373,          /* set_option_list  */
  YYSYMBOL_set_option = 374,               /* set_option  */
  YYSYMBOL_set_option_value_opt = 375,     /* set_option_value_opt  */
  YYSYMBOL_show_command = 376,             /* show_command  */
  YYSYMBOL_show_format = 377,              /* show_format  */
  YYSYMBOL_show_format_exp = 378,          /* show_format_exp  */
  YYSYMBOL_show_format_opt = 379,          /* show_format_opt  */
  YYSYMBOL_show_types_opt = 380,           /* show_types_opt  */
  YYSYMBOL_predefined_or_user_types_opt = 381, /* predefined_or_user_types_opt  */
  YYSYMBOL_template_command = 382,         /* template_command  */
  YYSYMBOL_typedef_command = 383,          /* typedef_command  */
  YYSYMBOL_using_command = 384,            /* using_command  */
  YYSYMBOL_c_style_cast_expr_c = 385,      /* c_style_cast_expr_c  */
  YYSYMBOL_386_4 = 386,                    /* $@4  */
  YYSYMBOL_new_style_cast_expr_c = 387,    /* new_style_cast_expr_c  */
  YYSYMBOL_388_5 = 388,                    /* $@5  */
  YYSYMBOL_new_style_cast_c = 389,         /* new_style_cast_c  */
  YYSYMBOL_aligned_declaration_c = 390,    /* aligned_declaration_c  */
  YYSYMBOL_391_6 = 391,                    /* $@6  */
  YYSYMBOL_392_7 = 392,                    /* $@7  */
  YYSYMBOL_alignas_specifier_c = 393,      /* alignas_specifier_c  */
  YYSYMBOL_394_8 = 394,                    /* $@8  */
  YYSYMBOL_alignas = 395,                  /* alignas  */
  YYSYMBOL_asm_declaration_c = 396,        /* asm_declaration_c  */
  YYSYMBOL_scoped_declaration_c = 397,     /* scoped_declaration_c  */
  YYSYMBOL_class_struct_union_declaration_c = 398, /* class_struct_union_declaration_c  */
  YYSYMBOL_399_9 = 399,                    /* $@9  */
  YYSYMBOL_400_10 = 400,                   /* $@10  */
  YYSYMBOL_enum_declaration_c = 401,       /* enum_declaration_c  */
  YYSYMBOL_402_11 = 402,                   /* $@11  */
  YYSYMBOL_namespace_declaration_c = 403,  /* namespace_declaration_c  */
  YYSYMBOL_404_12 = 404,                   /* $@12  */
  YYSYMBOL_405_13 = 405,                   /* $@13  */
  YYSYMBOL_namespace_sname_c_exp = 406,    /* namespace_sname_c_exp  */
  YYSYMBOL_namespace_sname_c = 407,        /* namespace_sname_c  */
  YYSYMBOL_namespace_typedef_sname_c = 408, /* namespace_typedef_sname_c  */
  YYSYMBOL_brace_in_scope_declaration_c_exp = 409, /* brace_in_scope_declaration_c_exp  */
  YYSYMBOL_brace_in_scope_declaration_c_opt = 410, /* brace_in_scope_declaration_c_opt  */
  YYSYMBOL_brace_in_scope_declaration_c = 411, /* brace_in_scope_declaration_c  */
  YYSYMBOL_in_scope_declaration_c_exp = 412, /* in_scope_declaration_c_exp  */
  YYSYMBOL_lambda_declaration_c = 413,     /* lambda_declaration_c  */
  YYSYMBOL_capture_decl_list_c_opt = 414,  /* capture_decl_list_c_opt  */
  YYSYMBOL_capture_decl_list_c = 415,      /* capture_decl_list_c  */
  YYSYMBOL_capture_decl_c_ast = 416,       /* capture_decl_c_ast  */
  YYSYMBOL_lambda_return_type_c_ast_opt = 417, /* lambda_return_type_c_ast_opt  */
  YYSYMBOL_418_14 = 418,                   /* $@14  */
  YYSYMBOL_template_declaration_c = 419,   /* template_declaration_c  */
  YYSYMBOL_typed_declaration_c = 420,      /* typed_declaration_c  */
  YYSYMBOL_421_15 = 421,                   /* $@15  */
  YYSYMBOL_typedef_declaration_c = 422,    /* typedef_declaration_c  */
  YYSYMBOL_423_16 = 423,                   /* $@16  */
  YYSYMBOL_424_17 = 424,                   /* $@17  */
  YYSYMBOL_typedef_decl_list_c = 425,      /* typedef_decl_list_c  */
  YYSYMBOL_typedef_decl_c = 426,           /* typedef_decl_c  */
  YYSYMBOL_typedef_decl_c_exp = 427,       /* typedef_decl_c_exp  */
  YYSYMBOL_user_defined_conversion_declaration_c = 428, /* user_defined_conversion_declaration_c  */
  YYSYMBOL_using_declaration_c = 429,      /* using_declaration_c  */
  YYSYMBOL_using_decl_c_ast = 430,         /* using_decl_c_ast  */
  YYSYMBOL_431_18 = 431,                   /* $@18  */
  YYSYMBOL_432_19 = 432,                   /* $@19  */
  YYSYMBOL_decl_list_c_opt = 433,          /* decl_list_c_opt  */
  YYSYMBOL_decl_list_c = 434,              /* decl_list_c  */
  YYSYMBOL_decl_c = 435,                   /* decl_c  */
  YYSYMBOL_decl_c_exp = 436,               /* decl_c_exp  */
  YYSYMBOL_decl_c_astp = 437,              /* decl_c_astp  */
  YYSYMBOL_msc_calling_convention_c_astp = 438, /* msc_calling_convention_c_astp  */
  YYSYMBOL_decl2_c_astp = 439,             /* decl2_c_astp  */
  YYSYMBOL_param_pack_decl_c_ast = 440,    /* param_pack_decl_c_ast  */
  YYSYMBOL_array_decl_c_astp = 441,        /* array_decl_c_astp  */
  YYSYMBOL_array_size_c_ast = 442,         /* array_size_c_ast  */
  YYSYMBOL_block_decl_c_astp = 443,        /* block_decl_c_astp  */
  YYSYMBOL_444_20 = 444,                   /* $@20  */
  YYSYMBOL_destructor_declaration_c = 445, /* destructor_declaration_c  */
  YYSYMBOL_no_destructor_params = 446,     /* no_destructor_params  */
  YYSYMBOL_file_scope_constructor_declaration_c = 447, /* file_scope_constructor_declaration_c  */
  YYSYMBOL_file_scope_destructor_declaration_c = 448, /* file_scope_destructor_declaration_c  */
  YYSYMBOL_func_decl_c_astp = 449,         /* func_decl_c_astp  */
  YYSYMBOL_pc99_func_or_constructor_declaration_c = 450, /* pc99_func_or_constructor_declaration_c  */
  YYSYMBOL_451_21 = 451,                   /* $@21  */
  YYSYMBOL_param_list_rparen_func_qualifier_list_c_stid_opt = 452, /* param_list_rparen_func_qualifier_list_c_stid_opt  */
  YYSYMBOL_453_22 = 453,                   /* $@22  */
  YYSYMBOL_func_qualifier_list_c_stid_opt = 454, /* func_qualifier_list_c_stid_opt  */
  YYSYMBOL_func_qualifier_c_stid = 455,    /* func_qualifier_c_stid  */
  YYSYMBOL_noexcept_c_stid_opt = 456,      /* noexcept_c_stid_opt  */
  YYSYMBOL_noexcept_bool_stid_exp = 457,   /* noexcept_bool_stid_exp  */
  YYSYMBOL_trailing_return_type_c_ast_opt = 458, /* trailing_return_type_c_ast_opt  */
  YYSYMBOL_459_23 = 459,                   /* $@23  */
  YYSYMBOL_func_equals_c_stid_opt = 460,   /* func_equals_c_stid_opt  */
  YYSYMBOL_param_c_ast_list_exp = 461,     /* param_c_ast_list_exp  */
  YYSYMBOL_param_c_ast_list_opt = 462,     /* param_c_ast_list_opt  */
  YYSYMBOL_param_c_ast_list = 463,         /* param_c_ast_list  */
  YYSYMBOL_param_c_ast = 464,              /* param_c_ast  */
  YYSYMBOL_465_24 = 465,                   /* $@24  */
  YYSYMBOL_param_c_ast_exp = 466,          /* param_c_ast_exp  */
  YYSYMBOL_paren_param_c_ast_list_opt = 467, /* paren_param_c_ast_list_opt  */
  YYSYMBOL_param_list_c_lparen = 468,      /* param_list_c_lparen  */
  YYSYMBOL_param_list_rparen = 469,        /* param_list_rparen  */
  YYSYMBOL_nested_decl_c_astp = 470,       /* nested_decl_c_astp  */
  YYSYMBOL_471_25 = 471,                   /* $@25  */
  YYSYMBOL_oper_decl_c_astp = 472,         /* oper_decl_c_astp  */
  YYSYMBOL_pointer_decl_c_astp = 473,      /* pointer_decl_c_astp  */
  YYSYMBOL_474_26 = 474,                   /* $@26  */
  YYSYMBOL_pointer_type_c_ast = 475,       /* pointer_type_c_ast  */
  YYSYMBOL_pc99_pointer_decl_list_c = 476, /* pc99_pointer_decl_list_c  */
  YYSYMBOL_pc99_pointer_decl_c = 477,      /* pc99_pointer_decl_c  */
  YYSYMBOL_478_27 = 478,                   /* $@27  */
  YYSYMBOL_pc99_pointer_type_c_ast = 479,  /* pc99_pointer_type_c_ast  */
  YYSYMBOL_pointer_to_member_decl_c_astp = 480, /* pointer_to_member_decl_c_astp  */
  YYSYMBOL_481_28 = 481,                   /* $@28  */
  YYSYMBOL_pointer_to_member_type_c_ast = 482, /* pointer_to_member_type_c_ast  */
  YYSYMBOL_reference_decl_c_astp = 483,    /* reference_decl_c_astp  */
  YYSYMBOL_484_29 = 484,                   /* $@29  */
  YYSYMBOL_reference_type_c_ast = 485,     /* reference_type_c_ast  */
  YYSYMBOL_typedef_type_decl_c_ast = 486,  /* typedef_type_decl_c_ast  */
  YYSYMBOL_user_defined_conversion_decl_c_astp = 487, /* user_defined_conversion_decl_c_astp  */
  YYSYMBOL_488_30 = 488,                   /* $@30  */
  YYSYMBOL_user_defined_literal_decl_c_astp = 489, /* user_defined_literal_decl_c_astp  */
  YYSYMBOL_cast_c_astp_opt = 490,          /* cast_c_astp_opt  */
  YYSYMBOL_cast_c_astp = 491,              /* cast_c_astp  */
  YYSYMBOL_cast2_c_astp = 492,             /* cast2_c_astp  */
  YYSYMBOL_param_pack_cast_c_ast = 493,    /* param_pack_cast_c_ast  */
  YYSYMBOL_array_cast_c_astp = 494,        /* array_cast_c_astp  */
  YYSYMBOL_block_cast_c_astp = 495,        /* block_cast_c_astp  */
  YYSYMBOL_496_31 = 496,                   /* $@31  */
  YYSYMBOL_func_cast_c_astp = 497,         /* func_cast_c_astp  */
  YYSYMBOL_nested_cast_c_astp = 498,       /* nested_cast_c_astp  */
  YYSYMBOL_499_32 = 499,                   /* $@32  */
  YYSYMBOL_pointer_cast_c_astp = 500,      /* pointer_cast_c_astp  */
  YYSYMBOL_501_33 = 501,                   /* $@33  */
  YYSYMBOL_pointer_to_member_cast_c_astp = 502, /* pointer_to_member_cast_c_astp  */
  YYSYMBOL_503_34 = 503,                   /* $@34  */
  YYSYMBOL_reference_cast_c_astp = 504,    /* reference_cast_c_astp  */
  YYSYMBOL_505_35 = 505,                   /* $@35  */
  YYSYMBOL_udc_decl_c_ast_opt = 506,       /* udc_decl_c_ast_opt  */
  YYSYMBOL_udc_decl_c_ast = 507,           /* udc_decl_c_ast  */
  YYSYMBOL_pointer_udc_decl_c_ast = 508,   /* pointer_udc_decl_c_ast  */
  YYSYMBOL_509_36 = 509,                   /* $@36  */
  YYSYMBOL_pointer_to_member_udc_decl_c_ast = 510, /* pointer_to_member_udc_decl_c_ast  */
  YYSYMBOL_511_37 = 511,                   /* $@37  */
  YYSYMBOL_reference_udc_decl_c_ast = 512, /* reference_udc_decl_c_ast  */
  YYSYMBOL_513_38 = 513,                   /* $@38  */
  YYSYMBOL_type_c_ast = 514,               /* type_c_ast  */
  YYSYMBOL_type_modifier_list_c_type_opt = 515, /* type_modifier_list_c_type_opt  */
  YYSYMBOL_type_modifier_list_c_type = 516, /* type_modifier_list_c_type  */
  YYSYMBOL_type_modifier_c_type = 517,     /* type_modifier_c_type  */
  YYSYMBOL_type_modifier_base_type = 518,  /* type_modifier_base_type  */
  YYSYMBOL_east_modified_type_c_ast = 519, /* east_modified_type_c_ast  */
  YYSYMBOL_east_modifiable_type_c_ast = 520, /* east_modifiable_type_c_ast  */
  YYSYMBOL_atomic_specifier_type_c_ast = 521, /* atomic_specifier_type_c_ast  */
  YYSYMBOL_522_39 = 522,                   /* $@39  */
  YYSYMBOL_builtin_type_c_ast = 523,       /* builtin_type_c_ast  */
  YYSYMBOL_builtin_no_BitInt_c_btid = 524, /* builtin_no_BitInt_c_btid  */
  YYSYMBOL_concept_type_c_ast = 525,       /* concept_type_c_ast  */
  YYSYMBOL_structured_binding_type_c_ast = 526, /* structured_binding_type_c_ast  */
  YYSYMBOL_typedef_type_c_ast = 527,       /* typedef_type_c_ast  */
  YYSYMBOL_sub_scope_sname_c_opt = 528,    /* sub_scope_sname_c_opt  */
  YYSYMBOL_typeof_type_c_ast = 529,        /* typeof_type_c_ast  */
  YYSYMBOL_530_40 = 530,                   /* $@40  */
  YYSYMBOL_typeof = 531,                   /* typeof  */
  YYSYMBOL_enum_class_struct_union_c_ast = 532, /* enum_class_struct_union_c_ast  */
  YYSYMBOL_class_struct_union_c_ast = 533, /* class_struct_union_c_ast  */
  YYSYMBOL_enum_c_ast = 534,               /* enum_c_ast  */
  YYSYMBOL_enum_btids = 535,               /* enum_btids  */
  YYSYMBOL_enum_fixed_type_c_ast_opt = 536, /* enum_fixed_type_c_ast_opt  */
  YYSYMBOL_enum_fixed_type_c_ast = 537,    /* enum_fixed_type_c_ast  */
  YYSYMBOL_enum_fixed_type_modifier_list_btid_opt = 538, /* enum_fixed_type_modifier_list_btid_opt  */
  YYSYMBOL_enum_fixed_type_modifier_list_btid = 539, /* enum_fixed_type_modifier_list_btid  */
  YYSYMBOL_enum_fixed_type_modifier_btid = 540, /* enum_fixed_type_modifier_btid  */
  YYSYMBOL_enum_unmodified_fixed_type_c_ast = 541, /* enum_unmodified_fixed_type_c_ast  */
  YYSYMBOL_class_struct_btid_opt = 542,    /* class_struct_btid_opt  */
  YYSYMBOL_class_struct_btid = 543,        /* class_struct_btid  */
  YYSYMBOL_class_struct_union_btid = 544,  /* class_struct_union_btid  */
  YYSYMBOL_type_qualifier_list_c_stid_opt = 545, /* type_qualifier_list_c_stid_opt  */
  YYSYMBOL_type_qualifier_list_c_stid = 546, /* type_qualifier_list_c_stid  */
  YYSYMBOL_type_qualifier_c_stid = 547,    /* type_qualifier_c_stid  */
  YYSYMBOL_cv_qualifier_stid = 548,        /* cv_qualifier_stid  */
  YYSYMBOL_cv_qualifier_list_stid_opt = 549, /* cv_qualifier_list_stid_opt  */
  YYSYMBOL_restrict_qualifier_c_stid = 550, /* restrict_qualifier_c_stid  */
  YYSYMBOL_upc_layout_qualifier_c = 551,   /* upc_layout_qualifier_c  */
  YYSYMBOL_storage_class_c_type = 552,     /* storage_class_c_type  */
  YYSYMBOL__Noreturn_atid = 553,           /* _Noreturn_atid  */
  YYSYMBOL_attribute_specifier_list_c_atid_opt = 554, /* attribute_specifier_list_c_atid_opt  */
  YYSYMBOL_attribute_specifier_list_c_atid = 555, /* attribute_specifier_list_c_atid  */
  YYSYMBOL_556_41 = 556,                   /* $@41  */
  YYSYMBOL_using_opt = 557,                /* using_opt  */
  YYSYMBOL_attribute_list_c_atid_opt = 558, /* attribute_list_c_atid_opt  */
  YYSYMBOL_attribute_list_c_atid = 559,    /* attribute_list_c_atid  */
  YYSYMBOL_attribute_c_atid_exp = 560,     /* attribute_c_atid_exp  */
  YYSYMBOL_attribute_str_arg_c_opt = 561,  /* attribute_str_arg_c_opt  */
  YYSYMBOL_gnu_or_msc_attribute_specifier_list_c_opt = 562, /* gnu_or_msc_attribute_specifier_list_c_opt  */
  YYSYMBOL_gnu_or_msc_attribute_specifier_list_c = 563, /* gnu_or_msc_attribute_specifier_list_c  */
  YYSYMBOL_gnu_attribute_specifier_list_c_opt = 564, /* gnu_attribute_specifier_list_c_opt  */
  YYSYMBOL_gnu_attribute_specifier_list_c = 565, /* gnu_attribute_specifier_list_c  */
  YYSYMBOL_gnu_attribute_specifier_c = 566, /* gnu_attribute_specifier_c  */
  YYSYMBOL_567_42 = 567,                   /* $@42  */
  YYSYMBOL_gnu_attribute_list_c_opt = 568, /* gnu_attribute_list_c_opt  */
  YYSYMBOL_gnu_attribuet_list_c = 569,     /* gnu_attribuet_list_c  */
  YYSYMBOL_gnu_attribute_c_exp = 570,      /* gnu_attribute_c_exp  */
  YYSYMBOL_gnu_attribute_decl_arg_list_c_opt = 571, /* gnu_attribute_decl_arg_list_c_opt  */
  YYSYMBOL_gnu_attribute_arg_list_c_opt = 572, /* gnu_attribute_arg_list_c_opt  */
  YYSYMBOL_gnu_attribute_arg_list_c = 573, /* gnu_attribute_arg_list_c  */
  YYSYMBOL_gnu_attribute_arg_c = 574,      /* gnu_attribute_arg_c  */
  YYSYMBOL_msc_attribute_specifier_list_c = 575, /* msc_attribute_specifier_list_c  */
  YYSYMBOL_msc_attribute_specifier_c = 576, /* msc_attribute_specifier_c  */
  YYSYMBOL_577_43 = 577,                   /* $@43  */
  YYSYMBOL_msc_attribute_list_c_opt = 578, /* msc_attribute_list_c_opt  */
  YYSYMBOL_msc_attribuet_list_c = 579,     /* msc_attribuet_list_c  */
  YYSYMBOL_decl_english_ast = 580,         /* decl_english_ast  */
  YYSYMBOL_array_decl_english_ast = 581,   /* array_decl_english_ast  */
  YYSYMBOL_array_size_decl_ast = 582,      /* array_size_decl_ast  */
  YYSYMBOL_length_opt = 583,               /* length_opt  */
  YYSYMBOL_block_decl_english_ast = 584,   /* block_decl_english_ast  */
  YYSYMBOL_constructor_decl_english_ast = 585, /* constructor_decl_english_ast  */
  YYSYMBOL_destructor_decl_english_ast = 586, /* destructor_decl_english_ast  */
  YYSYMBOL_destructor_parens_opt = 587,    /* destructor_parens_opt  */
  YYSYMBOL_func_decl_english_ast = 588,    /* func_decl_english_ast  */
  YYSYMBOL_func_qualifier_english_type_opt = 589, /* func_qualifier_english_type_opt  */
  YYSYMBOL_msc_calling_convention_atid = 590, /* msc_calling_convention_atid  */
  YYSYMBOL_paren_param_decl_list_english_opt = 591, /* paren_param_decl_list_english_opt  */
  YYSYMBOL_paren_param_decl_list_english = 592, /* paren_param_decl_list_english  */
  YYSYMBOL_param_decl_list_english_opt = 593, /* param_decl_list_english_opt  */
  YYSYMBOL_param_decl_list_english = 594,  /* param_decl_list_english  */
  YYSYMBOL_decl_english_ast_exp = 595,     /* decl_english_ast_exp  */
  YYSYMBOL_ref_qualifier_english_stid_opt = 596, /* ref_qualifier_english_stid_opt  */
  YYSYMBOL_returning_english_ast_opt = 597, /* returning_english_ast_opt  */
  YYSYMBOL_returning_english_ast = 598,    /* returning_english_ast  */
  YYSYMBOL_qualified_decl_english_ast = 599, /* qualified_decl_english_ast  */
  YYSYMBOL_type_qualifier_list_english_type_opt = 600, /* type_qualifier_list_english_type_opt  */
  YYSYMBOL_type_qualifier_list_english_type = 601, /* type_qualifier_list_english_type  */
  YYSYMBOL_type_qualifier_english_type = 602, /* type_qualifier_english_type  */
  YYSYMBOL_attribute_english_atid = 603,   /* attribute_english_atid  */
  YYSYMBOL_storage_class_english_stid = 604, /* storage_class_english_stid  */
  YYSYMBOL_eval_expr_init_stid = 605,      /* eval_expr_init_stid  */
  YYSYMBOL_linkage_stid = 606,             /* linkage_stid  */
  YYSYMBOL_linkage_opt = 607,              /* linkage_opt  */
  YYSYMBOL_type_qualifier_english_stid = 608, /* type_qualifier_english_stid  */
  YYSYMBOL_upc_layout_qualifier_english = 609, /* upc_layout_qualifier_english  */
  YYSYMBOL_qualifiable_decl_english_ast = 610, /* qualifiable_decl_english_ast  */
  YYSYMBOL_pointer_decl_english_ast = 611, /* pointer_decl_english_ast  */
  YYSYMBOL_reference_decl_english_ast = 612, /* reference_decl_english_ast  */
  YYSYMBOL_reference_english_ast = 613,    /* reference_english_ast  */
  YYSYMBOL_structured_binding_decl_english_ast = 614, /* structured_binding_decl_english_ast  */
  YYSYMBOL_user_defined_literal_decl_english_ast = 615, /* user_defined_literal_decl_english_ast  */
  YYSYMBOL_var_decl_english_ast = 616,     /* var_decl_english_ast  */
  YYSYMBOL_type_english_ast = 617,         /* type_english_ast  */
  YYSYMBOL_type_modifier_list_english_type_opt = 618, /* type_modifier_list_english_type_opt  */
  YYSYMBOL_type_modifier_list_english_type = 619, /* type_modifier_list_english_type  */
  YYSYMBOL_type_modifier_english_type = 620, /* type_modifier_english_type  */
  YYSYMBOL_unmodified_type_english_ast = 621, /* unmodified_type_english_ast  */
  YYSYMBOL_builtin_type_english_ast = 622, /* builtin_type_english_ast  */
  YYSYMBOL_builtin_no_BitInt_english_btid = 623, /* builtin_no_BitInt_english_btid  */
  YYSYMBOL_BitInt_english_int = 624,       /* BitInt_english_int  */
  YYSYMBOL_BitInt_english = 625,           /* BitInt_english  */
  YYSYMBOL_concept_type_english_ast = 626, /* concept_type_english_ast  */
  YYSYMBOL_parameter_pack_english_ast = 627, /* parameter_pack_english_ast  */
  YYSYMBOL_pack_exp = 628,                 /* pack_exp  */
  YYSYMBOL_precise_opt = 629,              /* precise_opt  */
  YYSYMBOL_class_struct_union_english_ast = 630, /* class_struct_union_english_ast  */
  YYSYMBOL_enum_english_ast = 631,         /* enum_english_ast  */
  YYSYMBOL_of_type_enum_fixed_type_english_ast_opt = 632, /* of_type_enum_fixed_type_english_ast_opt  */
  YYSYMBOL_enum_fixed_type_english_ast = 633, /* enum_fixed_type_english_ast  */
  YYSYMBOL_enum_fixed_type_modifier_list_english_btid_opt = 634, /* enum_fixed_type_modifier_list_english_btid_opt  */
  YYSYMBOL_enum_fixed_type_modifier_list_english_btid = 635, /* enum_fixed_type_modifier_list_english_btid  */
  YYSYMBOL_enum_unmodified_fixed_type_english_ast = 636, /* enum_unmodified_fixed_type_english_ast  */
  YYSYMBOL_any_name = 637,                 /* any_name  */
  YYSYMBOL_any_name_exp = 638,             /* any_name_exp  */
  YYSYMBOL_any_sname_c = 639,              /* any_sname_c  */
  YYSYMBOL_any_sname_c_exp = 640,          /* any_sname_c_exp  */
  YYSYMBOL_any_sname_c_opt = 641,          /* any_sname_c_opt  */
  YYSYMBOL_any_typedef_tdef = 642,         /* any_typedef_tdef  */
  YYSYMBOL_name_ast = 643,                 /* name_ast  */
  YYSYMBOL_name_exp = 644,                 /* name_exp  */
  YYSYMBOL_name_cat = 645,                 /* name_cat  */
  YYSYMBOL_name_opt = 646,                 /* name_opt  */
  YYSYMBOL_oper_sname_c_opt = 647,         /* oper_sname_c_opt  */
  YYSYMBOL_sname_c = 648,                  /* sname_c  */
  YYSYMBOL_sname_c_ast = 649,              /* sname_c_ast  */
  YYSYMBOL_bit_field_c_uint_opt = 650,     /* bit_field_c_uint_opt  */
  YYSYMBOL_sname_c_exp = 651,              /* sname_c_exp  */
  YYSYMBOL_sname_c_opt = 652,              /* sname_c_opt  */
  YYSYMBOL_sname_english = 653,            /* sname_english  */
  YYSYMBOL_sname_english_ast = 654,        /* sname_english_ast  */
  YYSYMBOL_sname_english_exp = 655,        /* sname_english_exp  */
  YYSYMBOL_sname_english_opt = 656,        /* sname_english_opt  */
  YYSYMBOL_sname_list_c = 657,             /* sname_list_c  */
  YYSYMBOL_sname_list_english = 658,       /* sname_list_english  */
  YYSYMBOL_typedef_sname_c = 659,          /* typedef_sname_c  */
  YYSYMBOL_address_exp = 660,              /* address_exp  */
  YYSYMBOL_array_exp = 661,                /* array_exp  */
  YYSYMBOL_as_exp = 662,                   /* as_exp  */
  YYSYMBOL_as_into_to_exp = 663,           /* as_into_to_exp  */
  YYSYMBOL_as_or_to_opt = 664,             /* as_or_to_opt  */
  YYSYMBOL_auto_TYPE_exp = 665,            /* auto_TYPE_exp  */
  YYSYMBOL_binding_exp = 666,              /* binding_exp  */
  YYSYMBOL_bits_opt = 667,                 /* bits_opt  */
  YYSYMBOL_bytes_opt = 668,                /* bytes_opt  */
  YYSYMBOL_cast_exp = 669,                 /* cast_exp  */
  YYSYMBOL_char_exp = 670,                 /* char_exp  */
  YYSYMBOL_class_struct_union_btid_exp = 671, /* class_struct_union_btid_exp  */
  YYSYMBOL_colon_exp = 672,                /* colon_exp  */
  YYSYMBOL_comma_exp = 673,                /* comma_exp  */
  YYSYMBOL_conversion_exp = 674,           /* conversion_exp  */
  YYSYMBOL_c_operator = 675,               /* c_operator  */
  YYSYMBOL_default_exp = 676,              /* default_exp  */
  YYSYMBOL_defined_exp = 677,              /* defined_exp  */
  YYSYMBOL_dependency_exp = 678,           /* dependency_exp  */
  YYSYMBOL_destructor_sname = 679,         /* destructor_sname  */
  YYSYMBOL_empty_str_lit_exp = 680,        /* empty_str_lit_exp  */
  YYSYMBOL_equals_exp = 681,               /* equals_exp  */
  YYSYMBOL_extern_linkage_c_stid = 682,    /* extern_linkage_c_stid  */
  YYSYMBOL_extern_linkage_c_stid_opt = 683, /* extern_linkage_c_stid_opt  */
  YYSYMBOL_glob = 684,                     /* glob  */
  YYSYMBOL_glob_opt = 685,                 /* glob_opt  */
  YYSYMBOL_gt_exp = 686,                   /* gt_exp  */
  YYSYMBOL_inline_stid_opt = 687,          /* inline_stid_opt  */
  YYSYMBOL_int_exp = 688,                  /* int_exp  */
  YYSYMBOL_lbracket_exp = 689,             /* lbracket_exp  */
  YYSYMBOL_literal_exp = 690,              /* literal_exp  */
  YYSYMBOL_local_exp = 691,                /* local_exp  */
  YYSYMBOL_lparen_exp = 692,               /* lparen_exp  */
  YYSYMBOL_lt_exp = 693,                   /* lt_exp  */
  YYSYMBOL_member_or_non_member_opt = 694, /* member_or_non_member_opt  */
  YYSYMBOL_namespace_btid_exp = 695,       /* namespace_btid_exp  */
  YYSYMBOL_namespace_type = 696,           /* namespace_type  */
  YYSYMBOL_of_exp = 697,                   /* of_exp  */
  YYSYMBOL_of_scope_english = 698,         /* of_scope_english  */
  YYSYMBOL_of_scope_list_english = 699,    /* of_scope_list_english  */
  YYSYMBOL_of_scope_list_english_opt = 700, /* of_scope_list_english_opt  */
  YYSYMBOL_operator_exp = 701,             /* operator_exp  */
  YYSYMBOL_operator_opt = 702,             /* operator_opt  */
  YYSYMBOL_point_exp = 703,                /* point_exp  */
  YYSYMBOL_precision_opt = 704,            /* precision_opt  */
  YYSYMBOL_rbrace_exp = 705,               /* rbrace_exp  */
  YYSYMBOL_rbracket_exp = 706,             /* rbracket_exp  */
  YYSYMBOL_ref_qualifier_c_stid_opt = 707, /* ref_qualifier_c_stid_opt  */
  YYSYMBOL_reference_exp = 708,            /* reference_exp  */
  YYSYMBOL_returning = 709,                /* returning  */
  YYSYMBOL_returning_exp = 710,            /* returning_exp  */
  YYSYMBOL_rparen_exp = 711,               /* rparen_exp  */
  YYSYMBOL_scope_english_type = 712,       /* scope_english_type  */
  YYSYMBOL_scope_english_type_exp = 713,   /* scope_english_type_exp  */
  YYSYMBOL_semi_exp = 714,                 /* semi_exp  */
  YYSYMBOL_semi_opt = 715,                 /* semi_opt  */
  YYSYMBOL_semi_or_end = 716,              /* semi_or_end  */
  YYSYMBOL_static_stid_opt = 717,          /* static_stid_opt  */
  YYSYMBOL_str_lit = 718,                  /* str_lit  */
  YYSYMBOL_str_lit_exp = 719,              /* str_lit_exp  */
  YYSYMBOL_this_exp = 720,                 /* this_exp  */
  YYSYMBOL_this_stid_opt = 721,            /* this_stid_opt  */
  YYSYMBOL_to_exp = 722,                   /* to_exp  */
  YYSYMBOL_type_opt = 723,                 /* type_opt  */
  YYSYMBOL_typename_flag_opt = 724,        /* typename_flag_opt  */
  YYSYMBOL_uint_lit = 725,                 /* uint_lit  */
  YYSYMBOL_uint_lit_exp = 726,             /* uint_lit_exp  */
  YYSYMBOL_uint_lit_opt = 727,             /* uint_lit_opt  */
  YYSYMBOL_unused_exp = 728,               /* unused_exp  */
  YYSYMBOL_user_defined = 729,             /* user_defined  */
  YYSYMBOL_virtual_stid_exp = 730,         /* virtual_stid_exp  */
  YYSYMBOL_virtual_stid_opt = 731          /* virtual_stid_opt  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   6608

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  314
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  418
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1126
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1485

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   540


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    81,     2,   159,   310,    89,    79,     2,
      72,    73,    80,    91,   132,    90,    76,    88,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   293,   294,
      98,   114,    99,   313,   311,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    74,     2,    75,   108,     2,   312,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   295,   109,   296,    83,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    77,    78,    82,
      84,    85,    86,    87,    92,    93,    94,    95,    96,    97,
     100,   101,   102,   103,   104,   105,   106,   107,   110,   111,
     112,   113,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,  1997,  1997,  1998,  2007,  2008,  2009,  2010,  2011,  2012,
    2013,  2014,  2015,  2016,  2017,  2018,  2019,  2020,  2021,  2022,
    2041,  2063,  2087,  2088,  2089,  2090,  2091,  2100,  2210,  2209,
    2273,  2308,  2340,  2350,  2352,  2367,  2397,  2409,  2427,  2436,
    2437,  2438,  2442,  2443,  2447,  2454,  2458,  2462,  2470,  2471,
    2475,  2490,  2505,  2510,  2515,  2521,  2525,  2526,  2527,  2531,
    2545,  2546,  2564,  2565,  2586,  2587,  2588,  2592,  2593,  2594,
    2595,  2596,  2597,  2598,  2602,  2603,  2604,  2605,  2606,  2607,
    2608,  2609,  2610,  2611,  2612,  2613,  2614,  2615,  2616,  2617,
    2618,  2624,  2672,  2693,  2700,  2715,  2727,  2735,  2736,  2743,
    2744,  2748,  2753,  2762,  2763,  2771,  2776,  2788,  2808,  2827,
    2849,  2856,  2864,  2869,  2888,  2900,  2909,  2914,  2918,  2924,
    2933,  2937,  2941,  2945,  2949,  2953,  2957,  2964,  2965,  2969,
    2970,  2971,  2975,  2976,  2977,  2978,  2981,  2982,  2984,  2985,
    2986,  2987,  2988,  2989,  2990,  2991,  2992,  2993,  2994,  2995,
    2996,  2997,  2998,  2999,  3000,  3001,  3002,  3003,  3004,  3005,
    3006,  3007,  3008,  3009,  3010,  3011,  3012,  3013,  3014,  3015,
    3016,  3017,  3018,  3019,  3020,  3021,  3022,  3023,  3024,  3025,
    3030,  3034,  3048,  3054,  3058,  3064,  3073,  3074,  3086,  3091,
    3096,  3101,  3106,  3111,  3116,  3121,  3126,  3131,  3141,  3150,
    3160,  3160,  3175,  3180,  3203,  3210,  3217,  3235,  3234,  3253,
    3254,  3255,  3256,  3261,  3273,  3274,  3276,  3278,  3282,  3286,
    3290,  3294,  3298,  3302,  3306,  3310,  3314,  3318,  3322,  3326,
    3333,  3374,  3375,  3379,  3389,  3393,  3406,  3421,  3426,  3431,
    3442,  3443,  3447,  3453,  3462,  3473,  3477,  3481,  3485,  3489,
    3493,  3500,  3509,  3515,  3521,  3525,  3529,  3530,  3534,  3544,
    3545,  3546,  3556,  3566,  3576,  3588,  3600,  3605,  3633,  3642,
    3643,  3644,  3658,  3659,  3669,  3670,  3674,  3675,  3679,  3680,
    3685,  3688,  3689,  3695,  3701,  3707,  3718,  3717,  3754,  3765,
    3764,  3796,  3797,  3798,  3799,  3809,  3810,  3809,  3815,  3828,
    3841,  3841,  3859,  3866,  3867,  3873,  3883,  3884,  3885,  3893,
    3898,  3892,  3950,  3949,  3989,  3993,  3988,  4064,  4065,  4066,
    4079,  4093,  4109,  4124,  4143,  4157,  4174,  4191,  4195,  4196,
    4203,  4204,  4208,  4209,  4213,  4214,  4215,  4216,  4225,  4257,
    4258,  4262,  4278,  4293,  4298,  4304,  4309,  4314,  4319,  4327,
    4328,  4328,  4348,  4357,  4357,  4367,  4373,  4366,  4388,  4389,
    4394,  4458,  4459,  4468,  4484,  4495,  4516,  4494,  4586,  4644,
    4656,  4661,  4670,  4701,  4702,  4709,  4710,  4711,  4712,  4713,
    4722,  4723,  4727,  4728,  4729,  4730,  4731,  4732,  4733,  4737,
    4741,  4742,  4746,  4757,  4768,  4803,  4808,  4814,  4820,  4826,
    4834,  4842,  4848,  4857,  4866,  4877,  4876,  4929,  4979,  4980,
    5007,  5044,  5086,  5218,  5217,  5330,  5329,  5348,  5349,  5365,
    5366,  5367,  5375,  5379,  5380,  5381,  5385,  5389,  5405,  5406,
    5407,  5414,  5416,  5416,  5468,  5475,  5476,  5477,  5478,  5486,
    5498,  5499,  5507,  5508,  5512,  5525,  5543,  5542,  5577,  5582,
    5594,  5595,  5602,  5603,  5610,  5614,  5621,  5620,  5645,  5701,
    5701,  5721,  5741,  5746,  5754,  5754,  5774,  5814,  5814,  5834,
    5874,  5873,  5897,  5912,  5931,  6021,  6020,  6066,  6111,  6112,
    6116,  6117,  6118,  6119,  6123,  6124,  6125,  6126,  6128,  6129,
    6137,  6150,  6167,  6205,  6204,  6255,  6331,  6330,  6373,  6373,
    6395,  6395,  6418,  6418,  6447,  6448,  6452,  6453,  6454,  6455,
    6459,  6459,  6477,  6477,  6495,  6495,  6522,  6574,  6589,  6593,
    6594,  6598,  6612,  6616,  6640,  6641,  6642,  6649,  6650,  6651,
    6652,  6653,  6654,  6655,  6661,  6665,  6681,  6699,  6700,  6701,
    6702,  6703,  6704,  6711,  6710,  6758,  6769,  6784,  6785,  6786,
    6787,  6788,  6789,  6790,  6791,  6792,  6796,  6797,  6798,  6799,
    6800,  6801,  6807,  6825,  6847,  6909,  6910,  6920,  6919,  6963,
    6972,  6973,  6979,  6980,  6984,  7003,  7014,  7035,  7048,  7052,
    7053,  7054,  7070,  7088,  7114,  7133,  7134,  7138,  7154,  7158,
    7159,  7160,  7161,  7165,  7166,  7167,  7173,  7174,  7178,  7179,
    7183,  7184,  7190,  7191,  7195,  7210,  7215,  7222,  7223,  7224,
    7225,  7226,  7227,  7228,  7232,  7233,  7237,  7238,  7254,  7268,
    7272,  7273,  7274,  7275,  7284,  7285,  7286,  7287,  7288,  7289,
    7290,  7291,  7292,  7293,  7294,  7295,  7296,  7297,  7326,  7328,
    7329,  7330,  7331,  7332,  7336,  7337,  7343,  7344,  7349,  7348,
    7373,  7380,  7381,  7389,  7390,  7394,  7408,  7412,  7413,  7414,
    7415,  7416,  7417,  7418,  7419,  7420,  7451,  7458,  7459,  7467,
    7468,  7472,  7473,  7477,  7478,  7482,  7483,  7488,  7487,  7503,
    7504,  7508,  7509,  7513,  7517,  7524,  7525,  7529,  7530,  7534,
    7535,  7539,  7540,  7541,  7542,  7543,  7544,  7551,  7552,  7557,
    7556,  7569,  7570,  7581,  7582,  7590,  7591,  7592,  7598,  7613,
    7637,  7641,  7647,  7653,  7661,  7662,  7669,  7691,  7709,  7721,
    7722,  7729,  7756,  7760,  7767,  7768,  7769,  7770,  7771,  7772,
    7778,  7779,  7783,  7797,  7798,  7802,  7817,  7834,  7835,  7844,
    7845,  7846,  7853,  7864,  7868,  7879,  7888,  7908,  7909,  7913,
    7929,  7933,  7934,  7935,  7939,  7940,  7941,  7942,  7943,  7944,
    7945,  7946,  7947,  7948,  7949,  7950,  7951,  7952,  7956,  7957,
    7958,  7962,  7963,  7964,  7965,  7966,  7967,  7968,  7969,  7970,
    7974,  7975,  7976,  7977,  7978,  7979,  7980,  7981,  7983,  7984,
    7985,  7986,  7987,  7988,  7989,  7990,  7991,  7995,  7996,  7997,
    8008,  8028,  8029,  8033,  8034,  8035,  8036,  8037,  8038,  8039,
    8043,  8044,  8048,  8049,  8050,  8051,  8052,  8053,  8054,  8055,
    8056,  8066,  8085,  8111,  8124,  8144,  8149,  8158,  8167,  8208,
    8231,  8236,  8253,  8275,  8295,  8296,  8300,  8316,  8320,  8324,
    8325,  8326,  8327,  8328,  8329,  8333,  8345,  8360,  8361,  8362,
    8363,  8364,  8376,  8377,  8378,  8379,  8383,  8384,  8385,  8386,
    8387,  8388,  8389,  8390,  8394,  8398,  8402,  8406,  8413,  8414,
    8415,  8419,  8433,  8451,  8460,  8461,  8468,  8469,  8473,  8490,
    8511,  8512,  8519,  8537,  8552,  8553,  8557,  8573,  8577,  8578,
    8586,  8587,  8595,  8596,  8604,  8605,  8609,  8610,  8618,  8619,
    8623,  8624,  8628,  8642,  8643,  8651,  8656,  8660,  8661,  8665,
    8667,  8676,  8701,  8723,  8737,  8756,  8757,  8771,  8772,  8780,
    8781,  8785,  8804,  8840,  8841,  8849,  8850,  8854,  8869,  8885,
    8901,  8917,  8936,  8959,  8967,  8968,  8975,  8976,  8983,  9003,
    9010,  9011,  9012,  9013,  9020,  9021,  9022,  9026,  9027,  9034,
    9035,  9042,  9043,  9044,  9048,  9049,  9053,  9054,  9061,  9062,
    9069,  9070,  9077,  9078,  9085,  9086,  9093,  9094,  9101,  9102,
    9103,  9104,  9105,  9106,  9107,  9108,  9109,  9110,  9111,  9112,
    9113,  9114,  9115,  9116,  9117,  9118,  9119,  9120,  9121,  9122,
    9123,  9124,  9125,  9126,  9127,  9128,  9129,  9130,  9131,  9132,
    9133,  9134,  9135,  9136,  9137,  9138,  9139,  9140,  9141,  9142,
    9143,  9144,  9145,  9146,  9147,  9148,  9152,  9153,  9160,  9161,
    9168,  9169,  9176,  9177,  9185,  9200,  9201,  9208,  9209,  9216,
    9217,  9221,  9236,  9237,  9241,  9242,  9249,  9250,  9254,  9255,
    9262,  9263,  9270,  9271,  9278,  9279,  9286,  9287,  9294,  9295,
    9302,  9303,  9304,  9308,  9309,  9316,  9317,  9321,  9322,  9329,
    9352,  9363,  9367,  9368,  9372,  9373,  9380,  9381,  9385,  9386,
    9392,  9393,  9397,  9398,  9405,  9406,  9413,  9414,  9415,  9419,
    9420,  9427,  9428,  9432,  9433,  9440,  9441,  9448,  9449,  9450,
    9454,  9455,  9464,  9465,  9472,  9473,  9477,  9478,  9482,  9483,
    9487,  9488,  9496,  9497,  9505,  9506,  9513,  9514,  9518,  9519,
    9526,  9527,  9531,  9532,  9536,  9552,  9553,  9560,  9561,  9565,
    9566,  9573,  9574,  9578,  9579,  9586,  9587
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "Y_cast", "Y_constant",
  "Y_declare", "Y_define", "Y_dynamic", "Y_explain", "Y_no", "Y_quit",
  "Y_reinterpret", "Y_set", "Y_show", "Y_aligned", "Y_all", "Y_array",
  "Y_as", "Y_binding", "Y_bit", "Y_bit_precise", "Y_bits", "Y_by",
  "Y_bytes", "Y_capturing", "Y_commands", "Y_constructor", "Y_conversion",
  "Y_copy", "Y_defined", "Y_destructor", "Y_english", "Y_evaluation",
  "Y_expand", "Y_expression", "Y_floating", "Y_function",
  "Y_initialization", "Y_into", "Y_lambda", "Y_length", "Y_linkage",
  "Y_literal", "Y_macros", "Y_member", "Y_non_empty", "Y_non_member",
  "Y_of", "Y_options", "Y_point", "Y_pointer", "Y_precise", "Y_precision",
  "Y_predefined", "Y_pure", "Y_reference", "Y_returning", "Y_rvalue",
  "Y_scope", "Y_structured", "Y_to", "Y_user", "Y_user_defined",
  "Y_variable", "Y_wide", "Y_width",
  "Y_PREC_LESS_THAN_upc_layout_qualifier", "Y_COLON_COLON", "\"::\"",
  "Y_COLON_COLON_STAR", "\"++\"", "\"--\"", "'('", "')'", "'['", "']'",
  "'.'", "Y_MINUS_GREATER", "\"->\"", "'&'", "'*'", "'!'", "Y_sizeof",
  "'~'", "Y_DOT_STAR", "\".*\"", "Y_MINUS_GREATER_STAR", "\"->*\"", "'/'",
  "'%'", "'-'", "'+'", "Y_LESS_LESS", "\"<<\"", "Y_GREATER_GREATER",
  "\">>\"", "Y_LESS_EQUAL_GREATER", "\"<=>\"", "'<'", "'>'",
  "Y_LESS_EQUAL", "\"<=\"", "Y_GREATER_EQUAL", "\">=\"", "Y_EQUAL_EQUAL",
  "\"==\"", "Y_EXCLAM_EQUAL", "Y_bit_and", "'^'", "'|'", "Y_AMPER_AMPER",
  "Y_PIPE_PIPE", "Y_QMARK_COLON", "\"?:\"", "'='", "Y_PERCENT_EQUAL",
  "\"%=\"", "Y_AMPER_EQUAL", "Y_STAR_EQUAL", "\"*=\"", "Y_PLUS_EQUAL",
  "\"+=\"", "Y_MINUS_EQUAL", "\"-=\"", "Y_SLASH_EQUAL", "\"/=\"",
  "Y_LESS_LESS_EQUAL", "\"<<=\"", "Y_GREATER_GREATER_EQUAL", "\">>=\"",
  "Y_CARET_EQUAL", "Y_PIPE_EQUAL", "','", "Y_auto_STORAGE", "Y_break",
  "Y_case", "Y_char", "Y_continue", "Y_default", "Y_do", "Y_double",
  "Y_else", "Y_extern", "Y_float", "Y_for", "Y_goto", "Y_if", "Y_int",
  "Y_long", "Y_register", "Y_return", "Y_short", "Y_static", "Y_struct",
  "Y_switch", "Y_typedef", "Y_union", "Y_unsigned", "Y_while", "'#'",
  "\"##\"", "Y_PRE_SPACE", "Y_PRE_define", "Y_PRE_elif", "Y_PRE_else",
  "Y_PRE_error", "Y_PRE_if", "Y_PRE_ifdef", "Y_PRE_ifndef", "Y_PRE_line",
  "Y_PRE_undef", "Y_PRE___VA_ARGS__", "Y_PRE___VA_OPT__", "Y_PRE_pragma",
  "Y_PRE_elifdef", "Y_PRE_elifndef", "Y_PRE_embed", "Y_PRE_warning",
  "Y_asm", "Y_const", "\"...\"", "Y_enum", "Y_signed", "Y_void",
  "Y_volatile", "Y_wchar_t", "Y__Bool", "Y__Complex", "Y__Imaginary",
  "Y_inline", "Y_restrict", "Y__Alignas", "Y__Alignof", "Y__Atomic_QUAL",
  "Y__Atomic_SPEC", "Y__Generic", "Y__Noreturn", "Y__Static_assert",
  "Y__Thread_local", "Y_thread", "Y_local", "Y_bool", "Y_catch", "Y_class",
  "Y_const_cast", "Y_CONSTRUCTOR_SNAME", "Y_delete", "Y_DESTRUCTOR_SNAME",
  "Y_dynamic_cast", "Y_explicit", "Y_false", "Y_friend", "Y_mutable",
  "Y_namespace", "Y_new", "Y_operator", "Y_OPERATOR_SNAME", "Y_private",
  "Y_protected", "Y_public", "Y_reinterpret_cast", "Y_static_cast",
  "Y_template", "Y_this", "Y_throw", "Y_true", "Y_try", "Y_typeid",
  "Y_typename", "Y_using", "Y_virtual", "Y_char16_t", "Y_char32_t",
  "Y__BitInt", "Y_reproducible", "Y_typeof", "Y_typeof_unqual",
  "Y_unsequenced", "Y_ATTR_BEGIN", "Y_auto_TYPE", "Y_alignas", "Y_alignof",
  "Y_carries", "Y_dependency", "Y_carries_dependency", "Y_constexpr",
  "Y_decltype", "Y_except", "Y_final", "Y_noexcept", "Y_nullptr",
  "Y_override", "Y_static_assert", "Y_thread_local", "Y_deprecated",
  "Y_auto_STRUCTURED_BINDING", "Y_discard", "Y_maybe_unused", "Y_maybe",
  "Y_unused", "Y_nodiscard", "Y_noreturn", "Y_char8_t", "Y_concept",
  "Y_consteval", "Y_constinit", "Y_co_await", "Y_co_return", "Y_co_yield",
  "Y_export", "Y_no_unique_address", "Y_parameter", "Y_pack", "Y_requires",
  "Y_unique", "Y_address", "Y_EMC__Accum", "Y_EMC__Fract", "Y_EMC__Sat",
  "Y_UPC_relaxed", "Y_UPC_shared", "Y_UPC_strict", "Y_GNU___attribute__",
  "Y_GNU___restrict", "Y_Apple___block", "Y_Apple_block", "Y_MSC___cdecl",
  "Y_MSC___clrcall", "Y_MSC___declspec", "Y_MSC___fastcall",
  "Y_MSC___stdcall", "Y_MSC___thiscall", "Y_MSC___vectorcall", "':'",
  "';'", "'{'", "'}'", "Y_CHAR_LIT", "Y_CONCEPT_SNAME", "Y_END", "Y_ERROR",
  "Y_FLOAT_LIT", "Y_GLOB", "Y_INT_LIT", "Y_NAME", "Y_SET_OPTION",
  "Y_STR_LIT", "Y_TYPEDEF_NAME_TDEF", "Y_TYPEDEF_SNAME_TDEF",
  "Y_LEXER_ERROR", "'$'", "'@'", "'`'", "'?'", "$accept", "command_list",
  "command", "cast_command", "new_style_cast_english", "declare_command",
  "$@1", "alignas_or_width_decl_english_ast", "alignas_specifier_english",
  "aligned_english", "capturing_paren_capture_decl_list_english_opt",
  "paren_capture_decl_list_english", "capture_decl_list_english_opt",
  "capture_decl_list_english", "capture_decl_english_ast",
  "capture_default_opt", "width_specifier_english_uint",
  "storage_class_subset_english_type_opt",
  "storage_class_subset_english_type", "storage_class_subset_english_stid",
  "define_command", "expand_command", "expand_command2",
  "p_extra_token_except_lparen", "p_extra_tokens_opt", "p_extra_tokens",
  "p_extra_token", "p_arg_list_opt", "p_comma_arg_list", "p_arg_list",
  "p_arg_tokens", "p_arg_token_as_list", "p_arg_token", "p_num_lit",
  "p_other", "p_punctuator", "p_arg_tokens_with_comma_opt",
  "p_arg_tokens_with_comma", "p_arg_token_with_comma_as_list",
  "p_arg_token_with_comma", "explain_command", "$@2", "explain",
  "help_command", "$@3", "help_what_opt", "preprocessor_command",
  "p_define", "p_paren_param_list_opt", "p_param_list_opt", "p_param_list",
  "p_param", "p_replace_list_opt", "p_replace_list", "p_replace_token",
  "p_undef", "quit_command", "scoped_command", "set_command",
  "set_option_list", "set_option", "set_option_value_opt", "show_command",
  "show_format", "show_format_exp", "show_format_opt", "show_types_opt",
  "predefined_or_user_types_opt", "template_command", "typedef_command",
  "using_command", "c_style_cast_expr_c", "$@4", "new_style_cast_expr_c",
  "$@5", "new_style_cast_c", "aligned_declaration_c", "$@6", "$@7",
  "alignas_specifier_c", "$@8", "alignas", "asm_declaration_c",
  "scoped_declaration_c", "class_struct_union_declaration_c", "$@9",
  "$@10", "enum_declaration_c", "$@11", "namespace_declaration_c", "$@12",
  "$@13", "namespace_sname_c_exp", "namespace_sname_c",
  "namespace_typedef_sname_c", "brace_in_scope_declaration_c_exp",
  "brace_in_scope_declaration_c_opt", "brace_in_scope_declaration_c",
  "in_scope_declaration_c_exp", "lambda_declaration_c",
  "capture_decl_list_c_opt", "capture_decl_list_c", "capture_decl_c_ast",
  "lambda_return_type_c_ast_opt", "$@14", "template_declaration_c",
  "typed_declaration_c", "$@15", "typedef_declaration_c", "$@16", "$@17",
  "typedef_decl_list_c", "typedef_decl_c", "typedef_decl_c_exp",
  "user_defined_conversion_declaration_c", "using_declaration_c",
  "using_decl_c_ast", "$@18", "$@19", "decl_list_c_opt", "decl_list_c",
  "decl_c", "decl_c_exp", "decl_c_astp", "msc_calling_convention_c_astp",
  "decl2_c_astp", "param_pack_decl_c_ast", "array_decl_c_astp",
  "array_size_c_ast", "block_decl_c_astp", "$@20",
  "destructor_declaration_c", "no_destructor_params",
  "file_scope_constructor_declaration_c",
  "file_scope_destructor_declaration_c", "func_decl_c_astp",
  "pc99_func_or_constructor_declaration_c", "$@21",
  "param_list_rparen_func_qualifier_list_c_stid_opt", "$@22",
  "func_qualifier_list_c_stid_opt", "func_qualifier_c_stid",
  "noexcept_c_stid_opt", "noexcept_bool_stid_exp",
  "trailing_return_type_c_ast_opt", "$@23", "func_equals_c_stid_opt",
  "param_c_ast_list_exp", "param_c_ast_list_opt", "param_c_ast_list",
  "param_c_ast", "$@24", "param_c_ast_exp", "paren_param_c_ast_list_opt",
  "param_list_c_lparen", "param_list_rparen", "nested_decl_c_astp", "$@25",
  "oper_decl_c_astp", "pointer_decl_c_astp", "$@26", "pointer_type_c_ast",
  "pc99_pointer_decl_list_c", "pc99_pointer_decl_c", "$@27",
  "pc99_pointer_type_c_ast", "pointer_to_member_decl_c_astp", "$@28",
  "pointer_to_member_type_c_ast", "reference_decl_c_astp", "$@29",
  "reference_type_c_ast", "typedef_type_decl_c_ast",
  "user_defined_conversion_decl_c_astp", "$@30",
  "user_defined_literal_decl_c_astp", "cast_c_astp_opt", "cast_c_astp",
  "cast2_c_astp", "param_pack_cast_c_ast", "array_cast_c_astp",
  "block_cast_c_astp", "$@31", "func_cast_c_astp", "nested_cast_c_astp",
  "$@32", "pointer_cast_c_astp", "$@33", "pointer_to_member_cast_c_astp",
  "$@34", "reference_cast_c_astp", "$@35", "udc_decl_c_ast_opt",
  "udc_decl_c_ast", "pointer_udc_decl_c_ast", "$@36",
  "pointer_to_member_udc_decl_c_ast", "$@37", "reference_udc_decl_c_ast",
  "$@38", "type_c_ast", "type_modifier_list_c_type_opt",
  "type_modifier_list_c_type", "type_modifier_c_type",
  "type_modifier_base_type", "east_modified_type_c_ast",
  "east_modifiable_type_c_ast", "atomic_specifier_type_c_ast", "$@39",
  "builtin_type_c_ast", "builtin_no_BitInt_c_btid", "concept_type_c_ast",
  "structured_binding_type_c_ast", "typedef_type_c_ast",
  "sub_scope_sname_c_opt", "typeof_type_c_ast", "$@40", "typeof",
  "enum_class_struct_union_c_ast", "class_struct_union_c_ast",
  "enum_c_ast", "enum_btids", "enum_fixed_type_c_ast_opt",
  "enum_fixed_type_c_ast", "enum_fixed_type_modifier_list_btid_opt",
  "enum_fixed_type_modifier_list_btid", "enum_fixed_type_modifier_btid",
  "enum_unmodified_fixed_type_c_ast", "class_struct_btid_opt",
  "class_struct_btid", "class_struct_union_btid",
  "type_qualifier_list_c_stid_opt", "type_qualifier_list_c_stid",
  "type_qualifier_c_stid", "cv_qualifier_stid",
  "cv_qualifier_list_stid_opt", "restrict_qualifier_c_stid",
  "upc_layout_qualifier_c", "storage_class_c_type", "_Noreturn_atid",
  "attribute_specifier_list_c_atid_opt", "attribute_specifier_list_c_atid",
  "$@41", "using_opt", "attribute_list_c_atid_opt",
  "attribute_list_c_atid", "attribute_c_atid_exp",
  "attribute_str_arg_c_opt", "gnu_or_msc_attribute_specifier_list_c_opt",
  "gnu_or_msc_attribute_specifier_list_c",
  "gnu_attribute_specifier_list_c_opt", "gnu_attribute_specifier_list_c",
  "gnu_attribute_specifier_c", "$@42", "gnu_attribute_list_c_opt",
  "gnu_attribuet_list_c", "gnu_attribute_c_exp",
  "gnu_attribute_decl_arg_list_c_opt", "gnu_attribute_arg_list_c_opt",
  "gnu_attribute_arg_list_c", "gnu_attribute_arg_c",
  "msc_attribute_specifier_list_c", "msc_attribute_specifier_c", "$@43",
  "msc_attribute_list_c_opt", "msc_attribuet_list_c", "decl_english_ast",
  "array_decl_english_ast", "array_size_decl_ast", "length_opt",
  "block_decl_english_ast", "constructor_decl_english_ast",
  "destructor_decl_english_ast", "destructor_parens_opt",
  "func_decl_english_ast", "func_qualifier_english_type_opt",
  "msc_calling_convention_atid", "paren_param_decl_list_english_opt",
  "paren_param_decl_list_english", "param_decl_list_english_opt",
  "param_decl_list_english", "decl_english_ast_exp",
  "ref_qualifier_english_stid_opt", "returning_english_ast_opt",
  "returning_english_ast", "qualified_decl_english_ast",
  "type_qualifier_list_english_type_opt",
  "type_qualifier_list_english_type", "type_qualifier_english_type",
  "attribute_english_atid", "storage_class_english_stid",
  "eval_expr_init_stid", "linkage_stid", "linkage_opt",
  "type_qualifier_english_stid", "upc_layout_qualifier_english",
  "qualifiable_decl_english_ast", "pointer_decl_english_ast",
  "reference_decl_english_ast", "reference_english_ast",
  "structured_binding_decl_english_ast",
  "user_defined_literal_decl_english_ast", "var_decl_english_ast",
  "type_english_ast", "type_modifier_list_english_type_opt",
  "type_modifier_list_english_type", "type_modifier_english_type",
  "unmodified_type_english_ast", "builtin_type_english_ast",
  "builtin_no_BitInt_english_btid", "BitInt_english_int", "BitInt_english",
  "concept_type_english_ast", "parameter_pack_english_ast", "pack_exp",
  "precise_opt", "class_struct_union_english_ast", "enum_english_ast",
  "of_type_enum_fixed_type_english_ast_opt", "enum_fixed_type_english_ast",
  "enum_fixed_type_modifier_list_english_btid_opt",
  "enum_fixed_type_modifier_list_english_btid",
  "enum_unmodified_fixed_type_english_ast", "any_name", "any_name_exp",
  "any_sname_c", "any_sname_c_exp", "any_sname_c_opt", "any_typedef_tdef",
  "name_ast", "name_exp", "name_cat", "name_opt", "oper_sname_c_opt",
  "sname_c", "sname_c_ast", "bit_field_c_uint_opt", "sname_c_exp",
  "sname_c_opt", "sname_english", "sname_english_ast", "sname_english_exp",
  "sname_english_opt", "sname_list_c", "sname_list_english",
  "typedef_sname_c", "address_exp", "array_exp", "as_exp",
  "as_into_to_exp", "as_or_to_opt", "auto_TYPE_exp", "binding_exp",
  "bits_opt", "bytes_opt", "cast_exp", "char_exp",
  "class_struct_union_btid_exp", "colon_exp", "comma_exp",
  "conversion_exp", "c_operator", "default_exp", "defined_exp",
  "dependency_exp", "destructor_sname", "empty_str_lit_exp", "equals_exp",
  "extern_linkage_c_stid", "extern_linkage_c_stid_opt", "glob", "glob_opt",
  "gt_exp", "inline_stid_opt", "int_exp", "lbracket_exp", "literal_exp",
  "local_exp", "lparen_exp", "lt_exp", "member_or_non_member_opt",
  "namespace_btid_exp", "namespace_type", "of_exp", "of_scope_english",
  "of_scope_list_english", "of_scope_list_english_opt", "operator_exp",
  "operator_opt", "point_exp", "precision_opt", "rbrace_exp",
  "rbracket_exp", "ref_qualifier_c_stid_opt", "reference_exp", "returning",
  "returning_exp", "rparen_exp", "scope_english_type",
  "scope_english_type_exp", "semi_exp", "semi_opt", "semi_or_end",
  "static_stid_opt", "str_lit", "str_lit_exp", "this_exp", "this_stid_opt",
  "to_exp", "type_opt", "typename_flag_opt", "uint_lit", "uint_lit_exp",
  "uint_lit_opt", "unused_exp", "user_defined", "virtual_stid_exp",
  "virtual_stid_opt", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-1141)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1127)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
   -1141,  1116, -1141, -1141,   475,  3169,    75,   703, -1141, -1141,
     703,  -174,   886,    59,   703, -1141,   -78, -1141,  1369,   703,
      25,    87, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141,   228,    75,   228,   228,   228,   228,
    1712,   228,     0,   228, -1141,   228,   228,   228,   228,   228,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141,   508, -1141,   424,
   -1141,   174,   514, -1141, -1141, -1141, -1141,   487,   133, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141,   517,   555, -1141,
    4829, -1141,   144, -1141, -1141, -1141,   470, -1141, -1141, -1141,
   -1141,   533,  -174, -1141, -1141,   537, -1141, -1141, -1141,    19,
     461, -1141,  5312, -1141, -1141, -1141, -1141,   105, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141,   105, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,    65,
     109, -1141,   174, -1141, -1141, -1141, -1141, -1141,  5947,   360,
     686, -1141, -1141, -1141,  -111, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141,   184, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141,   -59, -1141, -1141, -1141,   184, -1141, -1141, -1141,
   -1141, -1141, -1141,   553, -1141,   583, -1141, -1141,   184, -1141,
   -1141,   599, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,   625,
   -1141, -1141, -1141, -1141, -1141,    64,   637, -1141, -1141,   125,
   -1141, -1141,   184, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141,   582, -1141, -1141, -1141,  6110, -1141, -1141,
   -1141,  6320, -1141, -1141, -1141, -1141, -1141, -1141, -1141,   184,
   -1141, -1141, -1141,   -95,   -95, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141,   438, -1141,   442, -1141,   671,   528,   424,   540,
     545,   295,   698, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141,    81,    81,    92,   489, -1141,   508, -1141,   546, -1141,
   -1141, -1141, -1141,  4411,   475, -1141, -1141, -1141, -1141, -1141,
   -1141,   133,   133,   162,   320,   506, -1141,    68,  -111, -1141,
   -1141, -1141, -1141, -1141,   245, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141,   182, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141,    70, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141,   444, -1141, -1141, -1141,    75,  4411,   508,
    4411,    53, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
     466,   111, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
    1360, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,  5451, -1141,
   -1141, -1141, -1141, -1141,  6110, -1141, -1141,   719, -1141, -1141,
   -1141, -1141, -1141,   -95, -1141,   106, -1141, -1141,   510,  4411,
   -1141, -1141,   487, -1141, -1141,   529,    86, -1141, -1141, -1141,
     722,   151, -1141, -1141,   917,   405,   917, -1141, -1141,   515,
   -1141, -1141, -1141,    48,  6110, -1141,  6110,   115, -1141,   569,
     102, -1141,   184,   184, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141,  6110,   -78,  3804,   945,   945,   999, -1141, -1141, -1141,
    6320,  3973,   477,    57, -1141,    57, -1141, -1141,   475, -1141,
    6110, -1141,   184, -1141, -1141,   184,    65, -1141, -1141,   543,
   -1141, -1141, -1141, -1141,   774,   778, -1141, -1141, -1141, -1141,
   -1141, -1141,    81, -1141, -1141, -1141,   162,   472, -1141,    68,
     191, -1141, -1141, -1141,  -111, -1141, -1141, -1141, -1141, -1141,
   -1141,   245, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,   126, -1141,
   -1141,   641, -1141, -1141, -1141, -1141,  5079,  4709, -1141, -1141,
   -1141, -1141, -1141, -1141,   629, -1141,   544, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,    56,   463,
      42,   779, -1141, -1141, -1141,   811, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141,   519, -1141, -1141,   237,
     470, -1141, -1141, -1141,   111, -1141, -1141, -1141, -1141, -1141,
    5562, -1141,   784,  5701,   729,  5812, -1141, -1141, -1141, -1141,
   -1141,  5451, -1141, -1141,    74,  5201,   168, -1141, -1141, -1141,
   -1141, -1141,   560, -1141, -1141, -1141, -1141,   637, -1141, -1141,
     360,   405, -1141, -1141, -1141, -1141, -1141, -1141,   487, -1141,
   -1141, -1141, -1141, -1141,   487,   633, -1141, -1141,   212,   791,
   -1141,   133,   133,   184,    80,   266, -1141, -1141,   796, -1141,
     711,   487,   772, -1141,   686, -1141,   107, -1141, -1141, -1141,
   -1141, -1141, -1141,   743, -1141, -1141,   720, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,   686, -1141,
   -1141, -1141,   588,   453,   815,   739,   670,   134,   438, -1141,
   -1141,   743, -1141, -1141,   595,   543,   598, -1141,   602, -1141,
   -1141,   266,   500,   184,  4122, -1141,   603,    55,   323,   417,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141,   811, -1141, -1141,
   -1141, -1141, -1141,    39,   779,   822,   157,   165,   218,   187,
     859,   779, -1141, -1141, -1141, -1141, -1141, -1141,   767, -1141,
   -1141, -1141, -1141, -1141,   157, -1141, -1141,  4564,  4445, -1141,
   -1141,  4411, -1141, -1141,   184, -1141, -1141, -1141, -1141,    42,
      42, -1141,   149,   142,   827,   143, -1141, -1141,  4255,    71,
   -1141, -1141, -1141, -1141, -1141,   685,   173,   115, -1141, -1141,
   -1141,  1998, -1141,  4709, -1141,  5562,   831,  5562, -1141, -1141,
    5451, -1141,   729,  5701, -1141, -1141,   945, -1141, -1141, -1141,
     832,   156, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141,  5201, -1141, -1141, -1141,  6110,   803,   608, -1141, -1141,
   -1141,   643, -1141,   637, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141,   266, -1141, -1141, -1141,   560, -1141,
     105,   578, -1141, -1141,   608, -1141, -1141, -1141,    82, -1141,
     841, -1141,   842,    90, -1141, -1141, -1141,   843,   158, -1141,
   -1141,  6110,   560,  6110, -1141,   560, -1141, -1141, -1141,   945,
   -1141, -1141,    84, -1141,  1065,  1224,   438,   266,   945,   945,
   -1141,   115, -1141, -1141,   720,   756, -1141,   838,  1495, -1141,
   -1141,   438,   560, -1141, -1141, -1141,   130,   843, -1141,   843,
     500, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
    6259, -1141,   692,   462, -1141, -1141, -1141, -1141, -1141,   105,
   -1141, -1141,   105, -1141, -1141, -1141, -1141, -1141,   167, -1141,
   -1141,   500, -1141, -1141, -1141,  2291, -1141, -1141,   185, -1141,
   -1141, -1141, -1141,   188,    71, -1141, -1141,   878,  4411,   868,
     122,   166,   124,   617,   869, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141,    75,    58, -1141,
   -1141, -1141,    81,    81, -1141, -1141, -1141, -1141,    52, -1141,
   -1141, -1141, -1141, -1141, -1141,  4255,   851,   855,   139, -1141,
   -1141,   105, -1141, -1141,    42, -1141,   853,   159, -1141, -1141,
   -1141, -1141,  2584, -1141,   508, -1141, -1141, -1141,   825, -1141,
     909,   909,   834,   861, -1141, -1141, -1141,  5701,  5812,   805,
   -1141, -1141, -1141,    94, -1141, -1141, -1141,   560, -1141,   560,
     560,   560, -1141,   608,   266,  4955,   843,   643,   129, -1141,
   -1141, -1141, -1141,   863, -1141,   863, -1141, -1141,   867,   161,
   -1141,   424,   424,   479,   865,   467, -1141,   163, -1141, -1141,
   -1141, -1141,   235, -1141,  3478, -1141,   153, -1141,   643,   686,
     487, -1141, -1141, -1141,   870,   686,   133,   873,  1886, -1141,
     133, -1141,   843, -1141, -1141,   945, -1141, -1141,   637,   105,
   -1141,   643, -1141, -1141, -1141,   184, -1141, -1141, -1141, -1141,
   -1141,   235,   235,   843, -1141,   692, -1141,   692, -1141, -1141,
   -1141,   654,   127,   127, -1141, -1141, -1141, -1141,  4411,   883,
   -1141,   167, -1141, -1141, -1141,   653, -1141,   779, -1141, -1141,
     122, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141,   687, -1141, -1141, -1141,   916, -1141,
   -1141,   115,   115,   825,   891, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141,  2877, -1141, -1141,   128, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141,   218,   767, -1141,  1094, -1141,   560,
     686,   643,   897,   897,   897,   424, -1141,   843,  6110, -1141,
   -1141, -1141, -1141, -1141, -1141,    48, -1141, -1141,   133,   440,
     608, -1141,   487,   110,   163, -1141, -1141, -1141, -1141, -1141,
     900,   480, -1141,   184,   903,   864, -1141, -1141, -1141, -1141,
     560, -1141, -1141,   184, -1141,   945, -1141, -1141,   379, -1141,
     133, -1141, -1141,   451, -1141,    97, -1141,   477,   266,   184,
   -1141,   130,   130,   130,   843,   438,   438,   235, -1141, -1141,
     108, -1141, -1141, -1141, -1141, -1141, -1141,   452, -1141,   167,
      71, -1141,    58,   828, -1141,   825,   487, -1141,    71, -1141,
   -1141, -1141, -1141, -1141,  4411, -1141,   221, -1141, -1141, -1141,
     897,   560, -1141,   235, -1141,   487, -1141, -1141,   424, -1141,
   -1141,   493, -1141,   163,  3309,   112,   132, -1141,   484,   897,
     113,   487,   133,   133, -1141,   133,   133,   235,   843,  3641,
   -1141, -1141, -1141,   235, -1141, -1141,   438, -1141, -1141, -1141,
   -1141, -1141,    75,  4411, -1141, -1141, -1141,   692, -1141, -1141,
   -1141, -1141, -1141, -1141,   779,   643,    15,   560, -1141,   502,
   -1141, -1141,   509, -1141, -1141, -1141, -1141,   487, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,   424,   487,
     184, -1141, -1141, -1141, -1141,    15,    97, -1141,   904,   527,
     864,   864,  4411, -1141, -1141, -1141,  4586,  2192,    71,   637,
    6110, -1141,   438,   897, -1141, -1141, -1141,   266,   864,   235,
     235, -1141, -1141, -1141,   508, -1141, -1141, -1141, -1141, -1141,
     266, -1141,   907, -1141,    15,    15,   843,   560,   438,   864,
   -1141, -1141, -1141, -1141, -1141
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       2,     0,     1,    19,   925,     0,     0,     0,   206,   252,
       0,   254,     0,     0,     0,   599,  1112,   601,     0,     0,
     596,     0,   598,   291,   292,  1055,   293,   294,   352,   365,
    1096,  1097,   207,     3,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    12,     0,     0,     0,     0,     0,
      26,   253,   306,   307,   308,   283,   284,   285,   364,   312,
     600,   309,   314,    18,   913,   900,   901,  1062,   933,   894,
     926,     0,   895,    32,   996,   984,   988,     0,     0,   992,
     990,   977,   981,   973,  1015,   993,   991,   994,   975,   987,
     983,   998,  1005,  1001,   997,  1004,  1000,  1007,  1003,   974,
    1010,  1012,   978,  1013,  1008,  1002,   976,   979,   982,   985,
     989,   995,   999,  1006,  1011,  1014,   986,   971,   969,   968,
     616,   930,     0,    28,   924,   923,     0,   957,   956,    23,
      24,   259,   255,   257,   268,   280,   278,   279,   267,  1032,
     274,    93,    94,    25,  1113,   355,   229,     0,   217,   220,
     222,   223,   224,   225,   226,     0,   227,   218,   219,   221,
     228,   215,   216,    22,   578,   597,  1054,  1053,  1056,     0,
       0,     4,     0,     5,     6,     7,     8,   205,     0,   339,
     602,   624,   551,   559,   631,   558,   557,   529,   534,   530,
     639,   640,   532,     0,   614,   531,   547,   615,   556,   549,
     527,   528,   635,   618,   303,   607,     0,   644,   641,   550,
     629,   634,   636,     0,   200,   643,   553,   554,     0,   570,
     571,     0,   548,   304,   627,   555,   633,   638,   642,   616,
     645,   552,   626,   628,   630,   560,   561,   533,   610,   611,
     613,   677,   619,   625,   699,     0,   913,   188,   189,     0,
     191,   295,     0,   192,   196,   199,   190,   202,   194,   193,
     195,   197,   198,   463,   464,   363,   353,   516,   522,   523,
     518,   519,   537,   538,   545,   539,   540,   541,   542,     0,
     616,   572,   573,   646,   646,   524,   608,   609,   525,   637,
     526,   650,   671,   676,   672,   698,   565,     0,   204,   632,
       0,     0,     0,     9,    10,    11,    13,    14,    15,    16,
      17,     0,     0,     0,     0,  1061,  1063,   921,     0,   943,
     940,   941,   942,   747,     0,  1086,  1085,   980,  1075,  1074,
    1009,     0,     0,     0,     0,    42,    80,     0,    72,    82,
      88,    76,   762,    85,     0,    70,    75,    77,    83,    87,
      89,   766,   767,    64,     0,   755,    68,    74,    79,    81,
      86,   756,   758,     0,   760,   763,    67,    69,    71,   765,
      65,    61,    63,     0,    62,   939,   938,     0,   747,  1062,
     747,     0,   258,   256,   281,   282,   277,   266,  1031,  1033,
     274,     0,   269,   270,   271,   275,   262,   157,   177,   172,
       0,    98,   147,   148,   139,   170,   135,   136,   132,   153,
     158,   171,   140,   134,   138,   137,   167,   163,   166,   143,
     145,   165,   162,   160,   161,   149,   151,   154,   175,   144,
     173,   155,   179,   176,   169,   178,   168,   164,   156,   174,
     187,   133,   123,   159,   141,   142,   150,   152,   120,   127,
     128,   121,   124,   129,   130,   131,   146,    92,    99,   186,
     122,   125,   126,    97,     0,   904,   903,   231,   251,   893,
     890,   891,   892,   646,   213,     0,   906,   208,   210,   747,
     635,   643,     0,   286,   632,   343,     0,   345,   347,   346,
       0,     0,   342,   466,   603,   669,     0,  1100,  1101,  1027,
     800,  1047,  1046,     0,     0,   910,     0,     0,   648,  1076,
       0,   612,     0,     0,   948,   947,   562,   454,   413,  1049,
    1048,     0,  1112,     0,   909,   909,   368,   521,   517,   535,
     520,     0,   536,     0,   647,     0,   675,   697,     0,   564,
       0,   203,     0,  1022,  1023,     0,     0,   897,   896,   579,
     310,   319,   323,   315,   317,   318,   327,  1091,  1089,  1087,
    1088,  1090,     0,  1060,   911,   912,     0,     0,   786,     0,
       0,  1121,   768,   774,   778,   788,   794,   831,   782,   803,
     791,     0,   775,   776,   781,   783,   789,   793,   795,   772,
     780,   785,   787,   792,   771,   773,   777,   806,   807,   809,
     769,  1062,   804,   805,    20,   705,   834,   748,   750,   751,
     752,   753,   706,   707,     0,   830,     0,   932,   931,   972,
     970,   797,   798,   799,    66,   761,    78,   759,     0,     0,
      48,   730,  1124,  1123,    90,   801,  1045,  1044,    84,  1021,
    1020,   754,  1120,  1119,   757,   617,     0,   929,    27,    33,
       0,    91,   261,   260,     0,   264,   273,   272,   263,   111,
     180,   113,     0,   107,   106,   115,   117,   118,   104,   103,
      95,   100,   102,   356,     0,   240,     0,   212,   211,   905,
      21,   288,   478,   344,  1105,  1104,   348,   452,   965,   964,
       0,   669,   606,   670,   605,  1028,  1103,  1102,     0,   543,
     201,  1116,  1114,  1115,     0,   651,  1077,  1078,     0,     0,
     620,     0,     0,     0,     0,  1106,   289,   296,     0,   300,
       0,     0,   456,   472,   602,   473,     0,   724,   725,   726,
     727,   728,   729,   462,   371,   372,   375,   387,   382,   383,
     384,   385,   386,   376,   459,   377,   467,   378,   602,   389,
     390,   391,   915,   909,     0,   565,     0,   915,   673,   465,
     354,   369,   569,   567,   896,   579,     0,   574,     0,   566,
     475,  1106,     0,     0,     0,   313,   330,     0,     0,     0,
    1059,   770,   784,   796,  1019,  1018,  1122,   801,   790,   811,
     808,   810,   922,   710,   730,   719,     0,   740,     0,     0,
     714,   730,   838,   812,   813,   814,   815,   816,  1050,   723,
     722,   746,   817,   818,     0,   819,   820,     0,   835,   837,
     749,   747,  1043,  1042,     0,   935,   934,   764,    47,    48,
      48,    43,    56,    56,     0,     0,    51,    55,   747,   742,
     731,   802,    73,   967,   966,  1066,   944,     0,    40,    41,
      34,     0,    35,   747,   265,   180,     0,   181,   183,   184,
      99,   112,   108,   110,   116,   101,   909,   239,   238,   237,
       0,     0,   236,   245,   246,   247,   248,   249,   250,   244,
     230,   241,   243,  1026,  1025,     0,   496,   490,   498,   500,
     502,     0,   479,   480,   488,   484,   485,   486,   487,   481,
     482,   483,   489,    60,  1106,   341,   604,   305,   478,   546,
       0,     0,  1041,  1040,     0,   623,   622,   621,     0,   684,
     685,   704,     0,     0,   449,  1107,   902,     0,     0,   445,
     448,     0,   478,     0,   302,   478,   299,   298,   405,   909,
     461,   393,   915,   392,     0,     0,   673,  1106,   909,   909,
     470,     0,   474,   379,     0,   380,   381,     0,     0,   914,
     388,   674,   478,   576,   577,   575,   504,     0,   409,     0,
       0,   581,   589,   590,   592,   591,   593,   594,   595,   580,
     582,   588,   585,     0,   311,   331,   329,   316,   328,     0,
     320,   321,     0,   325,   324,   779,   713,   712,     0,   711,
     717,     0,   718,  1109,  1108,     0,  1080,  1079,   741,   950,
     949,   827,   715,     0,   742,  1051,  1052,     0,   747,   876,
       0,     0,     0,  1117,  1070,   859,   858,   847,   856,   849,
     850,   853,   854,   868,   848,   855,   852,     0,     0,   862,
     863,   844,     0,     0,   832,   839,   845,   846,     0,   841,
     843,   840,   842,   836,   829,   747,     0,     0,     0,    58,
      52,     0,    53,    44,     0,   736,     0,     0,  1081,  1082,
      30,   743,     0,  1067,  1062,   945,   946,    39,   951,    38,
     954,   954,   739,     0,   119,   182,    96,   109,   114,   357,
     359,   360,   232,     0,   242,   366,   493,   478,   491,   478,
     478,   478,   492,   919,  1106,   349,     0,     0,     0,   666,
     663,   664,   657,   667,   659,   667,   661,   662,     0,     0,
     656,   665,   928,     0,     0,     0,   682,   687,   683,   700,
     703,   455,   423,   415,     0,   446,     0,   297,     0,   602,
       0,   374,   373,   370,  1075,   602,     0,     0,     0,   395,
       0,   394,     0,   460,   468,   909,   916,   616,     0,     0,
    1024,     0,   510,   512,   514,     0,   505,   506,   507,   508,
     509,   423,   423,     0,   587,   585,   584,   586,   337,   332,
     334,  1094,     0,     0,   322,   326,  1058,  1057,   747,     0,
     823,     0,   821,   937,   936,   907,   716,   730,   824,   877,
       0,  1039,  1038,   869,  1069,  1068,   860,   959,   958,   857,
    1118,   851,  1071,   861,   871,   875,   874,   873,   880,   878,
     867,     0,     0,   951,     0,    46,    45,  1017,  1016,    57,
      54,    50,   732,     0,   745,   744,     0,   952,   953,    59,
     955,    37,    36,   740,     0,  1050,   185,     0,   235,   478,
     602,     0,   499,   501,   503,   920,   287,     0,     0,   338,
     453,   544,   963,   962,   652,     0,   658,   660,     0,     0,
       0,   563,     0,     0,     0,   692,   693,   691,   694,   696,
       0,     0,   690,     0,   424,   435,   417,   451,   450,   444,
     478,  1035,  1034,     0,   301,   909,   457,   404,     0,   397,
       0,  1099,   398,     0,   396,  1076,   471,   469,  1106,     0,
     568,   504,   504,   504,     0,   673,   673,   423,   583,  1095,
       0,  1093,  1092,   335,   336,   708,   720,     0,   908,     0,
     742,   870,     0,  1110,   879,   951,     0,   864,   742,   738,
     737,   735,  1084,  1083,   747,   741,     0,   362,   361,   358,
     367,   478,   497,   423,   350,     0,   649,   655,   927,   678,
     681,     0,   686,     0,     0,     0,     0,   414,   416,   447,
       0,     0,     0,     0,   401,     0,     0,   423,     0,     0,
     511,   513,   515,   423,   410,   411,   673,  1073,  1072,   333,
     961,   960,     0,   747,   721,   872,  1111,   884,   866,   865,
     828,    31,  1065,  1064,   730,     0,   431,   478,   668,   965,
     695,   689,     0,   426,   430,   428,   429,     0,   439,   436,
     437,   438,   420,   421,   422,   418,   419,   918,   917,     0,
       0,   403,   402,   400,   399,   431,  1076,   441,     0,     0,
     435,   435,   747,   709,   887,   881,     0,   885,   742,     0,
       0,   495,   434,   351,   427,   425,   290,  1106,   435,   423,
     423,   476,   407,   822,  1062,   888,   882,   889,   886,    29,
    1106,   432,     0,   412,   431,   431,     0,   478,   673,   435,
     477,   494,   433,   406,   458
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141,   -67, -1141,   -82,   160, -1141,    83, -1141, -1141,
   -1141, -1141, -1141,   847,   131, -1141,   319, -1141,  -400,   331,
    -743,  -640,  -268, -1141, -1141, -1141,   140, -1141,   145,  -205,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141,   -96, -1141, -1141,   118, -1141, -1141, -1141, -1141, -1141,
     872, -1141, -1141,  -327,   352,   619, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141,   967, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141,    27, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141,   234, -1141, -1141,
   -1141, -1141,  -140, -1141, -1141,   972,  -479, -1141,    30, -1141,
   -1141, -1141,  -232, -1141, -1141,    33,   727, -1141, -1141, -1141,
     496,    79, -1141,  -506, -1141,   276, -1141, -1141,  -621, -1141,
   -1141, -1141,  -790, -1141, -1141,   277, -1141, -1141,  -867, -1141,
   -1141, -1141, -1036, -1141,  -724, -1141,  -653, -1141,  -723,  -755,
    -115, -1141, -1141, -1141,  -236, -1064, -1141, -1141, -1141,   278,
   -1141,  -352,   874, -1141, -1141, -1141, -1141, -1141,  -440, -1141,
   -1141,  -263, -1141,   997, -1141, -1141,  -858, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141,  -511, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
    -172, -1141,   771,  -195,  -517,   776, -1141, -1141, -1141,  -536,
   -1141, -1141, -1141,  -387, -1141,  -530, -1141, -1141, -1141, -1141,
   -1141,    20,   282, -1141,  -117,   285,  -940,    89, -1141,  1040,
       4,  -687,   116,  -160,  -279,  -213,  -282, -1141, -1141, -1141,
    -179,   -12, -1141, -1141, -1141, -1141,  -206,   -51,   376,  -147,
    -900,  -679,  -281, -1141, -1141, -1141,  -871, -1141, -1141,  -204,
    -291, -1141,   780, -1141, -1141, -1141,  -300, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141,   469,  -766, -1141,    18,
   -1141, -1141,    -6,  -963, -1141, -1141,   224, -1141,   473,  -105,
   -1141,   516,  -270,   294, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141,   265, -1141,  -362, -1141,
   -1141, -1141, -1141, -1141,  -247, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141,   541,     3,  -278,   556,    -8, -1141,
    -133, -1141, -1141,  1048,    -4,  -277,   340, -1141, -1141,   820,
    -349,   -32, -1141, -1141, -1141, -1141, -1141, -1141,  -102,   926,
   -1141, -1141, -1141,  -728,    21,   723, -1141, -1141, -1141,  -465,
   -1141,   147, -1141, -1141, -1141, -1141, -1141, -1141,  1060, -1141,
   -1141, -1141, -1141, -1141,   -94, -1141, -1141,   531,  -189, -1141,
    -137, -1141,   799, -1050,   802, -1141,   -53, -1141, -1141, -1141,
   -1141, -1141,  -319, -1140,  -114,  -104, -1141,  -409, -1141, -1141,
     -52, -1141,  1477, -1141,  -485,  -903, -1141, -1141,   321, -1141,
     611,  -480,  -802, -1141, -1141,   761,   567, -1141
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,    33,    34,    35,    36,   379,   648,   850,   851,
     631,   831,   834,   835,   836,  1060,   852,   120,   371,   372,
      37,    38,   457,   669,   670,   671,   672,   662,   663,   664,
     665,   666,   459,   460,   461,   462,   856,   857,   858,   463,
      39,   506,    40,    41,   170,   477,    42,   161,   675,   870,
     871,   872,   880,   881,   882,   162,    43,    44,    45,   132,
     133,   382,    46,   395,   658,   396,   139,   386,    47,    48,
      49,   247,   682,   248,   932,    50,   250,   522,   933,   251,
     935,   252,   253,    51,    52,   312,   776,    53,   311,    54,
     313,   777,   553,   554,   555,   987,   984,   985,  1181,   254,
     490,   491,   837,  1259,  1407,    55,   256,   526,    56,   464,
     866,  1089,  1090,  1349,   257,    57,    58,   169,  1249,   760,
     733,   734,  1143,   735,   953,   736,   737,   738,  1102,   739,
    1139,   258,   969,   259,   260,   740,   261,   715,  1132,  1286,
    1368,  1425,  1285,  1417,  1451,  1477,  1367,  1438,   927,   928,
     929,  1290,  1289,   903,   947,  1133,   741,   939,   742,   743,
     948,   888,   262,   263,   525,   264,   745,   949,   889,   747,
    1155,   890,   749,   750,   966,   751,   891,   892,   893,   894,
     895,   896,  1250,   897,   898,  1097,   899,  1099,   900,  1100,
     901,  1101,  1165,  1166,  1167,  1311,  1168,  1312,  1169,  1313,
     266,   529,   267,   268,   269,   270,   271,   272,   908,   273,
     274,   275,   276,   277,   539,   278,   962,   279,   280,   281,
     282,   283,   775,   979,  1176,  1177,   981,   982,   164,    60,
     284,   493,   494,   285,   286,   373,   287,   511,   288,   289,
     533,   290,   705,   911,  1118,  1119,  1120,  1266,   692,   291,
     960,   292,   293,   512,  1124,  1125,   921,  1128,  1280,  1281,
    1282,   294,   295,   513,   922,   923,  1065,   803,   998,  1013,
     804,   805,   806,  1002,   807,   808,   753,   839,   840,  1066,
    1067,  1341,   810,  1070,  1071,   605,   606,   607,   608,   609,
     610,   624,   499,   842,   611,   790,   811,   812,   813,   814,
     815,   612,   613,   816,   817,   818,   819,  1044,  1045,  1046,
    1047,  1048,  1049,  1050,  1217,  1200,  1051,  1052,  1334,  1445,
    1446,  1447,  1466,   472,   473,   754,   549,   766,    68,   930,
     467,   478,  1329,   756,   757,   902,   959,  1429,  1256,   125,
     615,   126,    71,  1123,   122,    72,   827,  1195,   378,   323,
    1077,   516,  1011,  1239,  1241,   129,  1209,  1392,  1264,  1134,
     845,   123,  1229,   786,   641,   545,  1159,   885,   484,   300,
     389,   390,  1293,   301,  1203,   914,   824,   638,   503,   521,
    1017,   168,    62,  1188,   315,   316,   792,  1404,  1074,  1206,
    1213,  1389,   330,   708,  1008,  1072,  1344,   327,   561,   562,
    1323,  1320,    63,  1303,   500,   698,   686,   931,  1005,  1397,
     145,   703,   704,  1211,   644,   616,   634,   302
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      69,    69,    69,   172,   140,    61,   483,    67,    67,    67,
     518,   536,   619,   620,   317,   374,   509,   504,   697,   759,
     495,    59,   468,   604,   380,   864,   690,   700,  1000,   507,
     712,    69,   296,   496,   550,  1014,   298,   940,    67,   492,
    1174,   603,  1260,   721,   602,  1078,  1151,  1126,   967,   696,
    1107,  1196,  1130,  1220,   652,  1160,   986,   825,   547,  1215,
     141,   950,   387,   523,   657,   514,   469,   532,   635,   632,
     832,   642,   527,   681,  1136,   867,   124,  1138,   649,   961,
     651,   919,   547,   919,   746,   746,   746,   684,   166,   802,
     531,   919,  1450,   551,   645,   867,   603,   833,   603,   602,
    1171,   602,  1172,   709,  1161,   535,   465,   677,   941,  1387,
     474,   919,   656,  1414,  1427,   946,   701,  1221,   791,   996,
    1088,   485,   486,  1201,  1222,  1207,   519,  1068,  1321,  1342,
    1262,   131,   667,  1418,   328,  1315,  1316,   752,   752,   752,
    1227,  1327,   392,   221,   688,   375, -1037,  -233, -1037,  1156,
     144,   318,   688,  -701,  1291,  -679,   487,   688,  1003,   688,
     688,   376,   688,  -702,  1058,  1377,  -825,  1204,  1186,   883,
     296,  1058,   744,   744,   744,   319,   706,   710,    15,   680,
    1173,  1106,   711,   639,  1068,   501,  -826,   241,  1009,  1193,
    1075,   320,   784,   244,   621,   497,   622,   603,   498,   623,
     602,   318,  1061,  -894,  1194,  1010,   789,   707,   329,   723,
     724,  1189,   321,   912,  1187,  1205,   -49,  1004,   -49,  1006,
     785,  1069,  1402,   520,  1152,  -825,  -340,   945,    22,  -234,
     645,  -443,  -734,  1076,   322,  1274,  -654,  1174,   976,  1251,
     725,  1252,  1253,  1254,   978,  -826,   636,   758,   758,   758,
   -1037,   846,  1292,   645,   868,   765,   502,   767,  1147,   296,
    1208,   748,   748,   748,   863,   488,   393,   961,   475,  1202,
    1419,   534,   534,  1007,   868,   689,   377,  1228,  1069,  1393,
    1059,  1386,   884,   689,   780,  1305,   913,  1059,   689,   907,
     689,   689,   673,   689,   676,   909,  1459,   241,   633,   304,
     167,   802,   847,   515,   787,   556,  1317,    69,    69,   685,
     565,   936,   937,   999,   548,   548,   617,  1406,   559,   614,
     618,   388,  1415,   713,   714,   603,   650,   657,   602,   643,
    1216,   826,   699,   946,   691,   527,   694,  1416,  1420,  -442,
     394,  1435,   702,   997,  1088,   647,   489,  1440,   693,   716,
     983,   719,  -898,   771,   497,   702,   772,   498,   653,   763,
    1091,    64,  1355,   142,    65,    66,   752,  1394,   770,   470,
    1064,  1081,   471,    69,   614,  1400,   614,   951,   869,    64,
      67,  1257,    65,    66,   920,    64,   920,   977,    65,    66,
    1353,  1350,   916,   917,   920,   667,   552,   667,   869,    65,
      66,   744,  1360,  -209,  1388,   702,  1093,   879,  -209,   466,
     678,    64,  1481,   476,   920,  1384,  1385,    64,   702,  1335,
    1336,  1322,  1263,  1474,  1475,   640,   746,   951,   848,   702,
    1041,  1330,  1369,  1140,    64,   702,  1403,    65,    66,   485,
     486,  1109,  1153,  1154,   976,   637,   924,  1383,   864,   943,
     978,   904,  1295,  1390,  1137,   859,   296,  1444,  1298,  1283,
    1275,   534,  1087,  1178,   828,  1150,  1276,  1277,   688,  1278,
     625,   375,  1279,   697,   487,   614,   758,   849,   391,   752,
     328,   688,  1103,   654,  1284,  1469,  1441,   376,   325,   925,
     557,   318,   392,  1405,  1409,  1337,   296,   392,   296,   746,
     542,   968,   543, -1086,   746,   570,   571,  1468,   746,   746,
     688,  1436,   989,   296,   744,   296,   755,   755,   755,   720,
     843,  1054,    30,   296,   918,   722,  1163,    31,   688,    69,
     629,    69,   296,   724,    69,   829,   764,   830,   764,   603,
    -680,   769,   602,  1210,   693,   822,   844,   558,   853,  1453,
     905,  1080,   752,  -688,   329,   314,   603,   752,    69,   602,
     326,   752,   752,  1351,   495,   548,   326,   626,  1223,   603,
     926,   603,   602,  -408,   602, -1086,   627,   496,  1483,  1109,
     630,   324,  1454,   488,   970,  1378,   823,   744,   495,   758,
     384,   331,   744,   977,   628,   667,   744,   744,   385,   689,
    -440,   496,  1233,   748,   544,    15,   992,  1398,    17,  1412,
    1098,  1270,   689,   879,  1162,    15,   393,    16,    17,  1482,
     505,   393,   625,   194,  1439,   689,  1149,   990,   197,   332,
      65,    66,   886,   726, -1086,  1055,   961,   961,  1448,   723,
     724,   689,    15,    20,   325,    17,   821,   381,   706,  1306,
     859,    21,   859,  -653,  1269,    22,   194,  1104,  -913,   689,
    1273,   197,   758,   194,   489,    22, -1126,   758,   197,   213,
     725,   758,   758,   508,  1110,    25,   748,  1111,    21,   707,
     536,   748,   702,  1372,  1112,   748,   748,   241,   314,  1170,
     394,    29,    22,   244,  1113,   394,   318,  1114,  1261,   510,
    1115,  1116,    25,  1164,   127,  1192,   128,   961,  -913,   517,
    1117,  1458,   325,  1095,   524,   746,   326,   945,  1198,   782,
     241,    64,   942,   603,    65,    66,   602,  1452,   627,  1294,
     244,  1296,  1422,   130,  1472,  1423,   603,   143,   538,   602,
     887,  1091,   163,   540,    64,   296,   628,  1476,   194,   942,
    1479,  1480,  1310,   197,   702,  1375,  1452,    64,  1179,  1135,
      65,    66,  1056,  1057,  1218,  1219,   296,  1424,   752, -1030,
     991,   993,  1235,   603,    29,   994,   602,  1108,   318,    64,
     697,   546,    65,    66,   326,   495,   770,  1461,  1462,  1371,
     603,   674,   517,   602,   945,  1452,  1452,   687,   496,   961,
    1380,  1381,  1382,   744,  1271,  1473,   538,   746,  -933,   296,
     695,  1015,  1110,  1016,   679,  1111,  1363,   614,  1373,   667,
     667,  1043,  1112,  1376,    70,   121,  1484,  1299,  -384,  1302,
    -384,  1304,  1113,   683,   614,  1114,   774,  1042,  1115,  1116,
     972,   778,  1352,   973,  1237,   779,  1238,   614,  1117,   974,
     564,   838,   841,    65,    66,   746,  1184,   860,   755,  1185,
     752,   661,   910,  1359,    64,   194,   915,    65,    66,   934,
     197,  1163,  1163,  1163,   975,   944,   203,   296,   758,   205,
     938,   951,    64,   942,   957,   958,  1421,   134,  1325,  1243,
    -899,  1244,   748,   964,  1001,   744,  1363,   965,   983,  1012,
    1073,   135,  1063,  -276,  1084,  1092,   603,  1121,   752,   602,
    1122,  1096,    64,  1127,  1197,  1129,  1131,  -276,  1157,  1199,
     702,  1212,  1308,   296,  1225,   296,  1232,  1399,  1230,  -276,
    1226,   755,  1240,  1340,  1246,  1265,   755,  1247,  1272,   136,
     755,   755,  1268,   744,  1307,  1297,  1408,   137,  1319,  1356,
     296,   603,  1410,  1300,   602,  1413,  1326,  1328,  1332,  1162,
    1162,  1162,  1430,  1333,  1338,   238,   239,   240,   241,   242,
     758,   945,   296,  1362,   244,  1365,  1314,  1460,  1366,   495,
    1478,  1374,  1231,  1396,   748,   495,  1105,    61,   691,   458,
     865,  1086,   496,  1062,   862,  1083,  1449,  1248,   496,  1094,
     374,   614,  1085,    59,   383,  1214,   854,   249,  1455,   655,
    1180,   988,   255,  1182,   614,  1348,  1183,   722,   758,  1288,
    1456,  1236,   761,  1142,   723,   724,  1309,   541,   645,   954,
     955,   956,   748,    69,  1170,  1170,  1170,   265,    69,    69,
      67,  -276,   530,   528,  1401,   548,   548,   963,  1164,  1164,
    1164,   614,   482,  1431,  1432,   725,  1433,  1434,  1318,   980,
     165,  1148,   603,  1357,  1267,   602,  1141,   906,   614,  1175,
    1361,   722,  1411,  1224,   537,   809,  1245,  1082,   723,   724,
     820,   995,   781,  1053,  1465,  1395,  1354,   773,   297,  1426,
     495,   768,   952,  1443,  1364,  1347,   194,  1467,   479,  1255,
     299,   197,  1242,   496,  1370,  1158,  1331,   203,  1346,   725,
     205,   603,   788,   560,   602,  -276,     2,     3,   563,     4,
    1379,     5,     6,     7,     8,   726,     9,    10,    11,    12,
    1345,  1324,  1343,   717,   646,  1018,   783,   722,     0,     0,
       0,     0,  1463,     0,   723,   724,     0,   755,     0,    13,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     603,   213,     0,   602,     0,     0,   722,     0,     0,     0,
       0,   536,     0,   723,   724,   725,     0,     0,     0,   726,
    -276,     0,     0,     0,   614,  -276,     0,     0,  -276,     0,
     138,     0,     0,    65,    66,     0,   238,   239,   240,     0,
     242,     0,     0,     0,   725,     0,     0,     0,     0,     0,
       0,     0,     0,  1470,  -909,   213,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1144,     0,     0,     0,   614,
       0,   727,   728,     0,   729,   730,   731,   732,     0,   755,
       0,  1457,     0,     0,     0,   726,     0,     0,     0,    64,
     296,     0,    65,    66,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1121,  1358,     0,    14,    15,
       0,    16,    17,     0,   726,    18,     0,     0,  1471,     0,
    -909,   213,     0,     0,     0,   727,   728,   755,   729,   730,
     731,   732,     0,     0,     0,    19,     0,    20,     0,   329,
       0,     0,     0,    64,  -602,    21,    65,    66,     0,  -909,
     213,     0,     0,     0,     0,     0,     0,     0,     0,    22,
      23,     0,     0,     0,    24,     0,     0,     0,     0,    25,
       0,  1391,     0,     0,     0,     0,    26,    27,    28,     0,
     614,     0,     0,     0,     0,    29,     0,     0,     0,     0,
       0,   727,   728,     0,   729,   730,   731,   732,     0,     0,
    1442,   659,     0,     0,     0,     0,  1428,     0,     0,    64,
     146,     0,    65,    66,     0,     0,  1145,     0,     0,     0,
     727,   728,     0,   729,   730,   731,   732,     0,    69,   614,
       0,     0,     0,     0,     0,    67,     0,     0,    64,     0,
       0,    65,    66,   194,     0,     0,     0,     0,   197,     0,
      30,     0,     0,     0,   203,    31,     0,   205,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   397,     0,    32,
     398,   399,   660,  -105,   402,   403,   404,   405,   614,   406,
     407,   408,   296,   409,   410,     0,   411,     0,   412,   413,
     414,   415,   416,     0,   417,     0,   418,     0,   419,   420,
     421,     0,   422,     0,   423,     0,   424,     0,   425,   426,
     427,   428,     0,     0,   429,   430,     0,   431,   432,     0,
     433,     0,   434,     0,   435,     0,   436,     0,   437,     0,
     438,   439,   661,     0,     0,     0,   696,     0,     0,     0,
       0,     0,     0,   238,   239,   240,   241,   242,     0,     0,
       0,   171,   244,   173,   174,   175,   176,     0,   303,   441,
     305,   442,   306,   307,   308,   309,   310,   702,  1146,     0,
       0,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     443,     0,   156,   157,   158,   159,   160,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    74,     0,     0,    75,    76,    77,     0,    78,
       0,    79,    80,     0,    81,    82,    83,     0,    84,    85,
       0,    86,     0,    87,    88,    89,    90,    91,     0,    92,
       0,    93,     0,    94,    95,    96,     0,    97,     0,    98,
       0,    99,     0,   100,   101,   102,   103,   104,     0,   105,
     106,     0,   107,   108,     0,   109,     0,   110,     0,   111,
       0,   112,     0,   113,     0,   114,   115,   116,   181,     0,
       0,   182,     0,     0,     0,   183,     0,   184,   185,     0,
       0,     0,   186,   187,   188,     0,   189,   190,    15,     0,
     191,    17,   192,   444,   445,   446,   447,   448,     0,     0,
       0,   449,     0,   450,   451,     0,   452,     0,  -214,     0,
     453,   454,   455,   456,   194,     0,    20,   195,   196,   197,
     198,   199,   200,   201,   480,   203,     0,     0,   205,   206,
       0,   207,     0,   208,     0,     0,   209,     0,    22,     0,
       0,   117,     0,     0,   210,     0,   211,   212,     0,   118,
       0,     0,     0,   177,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   481,   216,   217,   218,     0,
     219,   220,     0,   221,   222,     0,     0,     0,     0,     0,
     224,   225,     0,   226,     0,     0,   227,     0,   228,     0,
     229,     0,     0,     0,     0,     0,   230,   231,     0,   232,
     233,   119,     0,     0,   234,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,     0,     0,   244,   178,     0,   179,     0,     0,     0,
       0,     0,   180,   245,     0, -1125,     0,     0,     0,     0,
       0,   497,    65,    66,   498,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   181,     0,     0,   182,     0,
       0,     0,   183,     0,   184,   185,     0,     0,     0,   186,
     187,   188,     0,   189,   190,    15,     0,   191,    17,   192,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   328,     0,     0,
     193,   194,     0,    20,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,     0,   205,   206,     0,   207,     0,
     208,     0,     0,   209,     0,    22,    23, -1036,     0, -1036,
      24,   210,     0,   211,   212,     0,     0,  -909,   213,     0,
       0,     0,    26,    27,    28,     0,     0,     0,     0,     0,
     214, -1029,   215,   216,   217,   218,     0,   219,   220,     0,
     221,   222,   223,     0,     0,     0,     0,   224,   225,     0,
     226,   329,     0,   227,     0,   228,  -603,   229,     0,     0,
       0,     0,     0,   230,   231,     0,   232,   233,     0,     0,
       0,   234,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,     0,  1079,
     244,     0,   566,     0,     0,     0,     0,   567,     0,     0,
     245,     0,     0,     0,  -747,     0,   246,  -747,  -747,    65,
      66, -1036,     0,     0,  -747,     0,     0,     0,  -747,     0,
       0,     0,     0,  -747,  -747,     0,     0,     0,  1301,     0,
       0,     0,  -747,   568,  -747,     0,     0,     0,  -747,     0,
       0,     0,   569,  -747,     0,  -747,     0,  -747,     0,   570,
     571,  -747,  -747,     0,     0,   194,     0,     0,     0,     0,
     197,     0,     0,     0,     0,     0,   203,     0,     0,   205,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   572,     0,     0,  -747,     0,   573,     0,  -747,     0,
     574,  -747,     0,     0,     0,  -747,  -747,  -747,     0,  -747,
     575,  -747,     0,   576,  -747,  -747,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   238,   239,   240,     0,   242,
       0,     0,     0,     0,     0,     0,     0,   194,   577,  -747,
    -747,  -747,   197,  -747,  -747,  -747,  -747,   578,   203, -1098,
   -1098,   579,     0,  -883,   342,     0,   580,   581,     0,  -747,
       0,  -747,     0,     0,   582,     0,  -883,   583,     0,   584,
     585,     0,     0,     0,     0,  -883,     0,     0,     0,     0,
       0,   586,   587,     0,     0,     0,     0,     0,   588,  -747,
    -747,  -747,   351,     0,     0,   352,     0,  -747,     0,     0,
     354,     0,   355,   589,  -747,     0,   590,   591,     0,   592,
       0,   593,   361,     0,     0,   362,   363,  -883,   364,   365,
    -747,  -747,   594,   595,     0,  -883,     0,   596,   369,  -747,
       0,     0,     0,     0,  -747,  -747,  -747,   597,   598,   599,
       0,   242,   600,  -747,  -747,  -747,     0,  -747,  -747,  -747,
    -747,     0,  1190,     0,     0,   566,     0,     0,     0,     0,
     567,   702,   601,     0,     0,  -747,  -747,  -747,     0,     0,
    -747,  -747,     0,     0,     0,     0,     0,  -747,     0,     0,
       0,  -747,     0,     0,  -883,     0,  -747,  -747,     0,     0,
       0,     0,     0,     0,     0,  1191,   568,  -747,     0,     0,
     972,  -747,     0,   973,     0,   569,  -747,     0,  -747,   974,
    -747,     0,   570,   571,  -747,  -747,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   975,     0,     0,     0,     0,     0,
       0,     0,     0,  -883,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   572,     0,     0,  -747,     0,   573,
       0,  -747,  -883,   574,  -747,     0,     0,     0,  -747,  -747,
    -747,     0,  -747,   575,  -747,     0,   576,  -747,  -747,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     194,   577,  -747,  -747,  -747,   197,  -747,  -747,  -747,  -747,
     578,   203,     0,     0,   579,     0,  -883,   342,     0,   580,
     581,  -883,  -747,     0,  -747,     0,     0,   582,     0,     0,
     583,     0,   584,   585,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   586,   587,     0,     0,     0,     0,
       0,   588,  -747,  -747,  -747,   351,     0,     0,   352,     0,
    -747,     0,     0,   354,     0,   355,   589,  -747,     0,   590,
     591,     0,   592,     0,   593,   361,     0,     0,   362,   363,
       0,   364,   365,  -747,  -747,   594,   595,     0,     0,     0,
     596,   369,  -747,     0,     0,     0,     0,  -747,  -747,  -747,
     597,   598,   599,     0,   242,   600,  -747,  -747,  -747,     0,
    -747,  -747,  -747,  -747,     0,  1234,     0,     0,   566,     0,
       0,     0,     0,   567,     0,   601,     0,     0,  -747,  -747,
    -747,     0,     0,  -747,  -747,     0,     0,     0,     0,     0,
    -747,     0,     0,     0,  -747,     0,     0,     0,     0,  -747,
    -747,     0,     0,     0,     0,     0,     0,     0,  -747,   568,
    -747,     0,     0,     0,  -747,     0,     0,     0,   569,  -747,
       0,  -747,     0,  -747,     0,   570,   571,  -747,  -747,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   572,     0,     0,
    -747,     0,   573,     0,  -747,     0,   574,  -747,     0,     0,
       0,  -747,  -747,  -747,     0,  -747,   575,  -747,     0,   576,
    -747,  -747,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   194,   577,  -747,  -747,  -747,   197,  -747,
    -747,  -747,  -747,   578,   203,     0,     0,   579,     0,     0,
     342,     0,   580,   581,     0,  -747,     0,  -747,     0,     0,
     582,     0,     0,   583,     0,   584,   585,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   586,   587,     0,
       0,     0,     0,     0,   588,  -747,  -747,  -747,   351,     0,
       0,   352,     0,  -747,     0,     0,   354,     0,   355,   589,
    -747,     0,   590,   591,     0,   592,     0,   593,   361,     0,
       0,   362,   363,     0,   364,   365,  -747,  -747,   594,   595,
       0,     0,     0,   596,   369,  -747,     0,     0,     0,     0,
    -747,  -747,  -747,   597,   598,   599,     0,   242,   600,  -747,
    -747,  -747,     0,  -747,  -747,  -747,  -747,     0,  1339,     0,
       0,   566,     0,     0,     0,     0,   567,     0,   601,     0,
       0,  -747,  -747,  -747,     0,     0,  -747,  -747,     0,     0,
       0,     0,     0,  -747,     0,     0,     0,  -747,     0,     0,
       0,     0,  -747,  -747,     0,     0,     0,     0,     0,     0,
       0,  -747,   568,  -747,     0,     0,     0,  -747,     0,     0,
       0,   569,  -747,     0,  -747,     0,  -747,     0,   570,   571,
    -747,  -747,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     572,     0,     0,  -747,     0,   573,     0,  -747,     0,   574,
    -747,     0,     0,     0,  -747,  -747,  -747,     0,  -747,   575,
    -747,     0,   576,  -747,  -747,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   194,   577,  -747,  -747,
    -747,   197,  -747,  -747,  -747,  -747,   578,   203,     0,     0,
     579,     0,     0,   342,     0,   580,   581,     0,  -747,     0,
    -747,     0,     0,   582,     0,     0,   583,     0,   584,   585,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     586,   587,     0,     0,     0,     0,     0,   588,  -747,  -747,
    -747,   351,     0,     0,   352,     0,  -747,     0,     0,   354,
       0,   355,   589,  -747,     0,   590,   591,     0,   592,     0,
     593,   361,     0,     0,   362,   363,     0,   364,   365,  -747,
    -747,   594,   595,     0,     0,     0,   596,   369,  -747,     0,
       0,     0,     0,  -747,  -747,  -747,   597,   598,   599,     0,
     242,   600,  -747,  -747,  -747,     0,  -747,  -747,  -747,  -747,
      73,     0,     0,   -60,     0,     0,     0,     0,   -60,     0,
       0,   601,     0,     0,  -747,  -747,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   -60,     0,
       0,     0,     0,     0,   -60,     0,     0,     0,     0,     0,
       0,     0,     0,   -60,     0,     0,     0,     0,     0,     0,
     -60,   -60,     0,     0,     0,     0,    74,     0,     0,    75,
      76,    77,     0,    78,     0,    79,    80,     0,    81,    82,
      83,     0,    84,    85,     0,    86,     0,    87,    88,    89,
      90,    91,     0,    92,     0,    93,     0,    94,    95,    96,
       0,    97,     0,    98,     0,    99,     0,   100,   101,   102,
     103,   104,     0,   105,   106,     0,   107,   108,     0,   109,
       0,   110,     0,   111,     0,   112,     0,   113,     0,   114,
     115,   116,     0,     0,     0,     0,     0,     0,     0,     0,
     325,   -60,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   -60,     0,     0,   -60,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   -60,     0,
       0,     0,     0,   -60,     0,     0,     0,     0,   -60,     0,
       0,     0,     0,     0,     0,   -60,     0,   -60,   -60,     0,
       0,     0,     0,     0,     0,   117,     0,     0,   -60,     0,
     -60,   -60,   326,   118,     0,     0,     0,     0,     0,     0,
       0,     0,   -60,   -60,     0,     0,     0,     0,     0,   -60,
       0,     0,     0,   -60,     0,     0,   -60,     0,   -60,     0,
       0,   -60,     0,   -60,   -60,     0,     0,   -60,   -60,     0,
     -60,     0,   -60,   -60,     0,     0,   -60,   -60,     0,   -60,
     -60,     0,     0,   -60,   -60,   119,     0,     0,   -60,   -60,
       0,     0, -1106,     0,     0, -1106,     0,     0,     0, -1106,
       0, -1106, -1106,   -60,     0,     0, -1106, -1106, -1106,     0,
   -1106, -1106, -1106,     0, -1106, -1106, -1106,     0,     0,     0,
       0,     0,     0,    64,     0,     0,    65,    66,     0,  1287,
       0,     0,     0,     0,     0,     0,     0,     0, -1106,   924,
   -1106, -1106, -1106, -1106, -1106, -1106, -1106, -1106, -1106, -1106,
       0,     0, -1106, -1106,     0, -1106,     0, -1106,     0,     0,
   -1106,     0, -1106,     0,     0,     0,     0,     0, -1106,     0,
   -1106, -1106,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   925,     0,     0,     0,     0,     0,     0, -1106,
   -1106, -1106, -1106,     0, -1106, -1106,     0, -1106, -1106,     0,
       0,     0,     0,     0, -1106, -1106,     0, -1106,     0,     0,
   -1106,     0, -1106,     0, -1106,     0,     0,     0,     0,     0,
   -1106, -1106,     0, -1106, -1106,     0,     0,     0, -1106,     0,
       0,     0,     0,     0,     0, -1106, -1106, -1106, -1106, -1106,
   -1106, -1106, -1106, -1106,     0,     0,     0, -1106,     0,     0,
       0,     0,     0,     0,     0,     0,     0, -1106,     0,     0,
       0, -1106,     0,   926, -1106,     0, -1106, -1106, -1106,     0,
   -1106, -1106,     0,     0,     0, -1106, -1106, -1106,     0, -1106,
   -1106, -1106,     0, -1106, -1106, -1106,     0,     0,     0,     0,
       0,     0,  1437,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0, -1106,   924, -1106,
   -1106, -1106, -1106, -1106, -1106, -1106, -1106, -1106, -1106,     0,
       0, -1106, -1106,     0, -1106,     0, -1106,     0,     0, -1106,
       0, -1106,     0,     0,     0,     0,     0, -1106,     0, -1106,
   -1106,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   925,     0,     0,     0,     0,     0,     0, -1106, -1106,
   -1106, -1106,     0, -1106, -1106,     0, -1106, -1106,     0,     0,
       0,     0,     0, -1106, -1106,     0, -1106,     0,     0, -1106,
       0, -1106,     0, -1106,     0,     0,     0,     0,     0, -1106,
   -1106,     0, -1106, -1106,     0,     0,     0, -1106,     0,     0,
       0,     0,     0,     0, -1106, -1106, -1106, -1106, -1106, -1106,
   -1106, -1106, -1106,     0,     0,     0, -1106,     0,     0,     0,
       0,     0,     0,     0, -1106,     0, -1106, -1106,     0,     0,
       0, -1106,   926, -1106, -1106, -1106, -1106,     0, -1106, -1106,
   -1106,     0, -1106, -1106, -1106,     0, -1106, -1106, -1106,     0,
       0,     0,     0,     0,     0,   718,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   -1106,   924, -1106, -1106, -1106, -1106, -1106, -1106, -1106, -1106,
   -1106, -1106,     0,     0, -1106, -1106,     0, -1106,     0, -1106,
       0,     0, -1106,     0, -1106,     0,     0,     0,     0,     0,
   -1106,     0, -1106, -1106,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   925,     0,     0,     0,     0,     0,
       0, -1106, -1106, -1106, -1106,     0, -1106, -1106,     0, -1106,
   -1106,     0,     0,     0,     0,     0, -1106, -1106,     0, -1106,
       0,     0, -1106,     0, -1106,     0, -1106,     0,     0,     0,
       0,     0, -1106, -1106,     0, -1106, -1106,     0,     0,     0,
   -1106,     0,     0,     0,     0,     0,     0, -1106, -1106, -1106,
   -1106, -1106, -1106, -1106, -1106, -1106,     0,     0,     0, -1106,
       0,     0,     0,     0,     0,     0,     0,   181,     0, -1106,
     182,     0,     0,     0,   183,   926,   184,   185, -1106, -1106,
       0,   186,   187,   188,     0,   189,   190,    15,     0,   191,
      17,   192,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   762,     0,     0,     0,     0,     0,
       0,     0,     0,   194,     0,    20,   195,   196,   197,   198,
     199,   200,   201,   480,   203,     0,     0,   205,   206,     0,
     207,     0,   208,     0,     0,   209,     0,    22,     0,     0,
       0,     0,     0,   210,     0,   211,   212,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   481,   216,   217,   218,     0,   219,
     220,     0,   221,   222,     0,     0,     0,     0,     0,   224,
     225,     0,   226,     0,     0,   227,     0,   228,     0,   229,
       0,     0,     0,     0,     0,   230,   231,     0,   232,   233,
       0,     0,     0,   234,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
       0,     0,   244,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   245,     0,     0,     0,   181,   702,    64,   182,
       0,    65,    66,   183,     0,   184,   185,     0,     0,     0,
     186,   187,   188,   971,   189,   190,    15,     0,   191,    17,
     192,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   194,     0,    20,   195,   196,   197,   198,   199,
     200,   201,   480,   203,     0,     0,   205,   206,     0,   207,
       0,   208,     0,     0,   209,     0,    22,     0,     0,     0,
       0,     0,   210,     0,   211,   212,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   481,   216,   217,   218,     0,   219,   220,
       0,   221,   222,     0,     0,     0,     0,     0,   224,   225,
       0,   226,     0,     0,   227,     0,   228,     0,   229,     0,
       0,     0,     0,     0,   230,   231,     0,   232,   233,     0,
       0,     0,   234,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   182,   566,
       0,   244,   183,     0,   567,   185,     0,     0,     0,   186,
     972,   245,     0,   973,     0,     0,     0,     0,     0,   974,
      65,    66,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     568,     0,     0,     0,   975,   196,     0,   198,   199,   569,
       0,     0,     0,     0,     0,     0,   570,   571,     0,     0,
       0,     0,     0,   209,     0,     0,     0,     0,  -733,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   216,   217,   218,     0,   219,   220,     0,
       0,   222,     0,     0,     0,     0,     0,     0,   225,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   231,     0,     0,     0,   572,     0,
       0,     0,     0,   573,     0,     0,     0,   574,   235,   236,
       0,     0,     0,     0,     0,     0,     0,   575,     0,     0,
     576,     0,     0,     0,     0,   566,     0,     0,     0,     0,
     567,     0,     0,     0,     0,     0,     0,     0,     0,    65,
      66,     0,     0,     0,   194,   577,     0,     0,     0,   197,
       0,     0,     0,     0,   578,   203,  -833,     0,   579,     0,
       0,   342,     0,   580,   581,     0,   568,     0,     0,  -833,
       0,   582,     0,     0,   583,   569,   584,   585,  -833,     0,
       0,     0,   570,   571,     0,     0,     0,     0,   586,   587,
       0,     0,     0,     0,     0,   588,     0,     0,     0,   351,
       0,     0,   352,     0,     0,     0,     0,   354,     0,   355,
     589,     0,     0,   590,   591,     0,   592,     0,   593,   361,
    -833,     0,   362,   363,     0,   364,   365,     0,  -833,   594,
     595,     0,     0,     0,   596,   369,     0,     0,     0,     0,
       0,     0,     0,     0,   597,   598,   599,     0,   242,   600,
       0,     0,     0,     0,   572,     0,     0,     0,     0,   573,
       0,     0,     0,   574,     0,     0,     0,     0,     0,   601,
       0,     0,     0,   575,     0,     0,   576,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  -833,     0,     0,
       0,     0,     0,  1019,  1020,     0,     0,     0,     0,     0,
     194,   577,     0,   187,   188,   197,   189,     0,     0,  1021,
     578,   203,   192,     0,   579,  1019,  1020,   342,     0,   580,
     581,     0,     0,     0,     0,     0,     0,   582,     0,     0,
     583,  1021,   584,   585,     0,     0,     0,   195,  1022,     0,
       0,     0,   200,   201,   586,   587,  -833,     0,     0,     0,
       0,   588,     0,     0,     0,   351,     0,     0,   352,     0,
    1022,     0,     0,   354,     0,   355,   589,     0,     0,   590,
     591,     0,   592,     0,   593,   361,     0,     0,   362,   363,
       0,   364,   365,     0,     0,   594,   595,     0,     0,     0,
     596,   369,     0,     0,     0,  -833,     0,     0,     0,     0,
     597,   598,   599,     0,   242,   600,     0,     0,     0,     0,
    1023,     0,     0,     0,  1024,     0,     0,  1025,     0,     0,
       0,  1026,     0,   566,     0,   601,     0,    15,   567,     0,
      17,     0,  1023,   237,     0,     0,  1024,     0,     0,  1025,
       0,     0,     0,  1026,     0,     0,     0,     0,     0,  -833,
       0,     0,     0,     0,  -833,    20,     0,  1027,     0,  1028,
    1029,     0,     0,     0,   568,     0,     0,     0,     0,     0,
       0,     0,     0,   569,     0,  1030,     0,    22,     0,  1027,
       0,  1028,  1029,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1030,     0,     0,
       0,     0,     0,     0,     0,  1031,  1032,  1033,     0,     0,
       0,     0,     0,  1034,     0,     0,     0,     0,     0,     0,
    1035,     0,     0,     0,     0,     0,     0,  1031,  1032,  1033,
       0,     0,     0,     0,     0,  1034,  1036,  1037,     0,     0,
       0,     0,  1035,   333,     0,  1038,     0,     0,   334,     0,
    1039,  1040,   572,     0,     0,     0,     0,   573,  1036,     0,
       0,   574,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   575,  1039,  1040,   576,     0,     0,     0,   335,     0,
       0,    65,    66,     0,   336,     0,     0,     0,     0,     0,
       0,     0,     0,   337,     0,     0,     0,     0,   194,     0,
    1464,     0,     0,   197,     0,     0,     0,     0,   578,   203,
       0,     0,   579,     0,     0,   342,     0,   580,   581,     0,
       0,     0,     0,     0,     0,   582,     0,     0,   583,     0,
     584,   585,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   586,   587,     0,     0,     0,     0,     0,   588,
       0,     0,     0,   351,     0,     0,   352,     0,     0,     0,
       0,   354,     0,   355,   589,     0,     0,   590,   591,   333,
     592,     0,   593,   361,   334,     0,   362,   363,     0,   364,
     365,   338,     0,   594,   595,     0,     0,     0,   596,   369,
       0,   339,     0,     0,   340,     0,     0,     0,   597,   598,
     599,     0,   242,   600,     0,     0,     0,     0,     0,     0,
     336,     0,     0,     0,     0,     0,     0,     0,     0,   337,
       0,     0,     0,     0,     0,     0,     0,     0,   341,     0,
       0,     0,     0,     0,     0,   342,     0,   343,   344,     0,
       0,     0,  1258,     0,     0,     0,     0,     0,   345,     0,
     346,   347,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   348,   349,     0,     0,     0,     0,     0,   350,
       0,     0,     0,   351,     0,     0,   352,     0,   353,     0,
       0,   354,     0,   355,   356,     0,     0,   357,   358,     0,
     359,     0,   360,   361,     0,     0,   362,   363,     0,   364,
     365,     0,     0,   366,   367,   793,     0,   338,   368,   369,
       0,     0,     0,     0,     0,   794,     0,   339,     0,   795,
     340,     0,     0,   370,     0,  -739,     0,     0,     0,     0,
       0,     0,     0,  -739,     0,  -739,     0,     0,     0,   796,
       0,     0,     0,     0,   797,     0,   798,     0,   799,     0,
       0,     0,   800,     0,   341,     0,     0,     0,     0,     0,
       0,   342,     0,   343,   344,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   345,     0,   346,   347,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   348,   349,
       0,     0,     0,     0,     0,   350,     0,     0,     0,   351,
       0,     0,   352,     0,   353,     0,     0,   354,     0,   355,
     356,     0,     0,   357,   358,     0,   359,     0,   360,   361,
       0,     0,   362,   363,     0,   364,   365,     0,     0,   366,
     367,     0,     0,     0,   368,   369,     0,   187,   188,     0,
     189,     0,     0,     0,     0,     0,   192,     0,     0,   370,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   195,     0,     0,     0,     0,   200,   201,   397,     0,
       0,   398,   399,   873,   874,   402,   403,   404,   405,     0,
     406,   407,   408,     0,   409,   410,     0,   411,     0,   412,
     413,   414,   415,   416,     0,   417,     0,   418,     0,   419,
     420,   421,     0,   422,     0,   423,     0,   424,     0,   425,
     426,   427,   428,     0,     0,   429,   430,     0,   431,   432,
       0,   433,     0,   434,     0,   435,     0,   436,     0,   437,
       0,   438,   439,   875,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   237,     0,     0,
     441,   876,   442,     0,   801,   727,   728,     0,   729,   730,
     731,   732,   877,   878,     0,     0,     0,     0,     0,   397,
       0,   443,   398,   399,   400,   401,   402,   403,   404,   405,
       0,   406,   407,   408,     0,   409,   410,     0,   411,     0,
     412,   413,   414,   415,   416,     0,   417,     0,   418,     0,
     419,   420,   421,     0,   422,     0,   423,     0,   424,     0,
     425,   426,   427,   428,     0,     0,   429,   430,     0,   431,
     432,     0,   433,     0,   434,     0,   435,     0,   436,     0,
     437,     0,   438,   439,   440,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   441,     0,   442,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   443,     0,   444,   445,   446,   447,   448,     0,
       0,     0,   449,     0,   450,   451,     0,   452,     0,     0,
       0,   453,   454,   455,   456,     0,     0,     0,   397,     0,
       0,   398,   399,   668,   401,   402,   403,   404,   405,     0,
     406,   407,   408,     0,   409,   410,     0,   411,     0,   412,
     413,   414,   415,   416,     0,   417,     0,   418,     0,   419,
     420,   421,     0,   422,     0,   423,     0,   424,     0,   425,
     426,   427,   428,     0,     0,   429,   430,     0,   431,   432,
       0,   433,     0,   434,     0,   435,     0,   436,     0,   437,
       0,   438,   439,   440,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   444,   445,   446,   447,   448,
     441,     0,   442,   449,     0,   450,   451,     0,   452,     0,
       0,     0,   453,   454,   455,   456,     0,     0,     0,   397,
       0,   443,   398,   399,   855,     0,   402,   403,   404,   405,
       0,   406,   407,   408,     0,   409,   410,     0,   411,     0,
     412,   413,   414,   415,   416,     0,   417,     0,   418,     0,
     419,   420,   421,     0,   422,     0,   423,     0,   424,     0,
     425,   426,   427,   428,     0,     0,   429,   430,     0,   431,
     432,     0,   433,     0,   434,     0,   435,     0,   436,     0,
     437,     0,   438,   439,   440,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   441,     0,   442,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   443,     0,   444,   445,   446,   447,   448,     0,
       0,     0,   449,     0,   450,   451,     0,   452,     0,     0,
       0,   453,   454,   455,   456,     0,     0,     0,   397,     0,
       0,   398,   399,   660,     0,   402,   403,   404,   405,     0,
     406,   407,   408,     0,   409,   410,     0,   411,     0,   412,
     413,   414,   415,   416,     0,   417,     0,   418,     0,   419,
     420,   421,     0,   422,     0,   423,     0,   424,     0,   425,
     426,   427,   428,     0,     0,   429,   430,     0,   431,   432,
       0,   433,     0,   434,     0,   435,     0,   436,     0,   437,
       0,   438,   439,   861,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   444,   445,   446,   447,   448,
     441,     0,   442,   449,     0,   450,   451,     0,   452,     0,
       0,     0,   453,   454,   455,   456,     0,     0,     0,   397,
       0,   443,   398,   399,   660,     0,   402,   403,   404,   405,
       0,   406,   407,   408,     0,   409,   410,     0,   411,     0,
     412,   413,   414,   415,   416,     0,   417,     0,   418,     0,
     419,   420,   421,     0,   422,     0,   423,     0,   424,     0,
     425,   426,   427,   428,     0,     0,   429,   430,     0,   431,
     432,     0,   433,     0,   434,     0,   435,     0,   436,     0,
     437,     0,   438,   439,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   441,     0,   442,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   443,     0,   444,   445,   446,   447,   448,     0,
       0,     0,   449,     0,   450,   451,     0,   452,     0,     0,
       0,   453,   454,   455,   456,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   180,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     181,     0,     0,   182,     0,     0,     0,   183,     0,   184,
     185,     0,     0,     0,   186,   187,   188,     0,   189,   190,
      15,     0,   191,    17,   192,   444,   445,   446,   447,   448,
       0,     0,     0,   449,     0,   450,   451,     0,   452,     0,
       0,     0,   453,   454,   455,   456,   194,     0,    20,   195,
     196,   197,   198,   199,   200,   201,   480,   203,     0,     0,
     205,   206,     0,   207,     0,   208,     0,     0,   209,     0,
      22,     0,     0,     0,     0,     0,   210,     0,   211,   212,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   481,   216,   217,
     218,     0,   219,   220,     0,   221,   222,     0,     0,     0,
       0,     0,   224,   225,     0,   226,     0,     0,   227,     0,
     228,     0,   229,     0,     0,     0,     0,     0,   230,   231,
       0,   232,   233,     0,     0,     0,   234,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,     0,     0,   244,     0,     0,     0,     0,
       0,     0,     0,   181,     0,   245,   182,     0,     0,     0,
     183,     0,   184,   185,    65,    66,     0,   186,   187,   188,
       0,   189,   190,    15,     0,   191,    17,   192,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   194,
       0,    20,   195,   196,   197,   198,   199,   200,   201,   480,
     203,     0,     0,   205,   206,     0,   207,     0,   208,     0,
       0,   209,     0,    22,     0,     0,     0,     0,     0,   210,
       0,   211,   212,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     481,   216,   217,   218,     0,   219,   220,     0,   221,   222,
       0,     0,     0,     0,     0,   224,   225,     0,   226,     0,
       0,   227,     0,   228,     0,   229,     0,     0,     0,     0,
       0,   230,   231,     0,   232,   233,     0,     0,     0,   234,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   182,     0,     0,   244,   183,
       0,     0,   185,     0,     0,     0,   186,   972,   245,     0,
     973,     0,     0,     0,     0,     0,   974,    65,    66,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   975,   196,     0,   198,   199,     0,     0,     0,     0,
       0,     0,     0,   181,     0,     0,     0,     0,     0,     0,
     209,     0,   184,     0,     0,     0,     0,     0,   187,   188,
       0,   189,   190,     0,     0,   191,     0,   192,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     216,   217,   218,     0,   219,   220,     0,     0,   222,   194,
       0,     0,   195,     0,   197,   225,     0,   200,   201,   480,
     203,     0,     0,   205,     0,     0,   207,     0,   208,     0,
       0,   231,     0,     0,     0,     0,     0,     0,     0,   210,
       0,   211,   212,     0,     0,   235,   236,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     481,     0,     0,     0,     0,     0,     0,     0,   221,     0,
       0,     0,     0,     0,     0,   224,    65,    66,   226,     0,
       0,   227,     0,   228,     0,     0,     0,     0,     0,     0,
       0,   230,     0,     0,   232,   233,     0,     0,     0,   234,
       0,     0,     0,     0,     0,     0,     0,     0,   237,   238,
     239,   240,   241,   242,   243,     0,     0,     0,   244
};

static const yytype_int16 yycheck[] =
{
       4,     5,     6,    35,    12,     1,   178,     4,     5,     6,
     246,   292,   331,   332,    67,   120,   229,   206,   503,   525,
     180,     1,   155,   323,   126,   665,   491,   506,   794,   218,
     510,    35,    40,   180,   312,   801,    40,   724,    35,   179,
     980,   323,  1106,   523,   323,   847,   946,   918,   771,     1,
     908,  1014,   923,     1,     1,   958,     1,     1,     1,     1,
       1,   748,    43,   252,   391,     1,     1,   280,   338,     1,
      28,     1,   267,   482,   932,     1,     1,   935,   378,   758,
     380,     1,     1,     1,   524,   525,   526,     1,     1,   606,
     279,     1,    77,     1,   373,     1,   378,    55,   380,   378,
     967,   380,   969,     1,   962,   284,     1,     1,     1,     1,
       1,     1,     1,     1,     1,   736,     1,    65,   598,    80,
     863,    79,    80,     1,    72,     1,     1,    56,     1,     1,
       1,   305,   400,     1,     1,  1171,  1172,   524,   525,   526,
       1,  1191,    31,   238,     1,     1,   205,    73,   207,   951,
     228,    67,     1,    73,     1,    73,   114,     1,     1,     1,
       1,    17,     1,    73,    22,  1305,     1,     1,     1,     1,
     178,    22,   524,   525,   526,     1,    79,    75,   153,   479,
     970,   904,    80,     1,    56,     1,     1,   282,     1,     1,
      17,    17,     1,   288,    32,   306,    34,   479,   309,    37,
     479,    67,    60,    69,    16,    18,    80,   110,    75,    79,
      80,  1001,    38,     1,    47,    49,    73,    60,    75,     1,
      29,   150,     1,    98,   947,    60,    75,    74,   203,    73,
     509,    73,    73,    60,    60,    72,    75,  1177,   774,  1097,
     110,  1099,  1100,  1101,   774,    60,     1,   524,   525,   526,
     309,    14,    99,   532,   180,   533,    72,   535,   945,   267,
     136,   524,   525,   526,   664,   223,   155,   946,   159,   147,
     138,   283,   284,    55,   180,   132,   132,   138,   150,  1329,
     138,  1317,   114,   132,   562,  1152,    74,   138,   132,   698,
     132,   132,   464,   132,   473,   704,  1436,   282,   230,   299,
     213,   818,    65,   239,   574,   313,  1173,   311,   312,   223,
     318,   720,   721,   793,   311,   312,   324,  1353,   314,   323,
     324,   302,   210,   512,   513,   607,   379,   654,   607,   259,
     272,   275,   504,   954,   494,   530,   496,   225,   206,    73,
     229,  1377,   303,   304,  1087,   377,   304,  1383,   495,   521,
     295,   523,   295,   542,   306,   303,   545,   309,   305,   531,
     866,   304,  1265,   304,   307,   308,   753,  1330,   540,   304,
     835,   851,   307,   377,   378,  1338,   380,   293,   304,   304,
     377,  1104,   307,   308,   304,   304,   304,   774,   307,   308,
    1257,  1249,   711,   712,   304,   663,   304,   665,   304,   307,
     308,   753,  1273,   294,   296,   303,   871,   675,   299,   304,
     304,   304,  1476,   304,   304,  1315,  1316,   304,   303,  1221,
    1222,   294,   293,  1459,  1460,   243,   866,   293,   191,   303,
     817,  1197,  1290,   939,   304,   303,   215,   307,   308,    79,
      80,     1,   948,   949,   980,   200,   180,  1314,  1088,   726,
     980,   687,  1139,     1,   933,   660,   464,  1397,  1145,   224,
     297,   473,   862,     1,     1,   945,   303,   304,     1,   306,
     150,     1,   309,   958,   114,   479,   753,   240,    17,   866,
       1,     1,   891,    17,   249,  1448,  1386,    17,     1,   223,
       1,    67,    31,  1351,     1,  1223,   504,    31,   506,   939,
     205,     1,   207,     1,   944,    61,    62,  1447,   948,   949,
       1,  1378,   189,   521,   866,   523,   524,   525,   526,   523,
       1,   821,   294,   531,   713,    72,   966,   299,     1,   533,
      24,   535,   540,    80,   538,    72,   533,    74,   535,   821,
      73,   538,   821,  1023,   691,     1,    27,    58,   650,  1407,
     690,   851,   939,    73,    75,    47,   838,   944,   562,   838,
      73,   948,   949,  1250,   724,   562,    73,   247,  1048,   851,
     304,   853,   851,    73,   853,    73,   256,   724,  1478,     1,
      74,    67,    73,   223,   773,  1308,    42,   939,   748,   866,
      53,    74,   944,   980,   274,   863,   948,   949,    61,   132,
      73,   748,  1067,   866,   309,   153,   189,  1335,   156,  1364,
     887,   132,   132,   881,   966,   153,   155,   155,   156,  1477,
      67,   155,   150,   179,  1379,   132,   945,   304,   184,    74,
     307,   308,    72,   180,   132,   824,  1315,  1316,  1404,    79,
      80,   132,   153,   181,     1,   156,    17,   114,    79,  1155,
     855,   189,   857,    75,  1119,   203,   179,   893,    17,   132,
    1125,   184,   939,   179,   304,   203,    83,   944,   184,   216,
     110,   948,   949,    74,   234,   213,   939,   237,   189,   110,
     961,   944,   303,   304,   244,   948,   949,   282,    47,   966,
     229,   229,   203,   288,   254,   229,    67,   257,  1107,    74,
     260,   261,   213,   966,     1,  1005,     3,  1386,    67,    72,
     270,  1435,     1,   885,   132,  1155,    73,    74,  1018,   247,
     282,   304,   726,  1005,   307,   308,  1005,  1406,   256,  1138,
     288,  1140,   248,    10,  1457,   251,  1018,    14,    67,  1018,
     180,  1247,    19,   215,   304,   753,   274,  1470,   179,   753,
    1474,  1475,  1161,   184,   303,   304,  1435,   304,   296,   931,
     307,   308,   829,   830,  1042,  1043,   774,   283,  1155,   229,
     778,   779,  1072,  1055,   229,   779,  1055,   910,    67,   304,
    1265,    83,   307,   308,    73,   945,   958,  1440,  1441,  1295,
    1072,    72,    72,  1072,    74,  1474,  1475,    75,   945,  1478,
    1311,  1312,  1313,  1155,  1123,  1458,    67,  1247,    69,   817,
     295,    44,   234,    46,   304,   237,  1281,   821,  1298,  1087,
    1088,   817,   244,  1303,     4,     5,  1479,  1146,    72,  1148,
      74,  1150,   254,   304,   838,   257,   293,   817,   260,   261,
     148,    67,  1251,   151,    19,    67,    21,   851,   270,   157,
     304,    72,    41,   307,   308,  1295,   989,    73,   866,   992,
    1247,   132,   229,  1272,   304,   179,    75,   307,   308,    73,
     184,  1311,  1312,  1313,   182,   132,   190,   885,  1155,   193,
     108,   293,   304,   887,    69,   215,  1366,     1,  1188,    55,
     295,    57,  1155,   295,    72,  1247,  1361,   295,   295,    40,
     215,    15,    75,    17,    73,    73,  1188,   911,  1295,  1188,
     914,   108,   304,    72,    36,    73,    73,    31,    80,    51,
     303,    52,  1158,   931,    73,   933,    73,  1336,  1061,    43,
      75,   939,    23,  1233,    73,    72,   944,   132,    73,    53,
     948,   949,    75,  1295,  1157,    75,  1355,    61,   294,  1268,
     958,  1233,  1361,    80,  1233,  1364,    73,   304,   271,  1311,
    1312,  1313,  1371,    47,    73,   279,   280,   281,   282,   283,
    1247,    74,   980,    73,   288,    72,  1165,    73,   114,  1139,
      73,  1300,  1064,   155,  1247,  1145,   903,   983,  1148,   142,
     671,   860,  1139,   833,   663,   855,  1405,  1093,  1145,   881,
    1105,  1005,   857,   983,   132,  1037,   654,    40,  1417,   390,
     983,   777,    40,   983,  1018,  1247,   983,    72,  1295,  1134,
    1429,  1074,   526,   944,    79,    80,  1159,   300,  1307,   753,
     753,   753,  1295,  1037,  1311,  1312,  1313,    40,  1042,  1043,
    1037,   155,   271,   267,  1344,  1042,  1043,   765,  1311,  1312,
    1313,  1055,   178,  1372,  1373,   110,  1375,  1376,  1175,   774,
      20,   945,  1344,  1269,  1115,  1344,     1,   691,  1072,   980,
    1274,    72,  1363,  1055,   294,   606,  1082,   853,    79,    80,
     607,   787,   566,   818,  1446,  1332,  1258,   546,    40,  1368,
    1250,   535,   752,  1393,  1283,     1,   179,  1446,   172,  1103,
      40,   184,  1081,  1250,  1293,   958,  1200,   190,  1245,   110,
     193,  1393,   581,   314,  1393,   229,     0,     1,   316,     3,
    1309,     5,     6,     7,     8,   180,    10,    11,    12,    13,
    1244,  1183,  1236,   522,   373,   814,   569,    72,    -1,    -1,
      -1,    -1,  1442,    -1,    79,    80,    -1,  1155,    -1,    33,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1442,   216,    -1,  1442,    -1,    -1,    72,    -1,    -1,    -1,
      -1,  1452,    -1,    79,    80,   110,    -1,    -1,    -1,   180,
     294,    -1,    -1,    -1,  1188,   299,    -1,    -1,   302,    -1,
     304,    -1,    -1,   307,   308,    -1,   279,   280,   281,    -1,
     283,    -1,    -1,    -1,   110,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1449,   215,   216,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,  1233,
      -1,   286,   287,    -1,   289,   290,   291,   292,    -1,  1247,
      -1,  1430,    -1,    -1,    -1,   180,    -1,    -1,    -1,   304,
    1258,    -1,   307,   308,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1269,  1270,    -1,   152,   153,
      -1,   155,   156,    -1,   180,   159,    -1,    -1,  1450,    -1,
     215,   216,    -1,    -1,    -1,   286,   287,  1295,   289,   290,
     291,   292,    -1,    -1,    -1,   179,    -1,   181,    -1,    75,
      -1,    -1,    -1,   304,    80,   189,   307,   308,    -1,   215,
     216,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   203,
     204,    -1,    -1,    -1,   208,    -1,    -1,    -1,    -1,   213,
      -1,  1327,    -1,    -1,    -1,    -1,   220,   221,   222,    -1,
    1344,    -1,    -1,    -1,    -1,   229,    -1,    -1,    -1,    -1,
      -1,   286,   287,    -1,   289,   290,   291,   292,    -1,    -1,
    1392,     1,    -1,    -1,    -1,    -1,  1370,    -1,    -1,   304,
       1,    -1,   307,   308,    -1,    -1,   152,    -1,    -1,    -1,
     286,   287,    -1,   289,   290,   291,   292,    -1,  1392,  1393,
      -1,    -1,    -1,    -1,    -1,  1392,    -1,    -1,   304,    -1,
      -1,   307,   308,   179,    -1,    -1,    -1,    -1,   184,    -1,
     294,    -1,    -1,    -1,   190,   299,    -1,   193,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,    -1,   313,
      70,    71,    72,    73,    74,    75,    76,    77,  1442,    79,
      80,    81,  1450,    83,    84,    -1,    86,    -1,    88,    89,
      90,    91,    92,    -1,    94,    -1,    96,    -1,    98,    99,
     100,    -1,   102,    -1,   104,    -1,   106,    -1,   108,   109,
     110,   111,    -1,    -1,   114,   115,    -1,   117,   118,    -1,
     120,    -1,   122,    -1,   124,    -1,   126,    -1,   128,    -1,
     130,   131,   132,    -1,    -1,    -1,     1,    -1,    -1,    -1,
      -1,    -1,    -1,   279,   280,   281,   282,   283,    -1,    -1,
      -1,    34,   288,    36,    37,    38,    39,    -1,    41,   159,
      43,   161,    45,    46,    47,    48,    49,   303,   304,    -1,
      -1,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     180,    -1,   173,   174,   175,   176,   177,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    67,    -1,    -1,    70,    71,    72,    -1,    74,
      -1,    76,    77,    -1,    79,    80,    81,    -1,    83,    84,
      -1,    86,    -1,    88,    89,    90,    91,    92,    -1,    94,
      -1,    96,    -1,    98,    99,   100,    -1,   102,    -1,   104,
      -1,   106,    -1,   108,   109,   110,   111,   112,    -1,   114,
     115,    -1,   117,   118,    -1,   120,    -1,   122,    -1,   124,
      -1,   126,    -1,   128,    -1,   130,   131,   132,   133,    -1,
      -1,   136,    -1,    -1,    -1,   140,    -1,   142,   143,    -1,
      -1,    -1,   147,   148,   149,    -1,   151,   152,   153,    -1,
     155,   156,   157,   293,   294,   295,   296,   297,    -1,    -1,
      -1,   301,    -1,   303,   304,    -1,   306,    -1,   299,    -1,
     310,   311,   312,   313,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,    -1,    -1,   193,   194,
      -1,   196,    -1,   198,    -1,    -1,   201,    -1,   203,    -1,
      -1,   206,    -1,    -1,   209,    -1,   211,   212,    -1,   214,
      -1,    -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   230,   231,   232,   233,    -1,
     235,   236,    -1,   238,   239,    -1,    -1,    -1,    -1,    -1,
     245,   246,    -1,   248,    -1,    -1,   251,    -1,   253,    -1,
     255,    -1,    -1,    -1,    -1,    -1,   261,   262,    -1,   264,
     265,   266,    -1,    -1,   269,    -1,    -1,    -1,    -1,    -1,
      -1,   276,   277,   278,   279,   280,   281,   282,   283,   284,
      -1,    -1,    -1,   288,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    80,   298,    -1,    83,    -1,    -1,    -1,    -1,
      -1,   306,   307,   308,   309,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   133,    -1,    -1,   136,    -1,
      -1,    -1,   140,    -1,   142,   143,    -1,    -1,    -1,   147,
     148,   149,    -1,   151,   152,   153,    -1,   155,   156,   157,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,    -1,   193,   194,    -1,   196,    -1,
     198,    -1,    -1,   201,    -1,   203,   204,   205,    -1,   207,
     208,   209,    -1,   211,   212,    -1,    -1,   215,   216,    -1,
      -1,    -1,   220,   221,   222,    -1,    -1,    -1,    -1,    -1,
     228,   229,   230,   231,   232,   233,    -1,   235,   236,    -1,
     238,   239,   240,    -1,    -1,    -1,    -1,   245,   246,    -1,
     248,    75,    -1,   251,    -1,   253,    80,   255,    -1,    -1,
      -1,    -1,    -1,   261,   262,    -1,   264,   265,    -1,    -1,
      -1,   269,    -1,    -1,    -1,    -1,    -1,    -1,   276,   277,
     278,   279,   280,   281,   282,   283,   284,    -1,    -1,     1,
     288,    -1,     4,    -1,    -1,    -1,    -1,     9,    -1,    -1,
     298,    -1,    -1,    -1,    16,    -1,   304,    19,    20,   307,
     308,   309,    -1,    -1,    26,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    -1,    35,    36,    -1,    -1,    -1,   152,    -1,
      -1,    -1,    44,    45,    46,    -1,    -1,    -1,    50,    -1,
      -1,    -1,    54,    55,    -1,    57,    -1,    59,    -1,    61,
      62,    63,    64,    -1,    -1,   179,    -1,    -1,    -1,    -1,
     184,    -1,    -1,    -1,    -1,    -1,   190,    -1,    -1,   193,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   133,    -1,    -1,   136,    -1,   138,    -1,   140,    -1,
     142,   143,    -1,    -1,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   279,   280,   281,    -1,   283,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   303,
     304,   193,    -1,     1,   196,    -1,   198,   199,    -1,   201,
      -1,   203,    -1,    -1,   206,    -1,    14,   209,    -1,   211,
     212,    -1,    -1,    -1,    -1,    23,    -1,    -1,    -1,    -1,
      -1,   223,   224,    -1,    -1,    -1,    -1,    -1,   230,   231,
     232,   233,   234,    -1,    -1,   237,    -1,   239,    -1,    -1,
     242,    -1,   244,   245,   246,    -1,   248,   249,    -1,   251,
      -1,   253,   254,    -1,    -1,   257,   258,    65,   260,   261,
     262,   263,   264,   265,    -1,    73,    -1,   269,   270,   271,
      -1,    -1,    -1,    -1,   276,   277,   278,   279,   280,   281,
      -1,   283,   284,   285,   286,   287,    -1,   289,   290,   291,
     292,    -1,     1,    -1,    -1,     4,    -1,    -1,    -1,    -1,
       9,   303,   304,    -1,    -1,   307,   308,    16,    -1,    -1,
      19,    20,    -1,    -1,    -1,    -1,    -1,    26,    -1,    -1,
      -1,    30,    -1,    -1,   132,    -1,    35,    36,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    44,    45,    46,    -1,    -1,
     148,    50,    -1,   151,    -1,    54,    55,    -1,    57,   157,
      59,    -1,    61,    62,    63,    64,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   191,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   133,    -1,    -1,   136,    -1,   138,
      -1,   140,   240,   142,   143,    -1,    -1,    -1,   147,   148,
     149,    -1,   151,   152,   153,    -1,   155,   156,   157,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,    -1,    -1,   193,    -1,   294,   196,    -1,   198,
     199,   299,   201,    -1,   203,    -1,    -1,   206,    -1,    -1,
     209,    -1,   211,   212,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   223,   224,    -1,    -1,    -1,    -1,
      -1,   230,   231,   232,   233,   234,    -1,    -1,   237,    -1,
     239,    -1,    -1,   242,    -1,   244,   245,   246,    -1,   248,
     249,    -1,   251,    -1,   253,   254,    -1,    -1,   257,   258,
      -1,   260,   261,   262,   263,   264,   265,    -1,    -1,    -1,
     269,   270,   271,    -1,    -1,    -1,    -1,   276,   277,   278,
     279,   280,   281,    -1,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,   292,    -1,     1,    -1,    -1,     4,    -1,
      -1,    -1,    -1,     9,    -1,   304,    -1,    -1,   307,   308,
      16,    -1,    -1,    19,    20,    -1,    -1,    -1,    -1,    -1,
      26,    -1,    -1,    -1,    30,    -1,    -1,    -1,    -1,    35,
      36,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    44,    45,
      46,    -1,    -1,    -1,    50,    -1,    -1,    -1,    54,    55,
      -1,    57,    -1,    59,    -1,    61,    62,    63,    64,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   133,    -1,    -1,
     136,    -1,   138,    -1,   140,    -1,   142,   143,    -1,    -1,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,    -1,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,    -1,   201,    -1,   203,    -1,    -1,
     206,    -1,    -1,   209,    -1,   211,   212,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   223,   224,    -1,
      -1,    -1,    -1,    -1,   230,   231,   232,   233,   234,    -1,
      -1,   237,    -1,   239,    -1,    -1,   242,    -1,   244,   245,
     246,    -1,   248,   249,    -1,   251,    -1,   253,   254,    -1,
      -1,   257,   258,    -1,   260,   261,   262,   263,   264,   265,
      -1,    -1,    -1,   269,   270,   271,    -1,    -1,    -1,    -1,
     276,   277,   278,   279,   280,   281,    -1,   283,   284,   285,
     286,   287,    -1,   289,   290,   291,   292,    -1,     1,    -1,
      -1,     4,    -1,    -1,    -1,    -1,     9,    -1,   304,    -1,
      -1,   307,   308,    16,    -1,    -1,    19,    20,    -1,    -1,
      -1,    -1,    -1,    26,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    -1,    35,    36,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    44,    45,    46,    -1,    -1,    -1,    50,    -1,    -1,
      -1,    54,    55,    -1,    57,    -1,    59,    -1,    61,    62,
      63,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     133,    -1,    -1,   136,    -1,   138,    -1,   140,    -1,   142,
     143,    -1,    -1,    -1,   147,   148,   149,    -1,   151,   152,
     153,    -1,   155,   156,   157,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,    -1,    -1,
     193,    -1,    -1,   196,    -1,   198,   199,    -1,   201,    -1,
     203,    -1,    -1,   206,    -1,    -1,   209,    -1,   211,   212,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     223,   224,    -1,    -1,    -1,    -1,    -1,   230,   231,   232,
     233,   234,    -1,    -1,   237,    -1,   239,    -1,    -1,   242,
      -1,   244,   245,   246,    -1,   248,   249,    -1,   251,    -1,
     253,   254,    -1,    -1,   257,   258,    -1,   260,   261,   262,
     263,   264,   265,    -1,    -1,    -1,   269,   270,   271,    -1,
      -1,    -1,    -1,   276,   277,   278,   279,   280,   281,    -1,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,   292,
       1,    -1,    -1,     4,    -1,    -1,    -1,    -1,     9,    -1,
      -1,   304,    -1,    -1,   307,   308,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    -1,
      -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,
      61,    62,    -1,    -1,    -1,    -1,    67,    -1,    -1,    70,
      71,    72,    -1,    74,    -1,    76,    77,    -1,    79,    80,
      81,    -1,    83,    84,    -1,    86,    -1,    88,    89,    90,
      91,    92,    -1,    94,    -1,    96,    -1,    98,    99,   100,
      -1,   102,    -1,   104,    -1,   106,    -1,   108,   109,   110,
     111,   112,    -1,   114,   115,    -1,   117,   118,    -1,   120,
      -1,   122,    -1,   124,    -1,   126,    -1,   128,    -1,   130,
     131,   132,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       1,   142,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   152,    -1,    -1,   155,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,
      -1,    -1,    -1,   184,    -1,    -1,    -1,    -1,   189,    -1,
      -1,    -1,    -1,    -1,    -1,   196,    -1,   198,   199,    -1,
      -1,    -1,    -1,    -1,    -1,   206,    -1,    -1,   209,    -1,
     211,   212,    73,   214,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   223,   224,    -1,    -1,    -1,    -1,    -1,   230,
      -1,    -1,    -1,   234,    -1,    -1,   237,    -1,   239,    -1,
      -1,   242,    -1,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,   253,   254,    -1,    -1,   257,   258,    -1,   260,
     261,    -1,    -1,   264,   265,   266,    -1,    -1,   269,   270,
      -1,    -1,   133,    -1,    -1,   136,    -1,    -1,    -1,   140,
      -1,   142,   143,   284,    -1,    -1,   147,   148,   149,    -1,
     151,   152,   153,    -1,   155,   156,   157,    -1,    -1,    -1,
      -1,    -1,    -1,   304,    -1,    -1,   307,   308,    -1,     1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
      -1,    -1,   193,   194,    -1,   196,    -1,   198,    -1,    -1,
     201,    -1,   203,    -1,    -1,    -1,    -1,    -1,   209,    -1,
     211,   212,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   223,    -1,    -1,    -1,    -1,    -1,    -1,   230,
     231,   232,   233,    -1,   235,   236,    -1,   238,   239,    -1,
      -1,    -1,    -1,    -1,   245,   246,    -1,   248,    -1,    -1,
     251,    -1,   253,    -1,   255,    -1,    -1,    -1,    -1,    -1,
     261,   262,    -1,   264,   265,    -1,    -1,    -1,   269,    -1,
      -1,    -1,    -1,    -1,    -1,   276,   277,   278,   279,   280,
     281,   282,   283,   284,    -1,    -1,    -1,   288,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   298,    -1,    -1,
      -1,   133,    -1,   304,   136,    -1,   307,   308,   140,    -1,
     142,   143,    -1,    -1,    -1,   147,   148,   149,    -1,   151,
     152,   153,    -1,   155,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,    -1,
      -1,   193,   194,    -1,   196,    -1,   198,    -1,    -1,   201,
      -1,   203,    -1,    -1,    -1,    -1,    -1,   209,    -1,   211,
     212,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   223,    -1,    -1,    -1,    -1,    -1,    -1,   230,   231,
     232,   233,    -1,   235,   236,    -1,   238,   239,    -1,    -1,
      -1,    -1,    -1,   245,   246,    -1,   248,    -1,    -1,   251,
      -1,   253,    -1,   255,    -1,    -1,    -1,    -1,    -1,   261,
     262,    -1,   264,   265,    -1,    -1,    -1,   269,    -1,    -1,
      -1,    -1,    -1,    -1,   276,   277,   278,   279,   280,   281,
     282,   283,   284,    -1,    -1,    -1,   288,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   133,    -1,   298,   136,    -1,    -1,
      -1,   140,   304,   142,   143,   307,   308,    -1,   147,   148,
     149,    -1,   151,   152,   153,    -1,   155,   156,   157,    -1,
      -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,    -1,    -1,   193,   194,    -1,   196,    -1,   198,
      -1,    -1,   201,    -1,   203,    -1,    -1,    -1,    -1,    -1,
     209,    -1,   211,   212,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   223,    -1,    -1,    -1,    -1,    -1,
      -1,   230,   231,   232,   233,    -1,   235,   236,    -1,   238,
     239,    -1,    -1,    -1,    -1,    -1,   245,   246,    -1,   248,
      -1,    -1,   251,    -1,   253,    -1,   255,    -1,    -1,    -1,
      -1,    -1,   261,   262,    -1,   264,   265,    -1,    -1,    -1,
     269,    -1,    -1,    -1,    -1,    -1,    -1,   276,   277,   278,
     279,   280,   281,   282,   283,   284,    -1,    -1,    -1,   288,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   133,    -1,   298,
     136,    -1,    -1,    -1,   140,   304,   142,   143,   307,   308,
      -1,   147,   148,   149,    -1,   151,   152,   153,    -1,   155,
     156,   157,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,    -1,    -1,   193,   194,    -1,
     196,    -1,   198,    -1,    -1,   201,    -1,   203,    -1,    -1,
      -1,    -1,    -1,   209,    -1,   211,   212,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   230,   231,   232,   233,    -1,   235,
     236,    -1,   238,   239,    -1,    -1,    -1,    -1,    -1,   245,
     246,    -1,   248,    -1,    -1,   251,    -1,   253,    -1,   255,
      -1,    -1,    -1,    -1,    -1,   261,   262,    -1,   264,   265,
      -1,    -1,    -1,   269,    -1,    -1,    -1,    -1,    -1,    -1,
     276,   277,   278,   279,   280,   281,   282,   283,   284,    -1,
      -1,    -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   298,    -1,    -1,    -1,   133,   303,   304,   136,
      -1,   307,   308,   140,    -1,   142,   143,    -1,    -1,    -1,
     147,   148,   149,     1,   151,   152,   153,    -1,   155,   156,
     157,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,    -1,    -1,   193,   194,    -1,   196,
      -1,   198,    -1,    -1,   201,    -1,   203,    -1,    -1,    -1,
      -1,    -1,   209,    -1,   211,   212,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   230,   231,   232,   233,    -1,   235,   236,
      -1,   238,   239,    -1,    -1,    -1,    -1,    -1,   245,   246,
      -1,   248,    -1,    -1,   251,    -1,   253,    -1,   255,    -1,
      -1,    -1,    -1,    -1,   261,   262,    -1,   264,   265,    -1,
      -1,    -1,   269,    -1,    -1,    -1,    -1,    -1,    -1,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   136,     4,
      -1,   288,   140,    -1,     9,   143,    -1,    -1,    -1,   147,
     148,   298,    -1,   151,    -1,    -1,    -1,    -1,    -1,   157,
     307,   308,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      45,    -1,    -1,    -1,   182,   183,    -1,   185,   186,    54,
      -1,    -1,    -1,    -1,    -1,    -1,    61,    62,    -1,    -1,
      -1,    -1,    -1,   201,    -1,    -1,    -1,    -1,    73,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   231,   232,   233,    -1,   235,   236,    -1,
      -1,   239,    -1,    -1,    -1,    -1,    -1,    -1,   246,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   262,    -1,    -1,    -1,   133,    -1,
      -1,    -1,    -1,   138,    -1,    -1,    -1,   142,   276,   277,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   152,    -1,    -1,
     155,    -1,    -1,    -1,    -1,     4,    -1,    -1,    -1,    -1,
       9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,    -1,    -1,    -1,   179,   180,    -1,    -1,    -1,   184,
      -1,    -1,    -1,    -1,   189,   190,     1,    -1,   193,    -1,
      -1,   196,    -1,   198,   199,    -1,    45,    -1,    -1,    14,
      -1,   206,    -1,    -1,   209,    54,   211,   212,    23,    -1,
      -1,    -1,    61,    62,    -1,    -1,    -1,    -1,   223,   224,
      -1,    -1,    -1,    -1,    -1,   230,    -1,    -1,    -1,   234,
      -1,    -1,   237,    -1,    -1,    -1,    -1,   242,    -1,   244,
     245,    -1,    -1,   248,   249,    -1,   251,    -1,   253,   254,
      65,    -1,   257,   258,    -1,   260,   261,    -1,    73,   264,
     265,    -1,    -1,    -1,   269,   270,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   279,   280,   281,    -1,   283,   284,
      -1,    -1,    -1,    -1,   133,    -1,    -1,    -1,    -1,   138,
      -1,    -1,    -1,   142,    -1,    -1,    -1,    -1,    -1,   304,
      -1,    -1,    -1,   152,    -1,    -1,   155,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   132,    -1,    -1,
      -1,    -1,    -1,    19,    20,    -1,    -1,    -1,    -1,    -1,
     179,   180,    -1,   148,   149,   184,   151,    -1,    -1,    35,
     189,   190,   157,    -1,   193,    19,    20,   196,    -1,   198,
     199,    -1,    -1,    -1,    -1,    -1,    -1,   206,    -1,    -1,
     209,    35,   211,   212,    -1,    -1,    -1,   182,    64,    -1,
      -1,    -1,   187,   188,   223,   224,   191,    -1,    -1,    -1,
      -1,   230,    -1,    -1,    -1,   234,    -1,    -1,   237,    -1,
      64,    -1,    -1,   242,    -1,   244,   245,    -1,    -1,   248,
     249,    -1,   251,    -1,   253,   254,    -1,    -1,   257,   258,
      -1,   260,   261,    -1,    -1,   264,   265,    -1,    -1,    -1,
     269,   270,    -1,    -1,    -1,   240,    -1,    -1,    -1,    -1,
     279,   280,   281,    -1,   283,   284,    -1,    -1,    -1,    -1,
     136,    -1,    -1,    -1,   140,    -1,    -1,   143,    -1,    -1,
      -1,   147,    -1,     4,    -1,   304,    -1,   153,     9,    -1,
     156,    -1,   136,   278,    -1,    -1,   140,    -1,    -1,   143,
      -1,    -1,    -1,   147,    -1,    -1,    -1,    -1,    -1,   294,
      -1,    -1,    -1,    -1,   299,   181,    -1,   183,    -1,   185,
     186,    -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    54,    -1,   201,    -1,   203,    -1,   183,
      -1,   185,   186,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   231,   232,   233,    -1,    -1,
      -1,    -1,    -1,   239,    -1,    -1,    -1,    -1,    -1,    -1,
     246,    -1,    -1,    -1,    -1,    -1,    -1,   231,   232,   233,
      -1,    -1,    -1,    -1,    -1,   239,   262,   263,    -1,    -1,
      -1,    -1,   246,     4,    -1,   271,    -1,    -1,     9,    -1,
     276,   277,   133,    -1,    -1,    -1,    -1,   138,   262,    -1,
      -1,   142,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   152,   276,   277,   155,    -1,    -1,    -1,    39,    -1,
      -1,   307,   308,    -1,    45,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,   179,    -1,
     304,    -1,    -1,   184,    -1,    -1,    -1,    -1,   189,   190,
      -1,    -1,   193,    -1,    -1,   196,    -1,   198,   199,    -1,
      -1,    -1,    -1,    -1,    -1,   206,    -1,    -1,   209,    -1,
     211,   212,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   223,   224,    -1,    -1,    -1,    -1,    -1,   230,
      -1,    -1,    -1,   234,    -1,    -1,   237,    -1,    -1,    -1,
      -1,   242,    -1,   244,   245,    -1,    -1,   248,   249,     4,
     251,    -1,   253,   254,     9,    -1,   257,   258,    -1,   260,
     261,   142,    -1,   264,   265,    -1,    -1,    -1,   269,   270,
      -1,   152,    -1,    -1,   155,    -1,    -1,    -1,   279,   280,
     281,    -1,   283,   284,    -1,    -1,    -1,    -1,    -1,    -1,
      45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    54,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   189,    -1,
      -1,    -1,    -1,    -1,    -1,   196,    -1,   198,   199,    -1,
      -1,    -1,    77,    -1,    -1,    -1,    -1,    -1,   209,    -1,
     211,   212,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   223,   224,    -1,    -1,    -1,    -1,    -1,   230,
      -1,    -1,    -1,   234,    -1,    -1,   237,    -1,   239,    -1,
      -1,   242,    -1,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,   253,   254,    -1,    -1,   257,   258,    -1,   260,
     261,    -1,    -1,   264,   265,    16,    -1,   142,   269,   270,
      -1,    -1,    -1,    -1,    -1,    26,    -1,   152,    -1,    30,
     155,    -1,    -1,   284,    -1,    36,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    44,    -1,    46,    -1,    -1,    -1,    50,
      -1,    -1,    -1,    -1,    55,    -1,    57,    -1,    59,    -1,
      -1,    -1,    63,    -1,   189,    -1,    -1,    -1,    -1,    -1,
      -1,   196,    -1,   198,   199,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   209,    -1,   211,   212,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   223,   224,
      -1,    -1,    -1,    -1,    -1,   230,    -1,    -1,    -1,   234,
      -1,    -1,   237,    -1,   239,    -1,    -1,   242,    -1,   244,
     245,    -1,    -1,   248,   249,    -1,   251,    -1,   253,   254,
      -1,    -1,   257,   258,    -1,   260,   261,    -1,    -1,   264,
     265,    -1,    -1,    -1,   269,   270,    -1,   148,   149,    -1,
     151,    -1,    -1,    -1,    -1,    -1,   157,    -1,    -1,   284,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   182,    -1,    -1,    -1,    -1,   187,   188,    67,    -1,
      -1,    70,    71,    72,    73,    74,    75,    76,    77,    -1,
      79,    80,    81,    -1,    83,    84,    -1,    86,    -1,    88,
      89,    90,    91,    92,    -1,    94,    -1,    96,    -1,    98,
      99,   100,    -1,   102,    -1,   104,    -1,   106,    -1,   108,
     109,   110,   111,    -1,    -1,   114,   115,    -1,   117,   118,
      -1,   120,    -1,   122,    -1,   124,    -1,   126,    -1,   128,
      -1,   130,   131,   132,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   278,    -1,    -1,
     159,   160,   161,    -1,   285,   286,   287,    -1,   289,   290,
     291,   292,   171,   172,    -1,    -1,    -1,    -1,    -1,    67,
      -1,   180,    70,    71,    72,    73,    74,    75,    76,    77,
      -1,    79,    80,    81,    -1,    83,    84,    -1,    86,    -1,
      88,    89,    90,    91,    92,    -1,    94,    -1,    96,    -1,
      98,    99,   100,    -1,   102,    -1,   104,    -1,   106,    -1,
     108,   109,   110,   111,    -1,    -1,   114,   115,    -1,   117,
     118,    -1,   120,    -1,   122,    -1,   124,    -1,   126,    -1,
     128,    -1,   130,   131,   132,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   159,    -1,   161,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   180,    -1,   293,   294,   295,   296,   297,    -1,
      -1,    -1,   301,    -1,   303,   304,    -1,   306,    -1,    -1,
      -1,   310,   311,   312,   313,    -1,    -1,    -1,    67,    -1,
      -1,    70,    71,    72,    73,    74,    75,    76,    77,    -1,
      79,    80,    81,    -1,    83,    84,    -1,    86,    -1,    88,
      89,    90,    91,    92,    -1,    94,    -1,    96,    -1,    98,
      99,   100,    -1,   102,    -1,   104,    -1,   106,    -1,   108,
     109,   110,   111,    -1,    -1,   114,   115,    -1,   117,   118,
      -1,   120,    -1,   122,    -1,   124,    -1,   126,    -1,   128,
      -1,   130,   131,   132,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   293,   294,   295,   296,   297,
     159,    -1,   161,   301,    -1,   303,   304,    -1,   306,    -1,
      -1,    -1,   310,   311,   312,   313,    -1,    -1,    -1,    67,
      -1,   180,    70,    71,    72,    -1,    74,    75,    76,    77,
      -1,    79,    80,    81,    -1,    83,    84,    -1,    86,    -1,
      88,    89,    90,    91,    92,    -1,    94,    -1,    96,    -1,
      98,    99,   100,    -1,   102,    -1,   104,    -1,   106,    -1,
     108,   109,   110,   111,    -1,    -1,   114,   115,    -1,   117,
     118,    -1,   120,    -1,   122,    -1,   124,    -1,   126,    -1,
     128,    -1,   130,   131,   132,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   159,    -1,   161,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   180,    -1,   293,   294,   295,   296,   297,    -1,
      -1,    -1,   301,    -1,   303,   304,    -1,   306,    -1,    -1,
      -1,   310,   311,   312,   313,    -1,    -1,    -1,    67,    -1,
      -1,    70,    71,    72,    -1,    74,    75,    76,    77,    -1,
      79,    80,    81,    -1,    83,    84,    -1,    86,    -1,    88,
      89,    90,    91,    92,    -1,    94,    -1,    96,    -1,    98,
      99,   100,    -1,   102,    -1,   104,    -1,   106,    -1,   108,
     109,   110,   111,    -1,    -1,   114,   115,    -1,   117,   118,
      -1,   120,    -1,   122,    -1,   124,    -1,   126,    -1,   128,
      -1,   130,   131,   132,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   293,   294,   295,   296,   297,
     159,    -1,   161,   301,    -1,   303,   304,    -1,   306,    -1,
      -1,    -1,   310,   311,   312,   313,    -1,    -1,    -1,    67,
      -1,   180,    70,    71,    72,    -1,    74,    75,    76,    77,
      -1,    79,    80,    81,    -1,    83,    84,    -1,    86,    -1,
      88,    89,    90,    91,    92,    -1,    94,    -1,    96,    -1,
      98,    99,   100,    -1,   102,    -1,   104,    -1,   106,    -1,
     108,   109,   110,   111,    -1,    -1,   114,   115,    -1,   117,
     118,    -1,   120,    -1,   122,    -1,   124,    -1,   126,    -1,
     128,    -1,   130,   131,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   159,    -1,   161,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   180,    -1,   293,   294,   295,   296,   297,    -1,
      -1,    -1,   301,    -1,   303,   304,    -1,   306,    -1,    -1,
      -1,   310,   311,   312,   313,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    80,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     133,    -1,    -1,   136,    -1,    -1,    -1,   140,    -1,   142,
     143,    -1,    -1,    -1,   147,   148,   149,    -1,   151,   152,
     153,    -1,   155,   156,   157,   293,   294,   295,   296,   297,
      -1,    -1,    -1,   301,    -1,   303,   304,    -1,   306,    -1,
      -1,    -1,   310,   311,   312,   313,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,    -1,    -1,
     193,   194,    -1,   196,    -1,   198,    -1,    -1,   201,    -1,
     203,    -1,    -1,    -1,    -1,    -1,   209,    -1,   211,   212,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   230,   231,   232,
     233,    -1,   235,   236,    -1,   238,   239,    -1,    -1,    -1,
      -1,    -1,   245,   246,    -1,   248,    -1,    -1,   251,    -1,
     253,    -1,   255,    -1,    -1,    -1,    -1,    -1,   261,   262,
      -1,   264,   265,    -1,    -1,    -1,   269,    -1,    -1,    -1,
      -1,    -1,    -1,   276,   277,   278,   279,   280,   281,   282,
     283,   284,    -1,    -1,    -1,   288,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   133,    -1,   298,   136,    -1,    -1,    -1,
     140,    -1,   142,   143,   307,   308,    -1,   147,   148,   149,
      -1,   151,   152,   153,    -1,   155,   156,   157,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,    -1,    -1,   193,   194,    -1,   196,    -1,   198,    -1,
      -1,   201,    -1,   203,    -1,    -1,    -1,    -1,    -1,   209,
      -1,   211,   212,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     230,   231,   232,   233,    -1,   235,   236,    -1,   238,   239,
      -1,    -1,    -1,    -1,    -1,   245,   246,    -1,   248,    -1,
      -1,   251,    -1,   253,    -1,   255,    -1,    -1,    -1,    -1,
      -1,   261,   262,    -1,   264,   265,    -1,    -1,    -1,   269,
      -1,    -1,    -1,    -1,    -1,    -1,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   136,    -1,    -1,   288,   140,
      -1,    -1,   143,    -1,    -1,    -1,   147,   148,   298,    -1,
     151,    -1,    -1,    -1,    -1,    -1,   157,   307,   308,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   182,   183,    -1,   185,   186,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   133,    -1,    -1,    -1,    -1,    -1,    -1,
     201,    -1,   142,    -1,    -1,    -1,    -1,    -1,   148,   149,
      -1,   151,   152,    -1,    -1,   155,    -1,   157,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     231,   232,   233,    -1,   235,   236,    -1,    -1,   239,   179,
      -1,    -1,   182,    -1,   184,   246,    -1,   187,   188,   189,
     190,    -1,    -1,   193,    -1,    -1,   196,    -1,   198,    -1,
      -1,   262,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   209,
      -1,   211,   212,    -1,    -1,   276,   277,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     230,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,    -1,
      -1,    -1,    -1,    -1,    -1,   245,   307,   308,   248,    -1,
      -1,   251,    -1,   253,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   261,    -1,    -1,   264,   265,    -1,    -1,    -1,   269,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   278,   279,
     280,   281,   282,   283,   284,    -1,    -1,    -1,   288
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   315,     0,     1,     3,     5,     6,     7,     8,    10,
      11,    12,    13,    33,   152,   153,   155,   156,   159,   179,
     181,   189,   203,   204,   208,   213,   220,   221,   222,   229,
     294,   299,   313,   316,   317,   318,   319,   334,   335,   354,
     356,   357,   360,   370,   371,   372,   376,   382,   383,   384,
     389,   397,   398,   401,   403,   419,   422,   429,   430,   535,
     543,   544,   696,   716,   304,   307,   308,   639,   642,   648,
     653,   656,   659,     1,    67,    70,    71,    72,    74,    76,
      77,    79,    80,    81,    83,    84,    86,    88,    89,    90,
      91,    92,    94,    96,    98,    99,   100,   102,   104,   106,
     108,   109,   110,   111,   112,   114,   115,   117,   118,   120,
     122,   124,   126,   128,   130,   131,   132,   206,   214,   266,
     331,   653,   658,   675,     1,   653,   655,     1,     3,   669,
     669,   305,   373,   374,     1,    15,    53,    61,   304,   380,
     642,     1,   304,   669,   228,   724,     1,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   173,   174,   175,   176,
     177,   361,   369,   669,   542,   543,     1,   213,   695,   431,
     358,   716,   655,   716,   716,   716,   716,     1,    72,    74,
      80,   133,   136,   140,   142,   143,   147,   148,   149,   151,
     152,   155,   157,   178,   179,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   193,   194,   196,   198,   201,
     209,   211,   212,   216,   228,   230,   231,   232,   233,   235,
     236,   238,   239,   240,   245,   246,   248,   251,   253,   255,
     261,   262,   264,   265,   269,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   288,   298,   304,   385,   387,   389,
     390,   393,   395,   396,   413,   419,   420,   428,   445,   447,
     448,   450,   476,   477,   479,   487,   514,   516,   517,   518,
     519,   520,   521,   523,   524,   525,   526,   527,   529,   531,
     532,   533,   534,   535,   544,   547,   548,   550,   552,   553,
     555,   563,   565,   566,   575,   576,   642,   647,   648,   682,
     683,   687,   731,   716,   299,   716,   716,   716,   716,   716,
     716,   402,   399,   404,    47,   698,   699,   700,    67,     1,
      17,    38,    60,   663,    67,     1,    73,   711,     1,    75,
     706,    74,    74,     4,     9,    39,    45,    54,   142,   152,
     155,   189,   196,   198,   199,   209,   211,   212,   223,   224,
     230,   234,   237,   239,   242,   244,   245,   248,   249,   251,
     253,   254,   257,   258,   260,   261,   264,   265,   269,   270,
     284,   332,   333,   549,   603,     1,    17,   132,   662,   320,
     662,   114,   375,   374,    53,    61,   381,    43,   302,   684,
     685,    17,    31,   155,   229,   377,   379,    67,    70,    71,
      72,    73,    74,    75,    76,    77,    79,    80,    81,    83,
      84,    86,    88,    89,    90,    91,    92,    94,    96,    98,
      99,   100,   102,   104,   106,   108,   109,   110,   111,   114,
     115,   117,   118,   120,   122,   124,   126,   128,   130,   131,
     132,   159,   161,   180,   293,   294,   295,   296,   297,   301,
     303,   304,   306,   310,   311,   312,   313,   336,   337,   346,
     347,   348,   349,   353,   423,     1,   304,   644,   644,     1,
     304,   307,   637,   638,     1,   159,   304,   359,   645,   663,
     189,   230,   476,   514,   682,    79,    80,   114,   223,   304,
     414,   415,   416,   545,   546,   547,   563,   306,   309,   606,
     718,     1,    72,   692,   692,    67,   355,   692,    74,   549,
      74,   551,   567,   577,     1,   239,   665,    72,   468,     1,
      98,   693,   391,   692,   132,   478,   421,   517,   519,   515,
     516,   692,   549,   554,   555,   554,   566,   576,    67,   528,
     215,   430,   205,   207,   309,   679,    83,     1,   639,   640,
     640,     1,   304,   406,   407,   408,   642,     1,    58,   544,
     696,   712,   713,   698,   304,   642,     4,     9,    45,    54,
      61,    62,   133,   138,   142,   152,   155,   180,   189,   193,
     198,   199,   206,   209,   211,   212,   223,   224,   230,   245,
     248,   249,   251,   253,   264,   265,   269,   279,   280,   281,
     284,   304,   548,   550,   580,   599,   600,   601,   602,   603,
     604,   608,   615,   616,   648,   654,   729,   642,   648,   706,
     706,    32,    34,    37,   605,   150,   247,   256,   274,    24,
      74,   324,     1,   230,   730,   606,     1,   200,   691,     1,
     243,   678,     1,   259,   728,   548,   729,   655,   321,   580,
     700,   580,     1,   305,    17,   379,     1,   377,   378,     1,
      72,   132,   341,   342,   343,   344,   345,   346,    72,   337,
     338,   339,   340,   514,    72,   362,   554,     1,   304,   304,
     580,   711,   386,   304,     1,   223,   720,    75,     1,   132,
     673,   547,   562,   563,   547,   295,     1,   718,   719,   514,
     420,     1,   303,   725,   726,   556,    79,   110,   707,     1,
      75,    80,   725,   692,   692,   451,   514,   724,     1,   514,
     648,   725,    72,    79,    80,   110,   180,   286,   287,   289,
     290,   291,   292,   434,   435,   437,   439,   440,   441,   443,
     449,   470,   472,   473,   475,   480,   482,   483,   485,   486,
     487,   489,   527,   590,   639,   642,   647,   648,   649,   437,
     433,   434,     1,   514,   639,   640,   641,   640,   641,   639,
     514,   692,   692,   638,   293,   536,   400,   405,    67,    67,
     640,   605,   247,   730,     1,    29,   677,   606,   691,    80,
     609,   725,   700,    16,    26,    30,    50,    55,    57,    59,
      63,   285,   518,   581,   584,   585,   586,   588,   589,   590,
     596,   610,   611,   612,   613,   614,   617,   618,   619,   620,
     602,    17,     1,    42,   690,     1,   275,   660,     1,    72,
      74,   325,    28,    55,   326,   327,   328,   416,    72,   591,
     592,    41,   607,     1,    27,   674,    14,    65,   191,   240,
     322,   323,   330,   662,   378,    72,   350,   351,   352,   353,
      73,   132,   343,   342,   345,   340,   424,     1,   180,   304,
     363,   364,   365,    72,    73,   132,   160,   171,   172,   346,
     366,   367,   368,     1,   114,   681,    72,   180,   475,   482,
     485,   490,   491,   492,   493,   494,   495,   497,   498,   500,
     502,   504,   649,   467,   468,   416,   562,   711,   522,   711,
     229,   557,     1,    74,   689,    75,   706,   706,   692,     1,
     304,   570,   578,   579,   180,   223,   304,   462,   463,   464,
     643,   721,   388,   392,    73,   394,   711,   711,   108,   471,
     545,     1,   648,   649,   132,    74,   442,   468,   474,   481,
     545,   293,   650,   438,   439,   449,   473,    69,   215,   650,
     564,   565,   530,   536,   295,   295,   488,   462,     1,   446,
     692,     1,   148,   151,   157,   182,   523,   527,   529,   537,
     539,   540,   541,   295,   410,   411,     1,   409,   411,   189,
     304,   642,   189,   642,   648,   607,    80,   304,   582,   725,
     591,    72,   587,     1,    60,   722,     1,    55,   708,     1,
      18,   666,    40,   583,   591,    44,    46,   694,   722,    19,
      20,    35,    64,   136,   140,   143,   147,   183,   185,   186,
     201,   231,   232,   233,   239,   246,   262,   263,   271,   276,
     277,   527,   535,   544,   621,   622,   623,   624,   625,   626,
     627,   630,   631,   620,   580,   692,   326,   326,    22,   138,
     329,    60,   329,    75,   673,   580,   593,   594,    56,   150,
     597,   598,   709,   215,   702,    17,    60,   664,   726,     1,
     580,   725,   600,   350,    73,   352,   338,   342,   344,   425,
     426,   437,    73,   673,   368,   514,   108,   499,   649,   501,
     503,   505,   442,   711,   468,   331,   462,   490,   644,     1,
     234,   237,   244,   254,   257,   260,   261,   270,   558,   559,
     560,   648,   648,   657,   568,   569,   570,    72,   571,    73,
     570,    73,   452,   469,   673,   514,   490,   420,   490,   444,
     437,     1,   435,   436,     1,   152,   304,   545,   546,   706,
     725,   564,   462,   437,   437,   484,   726,    80,   675,   680,
     719,   490,   475,   482,   485,   506,   507,   508,   510,   512,
     649,   452,   452,   446,   540,   541,   538,   539,     1,   296,
     397,   412,   422,   429,   644,   644,     1,    47,   697,   446,
       1,    44,   580,     1,    16,   661,   597,    36,   580,    51,
     629,     1,   147,   688,     1,    49,   703,     1,   136,   670,
     725,   727,    52,   704,   655,     1,   272,   628,   640,   640,
       1,    65,    72,   725,   593,    73,    75,     1,   138,   676,
     644,   328,    73,   673,     1,   580,   700,    19,    21,   667,
      23,   668,   668,    55,    57,   596,    73,   132,   365,   432,
     496,   490,   490,   490,   490,   648,   652,   462,    77,   417,
     469,   711,     1,   293,   672,    72,   561,   561,    75,   673,
     132,   706,    73,   673,    72,   297,   303,   304,   306,   309,
     572,   573,   574,   224,   249,   456,   453,     1,   464,   466,
     465,     1,    99,   686,   711,   545,   711,    75,   545,   706,
      80,   152,   706,   717,   706,   452,   437,   549,   468,   644,
     711,   509,   511,   513,   692,   456,   456,   452,   538,   294,
     715,     1,   294,   714,   714,   580,    73,   697,   304,   646,
     591,   688,   271,    47,   632,   726,   726,   667,    73,     1,
     580,   595,     1,   709,   710,   708,   694,     1,   426,   427,
     490,   545,   711,   452,   514,   719,   706,   560,   648,   711,
     570,   573,    73,   673,   692,    72,   114,   460,   454,   490,
     692,   437,   304,   725,   706,   304,   725,   707,   462,   692,
     506,   506,   506,   452,   564,   564,   456,     1,   296,   705,
       1,   544,   671,   697,   597,   628,   155,   723,   667,   711,
     597,   580,     1,   215,   701,   490,   456,   418,   711,     1,
     711,   574,   463,   711,     1,   210,   225,   457,     1,   138,
     206,   725,   248,   251,   283,   455,   548,     1,   648,   651,
     711,   706,   706,   706,   706,   456,   452,     1,   461,   463,
     456,   564,   655,   580,   540,   633,   634,   635,   591,   711,
      77,   458,   565,   490,    73,   711,   711,   692,   458,   707,
      73,   460,   460,   580,   304,   622,   636,   654,   540,   597,
     468,   514,   462,   460,   456,   456,   462,   459,    73,   458,
     458,   469,   490,   564,   460
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   314,   315,   315,   316,   316,   316,   316,   316,   316,
     316,   316,   316,   316,   316,   316,   316,   316,   316,   316,
     317,   317,   318,   318,   318,   318,   318,   319,   320,   319,
     319,   319,   319,   321,   321,   321,   322,   322,   322,   323,
     323,   323,   324,   324,   324,   325,   325,   325,   326,   326,
     327,   327,   328,   328,   328,   328,   329,   329,   329,   330,
     331,   331,   332,   332,   333,   333,   333,   333,   333,   333,
     333,   333,   333,   333,   333,   333,   333,   333,   333,   333,
     333,   333,   333,   333,   333,   333,   333,   333,   333,   333,
     333,   334,   335,   335,   336,   336,   336,   337,   337,   338,
     338,   339,   339,   340,   340,   341,   341,   341,   341,   341,
     341,   341,   342,   342,   343,   343,   344,   344,   345,   345,
     346,   346,   346,   346,   346,   346,   346,   347,   347,   348,
     348,   348,   349,   349,   349,   349,   349,   349,   349,   349,
     349,   349,   349,   349,   349,   349,   349,   349,   349,   349,
     349,   349,   349,   349,   349,   349,   349,   349,   349,   349,
     349,   349,   349,   349,   349,   349,   349,   349,   349,   349,
     349,   349,   349,   349,   349,   349,   349,   349,   349,   349,
     350,   350,   351,   351,   352,   352,   353,   353,   354,   354,
     354,   354,   354,   354,   354,   354,   354,   354,   354,   354,
     355,   354,   354,   354,   354,   354,   356,   358,   357,   359,
     359,   359,   359,   359,   360,   360,   360,   360,   360,   360,
     360,   360,   360,   360,   360,   360,   360,   360,   360,   360,
     361,   362,   362,   363,   363,   364,   364,   365,   365,   365,
     366,   366,   367,   367,   368,   368,   368,   368,   368,   368,
     368,   369,   370,   371,   372,   372,   373,   373,   374,   375,
     375,   375,   376,   376,   376,   376,   376,   376,   376,   377,
     377,   377,   378,   378,   379,   379,   380,   380,   380,   380,
     381,   381,   381,   382,   383,   384,   386,   385,   385,   388,
     387,   389,   389,   389,   389,   391,   392,   390,   393,   393,
     394,   393,   393,   395,   395,   396,   397,   397,   397,   399,
     400,   398,   402,   401,   404,   405,   403,   406,   406,   406,
     407,   407,   407,   407,   408,   408,   408,   408,   409,   409,
     410,   410,   411,   411,   412,   412,   412,   412,   413,   414,
     414,   415,   415,   416,   416,   416,   416,   416,   416,   417,
     418,   417,   419,   421,   420,   423,   424,   422,   425,   425,
     426,   427,   427,   428,   429,   431,   432,   430,   433,   433,
     434,   434,   435,   436,   436,   437,   437,   437,   437,   437,
     438,   438,   439,   439,   439,   439,   439,   439,   439,   439,
     439,   439,   440,   440,   441,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   444,   443,   445,   446,   446,
     447,   448,   449,   451,   450,   453,   452,   454,   454,   455,
     455,   455,   455,   456,   456,   456,   456,   456,   457,   457,
     457,   458,   459,   458,   458,   460,   460,   460,   460,   460,
     461,   461,   462,   462,   463,   463,   465,   464,   464,   464,
     466,   466,   467,   467,   468,   469,   471,   470,   472,   474,
     473,   475,   476,   476,   478,   477,   479,   481,   480,   482,
     484,   483,   485,   485,   486,   488,   487,   489,   490,   490,
     491,   491,   491,   491,   492,   492,   492,   492,   492,   492,
     493,   493,   494,   496,   495,   497,   499,   498,   501,   500,
     503,   502,   505,   504,   506,   506,   507,   507,   507,   507,
     509,   508,   511,   510,   513,   512,   514,   514,   514,   515,
     515,   516,   516,   517,   517,   517,   517,   518,   518,   518,
     518,   518,   518,   518,   518,   519,   519,   520,   520,   520,
     520,   520,   520,   522,   521,   523,   523,   524,   524,   524,
     524,   524,   524,   524,   524,   524,   524,   524,   524,   524,
     524,   524,   525,   526,   527,   528,   528,   530,   529,   529,
     531,   531,   532,   532,   533,   533,   534,   534,   535,   536,
     536,   536,   537,   537,   537,   538,   538,   539,   539,   540,
     540,   540,   540,   541,   541,   541,   542,   542,   543,   543,
     544,   544,   545,   545,   546,   546,   546,   547,   547,   547,
     547,   547,   547,   547,   548,   548,   549,   549,   550,   550,
     551,   551,   551,   551,   552,   552,   552,   552,   552,   552,
     552,   552,   552,   552,   552,   552,   552,   552,   552,   552,
     552,   552,   552,   552,   553,   553,   554,   554,   556,   555,
     555,   557,   557,   558,   558,   559,   559,   560,   560,   560,
     560,   560,   560,   560,   560,   560,   560,   561,   561,   562,
     562,   563,   563,   564,   564,   565,   565,   567,   566,   568,
     568,   569,   569,   570,   570,   571,   571,   572,   572,   573,
     573,   574,   574,   574,   574,   574,   574,   575,   575,   577,
     576,   578,   578,   579,   579,   580,   580,   580,   581,   581,
     582,   582,   582,   582,   583,   583,   584,   585,   586,   587,
     587,   588,   589,   589,   590,   590,   590,   590,   590,   590,
     591,   591,   592,   593,   593,   594,   594,   595,   595,   596,
     596,   596,   597,   597,   598,   598,   599,   600,   600,   601,
     601,   602,   602,   602,   603,   603,   603,   603,   603,   603,
     603,   603,   603,   603,   603,   603,   603,   603,   604,   604,
     604,   604,   604,   604,   604,   604,   604,   604,   604,   604,
     604,   604,   604,   604,   604,   604,   604,   604,   604,   604,
     604,   604,   604,   604,   604,   604,   604,   605,   605,   605,
     606,   607,   607,   608,   608,   608,   608,   608,   608,   608,
     609,   609,   610,   610,   610,   610,   610,   610,   610,   610,
     610,   611,   611,   611,   612,   613,   613,   614,   615,   616,
     616,   616,   617,   617,   618,   618,   619,   619,   620,   621,
     621,   621,   621,   621,   621,   622,   622,   623,   623,   623,
     623,   623,   623,   623,   623,   623,   623,   623,   623,   623,
     623,   623,   623,   623,   624,   624,   624,   624,   625,   625,
     625,   626,   626,   627,   628,   628,   629,   629,   630,   631,
     632,   632,   633,   633,   634,   634,   635,   635,   636,   636,
     637,   637,   638,   638,   639,   639,   640,   640,   641,   641,
     642,   642,   643,   644,   644,   645,   645,   646,   646,   647,
     647,   648,   648,   648,   649,   650,   650,   651,   651,   652,
     652,   653,   654,   655,   655,   656,   656,   657,   657,   658,
     658,   659,   659,   659,   660,   660,   661,   661,   662,   662,
     663,   663,   663,   663,   664,   664,   664,   665,   665,   666,
     666,   667,   667,   667,   668,   668,   669,   669,   670,   670,
     671,   671,   672,   672,   673,   673,   674,   674,   675,   675,
     675,   675,   675,   675,   675,   675,   675,   675,   675,   675,
     675,   675,   675,   675,   675,   675,   675,   675,   675,   675,
     675,   675,   675,   675,   675,   675,   675,   675,   675,   675,
     675,   675,   675,   675,   675,   675,   675,   675,   675,   675,
     675,   675,   675,   675,   675,   675,   676,   676,   677,   677,
     678,   678,   679,   679,   680,   681,   681,   682,   682,   683,
     683,   684,   685,   685,   686,   686,   687,   687,   688,   688,
     689,   689,   690,   690,   691,   691,   692,   692,   693,   693,
     694,   694,   694,   695,   695,   696,   696,   697,   697,   698,
     699,   699,   700,   700,   701,   701,   702,   702,   703,   703,
     704,   704,   705,   705,   706,   706,   707,   707,   707,   708,
     708,   709,   709,   710,   710,   711,   711,   712,   712,   712,
     713,   713,   714,   714,   715,   715,   716,   716,   717,   717,
     718,   718,   719,   719,   720,   720,   721,   721,   722,   722,
     723,   723,   724,   724,   725,   726,   726,   727,   727,   728,
     728,   729,   729,   730,   730,   731,   731
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     1,     2,     2,     2,     2,     2,     1,     1,
       4,     4,     2,     2,     2,     2,     1,     4,     0,    11,
       6,     9,     2,     1,     2,     2,     3,     3,     2,     2,
       1,     1,     0,     2,     3,     3,     3,     1,     0,     1,
       3,     1,     2,     2,     3,     1,     0,     2,     1,     3,
       0,     2,     1,     1,     1,     1,     2,     1,     1,     1,
       1,     1,     1,     3,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     1,
       2,     4,     3,     2,     0,     2,     4,     1,     1,     0,
       1,     2,     1,     1,     1,     0,     1,     1,     2,     3,
       2,     1,     2,     1,     3,     1,     2,     1,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     1,     2,     1,     1,     3,     1,     1,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       0,     4,     2,     3,     2,     2,     1,     0,     3,     0,
       1,     2,     2,     1,     1,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       4,     0,     3,     0,     1,     3,     1,     1,     1,     1,
       0,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     1,     1,     2,     2,     1,     2,     0,
       2,     2,     3,     4,     4,     5,     3,     2,     2,     1,
       1,     1,     1,     1,     0,     1,     0,     2,     1,     1,
       0,     1,     1,     1,     1,     1,     0,     6,     3,     0,
       9,     1,     1,     1,     1,     0,     0,     5,     4,     4,
       0,     6,     4,     1,     1,     4,     1,     1,     1,     0,
       0,     5,     0,     4,     0,     0,     5,     1,     1,     1,
       3,     3,     4,     1,     3,     3,     4,     1,     1,     1,
       0,     1,     2,     4,     1,     2,     2,     1,     6,     0,
       1,     3,     1,     1,     2,     1,     1,     1,     2,     0,
       0,     4,     1,     0,     3,     0,     0,     6,     3,     1,
       1,     1,     1,     1,     1,     0,     0,     8,     0,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       1,     1,     2,     2,     3,     2,     3,     3,     3,     5,
       5,     4,     5,     5,     3,     0,    10,     9,     0,     1,
       7,     7,     8,     0,     7,     0,     3,     0,     2,     1,
       1,     1,     1,     0,     1,     4,     3,     4,     1,     1,
       1,     0,     0,     4,     1,     0,     2,     2,     2,     2,
       1,     1,     0,     1,     3,     1,     0,     4,     1,     1,
       1,     1,     0,     3,     1,     1,     0,     4,    10,     0,
       3,     2,     3,     1,     0,     3,     2,     0,     3,     4,
       0,     4,     1,     1,     2,     0,     9,     9,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     0,     9,     6,     0,     4,     0,     3,
       0,     3,     0,     3,     0,     1,     1,     1,     1,     1,
       0,     3,     0,     3,     0,     3,     1,     2,     1,     0,
       1,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     1,     1,     1,
       1,     1,     1,     0,     6,     1,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     6,     2,     0,     2,     0,     6,     3,
       1,     1,     1,     1,     3,     4,     4,     4,     2,     0,
       2,     2,     1,     3,     2,     0,     1,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     1,     1,
       1,     1,     0,     1,     3,     2,     2,     1,     1,     1,
       1,     1,     2,     1,     1,     1,     0,     2,     1,     1,
       2,     3,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     0,     7,
       1,     0,     3,     0,     1,     3,     1,     1,     2,     1,
       2,     1,     1,     1,     1,     1,     1,     0,     3,     0,
       1,     1,     1,     0,     1,     2,     1,     0,     7,     0,
       1,     3,     1,     2,     1,     0,     3,     0,     1,     3,
       1,     1,     1,     1,     1,     3,     1,     2,     1,     0,
       5,     0,     1,     2,     1,     1,     1,     1,     4,     6,
       0,     1,     1,     1,     0,     1,     3,     2,     2,     0,
       3,     5,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     1,     3,     0,     1,     3,     1,     1,     1,     0,
       1,     2,     0,     1,     2,     2,     2,     0,     1,     2,
       1,     1,     1,     1,     2,     1,     1,     2,     1,     2,
       1,     2,     1,     1,     3,     1,     1,     1,     1,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     1,
       2,     1,     1,     1,     1,     1,     2,     1,     1,     1,
       1,     0,     1,     1,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     7,     3,     3,     1,     2,     2,     6,     3,
       1,     1,     2,     1,     0,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     1,     1,     1,     1,     2,     1,     1,
       2,     2,     1,     1,     3,     4,     4,     2,     1,     2,
       3,     2,     4,     2,     1,     1,     0,     1,     2,     3,
       0,     3,     2,     1,     0,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     1,
       1,     1,     1,     1,     1,     2,     1,     0,     1,     0,
       2,     3,     3,     1,     2,     0,     2,     1,     1,     0,
       1,     2,     2,     1,     1,     0,     1,     3,     1,     3,
       1,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     1,     1,     1,     1,     1,
       1,     0,     1,     1,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     3,     0,
       1,     1,     0,     1,     1,     1,     0,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     1,     1,     1,     1,     1,     2,     1,     1,     3,
       2,     1,     0,     1,     1,     1,     0,     1,     1,     1,
       0,     1,     1,     1,     1,     1,     0,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     1,     1,     1,     0,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     1,     1,
       0,     1,     0,     1,     1,     1,     1,     0,     1,     1,
       1,     1,     2,     1,     1,     0,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YYLOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YYLOCATION_PRINT

#  if defined YY_LOCATION_PRINT

   /* Temporary convenience wrapper in case some people defined the
      undocumented and private YY_LOCATION_PRINT macros.  */
#   define YYLOCATION_PRINT(File, Loc)  YY_LOCATION_PRINT(File, *(Loc))

#  elif defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
}

#   define YYLOCATION_PRINT  yy_location_print_

    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT(File, Loc)  YYLOCATION_PRINT(File, &(Loc))

#  else

#   define YYLOCATION_PRINT(File, Loc) ((void) 0)
    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT  YYLOCATION_PRINT

#  endif
# endif /* !defined YYLOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YYLOCATION_PRINT (yyo, yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yykind)
    {
    case YYSYMBOL_Y_CONSTRUCTOR_SNAME: /* Y_CONSTRUCTOR_SNAME  */
#line 1989 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5312 "parser.c"
        break;

    case YYSYMBOL_Y_DESTRUCTOR_SNAME: /* Y_DESTRUCTOR_SNAME  */
#line 1989 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5318 "parser.c"
        break;

    case YYSYMBOL_Y_OPERATOR_SNAME: /* Y_OPERATOR_SNAME  */
#line 1989 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5324 "parser.c"
        break;

    case YYSYMBOL_Y_CHAR_LIT: /* Y_CHAR_LIT  */
#line 1991 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).str_val) );                             }
#line 5330 "parser.c"
        break;

    case YYSYMBOL_Y_CONCEPT_SNAME: /* Y_CONCEPT_SNAME  */
#line 1989 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5336 "parser.c"
        break;

    case YYSYMBOL_Y_GLOB: /* Y_GLOB  */
#line 1983 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5342 "parser.c"
        break;

    case YYSYMBOL_Y_NAME: /* Y_NAME  */
#line 1983 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5348 "parser.c"
        break;

    case YYSYMBOL_Y_SET_OPTION: /* Y_SET_OPTION  */
#line 1983 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5354 "parser.c"
        break;

    case YYSYMBOL_Y_STR_LIT: /* Y_STR_LIT  */
#line 1991 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).str_val) );                             }
#line 5360 "parser.c"
        break;

    case YYSYMBOL_capturing_paren_capture_decl_list_english_opt: /* capturing_paren_capture_decl_list_english_opt  */
#line 1982 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5366 "parser.c"
        break;

    case YYSYMBOL_paren_capture_decl_list_english: /* paren_capture_decl_list_english  */
#line 1982 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5372 "parser.c"
        break;

    case YYSYMBOL_capture_decl_list_english_opt: /* capture_decl_list_english_opt  */
#line 1982 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5378 "parser.c"
        break;

    case YYSYMBOL_capture_decl_list_english: /* capture_decl_list_english  */
#line 1982 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5384 "parser.c"
        break;

    case YYSYMBOL_p_extra_token_except_lparen: /* p_extra_token_except_lparen  */
#line 1987 "parser.y"
            { DTRACE; p_token_free( ((*yyvaluep).p_token) );                     }
#line 5390 "parser.c"
        break;

    case YYSYMBOL_p_extra_tokens_opt: /* p_extra_tokens_opt  */
#line 1988 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5396 "parser.c"
        break;

    case YYSYMBOL_p_extra_tokens: /* p_extra_tokens  */
#line 1988 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5402 "parser.c"
        break;

    case YYSYMBOL_p_extra_token: /* p_extra_token  */
#line 1987 "parser.y"
            { DTRACE; p_token_free( ((*yyvaluep).p_token) );                     }
#line 5408 "parser.c"
        break;

    case YYSYMBOL_p_arg_list_opt: /* p_arg_list_opt  */
#line 1984 "parser.y"
            { DTRACE; p_arg_list_cleanup( ((*yyvaluep).p_arg_list) );   FREE( ((*yyvaluep).p_arg_list) ); }
#line 5414 "parser.c"
        break;

    case YYSYMBOL_p_comma_arg_list: /* p_comma_arg_list  */
#line 1984 "parser.y"
            { DTRACE; p_arg_list_cleanup( ((*yyvaluep).p_arg_list) );   FREE( ((*yyvaluep).p_arg_list) ); }
#line 5420 "parser.c"
        break;

    case YYSYMBOL_p_arg_list: /* p_arg_list  */
#line 1984 "parser.y"
            { DTRACE; p_arg_list_cleanup( ((*yyvaluep).p_arg_list) );   FREE( ((*yyvaluep).p_arg_list) ); }
#line 5426 "parser.c"
        break;

    case YYSYMBOL_p_arg_tokens: /* p_arg_tokens  */
#line 1988 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5432 "parser.c"
        break;

    case YYSYMBOL_p_arg_token_as_list: /* p_arg_token_as_list  */
#line 1988 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5438 "parser.c"
        break;

    case YYSYMBOL_p_arg_token: /* p_arg_token  */
#line 1987 "parser.y"
            { DTRACE; p_token_free( ((*yyvaluep).p_token) );                     }
#line 5444 "parser.c"
        break;

    case YYSYMBOL_p_arg_tokens_with_comma_opt: /* p_arg_tokens_with_comma_opt  */
#line 1988 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5450 "parser.c"
        break;

    case YYSYMBOL_p_arg_tokens_with_comma: /* p_arg_tokens_with_comma  */
#line 1988 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5456 "parser.c"
        break;

    case YYSYMBOL_p_arg_token_with_comma_as_list: /* p_arg_token_with_comma_as_list  */
#line 1988 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5462 "parser.c"
        break;

    case YYSYMBOL_p_arg_token_with_comma: /* p_arg_token_with_comma  */
#line 1987 "parser.y"
            { DTRACE; p_token_free( ((*yyvaluep).p_token) );                     }
#line 5468 "parser.c"
        break;

    case YYSYMBOL_help_what_opt: /* help_what_opt  */
#line 1983 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5474 "parser.c"
        break;

    case YYSYMBOL_p_paren_param_list_opt: /* p_paren_param_list_opt  */
#line 1986 "parser.y"
            { DTRACE; p_param_list_cleanup( ((*yyvaluep).p_param_list) ); FREE( ((*yyvaluep).p_param_list) ); }
#line 5480 "parser.c"
        break;

    case YYSYMBOL_p_param_list_opt: /* p_param_list_opt  */
#line 1986 "parser.y"
            { DTRACE; p_param_list_cleanup( ((*yyvaluep).p_param_list) ); FREE( ((*yyvaluep).p_param_list) ); }
#line 5486 "parser.c"
        break;

    case YYSYMBOL_p_param_list: /* p_param_list  */
#line 1986 "parser.y"
            { DTRACE; p_param_list_cleanup( ((*yyvaluep).p_param_list) ); FREE( ((*yyvaluep).p_param_list) ); }
#line 5492 "parser.c"
        break;

    case YYSYMBOL_p_param: /* p_param  */
#line 1985 "parser.y"
            { DTRACE; p_param_free( ((*yyvaluep).p_param) );                     }
#line 5498 "parser.c"
        break;

    case YYSYMBOL_p_replace_list_opt: /* p_replace_list_opt  */
#line 1988 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5504 "parser.c"
        break;

    case YYSYMBOL_p_replace_list: /* p_replace_list  */
#line 1988 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5510 "parser.c"
        break;

    case YYSYMBOL_p_replace_token: /* p_replace_token  */
#line 1987 "parser.y"
            { DTRACE; p_token_free( ((*yyvaluep).p_token) );                     }
#line 5516 "parser.c"
        break;

    case YYSYMBOL_set_option_value_opt: /* set_option_value_opt  */
#line 1991 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).str_val) );                             }
#line 5522 "parser.c"
        break;

    case YYSYMBOL_namespace_sname_c_exp: /* namespace_sname_c_exp  */
#line 1989 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5528 "parser.c"
        break;

    case YYSYMBOL_namespace_sname_c: /* namespace_sname_c  */
#line 1989 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5534 "parser.c"
        break;

    case YYSYMBOL_namespace_typedef_sname_c: /* namespace_typedef_sname_c  */
#line 1989 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5540 "parser.c"
        break;

    case YYSYMBOL_capture_decl_list_c_opt: /* capture_decl_list_c_opt  */
#line 1982 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5546 "parser.c"
        break;

    case YYSYMBOL_capture_decl_list_c: /* capture_decl_list_c  */
#line 1982 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5552 "parser.c"
        break;

    case YYSYMBOL_decl_list_c: /* decl_list_c  */
#line 1982 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5558 "parser.c"
        break;

    case YYSYMBOL_param_c_ast_list_exp: /* param_c_ast_list_exp  */
#line 1982 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5564 "parser.c"
        break;

    case YYSYMBOL_param_c_ast_list_opt: /* param_c_ast_list_opt  */
#line 1982 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5570 "parser.c"
        break;

    case YYSYMBOL_param_c_ast_list: /* param_c_ast_list  */
#line 1982 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5576 "parser.c"
        break;

    case YYSYMBOL_paren_param_c_ast_list_opt: /* paren_param_c_ast_list_opt  */
#line 1982 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5582 "parser.c"
        break;

    case YYSYMBOL_pc99_pointer_decl_list_c: /* pc99_pointer_decl_list_c  */
#line 1982 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5588 "parser.c"
        break;

    case YYSYMBOL_sub_scope_sname_c_opt: /* sub_scope_sname_c_opt  */
#line 1989 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5594 "parser.c"
        break;

    case YYSYMBOL_paren_param_decl_list_english_opt: /* paren_param_decl_list_english_opt  */
#line 1982 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5600 "parser.c"
        break;

    case YYSYMBOL_paren_param_decl_list_english: /* paren_param_decl_list_english  */
#line 1982 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5606 "parser.c"
        break;

    case YYSYMBOL_param_decl_list_english_opt: /* param_decl_list_english_opt  */
#line 1982 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5612 "parser.c"
        break;

    case YYSYMBOL_param_decl_list_english: /* param_decl_list_english  */
#line 1982 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5618 "parser.c"
        break;

    case YYSYMBOL_any_name: /* any_name  */
#line 1983 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5624 "parser.c"
        break;

    case YYSYMBOL_any_name_exp: /* any_name_exp  */
#line 1983 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5630 "parser.c"
        break;

    case YYSYMBOL_any_sname_c: /* any_sname_c  */
#line 1989 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5636 "parser.c"
        break;

    case YYSYMBOL_any_sname_c_exp: /* any_sname_c_exp  */
#line 1989 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5642 "parser.c"
        break;

    case YYSYMBOL_any_sname_c_opt: /* any_sname_c_opt  */
#line 1989 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5648 "parser.c"
        break;

    case YYSYMBOL_name_exp: /* name_exp  */
#line 1983 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5654 "parser.c"
        break;

    case YYSYMBOL_name_cat: /* name_cat  */
#line 1983 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5660 "parser.c"
        break;

    case YYSYMBOL_name_opt: /* name_opt  */
#line 1983 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5666 "parser.c"
        break;

    case YYSYMBOL_oper_sname_c_opt: /* oper_sname_c_opt  */
#line 1989 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5672 "parser.c"
        break;

    case YYSYMBOL_sname_c: /* sname_c  */
#line 1989 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5678 "parser.c"
        break;

    case YYSYMBOL_sname_c_exp: /* sname_c_exp  */
#line 1989 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5684 "parser.c"
        break;

    case YYSYMBOL_sname_c_opt: /* sname_c_opt  */
#line 1989 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5690 "parser.c"
        break;

    case YYSYMBOL_sname_english: /* sname_english  */
#line 1989 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5696 "parser.c"
        break;

    case YYSYMBOL_sname_english_exp: /* sname_english_exp  */
#line 1989 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5702 "parser.c"
        break;

    case YYSYMBOL_sname_english_opt: /* sname_english_opt  */
#line 1989 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5708 "parser.c"
        break;

    case YYSYMBOL_sname_list_c: /* sname_list_c  */
#line 1990 "parser.y"
            { DTRACE; c_sname_list_cleanup( &((*yyvaluep).sname_list) );            }
#line 5714 "parser.c"
        break;

    case YYSYMBOL_sname_list_english: /* sname_list_english  */
#line 1990 "parser.y"
            { DTRACE; c_sname_list_cleanup( &((*yyvaluep).sname_list) );            }
#line 5720 "parser.c"
        break;

    case YYSYMBOL_typedef_sname_c: /* typedef_sname_c  */
#line 1989 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5726 "parser.c"
        break;

    case YYSYMBOL_destructor_sname: /* destructor_sname  */
#line 1989 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5732 "parser.c"
        break;

    case YYSYMBOL_glob: /* glob  */
#line 1983 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5738 "parser.c"
        break;

    case YYSYMBOL_glob_opt: /* glob_opt  */
#line 1983 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5744 "parser.c"
        break;

    case YYSYMBOL_of_scope_english: /* of_scope_english  */
#line 1989 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5750 "parser.c"
        break;

    case YYSYMBOL_of_scope_list_english: /* of_scope_list_english  */
#line 1989 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5756 "parser.c"
        break;

    case YYSYMBOL_of_scope_list_english_opt: /* of_scope_list_english_opt  */
#line 1989 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5762 "parser.c"
        break;

    case YYSYMBOL_str_lit: /* str_lit  */
#line 1991 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).str_val) );                             }
#line 5768 "parser.c"
        break;

    case YYSYMBOL_str_lit_exp: /* str_lit_exp  */
#line 1991 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).str_val) );                             }
#line 5774 "parser.c"
        break;

      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* command_list: command_list command  */
#line 1999 "parser.y"
    { //
      // We get here only after a successful parse.
      //
      parse_cleanup( /*fatal_error=*/false );
    }
#line 6073 "parser.c"
    break;

  case 19: /* command: error  */
#line 2023 "parser.y"
    {
      if ( printable_yytext() != NULL )
        elaborate_error_dym( DYM_COMMANDS, "unexpected token" );
      else
        elaborate_error( "unexpected end of command" );
    }
#line 6084 "parser.c"
    break;

  case 20: /* cast_command: Y_cast sname_english_opt as_into_to_exp decl_english_ast  */
#line 2042 "parser.y"
    {
      DUMP_START( "cast_command",
                  "CAST sname_english_opt {AS|[IN]TO} decl_english_ast" );
      DUMP_SNAME( "sname_english_opt", (yyvsp[-2].sname) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      c_ast_t *const cast_ast = c_ast_new_gc( K_CAST, &(yylsp[-2]) );
      cast_ast->sname = c_sname_move( &(yyvsp[-2].sname) );
      cast_ast->cast.kind = C_CAST_C;
      cast_ast->cast.to_ast = (yyvsp[0].ast);

      DUMP_AST( "$$_ast", cast_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( cast_ast ) );
      c_ast_gibberish( cast_ast, C_GIB_PRINT_CAST, stdout );
    }
#line 6106 "parser.c"
    break;

  case 21: /* cast_command: new_style_cast_english sname_english_exp as_into_to_exp decl_english_ast  */
#line 2065 "parser.y"
    {
      DUMP_START( "cast_command",
                  "new_style_cast_english sname_english_exp {AS|[IN]TO} "
                  "decl_english_ast" );
      DUMP_STR( "new_style_cast_english", c_cast_gibberish( (yyvsp[-3].cast_kind) ) );
      DUMP_SNAME( "sname_english_exp", (yyvsp[-2].sname) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      c_ast_t *const cast_ast = c_ast_new_gc( K_CAST, &(yyloc) );
      cast_ast->sname = c_sname_move( &(yyvsp[-2].sname) );
      cast_ast->cast.kind = (yyvsp[-3].cast_kind);
      cast_ast->cast.to_ast = (yyvsp[0].ast);

      DUMP_AST( "$$_ast", cast_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( cast_ast ) );
      c_ast_gibberish( cast_ast, C_GIB_PRINT_CAST, stdout );
    }
#line 6130 "parser.c"
    break;

  case 22: /* new_style_cast_english: Y_const cast_exp  */
#line 2087 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_CONST;        }
#line 6136 "parser.c"
    break;

  case 23: /* new_style_cast_english: Y_dynamic cast_exp  */
#line 2088 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_DYNAMIC;      }
#line 6142 "parser.c"
    break;

  case 24: /* new_style_cast_english: Y_reinterpret cast_exp  */
#line 2089 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_REINTERPRET;  }
#line 6148 "parser.c"
    break;

  case 25: /* new_style_cast_english: Y_static cast_exp  */
#line 2090 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_STATIC;       }
#line 6154 "parser.c"
    break;

  case 27: /* declare_command: Y_declare sname_list_english as_exp alignas_or_width_decl_english_ast  */
#line 2102 "parser.y"
    {
      if ( c_ast_is_name_error( (yyvsp[0].ast) ) ) {
        //
        // This checks for a case like:
        //
        //      declare x as y
        //
        // i.e., declaring a variable name as another name (unknown type).
        // This can get this far due to the nature of the C/C++ grammar.
        //
        // This check has to be done now in the parser rather than later in the
        // AST because the name of the AST node needs to be set to the variable
        // name, but the AST node is itself a name and overwriting it would
        // lose information.
        //
        c_sname_list_cleanup( &(yyvsp[-2].sname_list) );
        PARSE_ABORT();
      }

      DUMP_START( "declare_command",
                  "DECLARE sname_list_english AS "
                  "alignas_or_width_decl_english_ast" );
      DUMP_SNAME_LIST( "sname_list_english", (yyvsp[-2].sname_list) );
      DUMP_AST( "alignas_or_width_decl_english_ast", (yyvsp[0].ast) );

      slist_t *sname_list = &(yyvsp[-2].sname_list);
      c_ast_t *const struct_bind_ast = c_ast_unreference_any( (yyvsp[0].ast) );

      if ( struct_bind_ast->kind == K_STRUCTURED_BINDING ) {
        //
        // For ref-qualified structured bindings, it's much simpler to
        // retroactively change $decl_ast to the structured binding AST
        // directly eliding the reference AST and fold in the reference type.
        //
        struct_bind_ast->type.stids |= (yyvsp[0].ast)->type.stids;
        switch ( (yyvsp[0].ast)->kind ) {
          case K_REFERENCE:
            struct_bind_ast->type.stids |= TS_REFERENCE;
            break;
          case K_RVALUE_REFERENCE:
            struct_bind_ast->type.stids |= TS_RVALUE_REFERENCE;
            break;
          default:
            /* suppress warning */;
        } // switch
        (yyvsp[0].ast) = struct_bind_ast;
        c_ast_set_parent( (yyvsp[0].ast), /*parent_ast=*/NULL );

        //
        // A structured binding is inverted: instead of having one structured
        // binding AST for each name, we have just one structured binding AST
        // with a list of name(s).
        //
        (yyvsp[0].ast)->struct_bind.sname_list = slist_move( sname_list );
        sname_list = &(yyvsp[0].ast)->struct_bind.sname_list;
      }

      DUMP_AST( "$$_ast", (yyvsp[0].ast) );
      DUMP_END();

      (yyvsp[0].ast)->loc = (yylsp[-2]);

      bool ok = true;
      //
      // Ensure that none of the names aren't of a previously declared type:
      //
      //      cdecl> struct S
      //      cdecl> declare S as int // error: "S": previously declared
      //
      // This check is done now in the parser rather than later in the AST
      // since similar checks are also done here in the parser.
      //
      FOREACH_SLIST_NODE( sname_node, sname_list ) {
        c_sname_t const *const sname = sname_node->data;
        if ( c_sname_is_type( sname, &(yyvsp[0].ast)->loc ) ) {
          ok = false;
          break;
        }
      } // for

      if ( ok ) {
        // To check the declaration, it needs a name: just dup the first one.
        c_sname_t temp_sname = c_sname_dup( slist_front( sname_list ) );
        c_sname_set( &(yyvsp[0].ast)->sname, &temp_sname );
        ok = c_ast_check( (yyvsp[0].ast) );
      }

      if ( ok ) {
        if ( (yyvsp[0].ast)->kind == K_STRUCTURED_BINDING ) {
          decl_flags_t decl_flags = C_GIB_PRINT_DECL;
          if ( opt_semicolon )
            decl_flags |= C_GIB_OPT_SEMICOLON;
          c_ast_gibberish( (yyvsp[0].ast), decl_flags, stdout );
        }
        else {
          c_ast_sname_list_gibberish( (yyvsp[0].ast), &(yyvsp[-2].sname_list), stdout );
        }
      }

      c_sname_list_cleanup( &(yyvsp[-2].sname_list) );
      PARSE_ASSERT( ok );
      PUTC( '\n' );
    }
#line 6262 "parser.c"
    break;

  case 28: /* $@1: %empty  */
#line 2210 "parser.y"
    { //
      // This check is done now in the parser right here mid-rule rather than
      // later in the end-rule action or in the AST since it yields a better
      // error message since otherwise it would warn that "operator" is a
      // keyword in C++98 which skims right past the bigger error that operator
      // overloading isn't supported in C.
      //
      if ( !IS_SUPPORTED( operator ) ) {
        print_error( &(yylsp[0]),
          "operator overloading not supported%s\n",
          C_LANG_WHICH( operator )
        );
        PARSE_ABORT();
      }
    }
#line 6282 "parser.c"
    break;

  case 29: /* declare_command: Y_declare c_operator $@1 of_scope_list_english_opt as_exp type_qualifier_list_english_type_opt ref_qualifier_english_stid_opt member_or_non_member_opt operator_exp paren_param_decl_list_english_opt returning_english_ast_opt  */
#line 2231 "parser.y"
    {
      c_operator_t const *const operator = c_op_get( (yyvsp[-9].op_id) );

      DUMP_START( "declare_command",
                  "DECLARE c_operator of_scope_list_english_opt AS "
                  "type_qualifier_list_english_type_opt "
                  "ref_qualifier_english_stid_opt "
                  "member_or_non_member_opt "
                  "OPERATOR paren_param_decl_list_english_opt "
                  "returning_english_ast_opt" );
      DUMP_STR( "c_operator", operator->literal );
      DUMP_SNAME( "of_scope_list_english_opt", (yyvsp[-7].sname) );
      DUMP_TYPE( "type_qualifier_list_english_type_opt", (yyvsp[-5].type) );
      DUMP_TID( "ref_qualifier_english_stid_opt", (yyvsp[-4].tid) );
      DUMP_INT( "member_or_non_member_opt", (yyvsp[-3].member) );
      DUMP_AST_LIST( "paren_param_decl_list_english_opt", (yyvsp[-1].ast_list) );
      DUMP_AST( "returning_english_ast_opt", (yyvsp[0].ast) );
      DUMP_END();

      c_ast_t *const oper_ast = c_ast_new_gc( K_OPERATOR, &(yylsp[-9]) );
      c_sname_set( &oper_ast->sname, &(yyvsp[-7].sname) );
      PARSE_ASSERT( c_type_add( &oper_ast->type, &(yyvsp[-5].type), &(yylsp[-5]) ) );
      PARSE_ASSERT(
        c_type_add_tid( &oper_ast->type, (yyvsp[-4].tid), &(yylsp[-4]) )
      );
      oper_ast->oper.operator = operator;
      c_ast_list_set_param_of( &(yyvsp[-1].ast_list), oper_ast );
      oper_ast->oper.param_ast_list = slist_move( &(yyvsp[-1].ast_list) );
      oper_ast->oper.member = (yyvsp[-3].member);
      c_ast_set_parent( (yyvsp[0].ast), oper_ast );

      PARSE_ASSERT( c_ast_check( oper_ast ) );
      decl_flags_t decl_flags = C_GIB_PRINT_DECL;
      if ( opt_semicolon )
        decl_flags |= C_GIB_OPT_SEMICOLON;
      c_ast_gibberish( oper_ast, decl_flags, stdout );
      PUTC( '\n' );
    }
#line 6325 "parser.c"
    break;

  case 30: /* declare_command: Y_declare storage_class_subset_english_type_opt Y_lambda capturing_paren_capture_decl_list_english_opt paren_param_decl_list_english_opt returning_english_ast_opt  */
#line 2277 "parser.y"
    {
      DUMP_START( "declare_command",
                  "DECLARE storage_class_subset_english_type_opt "
                  "LAMBDA capturing_paren_capture_decl_list_english_opt "
                  "paren_param_decl_list_english_opt"
                  "returning_english_ast_opt" );
      DUMP_TYPE( "storage_class_subset_english_type_opt", (yyvsp[-4].type) );
      DUMP_AST_LIST( "capturing_paren_capture_decl_list_english_opt",
                     (yyvsp[-2].ast_list) );
      DUMP_AST_LIST( "paren_param_decl_list_english_opt", (yyvsp[-1].ast_list) );
      DUMP_AST( "returning_english_ast_opt", (yyvsp[0].ast) );

      c_ast_t *const lambda_ast = c_ast_new_gc( K_LAMBDA, &(yylsp[-3]) );
      lambda_ast->type = (yyvsp[-4].type);
      c_ast_list_set_param_of( &(yyvsp[-2].ast_list), lambda_ast );
      lambda_ast->lambda.capture_ast_list = slist_move( &(yyvsp[-2].ast_list) );
      c_ast_list_set_param_of( &(yyvsp[-1].ast_list), lambda_ast );
      lambda_ast->lambda.param_ast_list = slist_move( &(yyvsp[-1].ast_list) );
      c_ast_set_parent( (yyvsp[0].ast), lambda_ast );

      DUMP_AST( "$$_ast", lambda_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( lambda_ast ) );
      c_ast_gibberish( lambda_ast, C_GIB_PRINT_DECL, stdout );
      PUTC( '\n' );
    }
#line 6357 "parser.c"
    break;

  case 31: /* declare_command: Y_declare storage_class_subset_english_type_opt cv_qualifier_list_stid_opt user_defined conversion_exp operator_opt of_scope_list_english_opt returning_exp decl_english_ast  */
#line 2312 "parser.y"
    {
      DUMP_START( "declare_command",
                  "DECLARE storage_class_subset_english_type_opt "
                  "cv_qualifier_list_stid_opt "
                  "USER-DEFINED CONVERSION [OPERATOR] "
                  "of_scope_list_english_opt "
                  "RETURNING decl_english_ast" );
      DUMP_TYPE( "storage_class_subset_english_type_opt", (yyvsp[-7].type) );
      DUMP_TID( "cv_qualifier_list_stid_opt", (yyvsp[-6].tid) );
      DUMP_SNAME( "of_scope_list_english_opt", (yyvsp[-2].sname) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      c_ast_t *const udc_ast = c_ast_new_gc( K_UDEF_CONV, &(yyloc) );
      c_sname_set( &udc_ast->sname, &(yyvsp[-2].sname) );
      udc_ast->type = c_type_or( &(yyvsp[-7].type), &C_TYPE_LIT_S( (yyvsp[-6].tid) ) );
      c_ast_set_parent( (yyvsp[0].ast), udc_ast );

      DUMP_AST( "$$_ast", udc_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( udc_ast ) );
      decl_flags_t decl_flags = C_GIB_PRINT_DECL;
      if ( opt_semicolon )
        decl_flags |= C_GIB_OPT_SEMICOLON;
      c_ast_gibberish( udc_ast, decl_flags, stdout );
      PUTC( '\n' );
    }
#line 6389 "parser.c"
    break;

  case 32: /* declare_command: Y_declare error  */
#line 2341 "parser.y"
    {
      if ( OPT_LANG_IS( operator ) )
        elaborate_error( "name or operator expected" );
      else
        elaborate_error( "name expected" );
    }
#line 6400 "parser.c"
    break;

  case 34: /* alignas_or_width_decl_english_ast: decl_english_ast alignas_specifier_english  */
#line 2353 "parser.y"
    {
      DUMP_START( "alignas_or_width_decl_english_ast",
                  "decl_english_ast alignas_specifier_english" );
      DUMP_AST( "decl_english_ast", (yyvsp[-1].ast) );
      DUMP_ALIGN( "alignas_specifier_english", (yyvsp[0].align) );

      (yyval.ast) = (yyvsp[-1].ast);
      (yyval.ast)->align = (yyvsp[0].align);
      (yyval.ast)->loc = (yyloc);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 6418 "parser.c"
    break;

  case 35: /* alignas_or_width_decl_english_ast: decl_english_ast width_specifier_english_uint  */
#line 2368 "parser.y"
    {
      DUMP_START( "alignas_or_width_decl_english_ast",
                  "decl_english_ast width_specifier_english_uint" );
      DUMP_AST( "decl_english_ast", (yyvsp[-1].ast) );
      DUMP_INT( "width_specifier_english_uint", (yyvsp[0].uint_val) );

      //
      // This check has to be done now in the parser rather than later in the
      // AST since we need to use the builtin union member now.
      //
      if ( !c_ast_is_integral( (yyvsp[-1].ast) ) ) {
        print_error( &(yylsp[0]), "invalid bit-field type " );
        print_ast_type_aka( (yyvsp[-1].ast), stderr );
        EPRINTF( "; must be an integral %stype\n",
          OPT_LANG_IS( enum_BITFIELDS ) ? "or enumeration " : ""
        );
        PARSE_ABORT();
      }

      (yyval.ast) = (yyvsp[-1].ast);
      (yyval.ast)->loc = (yyloc);
      (yyval.ast)->bit_field.bit_width = (yyvsp[0].uint_val);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 6449 "parser.c"
    break;

  case 36: /* alignas_specifier_english: aligned_english uint_lit bytes_opt  */
#line 2398 "parser.y"
    {
      DUMP_START( "alignas_specifier_english", "ALIGNAS uint_lit [BYTES]" );
      DUMP_INT( "uint_lit", (yyvsp[-1].uint_val) );

      (yyval.align).kind = C_ALIGNAS_BYTES;
      (yyval.align).loc = (yyloc);
      (yyval.align).bytes = (yyvsp[-1].uint_val);

      DUMP_ALIGN( "$$_align", (yyval.align) );
      DUMP_END();
    }
#line 6465 "parser.c"
    break;

  case 37: /* alignas_specifier_english: aligned_english decl_english_ast bytes_opt  */
#line 2410 "parser.y"
    {
      DUMP_START( "alignas_specifier_english",
                  "ALIGNAS decl_english_ast [BYTES]" );
      DUMP_AST( "decl_english_ast", (yyvsp[-1].ast) );

      if ( (yyvsp[-1].ast)->kind == K_NAME ) {
        (yyval.align).kind = C_ALIGNAS_SNAME;
        (yyval.align).sname = c_sname_move( &(yyvsp[-1].ast)->sname );
      } else {
        (yyval.align).kind = C_ALIGNAS_TYPE;
        (yyval.align).type_ast = (yyvsp[-1].ast);
      }
      (yyval.align).loc = (yyloc);

      DUMP_ALIGN( "$$_align", (yyval.align) );
      DUMP_END();
    }
#line 6487 "parser.c"
    break;

  case 38: /* alignas_specifier_english: aligned_english error  */
#line 2428 "parser.y"
    {
      (yyval.align) = (c_alignas_t){ 0 };
      (yyval.align).loc = (yyloc);
      elaborate_error( "integer or type expected" );
    }
#line 6497 "parser.c"
    break;

  case 42: /* capturing_paren_capture_decl_list_english_opt: %empty  */
#line 2442 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 6503 "parser.c"
    break;

  case 43: /* capturing_paren_capture_decl_list_english_opt: Y_capturing paren_capture_decl_list_english  */
#line 2444 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[0].ast_list);
    }
#line 6511 "parser.c"
    break;

  case 44: /* capturing_paren_capture_decl_list_english_opt: '[' capture_decl_list_english_opt ']'  */
#line 2448 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[-1].ast_list);
    }
#line 6519 "parser.c"
    break;

  case 45: /* paren_capture_decl_list_english: '[' capture_decl_list_english_opt ']'  */
#line 2455 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[-1].ast_list);
    }
#line 6527 "parser.c"
    break;

  case 46: /* paren_capture_decl_list_english: '(' capture_decl_list_english_opt ')'  */
#line 2459 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[-1].ast_list);
    }
#line 6535 "parser.c"
    break;

  case 47: /* paren_capture_decl_list_english: error  */
#line 2463 "parser.y"
    {
      slist_init( &(yyval.ast_list) );
      elaborate_error( "'[' or '(' expected\n" );
    }
#line 6544 "parser.c"
    break;

  case 48: /* capture_decl_list_english_opt: %empty  */
#line 2470 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 6550 "parser.c"
    break;

  case 50: /* capture_decl_list_english: capture_decl_list_english comma_exp capture_decl_english_ast  */
#line 2477 "parser.y"
    {
      DUMP_START( "capture_decl_list_english",
                  "capture_decl_list_english ',' capture_decl_english_ast" );
      DUMP_AST_LIST( "capture_decl_list_english", (yyvsp[-2].ast_list) );
      DUMP_AST( "capture_decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast_list) = (yyvsp[-2].ast_list);
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 6567 "parser.c"
    break;

  case 51: /* capture_decl_list_english: capture_decl_english_ast  */
#line 2491 "parser.y"
    {
      DUMP_START( "capture_decl_list_english",
                  "capture_decl_english_ast" );
      DUMP_AST( "capture_decl_english_ast", (yyvsp[0].ast) );

      slist_init( &(yyval.ast_list) );
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 6583 "parser.c"
    break;

  case 52: /* capture_decl_english_ast: Y_copy capture_default_opt  */
#line 2506 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      (yyval.ast)->capture.kind = C_CAPTURE_COPY;
    }
#line 6592 "parser.c"
    break;

  case 53: /* capture_decl_english_ast: Y_reference capture_default_opt  */
#line 2511 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      (yyval.ast)->capture.kind = C_CAPTURE_REFERENCE;
    }
#line 6601 "parser.c"
    break;

  case 54: /* capture_decl_english_ast: Y_reference Y_to name_exp  */
#line 2516 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      c_sname_init_name( &(yyval.ast)->sname, (yyvsp[0].name) );
      (yyval.ast)->capture.kind = C_CAPTURE_REFERENCE;
    }
#line 6611 "parser.c"
    break;

  case 59: /* width_specifier_english_uint: Y_width uint_lit_exp bits_opt  */
#line 2532 "parser.y"
    { //
      // This check has to be done now in the parser rather than later in the
      // AST since we use 0 to mean "no bit-field."
      //
      if ( (yyvsp[-1].uint_val) == 0 ) {
        print_error( &(yylsp[-1]), "bit-field width must be > 0\n" );
        PARSE_ABORT();
      }
      (yyval.uint_val) = (yyvsp[-1].uint_val);
    }
#line 6626 "parser.c"
    break;

  case 60: /* storage_class_subset_english_type_opt: %empty  */
#line 2545 "parser.y"
                                  { (yyval.type) = T_NONE; }
#line 6632 "parser.c"
    break;

  case 61: /* storage_class_subset_english_type_opt: storage_class_subset_english_type_opt storage_class_subset_english_type  */
#line 2548 "parser.y"
    {
      DUMP_START( "storage_class_subset_english_type_opt",
                  "storage_class_subset_english_type_opt "
                  "storage_class_subset_english_type" );
      DUMP_TYPE( "storage_class_subset_english_type_opt", (yyvsp[-1].type) );
      DUMP_TYPE( "storage_class_subset_english_type", (yyvsp[0].type) );

      (yyval.type) = (yyvsp[-1].type);
      PARSE_ASSERT( c_type_add( &(yyval.type), &(yyvsp[0].type), &(yylsp[0]) ) );

      DUMP_TYPE( "$$_type", (yyval.type) );
      DUMP_END();
    }
#line 6650 "parser.c"
    break;

  case 62: /* storage_class_subset_english_type: attribute_english_atid  */
#line 2564 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_A( (yyvsp[0].tid) ); }
#line 6656 "parser.c"
    break;

  case 63: /* storage_class_subset_english_type: storage_class_subset_english_stid  */
#line 2566 "parser.y"
    {
      (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) );
    }
#line 6664 "parser.c"
    break;

  case 64: /* storage_class_subset_english_stid: Y_auto_TYPE  */
#line 2586 "parser.y"
                                  { (yyval.tid) = TS_auto; }
#line 6670 "parser.c"
    break;

  case 66: /* storage_class_subset_english_stid: Y_constant eval_expr_init_stid  */
#line 2589 "parser.y"
    {
      (yyval.tid) = (yyvsp[0].tid);
    }
#line 6678 "parser.c"
    break;

  case 73: /* storage_class_subset_english_stid: Y_extern linkage_stid linkage_opt  */
#line 2599 "parser.y"
    {
      (yyval.tid) = (yyvsp[-1].tid);
    }
#line 6686 "parser.c"
    break;

  case 78: /* storage_class_subset_english_stid: Y_no Y_except  */
#line 2606 "parser.y"
                                  { (yyval.tid) = TS_noexcept; }
#line 6692 "parser.c"
    break;

  case 80: /* storage_class_subset_english_stid: Y_non_empty  */
#line 2608 "parser.y"
                                  { (yyval.tid) = TS_NON_EMPTY_ARRAY; }
#line 6698 "parser.c"
    break;

  case 84: /* storage_class_subset_english_stid: Y_thread local_exp  */
#line 2612 "parser.y"
                                  { (yyval.tid) = TS_thread_local; }
#line 6704 "parser.c"
    break;

  case 90: /* storage_class_subset_english_stid: Y_pure virtual_stid_exp  */
#line 2618 "parser.y"
                                  { (yyval.tid) = TS_PURE_virtual | (yyvsp[0].tid); }
#line 6710 "parser.c"
    break;

  case 91: /* define_command: Y_define sname_english_exp as_exp decl_english_ast  */
#line 2625 "parser.y"
    {
      DUMP_START( "define_command",
                  "DEFINE sname_english AS decl_english_ast" );
      DUMP_SNAME( "sname_english_exp", (yyvsp[-2].sname) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      // see the comment in "declare_command"
      if ( c_ast_is_name_error( (yyvsp[0].ast) ) ) {
        c_sname_cleanup( &(yyvsp[-2].sname) );
        PARSE_ABORT();
      }

      if ( !c_tid_is_any( (yyvsp[0].ast)->type.stids, TS_typedef ) ) {
        //
        // Explicitly add TS_typedef (if it doesn't have it already) to
        // prohibit cases like:
        //
        //      define eint as extern int
        //      define rint as register int
        //      define sint as static int
        //      ...
        //
        // i.e., a defined type with a storage class.  Once the semantic checks
        // pass, remove the TS_typedef.
        //
        PARSE_ASSERT(
          c_type_add( &(yyvsp[0].ast)->type, &T_TS_typedef, &(yylsp[0]) )
        );
      }
      PARSE_ASSERT( c_ast_check( (yyvsp[0].ast) ) );
      PJL_DISCARD_RV( c_ast_take_type_any( (yyvsp[0].ast), &T_TS_typedef ) );

      c_sname_set( &(yyvsp[0].ast)->sname, &(yyvsp[-2].sname) );
      if ( c_tid_is_any( (yyvsp[0].ast)->type.btids, TB_ANY_SCOPE ) )
        c_sname_local_data( &(yyvsp[0].ast)->sname )->type = (yyvsp[0].ast)->type;
      c_sname_set_all_types( &(yyvsp[0].ast)->sname );

      DUMP_AST( "$$_ast", (yyvsp[0].ast) );
      DUMP_END();

      PARSE_ASSERT( define_type( (yyvsp[0].ast), C_ENG_DECL ) );
    }
#line 6757 "parser.c"
    break;

  case 92: /* expand_command: Y_expand Y_NAME expand_command2  */
#line 2673 "parser.y"
    {
      p_arg_list_t   *const arg_list   = (yyvsp[0].ptrs)[0];
      p_token_list_t *const extra_list = (yyvsp[0].ptrs)[1];

      DUMP_START( "expand_command", "EXPAND NAME arg_list_opt extra_list_opt" );
      DUMP_STR( "name", (yyvsp[-1].name) );
      DUMP_MACRO_ARG_LIST( "arg_list", arg_list );
      DUMP_MACRO_TOKEN_LIST( "extra_list", extra_list );
      DUMP_END();

      bool const ok =
        p_macro_expand( (yyvsp[-1].name), &(yylsp[-1]), arg_list, extra_list, stdout );
      p_arg_list_cleanup( arg_list );
      free( arg_list );
      p_token_list_cleanup( extra_list );
      free( extra_list );
      free( (yyvsp[-1].name) );
      PARSE_ASSERT( ok );
    }
#line 6781 "parser.c"
    break;

  case 93: /* expand_command: Y_expand error  */
#line 2694 "parser.y"
    {
      elaborate_error( "macro name expected" );
    }
#line 6789 "parser.c"
    break;

  case 94: /* expand_command2: %empty  */
#line 2700 "parser.y"
                                  { (yyval.ptrs)[0] = (yyval.ptrs)[1] = NULL; }
#line 6795 "parser.c"
    break;

  case 95: /* expand_command2: p_extra_token_except_lparen p_extra_tokens_opt  */
#line 2716 "parser.y"
    {
      if ( (yyvsp[0].p_token_list) == NULL ) {
        (yyvsp[0].p_token_list) = MALLOC( p_token_list_t, 1 );
        slist_init( (yyvsp[0].p_token_list) );
      }
      slist_push_front( (yyvsp[0].p_token_list), (yyvsp[-1].p_token) );

      (yyval.ptrs)[0] = NULL;
      (yyval.ptrs)[1] = (yyvsp[0].p_token_list);
    }
#line 6810 "parser.c"
    break;

  case 96: /* expand_command2: '(' p_arg_list_opt ')' p_extra_tokens_opt  */
#line 2728 "parser.y"
    {
      (yyval.ptrs)[0] = (yyvsp[-2].p_arg_list);
      (yyval.ptrs)[1] = (yyvsp[0].p_token_list);
    }
#line 6819 "parser.c"
    break;

  case 98: /* p_extra_token_except_lparen: ')'  */
#line 2737 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), ")" );
    }
#line 6827 "parser.c"
    break;

  case 99: /* p_extra_tokens_opt: %empty  */
#line 2743 "parser.y"
                                  { (yyval.p_token_list) = NULL; }
#line 6833 "parser.c"
    break;

  case 101: /* p_extra_tokens: p_extra_tokens p_extra_token  */
#line 2749 "parser.y"
    {
      (yyval.p_token_list) = (yyvsp[-1].p_token_list);
      slist_push_back( (yyval.p_token_list), (yyvsp[0].p_token) );
    }
#line 6842 "parser.c"
    break;

  case 102: /* p_extra_tokens: p_extra_token  */
#line 2754 "parser.y"
    {
      (yyval.p_token_list) = MALLOC( p_token_list_t, 1 );
      slist_init( (yyval.p_token_list) );
      slist_push_back( (yyval.p_token_list), (yyvsp[0].p_token) );
    }
#line 6852 "parser.c"
    break;

  case 104: /* p_extra_token: '('  */
#line 2764 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), "(" );
    }
#line 6860 "parser.c"
    break;

  case 105: /* p_arg_list_opt: %empty  */
#line 2771 "parser.y"
    {
      (yyval.p_arg_list) = MALLOC( p_arg_list_t, 1 );
      slist_init( (yyval.p_arg_list) );
    }
#line 6869 "parser.c"
    break;

  case 107: /* p_arg_list_opt: p_comma_arg_list  */
#line 2789 "parser.y"
    {
      slist_push_back( (yyvsp[0].p_arg_list), p_token_list_new_placemarker() );
      slist_push_back( (yyvsp[0].p_arg_list), p_token_list_new_placemarker() );

      (yyval.p_arg_list) = MALLOC( p_arg_list_t, 1 );
      slist_init( (yyval.p_arg_list) );
      slist_push_list_back( (yyval.p_arg_list), (yyvsp[0].p_arg_list) );
    }
#line 6882 "parser.c"
    break;

  case 108: /* p_arg_list_opt: p_comma_arg_list p_arg_list  */
#line 2809 "parser.y"
    {
      slist_push_back( (yyvsp[-1].p_arg_list), p_token_list_new_placemarker() );
      (yyval.p_arg_list) = (yyvsp[0].p_arg_list);
      slist_push_list_front( (yyval.p_arg_list), (yyvsp[-1].p_arg_list) );
    }
#line 6892 "parser.c"
    break;

  case 109: /* p_arg_list_opt: p_comma_arg_list p_arg_list p_comma_arg_list  */
#line 2830 "parser.y"
    {
      slist_push_back( (yyvsp[-2].p_arg_list), p_token_list_new_placemarker() );
      slist_push_back( (yyvsp[0].p_arg_list), p_token_list_new_placemarker() );

      (yyval.p_arg_list) = (yyvsp[-1].p_arg_list);
      slist_push_list_front( (yyval.p_arg_list), (yyvsp[-2].p_arg_list) );
      slist_push_list_back ( (yyval.p_arg_list), (yyvsp[0].p_arg_list) );
    }
#line 6905 "parser.c"
    break;

  case 110: /* p_arg_list_opt: p_arg_list p_comma_arg_list  */
#line 2850 "parser.y"
    {
      slist_push_back( (yyvsp[0].p_arg_list), p_token_list_new_placemarker() );
      (yyval.p_arg_list) = (yyvsp[-1].p_arg_list);
      slist_push_list_back( (yyval.p_arg_list), (yyvsp[0].p_arg_list) );
    }
#line 6915 "parser.c"
    break;

  case 111: /* p_arg_list_opt: error  */
#line 2857 "parser.y"
    {
      (yyval.p_arg_list) = NULL;
      elaborate_error( "macro argument expected" );
    }
#line 6924 "parser.c"
    break;

  case 112: /* p_comma_arg_list: p_comma_arg_list ','  */
#line 2865 "parser.y"
    {
      (yyval.p_arg_list) = (yyvsp[-1].p_arg_list);
      slist_push_back( (yyval.p_arg_list), p_token_list_new_placemarker() );
    }
#line 6933 "parser.c"
    break;

  case 113: /* p_comma_arg_list: ','  */
#line 2870 "parser.y"
    {
      (yyval.p_arg_list) = MALLOC( p_arg_list_t, 1 );
      slist_init( (yyval.p_arg_list) );
    }
#line 6942 "parser.c"
    break;

  case 114: /* p_arg_list: p_arg_list p_comma_arg_list p_arg_tokens  */
#line 2891 "parser.y"
    {
      (yyval.p_arg_list) = (yyvsp[-2].p_arg_list);

      if ( !slist_empty( (yyvsp[-1].p_arg_list) ) )
        slist_push_list_back( (yyval.p_arg_list), (yyvsp[-1].p_arg_list) );

      slist_push_back( (yyval.p_arg_list), (yyvsp[0].p_token_list) );
    }
#line 6955 "parser.c"
    break;

  case 115: /* p_arg_list: p_arg_tokens  */
#line 2901 "parser.y"
    {
      (yyval.p_arg_list) = MALLOC( p_arg_list_t, 1 );
      slist_init( (yyval.p_arg_list) );
      slist_push_back( (yyval.p_arg_list), (yyvsp[0].p_token_list) );
    }
#line 6965 "parser.c"
    break;

  case 116: /* p_arg_tokens: p_arg_tokens p_arg_token_as_list  */
#line 2910 "parser.y"
    {
      (yyval.p_token_list) = (yyvsp[-1].p_token_list);
      slist_push_list_back( (yyval.p_token_list), (yyvsp[0].p_token_list) );
    }
#line 6974 "parser.c"
    break;

  case 118: /* p_arg_token_as_list: p_arg_token  */
#line 2919 "parser.y"
    {
      (yyval.p_token_list) = MALLOC( p_token_list_t, 1 );
      slist_init( (yyval.p_token_list) );
      slist_push_back( (yyval.p_token_list), (yyvsp[0].p_token) );
    }
#line 6984 "parser.c"
    break;

  case 119: /* p_arg_token_as_list: '(' p_arg_tokens_with_comma_opt ')'  */
#line 2925 "parser.y"
    {
      (yyval.p_token_list) = (yyvsp[-1].p_token_list);
      slist_push_front( (yyval.p_token_list), p_token_new_loc( P_PUNCTUATOR, &(yylsp[-2]), "(" ) );
      slist_push_back ( (yyval.p_token_list), p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), ")" ) );
    }
#line 6994 "parser.c"
    break;

  case 120: /* p_arg_token: Y_CHAR_LIT  */
#line 2934 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_CHAR_LIT, &(yylsp[0]), (yyvsp[0].str_val) );
    }
#line 7002 "parser.c"
    break;

  case 121: /* p_arg_token: Y_NAME  */
#line 2938 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_IDENTIFIER, &(yylsp[0]), (yyvsp[0].name) );
    }
#line 7010 "parser.c"
    break;

  case 122: /* p_arg_token: p_num_lit  */
#line 2942 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_NUM_LIT, &(yylsp[0]), check_strdup( yytext ) );
    }
#line 7018 "parser.c"
    break;

  case 123: /* p_arg_token: Y_PRE_SPACE  */
#line 2946 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_SPACE, &(yylsp[0]), /*literal=*/NULL );
    }
#line 7026 "parser.c"
    break;

  case 124: /* p_arg_token: Y_STR_LIT  */
#line 2950 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_STR_LIT, &(yylsp[0]), (yyvsp[0].str_val) );
    }
#line 7034 "parser.c"
    break;

  case 125: /* p_arg_token: p_other  */
#line 2954 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_OTHER, &(yylsp[0]), yytext );
    }
#line 7042 "parser.c"
    break;

  case 126: /* p_arg_token: p_punctuator  */
#line 2958 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), yytext );
    }
#line 7050 "parser.c"
    break;

  case 180: /* p_arg_tokens_with_comma_opt: %empty  */
#line 3030 "parser.y"
    {
      (yyval.p_token_list) = MALLOC( p_token_list_t, 1 );
      slist_init( (yyval.p_token_list) );
    }
#line 7059 "parser.c"
    break;

  case 182: /* p_arg_tokens_with_comma: p_arg_tokens_with_comma p_arg_token_with_comma_as_list  */
#line 3050 "parser.y"
    {
      (yyval.p_token_list) = (yyvsp[-1].p_token_list);
      slist_push_list_back( (yyval.p_token_list), (yyvsp[0].p_token_list) );
    }
#line 7068 "parser.c"
    break;

  case 184: /* p_arg_token_with_comma_as_list: p_arg_token_with_comma  */
#line 3059 "parser.y"
    {
      (yyval.p_token_list) = MALLOC( p_token_list_t, 1 );
      slist_init( (yyval.p_token_list) );
      slist_push_back( (yyval.p_token_list), (yyvsp[0].p_token) );
    }
#line 7078 "parser.c"
    break;

  case 185: /* p_arg_token_with_comma_as_list: '(' p_arg_tokens_with_comma_opt ')'  */
#line 3065 "parser.y"
    {
      (yyval.p_token_list) = (yyvsp[-1].p_token_list);
      slist_push_front( (yyval.p_token_list), p_token_new_loc( P_PUNCTUATOR, &(yylsp[-2]), "(" ) );
      slist_push_back ( (yyval.p_token_list), p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), ")" ) );
    }
#line 7088 "parser.c"
    break;

  case 187: /* p_arg_token_with_comma: ','  */
#line 3075 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), "," );
    }
#line 7096 "parser.c"
    break;

  case 198: /* explain_command: explain pc99_pointer_decl_list_c  */
#line 3142 "parser.y"
    {
      PARSE_ASSERT( c_ast_list_check( &(yyvsp[0].ast_list) ) );
      c_ast_list_english( &(yyvsp[0].ast_list), stdout );
    }
#line 7105 "parser.c"
    break;

  case 200: /* $@2: %empty  */
#line 3160 "parser.y"
                       { in_attr.is_typename = true; }
#line 7111 "parser.c"
    break;

  case 203: /* explain_command: explain extern_linkage_c_stid_opt using_decl_c_ast  */
#line 3181 "parser.y"
    {
      DUMP_START( "explain_command",
                  "EXPLAIN extern_linkage_c_stid_opt using_decl_c_ast" );
      DUMP_TID( "extern_linkage_c_stid_opt", (yyvsp[-1].tid) );
      DUMP_AST( "using_decl_c_ast", (yyvsp[0].ast) );

      PARSE_ASSERT(
        c_type_add_tid( &(yyvsp[0].ast)->type, (yyvsp[-1].tid), &(yylsp[-1]) )
      );

      DUMP_AST( "$$_ast", (yyvsp[0].ast) );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( (yyvsp[0].ast) ) );
      c_ast_english( (yyvsp[0].ast), C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 7133 "parser.c"
    break;

  case 204: /* explain_command: explain sname_c  */
#line 3204 "parser.y"
    {
      print_error_unknown_name( &(yylsp[0]), &(yyvsp[0].sname) );
      c_sname_cleanup( &(yyvsp[0].sname) );
      PARSE_ABORT();
    }
#line 7143 "parser.c"
    break;

  case 205: /* explain_command: explain error  */
#line 3211 "parser.y"
    {
      elaborate_error( "cast or declaration expected" );
    }
#line 7151 "parser.c"
    break;

  case 206: /* explain: Y_explain  */
#line 3218 "parser.y"
    { //
      // Set our mode to deciphering gibberish into English and specifically
      // tell the lexer to return cdecl keywords (e.g., "func") as ordinary
      // names, otherwise gibberish like:
      //
      //      int func(void);
      //
      // would result in a parser error.
      //
      gibberish_to_english();
    }
#line 7167 "parser.c"
    break;

  case 207: /* $@3: %empty  */
#line 3235 "parser.y"
    { //
      // We want cdecl commands (like "declare", etc.), other cdecl keywords
      // (like "cast", "commands", "english", "options", etc.), and C/C++
      // keywords (like "const", "static", "typedef", etc.) all to be returned
      // as just strings so we don't have to enumerate all the possible tokens
      // in the grammar.
      //
      lexer_find &= ~(LEXER_FIND_C_KEYWORDS | LEXER_FIND_CDECL_KEYWORDS);
    }
#line 7181 "parser.c"
    break;

  case 208: /* help_command: '?' $@3 help_what_opt  */
#line 3245 "parser.y"
    {
      bool const ok = print_help( (yyvsp[0].name), &(yylsp[0]) );
      free( (yyvsp[0].name) );
      PARSE_ASSERT( ok );
    }
#line 7191 "parser.c"
    break;

  case 209: /* help_what_opt: %empty  */
#line 3253 "parser.y"
                                  { (yyval.name) = NULL; }
#line 7197 "parser.c"
    break;

  case 211: /* help_what_opt: '#' Y_NAME  */
#line 3255 "parser.y"
                                  { (yyval.name) = str_realloc_pcat( "#", "", (yyvsp[0].name) ); }
#line 7203 "parser.c"
    break;

  case 212: /* help_what_opt: '#' error  */
#line 3257 "parser.y"
    {
      (yyval.name) = NULL;
      elaborate_error( "\"#define\", \"#include\", or \"#undef\" expected" );
    }
#line 7212 "parser.c"
    break;

  case 213: /* help_what_opt: error  */
#line 3262 "parser.y"
    {
      (yyval.name) = NULL;
      elaborate_error(
        "<command>, \"commands\", \"english\", or \"options\" expected"
      );
    }
#line 7223 "parser.c"
    break;

  case 217: /* preprocessor_command: '#' Y_PRE_elif  */
#line 3279 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#elif\"" );
    }
#line 7231 "parser.c"
    break;

  case 218: /* preprocessor_command: '#' Y_PRE_elifdef  */
#line 3283 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#elifdef\"" );
    }
#line 7239 "parser.c"
    break;

  case 219: /* preprocessor_command: '#' Y_PRE_elifndef  */
#line 3287 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#elifdef\"" );
    }
#line 7247 "parser.c"
    break;

  case 220: /* preprocessor_command: '#' Y_PRE_else  */
#line 3291 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#else\"" );
    }
#line 7255 "parser.c"
    break;

  case 221: /* preprocessor_command: '#' Y_PRE_embed  */
#line 3295 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#embed\"" );
    }
#line 7263 "parser.c"
    break;

  case 222: /* preprocessor_command: '#' Y_PRE_error  */
#line 3299 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#error\"" );
    }
#line 7271 "parser.c"
    break;

  case 223: /* preprocessor_command: '#' Y_PRE_if  */
#line 3303 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#if\"" );
    }
#line 7279 "parser.c"
    break;

  case 224: /* preprocessor_command: '#' Y_PRE_ifdef  */
#line 3307 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#ifdef\"" );
    }
#line 7287 "parser.c"
    break;

  case 225: /* preprocessor_command: '#' Y_PRE_ifndef  */
#line 3311 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#ifndef\"" );
    }
#line 7295 "parser.c"
    break;

  case 226: /* preprocessor_command: '#' Y_PRE_line  */
#line 3315 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#line\"" );
    }
#line 7303 "parser.c"
    break;

  case 227: /* preprocessor_command: '#' Y_PRE_pragma  */
#line 3319 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#pragma\"" );
    }
#line 7311 "parser.c"
    break;

  case 228: /* preprocessor_command: '#' Y_PRE_warning  */
#line 3323 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#warning\"" );
    }
#line 7319 "parser.c"
    break;

  case 229: /* preprocessor_command: '#' error  */
#line 3327 "parser.y"
    {
      elaborate_error( "\"#define\", \"#include\", or \"#undef\" expected" );
    }
#line 7327 "parser.c"
    break;

  case 230: /* p_define: Y_PRE_define name_exp p_paren_param_list_opt p_replace_list_opt  */
#line 3335 "parser.y"
    {
      DUMP_START( "p_define",
                  "#define NAME p_paren_param_list_opt p_replace_list_opt" );
      DUMP_STR( "name", (yyvsp[-2].name) );
      DUMP_MACRO_PARAM_LIST( "p_paren_param_list_opt", (yyvsp[-1].p_param_list) );
      DUMP_MACRO_TOKEN_LIST( "p_replace_list_opt", (yyvsp[0].p_token_list) );

      c_typedef_t const *const tdef = c_typedef_find_name( (yyvsp[-2].name) );
      if ( tdef != NULL ) {
        if ( tdef->is_predefined ) {
          print_warning( &(yylsp[-2]),
            "\"%s\" is a predefined type since %s\n",
            (yyvsp[-2].name),
            c_lang_name( c_lang_oldest( tdef->lang_ids ) )
          );
        }
        else {
          print_warning( &(yylsp[-2]),
            "\"%s\" previously defined as type (\"",
            (yyvsp[-2].name)
          );
          print_type_decl( tdef, tdef->decl_flags, stderr );
          EPUTS( "\")\n" );
        }
      }

      p_macro_t *const macro =
        p_macro_define( (yyvsp[-2].name), &(yylsp[-2]), (yyvsp[-1].p_param_list), (yyvsp[0].p_token_list) );
      p_param_list_cleanup( (yyvsp[-1].p_param_list) );
      free( (yyvsp[-1].p_param_list) );
      p_token_list_cleanup( (yyvsp[0].p_token_list) );
      free( (yyvsp[0].p_token_list) );
      PARSE_ASSERT( macro != NULL );

      DUMP_MACRO( "macro", macro );
      DUMP_END();
    }
#line 7369 "parser.c"
    break;

  case 231: /* p_paren_param_list_opt: %empty  */
#line 3374 "parser.y"
                                  { (yyval.p_param_list) = NULL; }
#line 7375 "parser.c"
    break;

  case 232: /* p_paren_param_list_opt: '(' p_param_list_opt ')'  */
#line 3375 "parser.y"
                                  { (yyval.p_param_list) = (yyvsp[-1].p_param_list); }
#line 7381 "parser.c"
    break;

  case 233: /* p_param_list_opt: %empty  */
#line 3379 "parser.y"
    { //
      // Use an empty list to distinguish a macro with an empty parameter list
      // from one with no parameter list.
      //
      //      #define M   X       // no parameter list: use NULL
      //      #define F() #X      // empty parameter list: use empty list
      //
      (yyval.p_param_list) = MALLOC( p_param_list_t, 1 );
      slist_init( (yyval.p_param_list) );
    }
#line 7396 "parser.c"
    break;

  case 235: /* p_param_list: p_param_list comma_exp p_param  */
#line 3394 "parser.y"
    {
      DUMP_START( "p_param_list", "p_param" );
      DUMP_MACRO_PARAM_LIST( "p_param_list", (yyvsp[-2].p_param_list) );
      DUMP_STR( "p_param", (yyvsp[0].p_param)->name );

      (yyval.p_param_list) = (yyvsp[-2].p_param_list);
      slist_push_back( (yyval.p_param_list), (yyvsp[0].p_param) );

      DUMP_MACRO_PARAM_LIST( "$$_list", (yyval.p_param_list) );
      DUMP_END();
    }
#line 7412 "parser.c"
    break;

  case 236: /* p_param_list: p_param  */
#line 3407 "parser.y"
    {
      DUMP_START( "p_param_list", "p_param" );
      DUMP_STR( "p_param", (yyvsp[0].p_param)->name );

      (yyval.p_param_list) = MALLOC( p_param_list_t, 1 );
      slist_init( (yyval.p_param_list) );
      slist_push_back( (yyval.p_param_list), (yyvsp[0].p_param) );

      DUMP_MACRO_PARAM_LIST( "$$_list", (yyval.p_param_list) );
      DUMP_END();
    }
#line 7428 "parser.c"
    break;

  case 237: /* p_param: Y_NAME  */
#line 3422 "parser.y"
    {
      (yyval.p_param) = MALLOC( p_param_t, 1 );
      *(yyval.p_param) = (p_param_t){ .name = (yyvsp[0].name), .loc = (yylsp[0]) };
    }
#line 7437 "parser.c"
    break;

  case 238: /* p_param: "..."  */
#line 3427 "parser.y"
    {
      (yyval.p_param) = MALLOC( p_param_t, 1 );
      *(yyval.p_param) = (p_param_t){ .name = check_strdup( L_ELLIPSIS ), .loc = (yylsp[0]) };
    }
#line 7446 "parser.c"
    break;

  case 239: /* p_param: error  */
#line 3432 "parser.y"
    {
      (yyval.p_param) = NULL;
      if ( OPT_LANG_IS( VARIADIC_MACROS ) )
        elaborate_error( "parameter name or \"...\" expected" );
      else
        elaborate_error( "parameter name expected" );
    }
#line 7458 "parser.c"
    break;

  case 240: /* p_replace_list_opt: %empty  */
#line 3442 "parser.y"
                                  { (yyval.p_token_list) = NULL; }
#line 7464 "parser.c"
    break;

  case 242: /* p_replace_list: p_replace_list p_replace_token  */
#line 3448 "parser.y"
    {
      (yyval.p_token_list) = (yyvsp[-1].p_token_list);
      slist_push_back( (yyval.p_token_list), (yyvsp[0].p_token) );
    }
#line 7473 "parser.c"
    break;

  case 243: /* p_replace_list: p_replace_token  */
#line 3454 "parser.y"
    {
      (yyval.p_token_list) = MALLOC( p_token_list_t, 1 );
      slist_init( (yyval.p_token_list) );
      slist_push_back( (yyval.p_token_list), (yyvsp[0].p_token) );
    }
#line 7483 "parser.c"
    break;

  case 244: /* p_replace_token: p_arg_token  */
#line 3463 "parser.y"
    {
      if ( p_token_is_punct( (yyvsp[0].p_token), '#' ) ) {
        //
        // A '#' macro argument token is an ordinary '#', but as a replacement
        // token, retroactively make it P_STRINGIFY.
        //
        (yyvsp[0].p_token)->kind = P_STRINGIFY;
      }
      (yyval.p_token) = (yyvsp[0].p_token);
    }
#line 7498 "parser.c"
    break;

  case 245: /* p_replace_token: '('  */
#line 3474 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), "(" );
    }
#line 7506 "parser.c"
    break;

  case 246: /* p_replace_token: ')'  */
#line 3478 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), ")" );
    }
#line 7514 "parser.c"
    break;

  case 247: /* p_replace_token: ','  */
#line 3482 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), "," );
    }
#line 7522 "parser.c"
    break;

  case 248: /* p_replace_token: "##"  */
#line 3486 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_CONCAT, &(yylsp[0]), /*literal=*/NULL );
    }
#line 7530 "parser.c"
    break;

  case 249: /* p_replace_token: Y_PRE___VA_ARGS__  */
#line 3490 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P___VA_ARGS__, &(yylsp[0]), /*literal=*/NULL );
    }
#line 7538 "parser.c"
    break;

  case 250: /* p_replace_token: Y_PRE___VA_OPT__  */
#line 3494 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P___VA_OPT__, &(yylsp[0]), /*literal=*/NULL );
    }
#line 7546 "parser.c"
    break;

  case 251: /* p_undef: Y_PRE_undef name_exp  */
#line 3501 "parser.y"
    {
      PARSE_ASSERT( p_macro_undef( (yyvsp[0].name), &(yylsp[0]) ) );
    }
#line 7554 "parser.c"
    break;

  case 252: /* quit_command: Y_quit  */
#line 3509 "parser.y"
                                  { cdecl_quit(); }
#line 7560 "parser.c"
    break;

  case 254: /* set_command: Y_set  */
#line 3522 "parser.y"
    {
      PARSE_ASSERT( set_option( NULL, NULL, NULL, NULL ) );
    }
#line 7568 "parser.c"
    break;

  case 258: /* set_option: Y_SET_OPTION set_option_value_opt  */
#line 3535 "parser.y"
    {
      bool const ok = set_option( (yyvsp[-1].name), &(yylsp[-1]), (yyvsp[0].str_val), &(yylsp[0]) );
      free( (yyvsp[-1].name) );
      free( (yyvsp[0].str_val) );
      PARSE_ASSERT( ok );
    }
#line 7579 "parser.c"
    break;

  case 259: /* set_option_value_opt: %empty  */
#line 3544 "parser.y"
                                  { (yyval.str_val) = NULL; }
#line 7585 "parser.c"
    break;

  case 260: /* set_option_value_opt: '=' Y_SET_OPTION  */
#line 3545 "parser.y"
                                  { (yyval.str_val) = (yyvsp[0].name); (yyloc) = (yylsp[0]); }
#line 7591 "parser.c"
    break;

  case 261: /* set_option_value_opt: '=' error  */
#line 3547 "parser.y"
    {
      (yyval.str_val) = NULL;
      elaborate_error( "option value expected" );
    }
#line 7600 "parser.c"
    break;

  case 262: /* show_command: Y_show any_typedef_tdef show_format_opt  */
#line 3557 "parser.y"
    {
      DUMP_START( "show_command", "SHOW any_typedef_tdef show_format_opt" );
      DUMP_AST( "any_typedef__ast", (yyvsp[-1].tdef)->ast );
      DUMP_INT( "show_format_opt", (yyvsp[0].flags) );
      DUMP_END();

      show_type( (yyvsp[-1].tdef), (yyvsp[0].flags), stdout );
    }
#line 7613 "parser.c"
    break;

  case 263: /* show_command: Y_show any_typedef_tdef Y_as show_format_exp  */
#line 3567 "parser.y"
    {
      DUMP_START( "show_command", "SHOW any_typedef_tdef AS show_format_exp" );
      DUMP_AST( "any_typedef__ast", (yyvsp[-2].tdef)->ast );
      DUMP_INT( "show_format_exp", (yyvsp[0].flags) );
      DUMP_END();

      show_type( (yyvsp[-2].tdef), (yyvsp[0].flags), stdout );
    }
#line 7626 "parser.c"
    break;

  case 264: /* show_command: Y_show show_types_opt glob_opt show_format_opt  */
#line 3577 "parser.y"
    {
      bool const showed_any = show_types( (yyvsp[-2].show), (yyvsp[-1].name), (yyvsp[0].flags), stdout );
      if ( (yyvsp[-1].name) != NULL && !showed_any ) {
        print_error( &(yylsp[-1]), "\"%s\": no such type or macro defined", (yyvsp[-1].name) );
        print_suggestions( DYM_C_MACROS | DYM_C_TYPES, (yyvsp[-1].name) );
        EPUTC( '\n' );
      }
      free( (yyvsp[-1].name) );
      PARSE_ASSERT( showed_any );
    }
#line 7641 "parser.c"
    break;

  case 265: /* show_command: Y_show show_types_opt glob_opt Y_as show_format_exp  */
#line 3589 "parser.y"
    {
      bool const showed_any = show_types( (yyvsp[-3].show), (yyvsp[-2].name), (yyvsp[0].flags), stdout );
      if ( !showed_any ) {
        print_error( &(yylsp[-2]), "\"%s\": no such type or macro defined", (yyvsp[-2].name) );
        print_suggestions( DYM_C_MACROS | DYM_C_TYPES, (yyvsp[-2].name) );
        EPUTC( '\n' );
      }
      free( (yyvsp[-2].name) );
      PARSE_ASSERT( showed_any );
    }
#line 7656 "parser.c"
    break;

  case 266: /* show_command: Y_show show_types_opt Y_macros  */
#line 3601 "parser.y"
    {
      show_macros( (yyvsp[-1].show), stdout );
    }
#line 7664 "parser.c"
    break;

  case 267: /* show_command: Y_show Y_NAME  */
#line 3606 "parser.y"
    {
      bool ok = false;

      //
      // Check to see if $name is a macro here rather than in the lexer since
      // this is the only place in the cdecl grammar where a name can be a
      // macro since cdecl doesn't support using macros everywhere.
      //
      p_macro_t const *const macro = p_macro_find( (yyvsp[0].name) );
      if ( macro == NULL ) {
        print_error( &(yylsp[0]), "\"%s\": no such type or macro defined", (yyvsp[0].name) );
        print_suggestions( DYM_C_MACROS | DYM_C_TYPES, (yyvsp[0].name) );
        EPUTC( '\n' );
      }
      else if ( !(ok = show_macro( macro, stdout )) ) {
        c_lang_id_t const lang_ids = (*macro->dyn_fn)( /*ptoken=*/NULL );
        print_error( &(yylsp[0]),
          "\"%s\" not supported%s\n",
          (yyvsp[0].name), c_lang_which( lang_ids )
        );
      }

      free( (yyvsp[0].name) );
      if ( !ok )
        PARSE_ABORT();
    }
#line 7695 "parser.c"
    break;

  case 268: /* show_command: Y_show error  */
#line 3634 "parser.y"
    {
      elaborate_error(
        "type or macro name, or \"all\", \"predefined\", or \"user\" expected"
      );
    }
#line 7705 "parser.c"
    break;

  case 269: /* show_format: Y_english  */
#line 3642 "parser.y"
                                  { (yyval.flags) = C_ENG_DECL; }
#line 7711 "parser.c"
    break;

  case 270: /* show_format: Y_typedef  */
#line 3643 "parser.y"
                                  { (yyval.flags) = C_GIB_TYPEDEF; }
#line 7717 "parser.c"
    break;

  case 271: /* show_format: Y_using  */
#line 3645 "parser.y"
    {
      if ( !IS_SUPPORTED( using_DECLS ) ) {
        print_error( &(yylsp[0]),
          "\"using\" not supported%s\n",
          C_LANG_WHICH( using_DECLS )
        );
        PARSE_ABORT();
      }
      (yyval.flags) = C_GIB_USING;
    }
#line 7732 "parser.c"
    break;

  case 273: /* show_format_exp: error  */
#line 3660 "parser.y"
    {
      if ( OPT_LANG_IS( using_DECLS ) )
        elaborate_error( "\"english\", \"typedef\", or \"using\" expected" );
      else
        elaborate_error( "\"english\" or \"typedef\" expected" );
    }
#line 7743 "parser.c"
    break;

  case 274: /* show_format_opt: %empty  */
#line 3669 "parser.y"
                                  { (yyval.flags) = 0/*as declared*/; }
#line 7749 "parser.c"
    break;

  case 276: /* show_types_opt: %empty  */
#line 3674 "parser.y"
                                  { (yyval.show) = CDECL_SHOW_USER_DEFINED; }
#line 7755 "parser.c"
    break;

  case 277: /* show_types_opt: Y_all predefined_or_user_types_opt  */
#line 3676 "parser.y"
    {
      (yyval.show) = (yyvsp[0].show) | CDECL_SHOW_OPT_IGNORE_LANG;
    }
#line 7763 "parser.c"
    break;

  case 278: /* show_types_opt: Y_predefined  */
#line 3679 "parser.y"
                                  { (yyval.show) = CDECL_SHOW_PREDEFINED; }
#line 7769 "parser.c"
    break;

  case 279: /* show_types_opt: Y_user  */
#line 3680 "parser.y"
                                  { (yyval.show) = CDECL_SHOW_USER_DEFINED; }
#line 7775 "parser.c"
    break;

  case 280: /* predefined_or_user_types_opt: %empty  */
#line 3685 "parser.y"
    {
      (yyval.show) = CDECL_SHOW_PREDEFINED | CDECL_SHOW_USER_DEFINED;
    }
#line 7783 "parser.c"
    break;

  case 281: /* predefined_or_user_types_opt: Y_predefined  */
#line 3688 "parser.y"
                                  { (yyval.show) = CDECL_SHOW_PREDEFINED; }
#line 7789 "parser.c"
    break;

  case 282: /* predefined_or_user_types_opt: Y_user  */
#line 3689 "parser.y"
                                  { (yyval.show) = CDECL_SHOW_USER_DEFINED; }
#line 7795 "parser.c"
    break;

  case 286: /* $@4: %empty  */
#line 3718 "parser.y"
    {
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 7803 "parser.c"
    break;

  case 287: /* c_style_cast_expr_c: '(' type_c_ast $@4 cast_c_astp_opt rparen_exp sname_c_opt  */
#line 3722 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "explain_command",
                  "EXPLAIN '(' type_c_ast cast_c_astp_opt ')' sname_c_opt" );
      DUMP_AST( "type_c_ast", (yyvsp[-4].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-2].ast_pair) );
      DUMP_SNAME( "sname_c_opt", (yyvsp[0].sname) );

      c_ast_t *const cast_ast = c_ast_new_gc( K_CAST, &(yyloc) );
      cast_ast->sname = c_sname_move( &(yyvsp[0].sname) );
      cast_ast->cast.kind = C_CAST_C;
      cast_ast->cast.to_ast =
        c_ast_patch_placeholder( (yyvsp[-4].ast), (yyvsp[-2].ast_pair).ast );

      DUMP_AST( "$$_ast", cast_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( cast_ast ) );
      c_ast_english( cast_ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 7830 "parser.c"
    break;

  case 288: /* c_style_cast_expr_c: '(' pc99_pointer_decl_list_c rparen_exp  */
#line 3755 "parser.y"
    {
      PARSE_ASSERT( c_ast_list_check( &(yyvsp[-1].ast_list) ) );
      c_ast_list_english( &(yyvsp[-1].ast_list), stdout );
    }
#line 7839 "parser.c"
    break;

  case 289: /* $@5: %empty  */
#line 3765 "parser.y"
    {
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 7847 "parser.c"
    break;

  case 290: /* new_style_cast_expr_c: new_style_cast_c lt_exp type_c_ast $@5 cast_c_astp_opt gt_exp lparen_exp sname_c_exp rparen_exp  */
#line 3769 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "explain_command",
                  "EXPLAIN new_style_cast_c"
                  "'<' type_c_ast cast_c_astp_opt '>' '(' sname ')'" );
      DUMP_STR( "new_style_cast_c", c_cast_english( (yyvsp[-8].cast_kind) ) );
      DUMP_AST( "type_c_ast", (yyvsp[-6].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-4].ast_pair) );
      DUMP_SNAME( "sname_c_exp", (yyvsp[-1].sname) );

      c_ast_t *const cast_ast = c_ast_new_gc( K_CAST, &(yyloc) );
      cast_ast->sname = c_sname_move( &(yyvsp[-1].sname) );
      cast_ast->cast.kind = (yyvsp[-8].cast_kind);
      cast_ast->cast.to_ast =
        c_ast_patch_placeholder( (yyvsp[-6].ast), (yyvsp[-4].ast_pair).ast );

      DUMP_AST( "$$_ast", cast_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( cast_ast ) );
      c_ast_english( cast_ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 7876 "parser.c"
    break;

  case 291: /* new_style_cast_c: Y_const_cast  */
#line 3796 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_CONST;        }
#line 7882 "parser.c"
    break;

  case 292: /* new_style_cast_c: Y_dynamic_cast  */
#line 3797 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_DYNAMIC;      }
#line 7888 "parser.c"
    break;

  case 293: /* new_style_cast_c: Y_reinterpret_cast  */
#line 3798 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_REINTERPRET;  }
#line 7894 "parser.c"
    break;

  case 294: /* new_style_cast_c: Y_static_cast  */
#line 3799 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_STATIC;       }
#line 7900 "parser.c"
    break;

  case 295: /* $@6: %empty  */
#line 3809 "parser.y"
                                  { in_attr.align = (yyvsp[0].align); }
#line 7906 "parser.c"
    break;

  case 296: /* $@7: %empty  */
#line 3810 "parser.y"
                                  { in_attr.is_typename = (yyvsp[0].flag); }
#line 7912 "parser.c"
    break;

  case 298: /* alignas_specifier_c: alignas lparen_exp uint_lit rparen_exp  */
#line 3816 "parser.y"
    {
      DUMP_START( "alignas_specifier_c", "ALIGNAS '(' uint_lit ')'" );
      DUMP_INT( "uint_lit", (yyvsp[-1].uint_val) );

      (yyval.align).kind = C_ALIGNAS_BYTES;
      (yyval.align).loc = (yyloc);
      (yyval.align).bytes = (yyvsp[-1].uint_val);

      DUMP_ALIGN( "$$_align", (yyval.align) );
      DUMP_END();
    }
#line 7928 "parser.c"
    break;

  case 299: /* alignas_specifier_c: alignas lparen_exp sname_c rparen_exp  */
#line 3829 "parser.y"
    {
      DUMP_START( "alignas_specifier_c", "ALIGNAS '(' sname_c ')'" );
      DUMP_SNAME( "sname", (yyvsp[-1].sname) );

      (yyval.align).kind = C_ALIGNAS_SNAME;
      (yyval.align).loc = (yyloc);
      (yyval.align).sname = c_sname_move( &(yyvsp[-1].sname) );

      DUMP_ALIGN( "$$_align", (yyval.align) );
      DUMP_END();
    }
#line 7944 "parser.c"
    break;

  case 300: /* $@8: %empty  */
#line 3841 "parser.y"
                                            { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 7950 "parser.c"
    break;

  case 301: /* alignas_specifier_c: alignas lparen_exp type_c_ast $@8 cast_c_astp_opt rparen_exp  */
#line 3843 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "alignas_specifier_c",
                  "ALIGNAS '(' type_c_ast cast_c_astp_opt ')'" );
      DUMP_AST( "type_c_ast", (yyvsp[-3].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-1].ast_pair) );

      (yyval.align).kind = C_ALIGNAS_TYPE;
      (yyval.align).loc = (yyloc);
      (yyval.align).type_ast = c_ast_patch_placeholder( (yyvsp[-3].ast), (yyvsp[-1].ast_pair).ast );

      DUMP_ALIGN( "$$_align", (yyval.align) );
      DUMP_END();
    }
#line 7970 "parser.c"
    break;

  case 302: /* alignas_specifier_c: alignas lparen_exp error ')'  */
#line 3860 "parser.y"
    {
      elaborate_error( "integer or type expected" );
    }
#line 7978 "parser.c"
    break;

  case 305: /* asm_declaration_c: Y_asm lparen_exp str_lit_exp rparen_exp  */
#line 3874 "parser.y"
    {
      free( (yyvsp[-1].str_val) );
      UNSUPPORTED( &(yylsp[-3]), "asm declarations" );
    }
#line 7987 "parser.c"
    break;

  case 309: /* $@9: %empty  */
#line 3893 "parser.y"
    {
      PARSE_ASSERT( is_nested_type_ok( &(yylsp[0]) ) );
      gibberish_to_english();           // see the comment in "explain"
    }
#line 7996 "parser.c"
    break;

  case 310: /* $@10: %empty  */
#line 3898 "parser.y"
    {
      c_type_t const *const cur_type =
        c_sname_local_type( &in_attr.scope_sname );
      if ( c_tid_is_any( cur_type->btids, TB_ANY_CLASS ) ) {
        char const *const cur_name = c_sname_local_name( &in_attr.scope_sname );
        char const *const mbr_name = c_sname_local_name( &(yyvsp[0].sname) );
        if ( strcmp( mbr_name, cur_name ) == 0 ) {
          print_error( &(yylsp[0]),
            "\"%s\": member has the same name as its enclosing %s\n",
            mbr_name, c_type_gibberish( cur_type )
          );
          c_sname_cleanup( &(yyvsp[0].sname) );
          PARSE_ABORT();
        }
      }

      DUMP_START( "class_struct_union_declaration_c",
                  "class_struct_union_btid any_sname_c_exp" );
      DUMP_SNAME( "in_attr__scope_sname", in_attr.scope_sname );
      DUMP_TID( "class_struct_union_btid", (yyvsp[-2].tid) );
      DUMP_SNAME( "any_sname_c_exp", (yyvsp[0].sname) );

      c_sname_append_sname( &in_attr.scope_sname, &(yyvsp[0].sname) );

      c_sname_local_data( &in_attr.scope_sname )->type =
        C_TYPE_LIT_B( (yyvsp[-2].tid) );
      c_sname_set_all_types( &in_attr.scope_sname );

      c_sname_t csu_sname = c_sname_dup( &in_attr.scope_sname );
      c_sname_append_sname( &csu_sname, &(yyvsp[0].sname) );

      c_ast_t *const csu_ast = c_ast_new_gc( K_CLASS_STRUCT_UNION, &(yylsp[0]) );
      csu_ast->sname = csu_sname;
      csu_ast->type.btids = c_tid_check( (yyvsp[-2].tid), C_TPID_BASE );
      c_sname_init_name(
        &csu_ast->csu.csu_sname,
        check_strdup( c_sname_local_name( &csu_ast->sname ) )
      );

      DUMP_AST( "$$_ast", csu_ast );
      DUMP_END();

      PARSE_ASSERT( define_type( csu_ast, C_GIB_TYPEDEF ) );
    }
#line 8045 "parser.c"
    break;

  case 312: /* $@11: %empty  */
#line 3950 "parser.y"
    {
      PARSE_ASSERT( is_nested_type_ok( &(yylsp[0]) ) );
      gibberish_to_english();           // see the comment in "explain"
    }
#line 8054 "parser.c"
    break;

  case 313: /* enum_declaration_c: enum_btids $@11 any_sname_c_exp enum_fixed_type_c_ast_opt  */
#line 3955 "parser.y"
    {
      DUMP_START( "enum_declaration_c",
                  "enum_btids any_sname_c_exp enum_fixed_type_c_ast_opt" );
      DUMP_TID( "enum_btids", (yyvsp[-3].tid) );
      DUMP_SNAME( "any_sname_c_exp", (yyvsp[-1].sname) );
      DUMP_AST( "enum_fixed_type_c_ast_opt", (yyvsp[0].ast) );

      c_sname_t enum_sname = c_sname_dup( &in_attr.scope_sname );
      c_sname_append_sname( &enum_sname, &(yyvsp[-1].sname) );

      c_sname_local_data( &enum_sname )->type = C_TYPE_LIT_B( (yyvsp[-3].tid) );
      c_sname_set_all_types( &enum_sname );

      c_ast_t *const enum_ast = c_ast_new_gc( K_ENUM, &(yylsp[-1]) );
      enum_ast->sname = enum_sname;
      enum_ast->type.btids = c_tid_check( (yyvsp[-3].tid), C_TPID_BASE );
      c_ast_set_parent( (yyvsp[0].ast), enum_ast );
      c_sname_init_name(
        &enum_ast->enum_.enum_sname,
        check_strdup( c_sname_local_name( &enum_ast->sname ) )
      );

      DUMP_AST( "$$_ast", enum_ast );
      DUMP_END();

      PARSE_ASSERT( define_type( enum_ast, C_GIB_TYPEDEF ) );
    }
#line 8086 "parser.c"
    break;

  case 314: /* $@12: %empty  */
#line 3989 "parser.y"
    {
      gibberish_to_english();           // see the comment in "explain"
    }
#line 8094 "parser.c"
    break;

  case 315: /* $@13: %empty  */
#line 3993 "parser.y"
    {
      DUMP_START( "namespace_declaration_c",
                  "namespace_type namespace_sname_c_exp" );
      DUMP_SNAME( "in_attr__scope_sname", in_attr.scope_sname );
      DUMP_TYPE( "namespace_type", (yyvsp[-2].type) );
      DUMP_SNAME( "namespace_sname_c_exp", (yyvsp[0].sname) );

      //
      // Nested namespace declarations are supported only in C++17 and later.
      // (However, we always allow them in configuration files.)
      //
      // This check has to be done now in the parser rather than later in the
      // AST because the AST has no "memory" of how a namespace was
      // constructed.
      //
      if ( c_sname_count( &(yyvsp[0].sname) ) > 1 && !IS_SUPPORTED( NESTED_namespace ) ) {
        print_error( &(yylsp[0]),
          "nested namespace declarations not supported%s\n",
          C_LANG_WHICH( NESTED_namespace )
        );
        c_sname_cleanup( &(yyvsp[0].sname) );
        PARSE_ABORT();
      }

      //
      // The namespace type (plain namespace or inline namespace) has to be
      // split across the namespace sname: only the storage classes (for
      // TS_inline) has to be or'd with the first scope-type of the sname ...
      //
      c_type_t *const sname_global_type = &c_sname_global_data( &(yyvsp[0].sname) )->type;
      *sname_global_type =
        C_TYPE_LIT(
          sname_global_type->btids,
          sname_global_type->stids | (yyvsp[-2].type).stids,
          sname_global_type->atids
        );
      //
      // ... and only the base types (for TB_namespace) has to be or'd with the
      // local scope type of the sname.
      //
      c_type_t *const sname_local_type = &c_sname_local_data( &(yyvsp[0].sname) )->type;
      *sname_local_type =
        C_TYPE_LIT(
          sname_local_type->btids | (yyvsp[-2].type).btids,
          sname_local_type->stids,
          sname_local_type->atids
        );

      c_sname_append_sname( &in_attr.scope_sname, &(yyvsp[0].sname) );
      c_sname_set_all_types( &in_attr.scope_sname );

      DUMP_SNAME( "$$_sname", (yyvsp[0].sname) );
      DUMP_END();

      //
      // These checks are better to do now in the parser rather than later in
      // the AST because they give a better error location.
      //
      if ( c_sname_is_inline_nested_namespace( &in_attr.scope_sname ) ) {
        print_error( &(yylsp[0]),
          "nested namespace can not be %s\n",
          c_tid_error( TS_inline )
        );
        PARSE_ABORT();
      }
      PARSE_ASSERT( c_sname_check( &in_attr.scope_sname, &(yylsp[0]) ) );
    }
#line 8166 "parser.c"
    break;

  case 319: /* namespace_sname_c_exp: error  */
#line 4067 "parser.y"
    {
      c_sname_init( &(yyval.sname) );
      elaborate_error( "name expected" );
    }
#line 8175 "parser.c"
    break;

  case 320: /* namespace_sname_c: namespace_sname_c Y_COLON_COLON Y_NAME  */
#line 4080 "parser.y"
    {
      DUMP_START( "namespace_sname_c", "sname_c '::' NAME" );
      DUMP_SNAME( "namespace_sname_c", (yyvsp[-2].sname) );
      DUMP_STR( "name", (yyvsp[0].name) );

      (yyval.sname) = (yyvsp[-2].sname);
      c_sname_append_name( &(yyval.sname), (yyvsp[0].name) );
      c_sname_local_data( &(yyval.sname) )->type = C_TYPE_LIT_B( TB_namespace );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 8192 "parser.c"
    break;

  case 321: /* namespace_sname_c: namespace_sname_c Y_COLON_COLON any_typedef_tdef  */
#line 4094 "parser.y"
    {
      DUMP_START( "namespace_sname_c",
                  "namespace_sname_c '::' any_typedef_tdef" );
      DUMP_SNAME( "namespace_sname_c", (yyvsp[-2].sname) );
      DUMP_AST( "any_typedef__ast", (yyvsp[0].tdef)->ast );

      (yyval.sname) = (yyvsp[-2].sname);
      c_sname_local_data( &(yyval.sname) )->type = C_TYPE_LIT_B( TB_namespace );
      c_sname_t temp_sname = c_sname_dup( &(yyvsp[0].tdef)->ast->sname );
      c_sname_append_sname( &(yyval.sname), &temp_sname );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 8211 "parser.c"
    break;

  case 322: /* namespace_sname_c: namespace_sname_c Y_COLON_COLON Y_inline name_exp  */
#line 4110 "parser.y"
    {
      DUMP_START( "namespace_sname_c", "sname_c '::' NAME INLINE NAME" );
      DUMP_SNAME( "namespace_sname_c", (yyvsp[-3].sname) );
      DUMP_STR( "name", (yyvsp[0].name) );

      (yyval.sname) = (yyvsp[-3].sname);
      c_sname_append_name( &(yyval.sname), (yyvsp[0].name) );
      c_sname_local_data( &(yyval.sname) )->type =
        C_TYPE_LIT( TB_namespace, (yyvsp[-1].tid), TA_NONE );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 8229 "parser.c"
    break;

  case 323: /* namespace_sname_c: Y_NAME  */
#line 4125 "parser.y"
    {
      DUMP_START( "namespace_sname_c", "NAME" );
      DUMP_STR( "NAME", (yyvsp[0].name) );

      c_sname_init_name( &(yyval.sname), (yyvsp[0].name) );
      c_sname_local_data( &(yyval.sname) )->type = C_TYPE_LIT_B( TB_namespace );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 8244 "parser.c"
    break;

  case 324: /* namespace_typedef_sname_c: namespace_typedef_sname_c Y_COLON_COLON sname_c  */
#line 4144 "parser.y"
    {
      DUMP_START( "namespace_typedef_sname_c",
                  "namespace_typedef_sname_c '::' sname_c" );
      DUMP_SNAME( "namespace_typedef_sname_c", (yyvsp[-2].sname) );
      DUMP_SNAME( "sname_c", (yyvsp[0].sname) );

      (yyval.sname) = (yyvsp[-2].sname);
      c_sname_append_sname( &(yyval.sname), &(yyvsp[0].sname) );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 8261 "parser.c"
    break;

  case 325: /* namespace_typedef_sname_c: namespace_typedef_sname_c Y_COLON_COLON any_typedef_tdef  */
#line 4158 "parser.y"
    {
      DUMP_START( "namespace_typedef_sname_c",
                  "namespace_typedef_sname_c '::' any_typedef_tdef" );
      DUMP_SNAME( "namespace_typedef_sname_c", (yyvsp[-2].sname) );
      DUMP_AST( "any_typedef__ast", (yyvsp[0].tdef)->ast );

      (yyval.sname) = (yyvsp[-2].sname);
      c_sname_local_data( &(yyval.sname) )->type =
        *c_sname_local_type( &(yyvsp[0].tdef)->ast->sname );
      c_sname_t temp_sname = c_sname_dup( &(yyvsp[0].tdef)->ast->sname );
      c_sname_append_sname( &(yyval.sname), &temp_sname );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 8281 "parser.c"
    break;

  case 326: /* namespace_typedef_sname_c: namespace_typedef_sname_c Y_COLON_COLON Y_inline name_exp  */
#line 4176 "parser.y"
    {
      DUMP_START( "namespace_typedef_sname_c",
                  "namespace_typedef_sname_c '::' INLINE NAME" );
      DUMP_SNAME( "namespace_typedef_sname_c", (yyvsp[-3].sname) );
      DUMP_STR( "name", (yyvsp[0].name) );

      (yyval.sname) = (yyvsp[-3].sname);
      c_sname_append_name( &(yyval.sname), (yyvsp[0].name) );
      c_sname_local_data( &(yyval.sname) )->type =
        C_TYPE_LIT( TB_namespace, (yyvsp[-1].tid), TA_NONE );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 8300 "parser.c"
    break;

  case 327: /* namespace_typedef_sname_c: any_typedef_tdef  */
#line 4191 "parser.y"
                                  { (yyval.sname) = c_sname_dup( &(yyvsp[0].tdef)->ast->sname ); }
#line 8306 "parser.c"
    break;

  case 329: /* brace_in_scope_declaration_c_exp: error  */
#line 4197 "parser.y"
    {
      punct_expected( '{' );
    }
#line 8314 "parser.c"
    break;

  case 337: /* in_scope_declaration_c_exp: error  */
#line 4217 "parser.y"
    {
      elaborate_error( "declaration expected" );
    }
#line 8322 "parser.c"
    break;

  case 338: /* lambda_declaration_c: '[' capture_decl_list_c_opt ']' paren_param_c_ast_list_opt storage_class_subset_english_type_opt lambda_return_type_c_ast_opt  */
#line 4229 "parser.y"
    {
      DUMP_START( "lambda_declaration_c",
                  "'[' capture_decl_list_c_opt ']' "
                  "paren_param_c_ast_list_opt "
                  "lambda_return_type_c_ast_opt" );
      DUMP_AST_LIST( "capture_decl_list_c_opt", (yyvsp[-4].ast_list) );
      DUMP_AST_LIST( "paren_param_c_ast_list_opt", (yyvsp[-2].ast_list) );
      DUMP_TYPE( "storage_class_subset_english_type_opt", (yyvsp[-1].type) );
      DUMP_AST( "lambda_return_type_c_ast_opt", (yyvsp[0].ast) );

      c_ast_t *const lambda_ast = c_ast_new_gc( K_LAMBDA, &(yyloc) );
      lambda_ast->type = (yyvsp[-1].type);
      c_ast_list_set_param_of( &(yyvsp[-4].ast_list), lambda_ast );
      lambda_ast->lambda.capture_ast_list = slist_move( &(yyvsp[-4].ast_list) );
      c_ast_list_set_param_of( &(yyvsp[-2].ast_list), lambda_ast );
      lambda_ast->lambda.param_ast_list = slist_move( &(yyvsp[-2].ast_list) );
      c_ast_set_parent( (yyvsp[0].ast), lambda_ast );

      DUMP_AST( "$$_ast", lambda_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( lambda_ast ) );
      c_ast_english( lambda_ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 8352 "parser.c"
    break;

  case 339: /* capture_decl_list_c_opt: %empty  */
#line 4257 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 8358 "parser.c"
    break;

  case 341: /* capture_decl_list_c: capture_decl_list_c comma_exp capture_decl_c_ast  */
#line 4264 "parser.y"
    {
      DUMP_START( "capture_decl_list_c",
                  "capture_decl_list_c ',' "
                  "capture_decl_c_ast" );
      DUMP_AST_LIST( "capture_decl_list_c", (yyvsp[-2].ast_list) );
      DUMP_AST( "capture_decl_c_ast", (yyvsp[0].ast) );

      (yyval.ast_list) = (yyvsp[-2].ast_list);
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 8376 "parser.c"
    break;

  case 342: /* capture_decl_list_c: capture_decl_c_ast  */
#line 4279 "parser.y"
    {
      DUMP_START( "capture_decl_list_c",
                  "capture_decl_c_ast" );
      DUMP_AST( "capture_decl_c_ast", (yyvsp[0].ast) );

      slist_init( &(yyval.ast_list) );
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 8392 "parser.c"
    break;

  case 343: /* capture_decl_c_ast: '&'  */
#line 4294 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      (yyval.ast)->capture.kind = C_CAPTURE_REFERENCE;
    }
#line 8401 "parser.c"
    break;

  case 344: /* capture_decl_c_ast: '&' Y_NAME  */
#line 4299 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      c_sname_init_name( &(yyval.ast)->sname, (yyvsp[0].name) );
      (yyval.ast)->capture.kind = C_CAPTURE_REFERENCE;
    }
#line 8411 "parser.c"
    break;

  case 345: /* capture_decl_c_ast: '='  */
#line 4305 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      (yyval.ast)->capture.kind = C_CAPTURE_COPY;
    }
#line 8420 "parser.c"
    break;

  case 346: /* capture_decl_c_ast: Y_NAME  */
#line 4310 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      c_sname_init_name( &(yyval.ast)->sname, (yyvsp[0].name) );
    }
#line 8429 "parser.c"
    break;

  case 347: /* capture_decl_c_ast: Y_this  */
#line 4315 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      (yyval.ast)->capture.kind = C_CAPTURE_THIS;
    }
#line 8438 "parser.c"
    break;

  case 348: /* capture_decl_c_ast: '*' this_exp  */
#line 4320 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      (yyval.ast)->capture.kind = C_CAPTURE_STAR_THIS;
    }
#line 8447 "parser.c"
    break;

  case 349: /* lambda_return_type_c_ast_opt: %empty  */
#line 4327 "parser.y"
                                  { (yyval.ast) = NULL; }
#line 8453 "parser.c"
    break;

  case 350: /* $@14: %empty  */
#line 4328 "parser.y"
                                         { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 8459 "parser.c"
    break;

  case 351: /* lambda_return_type_c_ast_opt: Y_MINUS_GREATER type_c_ast $@14 cast_c_astp_opt  */
#line 4330 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "lambda_return_type_c_ast_opt",
                  "'->' type_c_ast cast_c_astp_opt" );
      DUMP_AST( "type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      (yyval.ast) = IF_ELSE( (yyvsp[0].ast_pair).ast, (yyvsp[-2].ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 8477 "parser.c"
    break;

  case 352: /* template_declaration_c: Y_template  */
#line 4349 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "template declarations" );
    }
#line 8485 "parser.c"
    break;

  case 353: /* $@15: %empty  */
#line 4357 "parser.y"
                         { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 8491 "parser.c"
    break;

  case 354: /* typed_declaration_c: type_c_ast $@15 decl_list_c_opt  */
#line 4358 "parser.y"
    {
      ia_type_ast_pop();
    }
#line 8499 "parser.c"
    break;

  case 355: /* $@16: %empty  */
#line 4367 "parser.y"
    {
      PARSE_ASSERT( is_nested_type_ok( &(yylsp[-1]) ) );
      in_attr.is_typename = (yyvsp[0].flag);
      gibberish_to_english();           // see the comment in "explain"
    }
#line 8509 "parser.c"
    break;

  case 356: /* $@17: %empty  */
#line 4373 "parser.y"
    {
      PARSE_ASSERT( !in_attr.is_typename || c_ast_is_typename_ok( (yyvsp[0].ast) ) );
      // see the comment in "define_command" about TS_typedef
      PARSE_ASSERT(
        c_type_add_tid( &(yyvsp[0].ast)->type, TS_typedef, &(yylsp[0]) )
      );
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 8522 "parser.c"
    break;

  case 357: /* typedef_declaration_c: Y_typedef typename_flag_opt $@16 type_c_ast $@17 typedef_decl_list_c  */
#line 4382 "parser.y"
    {
      ia_type_ast_pop();
    }
#line 8530 "parser.c"
    break;

  case 360: /* typedef_decl_c: decl_c_astp  */
#line 4395 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "typedef_decl_c", "decl_c_astp" );
      DUMP_SNAME( "in_attr__scope_sname", in_attr.scope_sname );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[0].ast_pair) );

      c_ast_t *const decl_ast = (yyvsp[0].ast_pair).ast;
      c_ast_t *typedef_ast;
      c_sname_t temp_sname;

      if ( decl_ast->kind == K_TYPEDEF && c_sname_empty( &decl_ast->sname ) ) {
        //
        // This is for either of the following cases:
        //
        //      typedef int int32_t;
        //      typedef int32_t int_least32_t;
        //
        // that is: any type name followed by an existing typedef name.
        //
        typedef_ast = type_ast;
        if ( c_sname_empty( &typedef_ast->sname ) )
          typedef_ast->sname = c_sname_dup( &decl_ast->tdef.for_ast->sname );
      }
      else {
        //
        // This is for either of the following cases:
        //
        //      typedef int foo;
        //      typedef int32_t foo;
        //
        // that is: any type name followed by a new name.
        //
        typedef_ast = c_ast_patch_placeholder( type_ast, decl_ast );
        temp_sname = c_ast_move_sname( decl_ast );
        c_sname_set( &typedef_ast->sname, &temp_sname );
      }

      PARSE_ASSERT( c_ast_check( typedef_ast ) );
      // see the comment in "define_command" about TS_typedef
      PJL_DISCARD_RV( c_ast_take_type_any( typedef_ast, &T_TS_typedef ) );

      if ( c_sname_count( &typedef_ast->sname ) > 1 ) {
        print_error( &(yylsp[0]),
          "typedef names can not be scoped; "
          "use: namespace %s { typedef ... }\n",
          c_sname_scope_gibberish( &typedef_ast->sname )
        );
        PARSE_ABORT();
      }

      temp_sname = c_sname_dup( &in_attr.scope_sname );
      c_sname_prepend_sname( &typedef_ast->sname, &temp_sname );

      DUMP_AST( "$$_ast", typedef_ast );
      DUMP_END();

      PARSE_ASSERT( define_type( typedef_ast, C_GIB_TYPEDEF  ) );
    }
#line 8595 "parser.c"
    break;

  case 362: /* typedef_decl_c_exp: error  */
#line 4460 "parser.y"
    {
      elaborate_error( "type expected" );
    }
#line 8603 "parser.c"
    break;

  case 363: /* user_defined_conversion_declaration_c: user_defined_conversion_decl_c_astp  */
#line 4469 "parser.y"
    {
      DUMP_START( "user_defined_conversion_declaration_c",
                  "user_defined_conversion_decl_c_astp" );
      DUMP_AST_PAIR( "user_defined_conversion_declaration_c", (yyvsp[0].ast_pair) );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( (yyvsp[0].ast_pair).ast ) );
      c_ast_english( (yyvsp[0].ast_pair).ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 8618 "parser.c"
    break;

  case 364: /* using_declaration_c: using_decl_c_ast  */
#line 4485 "parser.y"
    {
      // see the comment in "define_command" about TS_typedef
      PJL_DISCARD_RV( c_ast_take_type_any( (yyvsp[0].ast), &T_TS_typedef ) );

      PARSE_ASSERT( define_type( (yyvsp[0].ast), C_GIB_USING ) );
    }
#line 8629 "parser.c"
    break;

  case 365: /* $@18: %empty  */
#line 4495 "parser.y"
    { //
      // Using declarations are supported only in C++11 and later.  (However,
      // we always allow them in configuration files.)
      //
      // This check has to be done now in the parser rather than later in the
      // AST because using declarations are treated like typedef declarations
      // and the AST has no "memory" that such a declaration was a using
      // declaration.
      //
      if ( !IS_SUPPORTED( using_DECLS ) ) {
        print_error( &(yylsp[0]),
          "\"using\" not supported%s\n",
          C_LANG_WHICH( using_DECLS )
        );
        PARSE_ABORT();
      }

      gibberish_to_english();           // see the comment in "explain"
    }
#line 8653 "parser.c"
    break;

  case 366: /* $@19: %empty  */
#line 4516 "parser.y"
    {
      // see the comment in "define_command" about TS_typedef
      if ( !c_type_add_tid( &(yyvsp[0].ast)->type, TS_typedef, &(yylsp[0]) ) ) {
        free( (yyvsp[-3].name) );
        PARSE_ABORT();
      }
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 8666 "parser.c"
    break;

  case 367: /* using_decl_c_ast: Y_using $@18 any_name_exp attribute_specifier_list_c_atid_opt equals_exp type_c_ast $@19 cast_c_astp_opt  */
#line 4525 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "using_decl_c_ast",
                  "USING any_name_exp attribute_specifier_list_c_atid_opt '=' "
                  "type_c_ast cast_c_astp_opt" );
      DUMP_SNAME( "in_attr__scope_sname", in_attr.scope_sname );
      DUMP_STR( "any_name_exp", (yyvsp[-5].name) );
      DUMP_TID( "attribute_specifier_list_c_atid_opt", (yyvsp[-4].tid) );
      DUMP_AST( "type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      c_ast_t *const cast_ast = (yyvsp[0].ast_pair).ast;

      //
      // Ensure the type on the right-hand side doesn't have a name, e.g.:
      //
      //      using U = void (*F)();    // error
      //
      // This check has to be done now in the parser rather than later in the
      // AST because the patched AST loses the name.
      //
      c_sname_t const *const sname = c_ast_find_name( cast_ast, C_VISIT_DOWN );
      if ( sname != NULL ) {
        print_error( &cast_ast->loc, "\"using\" type can not have a name\n" );
        free( (yyvsp[-5].name) );
        PARSE_ABORT();
      }

      c_sname_t temp_sname = c_sname_dup( &in_attr.scope_sname );
      c_sname_append_name( &temp_sname, (yyvsp[-5].name) );

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-2].ast), cast_ast );
      c_sname_set( &(yyval.ast)->sname, &temp_sname );
      (yyval.ast)->type.atids = c_tid_check( (yyvsp[-4].tid), C_TPID_ATTR );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( (yyval.ast) ) );
    }
#line 8712 "parser.c"
    break;

  case 368: /* decl_list_c_opt: %empty  */
#line 4586 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "decl_list_c_opt", "<empty>" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );

      if ( in_attr.align.kind != C_ALIGNAS_NONE ) {
        print_error( &in_attr.align.loc,
          "\"%s\" invalid here\n",
          alignas_name()
        );
        PARSE_ABORT();
      }

      bool const is_structured_binding =
        c_ast_unreference_any( type_ast )->kind == K_STRUCTURED_BINDING;

      if ( is_structured_binding ) {
        // do nothing
      }
      else if ( (type_ast->kind & K_ANY_ECSU) == 0 ) {
        //
        // The declaration is a non-ECSU type, e.g.:
        //
        //      int
        //
        c_loc_t const loc = lexer_loc();
        print_error( &loc, "declaration expected" );
        print_error_token_is_a( printable_yytext() );
        EPUTC( '\n' );
        PARSE_ABORT();
      }
      else {
        c_sname_t const *const ecsu_sname = &type_ast->csu.csu_sname;
        assert( !c_sname_empty( ecsu_sname ) );

        if ( c_sname_count( ecsu_sname ) > 1 ) {
          print_error( &type_ast->loc,
            "forward declaration can not have a scoped name\n"
          );
          PARSE_ABORT();
        }

        c_sname_t temp_sname = c_sname_dup( ecsu_sname );
        c_sname_set( &type_ast->sname, &temp_sname );
      }

      DUMP_AST( "$$_ast", type_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( type_ast ) );
      if ( is_structured_binding )
        c_ast_english( type_ast, C_ENG_DECL, stdout );
      else
        c_typedef_english( &C_TYPEDEF_LIT( type_ast, C_ENG_DECL ), stdout );
      PUTC( '\n' );
    }
#line 8774 "parser.c"
    break;

  case 369: /* decl_list_c_opt: decl_list_c  */
#line 4645 "parser.y"
    {
      DUMP_START( "decl_list_c_opt", "decl_list_c" );
      DUMP_AST_LIST( "decl_list_c", (yyvsp[0].ast_list) );
      DUMP_END();

      PARSE_ASSERT( c_ast_list_check( &(yyvsp[0].ast_list) ) );
      c_ast_list_english( &(yyvsp[0].ast_list), stdout );
    }
#line 8787 "parser.c"
    break;

  case 370: /* decl_list_c: decl_list_c ',' decl_c_exp  */
#line 4657 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[-2].ast_list);
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );
    }
#line 8796 "parser.c"
    break;

  case 371: /* decl_list_c: decl_c  */
#line 4662 "parser.y"
    {
      slist_init( &(yyval.ast_list) );
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );
    }
#line 8805 "parser.c"
    break;

  case 372: /* decl_c: decl_c_astp  */
#line 4671 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "decl_c", "decl_c_astp" );
      switch ( in_attr.align.kind ) {
        case C_ALIGNAS_NONE:
          break;
        case C_ALIGNAS_BYTES:
          DUMP_INT( "in_attr__alignas_bytes", in_attr.align.bytes );
          break;
        case C_ALIGNAS_SNAME:
          DUMP_SNAME( "in_attr__alignas_sname", in_attr.align.sname );
          break;
        case C_ALIGNAS_TYPE:
          DUMP_AST( "in_attr__alignas_type_ast", in_attr.align.type_ast );
          break;
      } // switch
      DUMP_BOOL( "in_attr__typename_flag_opt", in_attr.is_typename );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[0].ast_pair) );

      (yyval.ast) = join_type_decl( type_ast, (yyvsp[0].ast_pair).ast );
      PARSE_ASSERT( (yyval.ast) != NULL );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 8837 "parser.c"
    break;

  case 374: /* decl_c_exp: error  */
#line 4703 "parser.y"
    {
      elaborate_error( "declaration expected" );
    }
#line 8845 "parser.c"
    break;

  case 379: /* decl_c_astp: msc_calling_convention_atid msc_calling_convention_c_astp  */
#line 4714 "parser.y"
    {
      (yyval.ast_pair) = (yyvsp[0].ast_pair);
      (yyval.ast_pair).ast->loc = (yyloc);
      (yyval.ast_pair).ast->type.atids |= (yyvsp[-1].tid);
    }
#line 8855 "parser.c"
    break;

  case 387: /* decl2_c_astp: param_pack_decl_c_ast  */
#line 4732 "parser.y"
                                   { (yyval.ast_pair) = (c_ast_pair_t){ (yyvsp[0].ast), NULL }; }
#line 8861 "parser.c"
    break;

  case 388: /* decl2_c_astp: sname_c_ast gnu_attribute_specifier_list_c_opt  */
#line 4734 "parser.y"
    {
      (yyval.ast_pair) = (c_ast_pair_t){ (yyvsp[-1].ast), .target_ast = NULL };
    }
#line 8869 "parser.c"
    break;

  case 389: /* decl2_c_astp: typedef_type_decl_c_ast  */
#line 4738 "parser.y"
    {
      (yyval.ast_pair) = (c_ast_pair_t){ (yyvsp[0].ast), .target_ast = NULL };
    }
#line 8877 "parser.c"
    break;

  case 392: /* param_pack_decl_c_ast: "..." sname_c_ast  */
#line 4747 "parser.y"
    {
      DUMP_START( "param_pack_decl_c_ast", "... sname_c_ast" );\
      DUMP_AST( "sname_c_ast", (yyvsp[0].ast) );

      c_ast_set_parameter_pack( (yyvsp[0].ast) );
      (yyval.ast) = (yyvsp[0].ast);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 8892 "parser.c"
    break;

  case 393: /* param_pack_decl_c_ast: "..." error  */
#line 4758 "parser.y"
    {
      (yyval.ast) = NULL;
      elaborate_error( "name expected" );
    }
#line 8901 "parser.c"
    break;

  case 394: /* array_decl_c_astp: decl2_c_astp array_size_c_ast gnu_attribute_specifier_list_c_opt  */
#line 4770 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "array_decl_c_astp", "decl2_c_astp array_size_c_ast" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "decl2_c_astp", (yyvsp[-2].ast_pair) );
      DUMP_AST( "array_size_c_ast", (yyvsp[-1].ast) );

      c_ast_set_parent(
        c_ast_new_gc( K_PLACEHOLDER, &(yylsp[-2]) ), (yyvsp[-1].ast)
      );

      c_ast_t *const of_ast = ia_type_spec_ast( type_ast );
      if ( (yyvsp[-2].ast_pair).target_ast != NULL ) {
        // array-of or function-like-ret type
        (yyval.ast_pair) = (c_ast_pair_t){
          (yyvsp[-2].ast_pair).ast,
          c_ast_add_array( (yyvsp[-2].ast_pair).target_ast, (yyvsp[-1].ast), of_ast )
        };
      }
      else {
        (yyval.ast_pair) = (c_ast_pair_t){
          c_ast_add_array( (yyvsp[-2].ast_pair).ast, (yyvsp[-1].ast), of_ast ),
          .target_ast = NULL
        };
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 8936 "parser.c"
    break;

  case 395: /* array_size_c_ast: '[' rbracket_exp  */
#line 4804 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_SIZE_NONE;
    }
#line 8945 "parser.c"
    break;

  case 396: /* array_size_c_ast: '[' uint_lit rbracket_exp  */
#line 4809 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_SIZE_INT;
      (yyval.ast)->array.size_int = (yyvsp[-1].uint_val);
    }
#line 8955 "parser.c"
    break;

  case 397: /* array_size_c_ast: '[' Y_NAME rbracket_exp  */
#line 4815 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_SIZE_NAME;
      (yyval.ast)->array.size_name = (yyvsp[-1].name);
    }
#line 8965 "parser.c"
    break;

  case 398: /* array_size_c_ast: '[' type_qualifier_list_c_stid rbracket_exp  */
#line 4821 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[-1].tid), C_TPID_STORE );
      (yyval.ast)->array.kind = C_ARRAY_SIZE_NONE;
    }
#line 8975 "parser.c"
    break;

  case 399: /* array_size_c_ast: '[' type_qualifier_list_c_stid static_stid_opt uint_lit rbracket_exp  */
#line 4828 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[-3].tid) | (yyvsp[-2].tid), C_TPID_STORE );
      (yyval.ast)->array.kind = C_ARRAY_SIZE_INT;
      (yyval.ast)->array.size_int = (yyvsp[-1].uint_val);
    }
#line 8986 "parser.c"
    break;

  case 400: /* array_size_c_ast: '[' type_qualifier_list_c_stid static_stid_opt Y_NAME rbracket_exp  */
#line 4836 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[-3].tid) | (yyvsp[-2].tid), C_TPID_STORE );
      (yyval.ast)->array.kind = C_ARRAY_SIZE_NAME;
      (yyval.ast)->array.size_name = (yyvsp[-1].name);
    }
#line 8997 "parser.c"
    break;

  case 401: /* array_size_c_ast: '[' type_qualifier_list_c_stid_opt '*' rbracket_exp  */
#line 4843 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[-2].tid), C_TPID_STORE );
      (yyval.ast)->array.kind = C_ARRAY_SIZE_VLA;
    }
#line 9007 "parser.c"
    break;

  case 402: /* array_size_c_ast: '[' Y_static type_qualifier_list_c_stid_opt uint_lit rbracket_exp  */
#line 4850 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->type.stids =
        c_tid_check( TS_NON_EMPTY_ARRAY | (yyvsp[-2].tid), C_TPID_STORE );
      (yyval.ast)->array.kind = C_ARRAY_SIZE_INT;
      (yyval.ast)->array.size_int = (yyvsp[-1].uint_val);
    }
#line 9019 "parser.c"
    break;

  case 403: /* array_size_c_ast: '[' Y_static type_qualifier_list_c_stid_opt Y_NAME rbracket_exp  */
#line 4859 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->type.stids =
        c_tid_check( TS_NON_EMPTY_ARRAY | (yyvsp[-2].tid), C_TPID_STORE );
      (yyval.ast)->array.kind = C_ARRAY_SIZE_NAME;
      (yyval.ast)->array.size_name = (yyvsp[-1].name);
    }
#line 9031 "parser.c"
    break;

  case 404: /* array_size_c_ast: '[' error ']'  */
#line 4867 "parser.y"
    {
      elaborate_error( "array size expected" );
    }
#line 9039 "parser.c"
    break;

  case 405: /* $@20: %empty  */
#line 4877 "parser.y"
    { //
      // A block AST has to be the type inherited attribute for decl_c_astp so
      // we have to create it here.
      //
      ia_type_ast_push( c_ast_new_gc( K_APPLE_BLOCK, &(yyloc) ) );
    }
#line 9050 "parser.c"
    break;

  case 406: /* block_decl_c_astp: '(' '^' $@20 type_qualifier_list_c_stid_opt decl_c_astp rparen_exp lparen_exp param_c_ast_list_opt ')' gnu_attribute_specifier_list_c_opt  */
#line 4886 "parser.y"
    {
      c_ast_t *const block_ast = ia_type_ast_pop();
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "block_decl_c_astp",
                  "'(' '^' type_qualifier_list_c_stid_opt decl_c_astp ')' "
                  "'(' param_c_ast_list_opt ')'" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_TID( "type_qualifier_list_c_stid_opt", (yyvsp[-6].tid) );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[-5].ast_pair) );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-2].ast_list) );

      PARSE_ASSERT(
        c_type_add_tid( &block_ast->type, (yyvsp[-6].tid), &(yylsp[-6]) )
      );
      c_ast_list_set_param_of( &(yyvsp[-2].ast_list), block_ast );
      block_ast->block.param_ast_list = slist_move( &(yyvsp[-2].ast_list) );

      c_ast_t *const ret_ast = ia_type_spec_ast( type_ast );
      if ( (yyvsp[-5].ast_pair).target_ast != NULL ) {
        (yyval.ast_pair) = (c_ast_pair_t){
          (yyvsp[-5].ast_pair).ast,
          c_ast_add_func( (yyvsp[-5].ast_pair).target_ast, block_ast, ret_ast )
        };
      }
      else {
        (yyval.ast_pair) = (c_ast_pair_t){
          c_ast_add_func( (yyvsp[-5].ast_pair).ast, block_ast, ret_ast ),
          block_ast->block.ret_ast
        };
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9090 "parser.c"
    break;

  case 407: /* destructor_declaration_c: virtual_stid_opt '~' any_name_exp lparen_exp no_destructor_params param_list_rparen_func_qualifier_list_c_stid_opt noexcept_c_stid_opt gnu_attribute_specifier_list_c_opt func_equals_c_stid_opt  */
#line 4934 "parser.y"
    {
      DUMP_START( "destructor_declaration_c",
                  "virtual_stid_opt '~' any_name_exp '(' ')' "
                  "func_qualifier_list_c_stid_opt noexcept_c_stid_opt "
                  "gnu_attribute_specifier_list_c_opt func_equals_c_stid_opt" );
      DUMP_TID( "virtual_stid_opt", (yyvsp[-8].tid) );
      DUMP_STR( "any_name_exp", (yyvsp[-6].name) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-3].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_TID( "func_equals_c_stid_opt", (yyvsp[0].tid) );

      c_ast_t *const dtor_ast = c_ast_new_gc( K_DESTRUCTOR, &(yyloc) );
      c_sname_init_name( &dtor_ast->sname, (yyvsp[-6].name) );
      dtor_ast->type.stids = c_tid_check(
        (yyvsp[-8].tid) | (yyvsp[-3].tid) | (yyvsp[-2].tid) | (yyvsp[0].tid),
        C_TPID_STORE
      );

      DUMP_AST( "$$_ast", dtor_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( dtor_ast ) );
      c_ast_english( dtor_ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 9120 "parser.c"
    break;

  case 409: /* no_destructor_params: error  */
#line 4981 "parser.y"
    { //
      // Ordinarily, we'd get an error message like:
      //
      //      c++decl> explain ~C(int)
      //                          ^
      //      12: syntax error: "int": destructors may not have parameters
      //      ("int" is a keyword)
      //
      // where the <<("int" is a keyword)>> part seems wrong since the user
      // didn't try using "int" as an ordinary identifier.  To suppress that
      // part, set yytext to the empty string so elaborate_error() won't print
      // it nor call print_error_token_is_a() and and we'll instead get an
      // error message like:
      //
      //      c++decl> explain ~C(int)
      //                          ^
      //      12: syntax error: destructors may not have parameters
      //
      set_yytext( "" );
      elaborate_error( "destructors may not have parameters" );
    }
#line 9146 "parser.c"
    break;

  case 410: /* file_scope_constructor_declaration_c: inline_stid_opt Y_CONSTRUCTOR_SNAME lparen_exp param_c_ast_list_opt param_list_rparen_func_qualifier_list_c_stid_opt noexcept_c_stid_opt gnu_attribute_specifier_list_c_opt  */
#line 5011 "parser.y"
    {
      DUMP_START( "file_scope_constructor_declaration_c",
                  "inline_opt CONSTRUCTOR_SNAME '(' param_c_ast_list_opt ')' "
                  "func_qualifier_list_c_stid_opt noexcept_c_stid_opt" );
      DUMP_TID( "inline_stid_opt", (yyvsp[-6].tid) );
      DUMP_SNAME( "CONSTRUCTOR_SNAME", (yyvsp[-5].sname) );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-3].ast_list) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-1].tid) );

      c_sname_set_scope_type( &(yyvsp[-5].sname), &C_TYPE_LIT_B( TB_class ) );

      c_ast_t *const ctor_ast = c_ast_new_gc( K_CONSTRUCTOR, &(yyloc) );
      ctor_ast->sname = c_sname_move( &(yyvsp[-5].sname) );
      ctor_ast->type.stids = c_tid_check(
        (yyvsp[-6].tid) | (yyvsp[-2].tid) | (yyvsp[-1].tid),
        C_TPID_STORE
      );
      c_ast_list_set_param_of( &(yyvsp[-3].ast_list), ctor_ast );
      ctor_ast->ctor.param_ast_list = slist_move( &(yyvsp[-3].ast_list) );

      DUMP_AST( "$$_ast", ctor_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( ctor_ast ) );
      c_ast_english( ctor_ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 9179 "parser.c"
    break;

  case 411: /* file_scope_destructor_declaration_c: inline_stid_opt destructor_sname lparen_exp no_destructor_params param_list_rparen_func_qualifier_list_c_stid_opt noexcept_c_stid_opt gnu_attribute_specifier_list_c_opt  */
#line 5048 "parser.y"
    {
      DUMP_START( "file_scope_destructor_declaration_c",
                  "inline_opt destructor_sname '(' ')' "
                  "func_qualifier_list_c_stid_opt noexcept_c_stid_opt" );
      DUMP_TID( "inline_stid_opt", (yyvsp[-6].tid) );
      DUMP_SNAME( "destructor_sname", (yyvsp[-5].sname) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-1].tid) );

      c_sname_set_scope_type( &(yyvsp[-5].sname), &C_TYPE_LIT_B( TB_class ) );

      c_ast_t *const dtor_ast = c_ast_new_gc( K_DESTRUCTOR, &(yyloc) );
      dtor_ast->sname = c_sname_move( &(yyvsp[-5].sname) );
      dtor_ast->type.stids = c_tid_check(
        (yyvsp[-6].tid) | (yyvsp[-2].tid) | (yyvsp[-1].tid),
        C_TPID_STORE
      );

      DUMP_AST( "$$_ast", dtor_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( dtor_ast ) );
      c_ast_english( dtor_ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 9209 "parser.c"
    break;

  case 412: /* func_decl_c_astp: decl2_c_astp param_list_c_lparen param_c_ast_list_opt param_list_rparen_func_qualifier_list_c_stid_opt ref_qualifier_c_stid_opt noexcept_c_stid_opt trailing_return_type_c_ast_opt func_equals_c_stid_opt  */
#line 5093 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "func_decl_c_astp",
                  "decl2_c_astp '(' param_c_ast_list_opt ')' "
                  "func_qualifier_list_c_stid_opt "
                  "ref_qualifier_c_stid_opt noexcept_c_stid_opt "
                  "trailing_return_type_c_ast_opt "
                  "func_equals_c_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "decl2_c_astp", (yyvsp[-7].ast_pair) );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-5].ast_list) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-4].tid) );
      DUMP_TID( "ref_qualifier_c_stid_opt", (yyvsp[-3].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_AST( "trailing_return_type_c_ast_opt", (yyvsp[-1].ast) );
      DUMP_TID( "func_equals_c_stid_opt", (yyvsp[0].tid) );

      c_tid_t const func_stids = c_tid_check(
        (yyvsp[-4].tid) | (yyvsp[-3].tid) | (yyvsp[-2].tid) | (yyvsp[0].tid),
        C_TPID_STORE
      );

      bool const assume_constructor = c_ast_is_likely_ctor( type_ast );

      c_ast_t *const func_ast =
        c_ast_new_gc( assume_constructor ? K_CONSTRUCTOR : K_FUNCTION, &(yyloc) );
      func_ast->type.stids = func_stids;
      c_ast_list_set_param_of( &(yyvsp[-5].ast_list), func_ast );
      func_ast->func.param_ast_list = slist_move( &(yyvsp[-5].ast_list) );

      c_ast_t *const decl_ast = (yyvsp[-7].ast_pair).ast;

      if ( assume_constructor ) {
        assert( (yyvsp[-1].ast) == NULL );
        (yyval.ast_pair) = (c_ast_pair_t){
          c_ast_add_func( decl_ast, func_ast, /*ret_ast=*/NULL ),
          .target_ast = NULL
        };
      }
      else {
        c_ast_t *ret_ast;
        c_ast_t *target_ast = (yyvsp[-7].ast_pair).target_ast;

        if ( target_ast != NULL && target_ast->kind != K_POINTER ) {
          //
          // This is for a case like:
          //
          //      int f() ()
          //       |    |  |
          //       |    |  func
          //       |    |
          //       |    decl_ast (func)
          //       |
          //       ret_ast
          //
          // We replace ret_ast with decl_ast:
          //
          //      int f() ()
          //       |    |  |
          //       |    |  func
          //       X    |
          //       |    decl_ast (func)
          //       |
          //       ret_ast <- decl_ast (func)
          //
          // that is, a "function returning function" -- which is illegal
          // (since functions can't return functions) and will be caught by
          // c_ast_check_ret_type().
          //
          ret_ast = decl_ast;
          target_ast = NULL;
        }
        else {
          ret_ast = IF_ELSE( (yyvsp[-1].ast), ia_type_spec_ast( type_ast ) );
        }

        if ( target_ast != NULL ) {
          (yyval.ast_pair) = (c_ast_pair_t){
            decl_ast,
            c_ast_add_func( target_ast, func_ast, ret_ast )
          };
        }
        else {
          (yyval.ast_pair) = (c_ast_pair_t){
            c_ast_add_func( decl_ast, func_ast, ret_ast ),
            func_ast->func.ret_ast
          };
        }
      }

      c_tid_t const msc_call_atids = (yyval.ast_pair).ast->type.atids & TA_ANY_MSC_CALL;
      if ( msc_call_atids != TA_NONE ) {
        //
        // Microsoft calling conventions need to be moved from the pointer to
        // the function, e.g., change:
        //
        //      declare f as cdecl pointer to function returning void
        //
        // to:
        //
        //      declare f as pointer to cdecl function returning void
        //
        for ( c_ast_t *ast = (yyval.ast_pair).ast; (ast = c_ast_unpointer( ast )) != NULL; ) {
          if ( ast->kind == K_FUNCTION ) {
            (yyval.ast_pair).ast->type.atids &= c_tid_compl( TA_ANY_MSC_CALL );
            ast->type.atids |= msc_call_atids;
          }
        } // for
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9328 "parser.c"
    break;

  case 413: /* $@21: %empty  */
#line 5218 "parser.y"
    {
      if ( OPT_LANG_IS( CONSTRUCTORS ) ) {
        //
        // In C++, encountering a name followed by '(' declares an in-class
        // constructor.  That means NAME is the name of a class, so we have to
        // create a temporary class type for it so if it's used as the type of
        // a parameter, e.g.:
        //
        //      C(C const&)
        //
        // it'll be recognized as such.
        //
        c_ast_t *const csu_ast = c_ast_new_gc( K_CLASS_STRUCT_UNION, &(yylsp[-1]) );
        csu_ast->type.btids = TB_class;
        c_sname_init_name( &csu_ast->csu.csu_sname, check_strdup( (yyvsp[-1].name) ) );
        csu_ast->sname = c_sname_dup( &csu_ast->csu.csu_sname );

        in_attr.tdef_rb = c_typedef_add( csu_ast, C_GIB_TYPEDEF );
        MAYBE_UNUSED c_typedef_t const *const csu_tdef = in_attr.tdef_rb->data;
        assert( csu_tdef->ast == csu_ast );
      }
    }
#line 9355 "parser.c"
    break;

  case 414: /* pc99_func_or_constructor_declaration_c: Y_NAME param_list_c_lparen $@21 param_c_ast_list_opt param_list_rparen_func_qualifier_list_c_stid_opt noexcept_c_stid_opt func_equals_c_stid_opt  */
#line 5243 "parser.y"
    {
      DUMP_START( "pc99_func_or_constructor_declaration_c",
                  "NAME '(' param_c_ast_list_opt ')' noexcept_c_stid_opt "
                  "func_equals_c_stid_opt" );
      DUMP_STR( "NAME", (yyvsp[-6].name) );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-3].ast_list) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-1].tid) );
      DUMP_TID( "func_equals_c_stid_opt", (yyvsp[0].tid) );

      c_ast_t *ast;

      if ( OPT_LANG_IS( CONSTRUCTORS ) ) {
        //
        // Free the temporary typedef for the class.
        //
        // Note that we free only the typedef and not its AST; its AST will be
        // garbage collected.
        //
        free( c_typedef_remove( in_attr.tdef_rb ) );

        //
        // In C++, encountering a name followed by '(' declares an in-class
        // constructor.
        //
        ast = c_ast_new_gc( K_CONSTRUCTOR, &(yyloc) );
      }
      else {
        if ( !IS_SUPPORTED( IMPLICIT_int ) ) {
          //
          // In C99 and later, implicit int is an error.  This check has to be
          // done now in the parser rather than later in the AST since the AST
          // would have no "memory" that the return type was implicitly int.
          //
          print_error( &(yylsp[-6]),
            "implicit \"%s\" functions are illegal%s",
            c_tid_error( TB_int ),
            C_LANG_WHICH( IMPLICIT_int )
          );
          print_error_token_is_a( (yyvsp[-6].name) );
          if ( strcmp( (yyvsp[-6].name), L_typeof ) == 0 ||
               strcmp( (yyvsp[-6].name), L_typeof_unqual ) == 0 ) {
            EPRINTF( "; use \"%s\" instead", L_GNU___typeof__ );
          }
          else {
            print_suggestions(
              DYM_C_KEYWORDS | DYM_C_MACROS | DYM_C_TYPES,
              (yyvsp[-6].name)
            );
          }
          EPUTC( '\n' );
          free( (yyvsp[-6].name) );
          PARSE_ABORT();
        }

        //
        // In C prior to C99, encountering a name followed by '(' declares a
        // function that implicitly returns int:
        //
        //      power(x, n)             /* raise x to n-th power; n > 0 */
        //
        c_ast_t *const ret_ast = c_ast_new_gc( K_BUILTIN, &(yylsp[-6]) );
        ret_ast->type.btids = TB_int;

        ast = c_ast_new_gc( K_FUNCTION, &(yyloc) );
        c_ast_set_parent( ret_ast, ast );
      }

      c_sname_init_name( &ast->sname, (yyvsp[-6].name) );
      ast->type.stids = c_tid_check(
        (yyvsp[-2].tid) | (yyvsp[-1].tid) | (yyvsp[0].tid),
        C_TPID_STORE
      );
      c_ast_list_set_param_of( &(yyvsp[-3].ast_list), ast );
      ast->func.param_ast_list = slist_move( &(yyvsp[-3].ast_list) );

      DUMP_AST( "$$_ast", ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( ast ) );
      c_ast_english( ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 9443 "parser.c"
    break;

  case 415: /* $@22: %empty  */
#line 5330 "parser.y"
    {
      if ( OPT_LANG_IS( MEMBER_FUNCTIONS ) ) {
        //
        // Both "final" and "override" are matched only within member function
        // declarations.  Now that ')' has been parsed, we're within one, so
        // set the keyword context to C_KW_CTX_MBR_FUNC.
        //
        lexer_keyword_ctx = C_KW_CTX_MBR_FUNC;
      }
    }
#line 9458 "parser.c"
    break;

  case 416: /* param_list_rparen_func_qualifier_list_c_stid_opt: param_list_rparen $@22 func_qualifier_list_c_stid_opt  */
#line 5341 "parser.y"
    {
      lexer_keyword_ctx = C_KW_CTX_DEFAULT;
      (yyval.tid) = (yyvsp[0].tid);
    }
#line 9467 "parser.c"
    break;

  case 417: /* func_qualifier_list_c_stid_opt: %empty  */
#line 5348 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 9473 "parser.c"
    break;

  case 418: /* func_qualifier_list_c_stid_opt: func_qualifier_list_c_stid_opt func_qualifier_c_stid  */
#line 5350 "parser.y"
    {
      DUMP_START( "func_qualifier_list_c_stid_opt",
                  "func_qualifier_list_c_stid_opt func_qualifier_c_stid" );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-1].tid) );
      DUMP_TID( "func_qualifier_c_stid", (yyvsp[0].tid) );

      (yyval.tid) = (yyvsp[-1].tid);
      PARSE_ASSERT( c_tid_add( &(yyval.tid), (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_TID( "$$_stids", (yyval.tid) );
      DUMP_END();
    }
#line 9490 "parser.c"
    break;

  case 423: /* noexcept_c_stid_opt: %empty  */
#line 5379 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 9496 "parser.c"
    break;

  case 425: /* noexcept_c_stid_opt: Y_noexcept '(' noexcept_bool_stid_exp rparen_exp  */
#line 5382 "parser.y"
    {
      (yyval.tid) = (yyvsp[-1].tid);
    }
#line 9504 "parser.c"
    break;

  case 426: /* noexcept_c_stid_opt: Y_throw lparen_exp rparen_exp  */
#line 5386 "parser.y"
    {
      (yyval.tid) = (yyvsp[-2].tid);
    }
#line 9512 "parser.c"
    break;

  case 427: /* noexcept_c_stid_opt: Y_throw lparen_exp param_c_ast_list ')'  */
#line 5390 "parser.y"
    {
      c_ast_list_cleanup( &(yyvsp[-1].ast_list) );

      if ( OPT_LANG_IS( throw ) )
        UNSUPPORTED( &(yylsp[-1]), "dynamic exception specifications" );

      print_error( &(yylsp[-1]),
        "dynamic exception specifications not supported%s\n",
        C_LANG_WHICH( throw )
      );
      PARSE_ABORT();
    }
#line 9529 "parser.c"
    break;

  case 430: /* noexcept_bool_stid_exp: error  */
#line 5408 "parser.y"
    {
      elaborate_error( "\"true\" or \"false\" expected" );
    }
#line 9537 "parser.c"
    break;

  case 431: /* trailing_return_type_c_ast_opt: %empty  */
#line 5414 "parser.y"
                                  { (yyval.ast) = NULL; }
#line 9543 "parser.c"
    break;

  case 432: /* $@23: %empty  */
#line 5416 "parser.y"
                                         { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 9549 "parser.c"
    break;

  case 433: /* trailing_return_type_c_ast_opt: Y_MINUS_GREATER type_c_ast $@23 cast_c_astp_opt  */
#line 5418 "parser.y"
    { //
      // The function trailing return-type syntax is supported only in C++11
      // and later.  This check has to be done now in the parser rather than
      // later in the AST because the AST has no "memory" of where the return-
      // type came from.
      //
      if ( !IS_SUPPORTED( TRAILING_RETURN_TYPES ) ) {
        print_error( &(yylsp[-3]),
          "trailing return type not supported%s\n",
          C_LANG_WHICH( TRAILING_RETURN_TYPES )
        );
        PARSE_ABORT();
      }

      ia_type_ast_pop();
      c_ast_t const *const ret_ast = ia_type_ast_peek();

      DUMP_START( "trailing_return_type_c_ast_opt",
                  "'->' type_c_ast cast_c_astp_opt" );
      DUMP_AST( "in_attr__type_c_ast", ret_ast );
      DUMP_AST( "type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      (yyval.ast) = IF_ELSE( (yyvsp[0].ast_pair).ast, (yyvsp[-2].ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();

      //
      // Ensure that a function using the C++11 trailing return type syntax
      // starts with "auto":
      //
      //      void f() -> int
      //      ^
      //      error: must be "auto"
      //
      // This check has to be done now in the parser rather than later in the
      // AST because the "auto" is just a syntactic return-type placeholder in
      // C++11 and the AST node for the placeholder is discarded and never made
      // part of the AST.
      //
      if ( ret_ast->type.btids != TB_auto ) {
        print_error( &ret_ast->loc,
          "function with trailing return type must only specify \"%s\"\n",
          c_tid_error( TB_auto )
        );
        PARSE_ABORT();
      }
    }
#line 9603 "parser.c"
    break;

  case 434: /* trailing_return_type_c_ast_opt: gnu_attribute_specifier_list_c  */
#line 5469 "parser.y"
    {
      (yyval.ast) = NULL;
    }
#line 9611 "parser.c"
    break;

  case 435: /* func_equals_c_stid_opt: %empty  */
#line 5475 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 9617 "parser.c"
    break;

  case 436: /* func_equals_c_stid_opt: '=' Y_default  */
#line 5476 "parser.y"
                                  { (yyval.tid) = (yyvsp[0].tid); }
#line 9623 "parser.c"
    break;

  case 437: /* func_equals_c_stid_opt: '=' Y_delete  */
#line 5477 "parser.y"
                                  { (yyval.tid) = (yyvsp[0].tid); }
#line 9629 "parser.c"
    break;

  case 438: /* func_equals_c_stid_opt: '=' uint_lit  */
#line 5479 "parser.y"
    {
      if ( (yyvsp[0].uint_val) != 0 ) {
        print_error( &(yylsp[0]), "'0' expected\n" );
        PARSE_ABORT();
      }
      (yyval.tid) = TS_PURE_virtual;
    }
#line 9641 "parser.c"
    break;

  case 439: /* func_equals_c_stid_opt: '=' error  */
#line 5487 "parser.y"
    {
      if ( OPT_LANG_IS( default_delete_FUNCS ) )
        elaborate_error( "'0', \"default\", or \"delete\" expected" );
      else
        elaborate_error( "'0' expected" );
    }
#line 9652 "parser.c"
    break;

  case 441: /* param_c_ast_list_exp: error  */
#line 5500 "parser.y"
    {
      slist_init( &(yyval.ast_list) );
      elaborate_error( "parameter list expected" );
    }
#line 9661 "parser.c"
    break;

  case 442: /* param_c_ast_list_opt: %empty  */
#line 5507 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 9667 "parser.c"
    break;

  case 444: /* param_c_ast_list: param_c_ast_list comma_exp param_c_ast_exp  */
#line 5513 "parser.y"
    {
      DUMP_START( "param_c_ast_list", "param_c_ast_list ',' param_c_ast" );
      DUMP_AST_LIST( "param_c_ast_list", (yyvsp[-2].ast_list) );
      DUMP_AST( "param_c_ast", (yyvsp[0].ast) );

      (yyval.ast_list) = (yyvsp[-2].ast_list);
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 9683 "parser.c"
    break;

  case 445: /* param_c_ast_list: param_c_ast  */
#line 5526 "parser.y"
    {
      DUMP_START( "param_c_ast_list", "param_c_ast" );
      DUMP_AST( "param_c_ast", (yyvsp[0].ast) );

      slist_init( &(yyval.ast_list) );
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 9698 "parser.c"
    break;

  case 446: /* $@24: %empty  */
#line 5543 "parser.y"
    {
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 9706 "parser.c"
    break;

  case 447: /* param_c_ast: this_stid_opt type_c_ast $@24 cast_c_astp_opt  */
#line 5547 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "param_c_ast", "this_stid_opt type_c_ast cast_c_astp_opt" );
      DUMP_TID( "this_stid_opt", (yyvsp[-3].tid) );
      DUMP_AST( "type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast_pair).ast );

      if ( (yyval.ast)->kind == K_FUNCTION ) {
        //
        // From the C11 standard, section 6.3.2.1(4):
        //
        //    [A] function designator with type "function returning type" is
        //    converted to an expression that has type "pointer to function
        //    returning type."
        //
        (yyval.ast) = c_ast_pointer( (yyval.ast), &gc_ast_list );
      }

      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[-3].tid), &(yylsp[-3]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9737 "parser.c"
    break;

  case 449: /* param_c_ast: "..."  */
#line 5583 "parser.y"
    {
      DUMP_START( "param_c_ast", "..." );

      (yyval.ast) = c_ast_new_gc( K_VARIADIC, &(yyloc) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9750 "parser.c"
    break;

  case 451: /* param_c_ast_exp: error  */
#line 5596 "parser.y"
    {
      elaborate_error( "parameter declaration expected" );
    }
#line 9758 "parser.c"
    break;

  case 452: /* paren_param_c_ast_list_opt: %empty  */
#line 5602 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 9764 "parser.c"
    break;

  case 453: /* paren_param_c_ast_list_opt: param_list_c_lparen param_c_ast_list_opt param_list_rparen  */
#line 5604 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[-1].ast_list);
    }
#line 9772 "parser.c"
    break;

  case 454: /* param_list_c_lparen: '('  */
#line 5610 "parser.y"
                                  { lexer_is_param_list_decl = true; }
#line 9778 "parser.c"
    break;

  case 455: /* param_list_rparen: ')'  */
#line 5614 "parser.y"
                                  { lexer_is_param_list_decl = false; }
#line 9784 "parser.c"
    break;

  case 456: /* $@25: %empty  */
#line 5621 "parser.y"
    {
      ia_type_ast_push( c_ast_new_gc( K_PLACEHOLDER, &(yyloc) ) );
      ++in_attr.ast_depth;
    }
#line 9793 "parser.c"
    break;

  case 457: /* nested_decl_c_astp: '(' $@25 decl_c_astp rparen_exp  */
#line 5626 "parser.y"
    {
      ia_type_ast_pop();
      --in_attr.ast_depth;

      DUMP_START( "nested_decl_c_astp", "'(' decl_c_astp ')'" );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[-1].ast_pair) );

      (yyval.ast_pair) = (yyvsp[-1].ast_pair);
      (yyval.ast_pair).ast->loc = (yyloc);

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9811 "parser.c"
    break;

  case 458: /* oper_decl_c_astp: oper_sname_c_opt Y_operator c_operator param_list_c_lparen param_c_ast_list_opt param_list_rparen_func_qualifier_list_c_stid_opt ref_qualifier_c_stid_opt noexcept_c_stid_opt trailing_return_type_c_ast_opt func_equals_c_stid_opt  */
#line 5652 "parser.y"
    {
      c_operator_t const *const operator = c_op_get( (yyvsp[-7].op_id) );
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "oper_decl_c_astp",
                  "oper_sname_c_opt OPERATOR c_operator "
                  "'(' param_c_ast_list_opt ')' "
                  "func_qualifier_list_c_stid_opt "
                  "ref_qualifier_c_stid_opt noexcept_c_stid_opt "
                  "trailing_return_type_c_ast_opt "
                  "func_equals_c_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_SNAME( "oper_sname_c_opt", (yyvsp[-9].sname) );
      DUMP_STR( "c_operator", operator->literal );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-5].ast_list) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-4].tid) );
      DUMP_TID( "ref_qualifier_c_stid_opt", (yyvsp[-3].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_AST( "trailing_return_type_c_ast_opt", (yyvsp[-1].ast) );
      DUMP_TID( "func_equals_c_stid_opt", (yyvsp[0].tid) );

      c_tid_t const oper_stids = c_tid_check(
        (yyvsp[-4].tid) | (yyvsp[-3].tid) | (yyvsp[-2].tid) | (yyvsp[0].tid),
        C_TPID_STORE
      );

      c_ast_t *const oper_ast = c_ast_new_gc( K_OPERATOR, &(yyloc) );
      oper_ast->sname = c_sname_move( &(yyvsp[-9].sname) );
      oper_ast->type.stids = oper_stids;
      c_ast_list_set_param_of( &(yyvsp[-5].ast_list), oper_ast );
      oper_ast->oper.param_ast_list = slist_move( &(yyvsp[-5].ast_list) );
      oper_ast->oper.operator = operator;

      c_ast_t *const ret_ast =
        IF_ELSE( (yyvsp[-1].ast), ia_type_spec_ast( type_ast ) );

      (yyval.ast_pair) = (c_ast_pair_t){
        c_ast_add_func( type_ast, oper_ast, ret_ast ),
        oper_ast->oper.ret_ast
      };

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9860 "parser.c"
    break;

  case 459: /* $@26: %empty  */
#line 5701 "parser.y"
                                 { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 9866 "parser.c"
    break;

  case 460: /* pointer_decl_c_astp: pointer_type_c_ast $@26 decl_c_astp  */
#line 5703 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "pointer_decl_c_astp", "pointer_type_c_ast decl_c_astp" );
      DUMP_AST( "pointer_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[0].ast_pair) );

      PJL_DISCARD_RV( c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast_pair).ast ) );
      (yyval.ast_pair) = (yyvsp[0].ast_pair);
      (yyval.ast_pair).ast->loc = (yyloc);

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9885 "parser.c"
    break;

  case 461: /* pointer_type_c_ast: '*' type_qualifier_list_c_stid_opt  */
#line 5722 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "pointer_type_c_ast", "'*' type_qualifier_list_c_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_TID( "type_qualifier_list_c_stid_opt", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_POINTER, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[0].tid), C_TPID_STORE );
      c_ast_set_parent( ia_type_spec_ast( type_ast ), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9904 "parser.c"
    break;

  case 462: /* pc99_pointer_decl_list_c: pc99_pointer_decl_c ',' decl_list_c  */
#line 5742 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[0].ast_list);
      slist_push_front( &(yyval.ast_list), (yyvsp[-2].ast) );
    }
#line 9913 "parser.c"
    break;

  case 463: /* pc99_pointer_decl_list_c: pc99_pointer_decl_c  */
#line 5747 "parser.y"
    {
      slist_init( &(yyval.ast_list) );
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );
    }
#line 9922 "parser.c"
    break;

  case 464: /* $@27: %empty  */
#line 5754 "parser.y"
                                      { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 9928 "parser.c"
    break;

  case 465: /* pc99_pointer_decl_c: pc99_pointer_type_c_ast $@27 decl_c_astp  */
#line 5756 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "pc99_pointer_decl_c",
                  "pc99_pointer_type_c_ast decl_c_astp" );
      DUMP_AST( "pc99_pointer_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[0].ast_pair) );

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast_pair).ast );
      (yyval.ast)->loc = (yyloc);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9947 "parser.c"
    break;

  case 466: /* pc99_pointer_type_c_ast: '*' type_qualifier_list_c_stid_opt  */
#line 5775 "parser.y"
    {
      if ( !IS_SUPPORTED( IMPLICIT_int ) ) {
        //
        // In C99 and later, implicit int is an error.  This check has to be
        // done now in the parser rather than later in the AST since the AST
        // would have no "memory" that the return type was implicitly int.
        //
        print_error( &(yylsp[-1]),
          "implicit \"%s\" is illegal%s\n",
          c_tid_error( TB_int ),
          C_LANG_WHICH( IMPLICIT_int )
        );
        PARSE_ABORT();
      }

      c_ast_t *type_ast = ia_type_ast_peek();

      DUMP_START( "pc99_pointer_type_c_ast",
                  "'*' type_qualifier_list_c_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_TID( "type_qualifier_list_c_stid_opt", (yyvsp[0].tid) );

      if ( type_ast == NULL ) {
        type_ast = c_ast_new_gc( K_BUILTIN, &(yyloc) );
        type_ast->type.btids = TB_int;
        ia_type_ast_push( type_ast );
      }

      (yyval.ast) = c_ast_pointer( ia_type_spec_ast( type_ast ), &gc_ast_list );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[0].tid), C_TPID_STORE );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9986 "parser.c"
    break;

  case 467: /* $@28: %empty  */
#line 5814 "parser.y"
                                           { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 9992 "parser.c"
    break;

  case 468: /* pointer_to_member_decl_c_astp: pointer_to_member_type_c_ast $@28 decl_c_astp  */
#line 5816 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "pointer_to_member_decl_c_astp",
                  "pointer_to_member_type_c_ast decl_c_astp" );
      DUMP_AST( "pointer_to_member_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[0].ast_pair) );

      (yyval.ast_pair) = (yyvsp[0].ast_pair);
      (yyval.ast_pair).ast->loc = (yyloc);

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10011 "parser.c"
    break;

  case 469: /* pointer_to_member_type_c_ast: any_sname_c Y_COLON_COLON_STAR '*' cv_qualifier_list_stid_opt  */
#line 5836 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "pointer_to_member_type_c_ast",
                  "any_sname_c '::*' cv_qualifier_list_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_SNAME( "any_sname_c", (yyvsp[-3].sname) );
      DUMP_TID( "cv_qualifier_list_stid_opt", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_POINTER_TO_MEMBER, &(yyloc) );

      c_type_t scope_type = *c_sname_local_type( &(yyvsp[-3].sname) );
      if ( !c_tid_is_any( scope_type.btids, TB_ANY_SCOPE ) ) {
        //
        // The sname has no scope-type, but we now know there's a pointer-to-
        // member of it, so it must be a class.  (It could alternatively be a
        // struct, but we have no context to know, so just pick class because
        // it's more C++-like.)
        //
        scope_type.btids = TB_class;
        c_sname_local_data( &(yyvsp[-3].sname) )->type = scope_type;
      }

      // adopt sname's scope-type for the AST
      (yyval.ast)->type = c_type_or( &C_TYPE_LIT_S( (yyvsp[0].tid) ), &scope_type );

      (yyval.ast)->ptr_mbr.class_sname = c_sname_move( &(yyvsp[-3].sname) );
      c_ast_set_parent( c_ast_dup_gc( type_ast ), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10048 "parser.c"
    break;

  case 470: /* $@29: %empty  */
#line 5874 "parser.y"
    {
      (yyvsp[-1].ast)->type.stids = c_tid_check( (yyvsp[0].tid), C_TPID_STORE );
      ia_type_ast_push( (yyvsp[-1].ast) );
    }
#line 10057 "parser.c"
    break;

  case 471: /* reference_decl_c_astp: reference_type_c_ast type_qualifier_list_c_stid_opt $@29 decl_c_astp  */
#line 5879 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "reference_decl_c_astp", "reference_type_c_ast decl_c_astp" );
      DUMP_AST( "reference_type_c_ast", (yyvsp[-3].ast) );
      DUMP_TID( "type_qualifier_list_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[0].ast_pair) );

      (yyval.ast_pair) = (yyvsp[0].ast_pair);
      (yyval.ast_pair).ast->loc = (yyloc);

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10076 "parser.c"
    break;

  case 472: /* reference_type_c_ast: '&'  */
#line 5898 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "reference_type_c_ast", "'&'" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );

      (yyval.ast) = c_ast_new_gc( K_REFERENCE, &(yyloc) );
      c_ast_set_parent( ia_type_spec_ast( type_ast ), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10093 "parser.c"
    break;

  case 473: /* reference_type_c_ast: Y_AMPER_AMPER  */
#line 5913 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "reference_type_c_ast", "'&&'" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );

      (yyval.ast) = c_ast_new_gc( K_RVALUE_REFERENCE, &(yyloc) );
      c_ast_set_parent( ia_type_spec_ast( type_ast ), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10110 "parser.c"
    break;

  case 474: /* typedef_type_decl_c_ast: typedef_type_c_ast bit_field_c_uint_opt  */
#line 5932 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "typedef_type_decl_c_ast",
                  "typedef_type_c_ast bit_field_c_uint_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST( "typedef_type_c_ast", (yyvsp[-1].ast) );
      DUMP_INT( "bit_field_c_uint_opt", (yyvsp[0].uint_val) );

      if ( c_tid_is_any( type_ast->type.stids, TS_typedef ) ) {
        //
        // If we're defining a type, return the type as-is.
        //
        (yyval.ast) = (yyvsp[-1].ast);
      }
      else {
        //
        // Otherwise, return the type that it's typedef'd as.
        //
        c_ast_t const *const raw_tdef_ast = c_ast_untypedef( (yyvsp[-1].ast) );

        //
        // But first ensure the name isn't of a previously declared type:
        //
        //      cdecl> struct S
        //      cdecl> explain int S    // error: "S": previously declared
        //
        // Note that typedef_type_c_ast is like:
        //
        //      typedef_type_c_ast: {
        //        sname: { string: "" },
        //        kind: { value: 0x20, string: "typedef" },
        //        ...
        //        type: { btid: 0x10000001, ..., string: "none" },
        //        tdef: {
        //          for_ast: {
        //            sname: { string: "S", scopes: "struct" },
        //            kind: { value: 0x8, string: "struct or union" },
        //            ...
        //            type: { btid: 0x800001, ..., string: "struct" },
        //            csu: {
        //              csu_sname: { string: "S", scopes: "none" }
        //            }
        //          }
        //        },
        //        ...
        //      }
        //
        // That is, typedef_type_c_ast has no name itself (at this point), but
        // the raw type, of course, does, so it's that name we have to check.
        //
        // This check has to be done now in the parser rather than later in the
        // AST since if this declaration were joined with a type (like `int`
        // above), the type information would be lost and we'd get this from
        // above:
        //
        //      declare S as structure S          // wrong
        //
        // Additionally, we also get here when the typedef name is used as part
        // of longer name, e.g., `S::x`:
        //
        //      c++decl> explain int S::x
        //      declare x of structure S as int   // correct
        //
        // but that name isn't of a previously declared type, so it's OK.
        //
        PARSE_ASSERT(
          !c_sname_is_type( &raw_tdef_ast->sname, &(yyvsp[-1].ast)->loc )
        );

        //
        // We have to duplicate the type to set the current location.
        //
        (yyval.ast) = c_ast_dup_gc( raw_tdef_ast );
        (yyval.ast)->loc = (yyvsp[-1].ast)->loc;
      }

      PARSE_ASSERT( c_ast_set_bit_field_width( (yyval.ast), (yyvsp[0].uint_val) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10197 "parser.c"
    break;

  case 475: /* $@30: %empty  */
#line 6021 "parser.y"
    {
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 10205 "parser.c"
    break;

  case 476: /* user_defined_conversion_decl_c_astp: oper_sname_c_opt Y_operator type_c_ast $@30 udc_decl_c_ast_opt lparen_exp param_list_rparen_func_qualifier_list_c_stid_opt noexcept_c_stid_opt func_equals_c_stid_opt  */
#line 6027 "parser.y"
    {
      ia_type_ast_pop();

      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "user_defined_conversion_decl_c_astp",
                  "oper_sname_c_opt OPERATOR "
                  "type_c_ast udc_decl_c_ast_opt '(' ')' "
                  "func_qualifier_list_c_stid_opt noexcept_c_stid_opt "
                  "func_equals_c_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_SNAME( "oper_sname_c_opt", (yyvsp[-8].sname) );
      DUMP_AST( "type_c_ast", (yyvsp[-6].ast) );
      DUMP_AST( "udc_decl_c_ast_opt", (yyvsp[-4].ast) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-1].tid) );
      DUMP_TID( "func_equals_c_stid_opt", (yyvsp[0].tid) );

      c_ast_t *const udc_ast = c_ast_new_gc( K_UDEF_CONV, &(yyloc) );
      udc_ast->sname = c_sname_move( &(yyvsp[-8].sname) );
      udc_ast->type.stids = c_tid_check(
        (yyvsp[-2].tid) | (yyvsp[-1].tid) | (yyvsp[0].tid),
        C_TPID_STORE
      );
      if ( type_ast != NULL )
        c_type_or_eq( &udc_ast->type, &type_ast->type );
      udc_ast->udef_conv.to_ast = IF_ELSE( (yyvsp[-4].ast), (yyvsp[-6].ast) );

      (yyval.ast_pair) = (c_ast_pair_t){ udc_ast, udc_ast->udef_conv.to_ast };

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10243 "parser.c"
    break;

  case 477: /* user_defined_literal_decl_c_astp: oper_sname_c_opt Y_operator empty_str_lit_exp name_exp lparen_exp param_c_ast_list_exp ')' noexcept_c_stid_opt trailing_return_type_c_ast_opt  */
#line 6070 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "user_defined_literal_decl_c_astp",
                  "oper_sname_c_opt OPERATOR '\"\"' "
                  "'(' param_c_ast_list_exp ')' noexcept_c_stid_opt "
                  "trailing_return_type_c_ast_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_SNAME( "oper_sname_c_opt", (yyvsp[-8].sname) );
      DUMP_STR( "name", (yyvsp[-5].name) );
      DUMP_AST_LIST( "param_c_ast_list_exp", (yyvsp[-3].ast_list) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-1].tid) );
      DUMP_AST( "trailing_return_type_c_ast_opt", (yyvsp[0].ast) );

      c_sname_set( &type_ast->sname, &(yyvsp[-8].sname) );
      c_sname_append_name( &type_ast->sname, (yyvsp[-5].name) );

      c_ast_t *const udl_ast = c_ast_new_gc( K_UDEF_LIT, &(yyloc) );
      udl_ast->type.stids = c_tid_check( (yyvsp[-1].tid), C_TPID_STORE );
      c_ast_list_set_param_of( &(yyvsp[-3].ast_list), udl_ast );
      udl_ast->udef_lit.param_ast_list = slist_move( &(yyvsp[-3].ast_list) );

      (yyval.ast_pair) = (c_ast_pair_t){
        c_ast_add_func(
          type_ast,
          udl_ast,
          IF_ELSE( (yyvsp[0].ast), type_ast )
        ),
        udl_ast->udef_lit.ret_ast
      };

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10282 "parser.c"
    break;

  case 478: /* cast_c_astp_opt: %empty  */
#line 6111 "parser.y"
                                  { (yyval.ast_pair) = (c_ast_pair_t){ NULL, NULL }; }
#line 10288 "parser.c"
    break;

  case 488: /* cast2_c_astp: param_pack_cast_c_ast  */
#line 6128 "parser.y"
                                  { (yyval.ast_pair) = (c_ast_pair_t){ (yyvsp[0].ast), NULL }; }
#line 10294 "parser.c"
    break;

  case 489: /* cast2_c_astp: sname_c_ast  */
#line 6129 "parser.y"
                                  { (yyval.ast_pair) = (c_ast_pair_t){ (yyvsp[0].ast), NULL }; }
#line 10300 "parser.c"
    break;

  case 490: /* param_pack_cast_c_ast: "..."  */
#line 6138 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "param_pack_cast_c_ast", "..." );\
      DUMP_AST( "in_attr__type_c_ast", type_ast );

      c_ast_set_parameter_pack( type_ast );
      (yyval.ast) = NULL;

      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_END();
    }
#line 10317 "parser.c"
    break;

  case 491: /* param_pack_cast_c_ast: "..." sname_c_ast  */
#line 6151 "parser.y"
    {
      DUMP_START( "param_pack_cast_c_ast", "... sname_c_ast" );\
      DUMP_AST( "sname_c_ast", (yyvsp[0].ast) );

      c_ast_set_parameter_pack( (yyvsp[0].ast) );
      (yyval.ast) = (yyvsp[0].ast);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10332 "parser.c"
    break;

  case 492: /* array_cast_c_astp: cast_c_astp_opt array_size_c_ast  */
#line 6168 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "array_cast_c_astp", "cast_c_astp_opt array_size_c_ast" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-1].ast_pair) );
      DUMP_AST( "array_size_c_ast", (yyvsp[0].ast) );

      c_ast_set_parent(
        c_ast_new_gc( K_PLACEHOLDER, &(yylsp[-1]) ), (yyvsp[0].ast)
      );

      c_ast_t *const of_ast = ia_type_spec_ast( type_ast );
      if ( (yyvsp[-1].ast_pair).target_ast != NULL ) {
        // array-of or function-like-ret type
        (yyval.ast_pair) = (c_ast_pair_t){
          (yyvsp[-1].ast_pair).ast,
          c_ast_add_array( (yyvsp[-1].ast_pair).target_ast, (yyvsp[0].ast), of_ast )
        };
      } else {
        c_ast_t *const ast = IF_ELSE( (yyvsp[-1].ast_pair).ast, of_ast );
        (yyval.ast_pair) = (c_ast_pair_t){
          c_ast_add_array( ast, (yyvsp[0].ast), of_ast ),
          .target_ast = NULL
        };
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10367 "parser.c"
    break;

  case 493: /* $@31: %empty  */
#line 6205 "parser.y"
    { //
      // A block AST has to be the type inherited attribute for cast_c_astp_opt
      // so we have to create it here.
      //
      ia_type_ast_push( c_ast_new_gc( K_APPLE_BLOCK, &(yyloc) ) );
    }
#line 10378 "parser.c"
    break;

  case 494: /* block_cast_c_astp: '(' '^' $@31 type_qualifier_list_c_stid_opt cast_c_astp_opt rparen_exp param_list_c_lparen param_c_ast_list_opt param_list_rparen  */
#line 6214 "parser.y"
    {
      c_ast_t *const block_ast = ia_type_ast_pop();
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "block_cast_c_astp",
                  "'(' '^' type_qualifier_list_c_stid_opt cast_c_astp_opt ')' "
                  "'(' param_c_ast_list_opt ')'" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_TID( "type_qualifier_list_c_stid_opt", (yyvsp[-5].tid) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-4].ast_pair) );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-1].ast_list) );

      PARSE_ASSERT(
        c_type_add_tid( &block_ast->type, (yyvsp[-5].tid), &(yylsp[-5]) )
      );
      c_ast_list_set_param_of( &(yyvsp[-1].ast_list), block_ast );
      block_ast->block.param_ast_list = slist_move( &(yyvsp[-1].ast_list) );

      c_ast_t *const ret_ast = ia_type_spec_ast( type_ast );
      if ( (yyvsp[-4].ast_pair).target_ast != NULL ) {
        (yyval.ast_pair) = (c_ast_pair_t){
          (yyvsp[-4].ast_pair).ast,
          c_ast_add_func( (yyvsp[-4].ast_pair).target_ast, block_ast, ret_ast )
        };
      }
      else {
        (yyval.ast_pair) = (c_ast_pair_t){
          c_ast_add_func( (yyvsp[-4].ast_pair).ast, block_ast, ret_ast ),
          block_ast->block.ret_ast
        };
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10418 "parser.c"
    break;

  case 495: /* func_cast_c_astp: cast2_c_astp param_list_c_lparen param_c_ast_list_opt param_list_rparen_func_qualifier_list_c_stid_opt noexcept_c_stid_opt trailing_return_type_c_ast_opt  */
#line 6260 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "func_cast_c_astp",
                  "cast2_c_astp '(' param_c_ast_list_opt ')' "
                  "func_qualifier_list_c_stid_opt noexcept_c_stid_opt "
                  "trailing_return_type_c_ast_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "cast2_c_astp", (yyvsp[-5].ast_pair) );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-3].ast_list) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_AST( "trailing_return_type_c_ast_opt", (yyvsp[0].ast) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-1].tid) );

      c_ast_t *const func_ast = c_ast_new_gc( K_FUNCTION, &(yyloc) );
      func_ast->type.stids =
        c_tid_check( (yyvsp[-2].tid) | (yyvsp[-1].tid), C_TPID_STORE );
      c_ast_list_set_param_of( &(yyvsp[-3].ast_list), func_ast );
      func_ast->func.param_ast_list = slist_move( &(yyvsp[-3].ast_list) );

      c_ast_t *const cast_ast = (yyvsp[-5].ast_pair).ast;
      //
      // This is for a case similar to the one in func_decl_c_astp like:
      //
      //     void f( int () () )
      //              |   |  |
      //              |   |  func
      //              |   |
      //              |   cast_ast (func)
      //              |
      //              ret_ast
      //
      // We replace ret_ast with cast_ast:
      //
      //      void f( int() () )
      //              |  |  |
      //              |  |  func
      //              X  |
      //              |  cast_ast (func)
      //              |
      //              ret_ast <- cast_ast (func)
      //
      // that is, a "function returning function returning int" -- which is
      // illegal (since functions can't return functions) and will be caught by
      // c_ast_check_ret_type().
      //
      c_ast_t *const ret_ast = cast_ast->kind == K_FUNCTION ?
        cast_ast : IF_ELSE( (yyvsp[0].ast), ia_type_spec_ast( type_ast ) );

      if ( (yyvsp[-5].ast_pair).target_ast != NULL ) {
        (yyval.ast_pair) = (c_ast_pair_t){
          cast_ast,
          c_ast_add_func( (yyvsp[-5].ast_pair).target_ast, func_ast, ret_ast )
        };
      }
      else {
        (yyval.ast_pair) = (c_ast_pair_t){
          c_ast_add_func( cast_ast, func_ast, ret_ast ),
          func_ast->func.ret_ast
        };
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10488 "parser.c"
    break;

  case 496: /* $@32: %empty  */
#line 6331 "parser.y"
    {
      ia_type_ast_push( c_ast_new_gc( K_PLACEHOLDER, &(yyloc) ) );
      ++in_attr.ast_depth;
    }
#line 10497 "parser.c"
    break;

  case 497: /* nested_cast_c_astp: '(' $@32 cast_c_astp_opt rparen_exp  */
#line 6336 "parser.y"
    {
      ia_type_ast_pop();
      --in_attr.ast_depth;

      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "nested_cast_c_astp", "'(' cast_c_astp_opt ')'" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-1].ast_pair) );

      (yyval.ast_pair) = (yyvsp[-1].ast_pair);

      if ( (yyval.ast_pair).ast == NULL ) {
        //
        // This is for a case like:
        //
        //      void f( int() )
        //                 ^^
        //
        // where the unnamed parameter is a "function returning int".  (In
        // param_c_ast, this will be converted into a "pointer to function
        // returning int".)
        //
        (yyval.ast_pair).ast = c_ast_new_gc( K_FUNCTION, &(yyloc) );
        c_ast_set_parent( type_ast, (yyval.ast_pair).ast );
      } else {
        (yyval.ast_pair).ast->loc = (yyloc);
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10534 "parser.c"
    break;

  case 498: /* $@33: %empty  */
#line 6373 "parser.y"
                                 { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 10540 "parser.c"
    break;

  case 499: /* pointer_cast_c_astp: pointer_type_c_ast $@33 cast_c_astp_opt  */
#line 6375 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "pointer_cast_c_astp", "pointer_type_c_ast cast_c_astp_opt" );
      DUMP_AST( "pointer_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      (yyval.ast_pair) = (c_ast_pair_t){
        c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast_pair).ast ),
        (yyvsp[0].ast_pair).target_ast
      };

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10560 "parser.c"
    break;

  case 500: /* $@34: %empty  */
#line 6395 "parser.y"
                                           { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 10566 "parser.c"
    break;

  case 501: /* pointer_to_member_cast_c_astp: pointer_to_member_type_c_ast $@34 cast_c_astp_opt  */
#line 6397 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "pointer_to_member_cast_c_astp",
                  "pointer_to_member_type_c_ast cast_c_astp_opt" );
      DUMP_AST( "pointer_to_member_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      (yyval.ast_pair) = (c_ast_pair_t){
        c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast_pair).ast ),
        (yyvsp[0].ast_pair).target_ast
      };

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10587 "parser.c"
    break;

  case 502: /* $@35: %empty  */
#line 6418 "parser.y"
                                   { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 10593 "parser.c"
    break;

  case 503: /* reference_cast_c_astp: reference_type_c_ast $@35 cast_c_astp_opt  */
#line 6420 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "reference_cast_c_astp",
                  "reference_type_c_ast cast_c_astp_opt" );
      DUMP_AST( "reference_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      (yyval.ast_pair) = (c_ast_pair_t){
        c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast_pair).ast ),
        (yyvsp[0].ast_pair).target_ast
      };

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10614 "parser.c"
    break;

  case 504: /* udc_decl_c_ast_opt: %empty  */
#line 6447 "parser.y"
                                  { (yyval.ast) = NULL; }
#line 10620 "parser.c"
    break;

  case 510: /* $@36: %empty  */
#line 6459 "parser.y"
                                 { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 10626 "parser.c"
    break;

  case 511: /* pointer_udc_decl_c_ast: pointer_type_c_ast $@36 udc_decl_c_ast_opt  */
#line 6461 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "pointer_udc_decl_c_ast",
                  "pointer_type_c_ast udc_decl_c_ast_opt" );
      DUMP_AST( "pointer_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST( "udc_decl_c_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10644 "parser.c"
    break;

  case 512: /* $@37: %empty  */
#line 6477 "parser.y"
                                           { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 10650 "parser.c"
    break;

  case 513: /* pointer_to_member_udc_decl_c_ast: pointer_to_member_type_c_ast $@37 udc_decl_c_ast_opt  */
#line 6479 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "pointer_to_member_udc_decl_c_ast",
                  "pointer_to_member_type_c_ast udc_decl_c_ast_opt" );
      DUMP_AST( "pointer_to_member_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST( "udc_decl_c_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10668 "parser.c"
    break;

  case 514: /* $@38: %empty  */
#line 6495 "parser.y"
                                   { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 10674 "parser.c"
    break;

  case 515: /* reference_udc_decl_c_ast: reference_type_c_ast $@38 udc_decl_c_ast_opt  */
#line 6497 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "reference_udc_decl_c_ast",
                  "reference_type_c_ast udc_decl_c_ast_opt" );
      DUMP_AST( "reference_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST( "udc_decl_c_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10692 "parser.c"
    break;

  case 516: /* type_c_ast: type_modifier_list_c_type  */
#line 6523 "parser.y"
    {
      DUMP_START( "type_c_ast", "type_modifier_list_c_type" );
      DUMP_TYPE( "type_modifier_list_c_type", (yyvsp[0].type) );

      //
      // Prior to C99, typeless declarations are implicitly int, so we set it
      // here.  In C99 and later, however, implicit int is an error, so we
      // don't set it here and c_ast_check() will catch the error later.
      //
      // Note that type modifiers, e.g., unsigned, count as a type since that
      // means unsigned int; however, neither qualifiers, e.g., const, nor
      // storage classes, e.g., register, by themselves count as a type:
      //
      //      unsigned i;   // legal in C99
      //      const    j;   // illegal in C99
      //      register k;   // illegal in C99
      //
      c_type_t type = OPT_LANG_IS( IMPLICIT_int ) ?
        C_TYPE_LIT_B( TB_int ) : T_NONE;

      PARSE_ASSERT( c_type_add( &type, &(yyvsp[0].type), &(yylsp[0]) ) );

      if ( type.btids == TB_int ) {     // type is still the TB_int we added
        //
        // This check has to be done now in the parser rather than later in the
        // AST since the AST has no memory that the "int" is implicit.
        //
        // Alternatively, we could _not_ set TB_int here, but then we'd need a
        // new separate AST "fix-up" pass that would change TB_NONE to TB_int.
        // Objectively, that's probably the better solution, but it's a lot of
        // extra code that would currently only be needed to fix-up implicit
        // int.
        //
        print_warning( &(yylsp[0]),
          "missing type specifier; \"%s\" assumed\n",
          c_tid_error( TB_int )
        );
      }

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type = type;

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10742 "parser.c"
    break;

  case 517: /* type_c_ast: type_modifier_list_c_type east_modified_type_c_ast  */
#line 6575 "parser.y"
    {
      DUMP_START( "type_c_ast",
                  "type_modifier_list_c_type east_modified_type_c_ast " );
      DUMP_TYPE( "type_modifier_list_c_type", (yyvsp[-1].type) );
      DUMP_AST( "east_modified_type_c_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[0].ast);
      (yyval.ast)->loc = (yyloc);
      PARSE_ASSERT( c_type_add( &(yyval.ast)->type, &(yyvsp[-1].type), &(yylsp[-1]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10760 "parser.c"
    break;

  case 519: /* type_modifier_list_c_type_opt: %empty  */
#line 6593 "parser.y"
                                  { (yyval.type) = T_NONE; }
#line 10766 "parser.c"
    break;

  case 521: /* type_modifier_list_c_type: type_modifier_list_c_type type_modifier_c_type  */
#line 6599 "parser.y"
    {
      DUMP_START( "type_modifier_list_c_type",
                  "type_modifier_list_c_type type_modifier_c_type" );
      DUMP_TYPE( "type_modifier_list_c_type", (yyvsp[-1].type) );
      DUMP_TYPE( "type_modifier_c_type", (yyvsp[0].type) );

      (yyval.type) = (yyvsp[-1].type);
      PARSE_ASSERT( c_type_add( &(yyval.type), &(yyvsp[0].type), &(yylsp[0]) ) );

      DUMP_TYPE( "$$_type", (yyval.type) );
      DUMP_END();
    }
#line 10783 "parser.c"
    break;

  case 523: /* type_modifier_c_type: type_modifier_base_type  */
#line 6617 "parser.y"
    {
      (yyval.type) = (yyvsp[0].type);
      //
      // This is for a case like:
      //
      //      explain typedef unsigned long size_t
      //
      // that is: explain a redefinition of a typedef'd type with the same type
      // that contains only one or more type_modifier_base_type.  The problem
      // is that, without an east_modified_type_c_ast (like int), the parser
      // would ordinarily take the typedef'd type (here, the size_t) as part of
      // the type_c_ast and then be out of tokens for the decl_c_astp -- at
      // which time it'll complain.
      //
      // Since type modifiers can't apply to a typedef'd type (e.g., "long
      // size_t" is illegal), we tell the lexer not to return either
      // Y_TYPEDEF_NAME_TDEF or Y_TYPEDEF_SNAME_TDEF if we encounter at least
      // one type modifier (except "register" since it's is really a storage
      // class -- see the comment in type_modifier_base_type about "register").
      //
      if ( (yyval.type).stids != TS_register )
        lexer_find &= ~LEXER_FIND_TYPES;
    }
#line 10811 "parser.c"
    break;

  case 524: /* type_modifier_c_type: type_qualifier_c_stid  */
#line 6640 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10817 "parser.c"
    break;

  case 526: /* type_modifier_c_type: attribute_specifier_list_c_atid  */
#line 6643 "parser.y"
    {
      (yyval.type) = C_TYPE_LIT_A( (yyvsp[0].tid) );
    }
#line 10825 "parser.c"
    break;

  case 527: /* type_modifier_base_type: Y__Complex  */
#line 6649 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10831 "parser.c"
    break;

  case 528: /* type_modifier_base_type: Y__Imaginary  */
#line 6650 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10837 "parser.c"
    break;

  case 529: /* type_modifier_base_type: Y_long  */
#line 6651 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10843 "parser.c"
    break;

  case 530: /* type_modifier_base_type: Y_short  */
#line 6652 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10849 "parser.c"
    break;

  case 531: /* type_modifier_base_type: Y_signed  */
#line 6653 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10855 "parser.c"
    break;

  case 532: /* type_modifier_base_type: Y_unsigned  */
#line 6654 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10861 "parser.c"
    break;

  case 533: /* type_modifier_base_type: Y_EMC__Sat  */
#line 6655 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10867 "parser.c"
    break;

  case 534: /* type_modifier_base_type: Y_register  */
#line 6661 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10873 "parser.c"
    break;

  case 535: /* east_modified_type_c_ast: east_modifiable_type_c_ast type_modifier_list_c_type_opt  */
#line 6667 "parser.y"
    {
      DUMP_START( "east_modified_type_c_ast",
                  "east_modifiable_type_c_ast type_modifier_list_c_type_opt" );
      DUMP_AST( "east_modifiable_type_c_ast", (yyvsp[-1].ast) );
      DUMP_TYPE( "type_modifier_list_c_type_opt", (yyvsp[0].type) );

      (yyval.ast) = (yyvsp[-1].ast);
      (yyval.ast)->loc = (yyloc);
      PARSE_ASSERT( c_type_add( &(yyval.ast)->type, &(yyvsp[0].type), &(yylsp[0]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10891 "parser.c"
    break;

  case 536: /* east_modified_type_c_ast: enum_class_struct_union_c_ast cv_qualifier_list_stid_opt  */
#line 6683 "parser.y"
    {
      DUMP_START( "east_modified_type_c_ast",
                  "enum_class_struct_union_c_ast cv_qualifier_list_stid_opt" );
      DUMP_AST( "enum_class_struct_union_c_ast", (yyvsp[-1].ast) );
      DUMP_TID( "cv_qualifier_list_stid_opt", (yyvsp[0].tid) );

      (yyval.ast) = (yyvsp[-1].ast);
      (yyval.ast)->loc = (yyloc);
      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10909 "parser.c"
    break;

  case 543: /* $@39: %empty  */
#line 6711 "parser.y"
    {
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 10917 "parser.c"
    break;

  case 544: /* atomic_specifier_type_c_ast: Y__Atomic_SPEC lparen_exp type_c_ast $@39 cast_c_astp_opt rparen_exp  */
#line 6715 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "atomic_specifier_type_c_ast",
                  "ATOMIC '(' type_c_ast cast_c_astp_opt ')'" );
      DUMP_AST( "type_c_ast", (yyvsp[-3].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-1].ast_pair) );

      (yyval.ast) = IF_ELSE( (yyvsp[-1].ast_pair).ast, (yyvsp[-3].ast) );
      (yyval.ast)->loc = (yyloc);

      //
      // Ensure the _Atomic() specifier type doesn't have either a storage
      // class or attributes:
      //
      //      const _Atomic(int) x;     // OK
      //      _Atomic(const int) y;     // error
      //
      // This check has to be done now in the parser rather than later in the
      // AST since the type would be stored as "atomic const int" either way so
      // the AST has no "memory" of which it was.
      //
      if ( (yyval.ast)->type.stids != TS_NONE || (yyval.ast)->type.atids != TA_NONE ) {
        static c_type_t const TSA_ANY = { TB_NONE, TS_ANY, TA_ANY };
        c_type_t const error_type = c_type_and( &(yyval.ast)->type, &TSA_ANY );
        print_error( &(yylsp[-3]),
          "\"%s\" can not be of \"%s\"\n",
          c_tid_error( TS__Atomic ),
          c_type_gibberish( &error_type )
        );
        PARSE_ABORT();
      }

      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, TS__Atomic, &(yylsp[-5]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10960 "parser.c"
    break;

  case 545: /* builtin_type_c_ast: builtin_no_BitInt_c_btid  */
#line 6759 "parser.y"
    {
      DUMP_START( "builtin_type_c_ast", "builtin_no_BitInt_c_btid" );
      DUMP_TID( "builtin_no_BitInt_c_btid", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[0].tid), C_TPID_BASE );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10975 "parser.c"
    break;

  case 546: /* builtin_type_c_ast: Y__BitInt lparen_exp uint_lit_exp rparen_exp  */
#line 6770 "parser.y"
    {
      DUMP_START( "builtin_type_c_ast", "_BitInt '(' uint_lit_exp ')'" );
      DUMP_INT( "uint_lit_exp", (yyvsp[-1].uint_val) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type.btids = TB__BitInt;
      (yyval.ast)->builtin.BitInt.width = (yyvsp[-1].uint_val);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10991 "parser.c"
    break;

  case 555: /* builtin_no_BitInt_c_btid: Y_decltype  */
#line 6793 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "decltype declarations" );
    }
#line 10999 "parser.c"
    break;

  case 562: /* concept_type_c_ast: Y_CONCEPT_SNAME auto_TYPE_exp  */
#line 6808 "parser.y"
    {
      DUMP_START( "concept_type_c_ast", "Y_CONCEPT_SNAME AUTO" );
      DUMP_SNAME( "Y_CONCEPT_SNAME", (yyvsp[-1].sname) );

      c_sname_set_all_types( &(yyvsp[-1].sname) );

      (yyval.ast) = c_ast_new_gc( K_CONCEPT, &(yylsp[-1]) );
      (yyval.ast)->concept.concept_sname = c_sname_move( &(yyvsp[-1].sname) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11016 "parser.c"
    break;

  case 563: /* structured_binding_type_c_ast: Y_auto_STRUCTURED_BINDING cv_qualifier_list_stid_opt ref_qualifier_c_stid_opt lbracket_exp sname_list_c rbracket_exp  */
#line 6828 "parser.y"
    {
      DUMP_START( "structured_binding_type_c_ast",
                  "AUTO cv_qualifier_list_stid_opt ref_qualifier_c_stid_opt "
                  "'[' sname_list_c ']'" );
      DUMP_TID( "cv_qualifier_list_stid_opt", (yyvsp[-4].tid) );
      DUMP_TID( "ref_qualifier_c_stid_opt", (yyvsp[-3].tid) );

      (yyval.ast) = c_ast_new_gc( K_STRUCTURED_BINDING, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[-4].tid) | (yyvsp[-3].tid), C_TPID_STORE );
      (yyval.ast)->struct_bind.sname_list = slist_move( &(yyvsp[-1].sname_list) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11035 "parser.c"
    break;

  case 564: /* typedef_type_c_ast: any_typedef_tdef sub_scope_sname_c_opt  */
#line 6848 "parser.y"
    {
      c_ast_t *type_ast = ia_type_ast_peek();
      c_ast_t const *type_for_ast = (yyvsp[-1].tdef)->ast;

      DUMP_START( "typedef_type_c_ast",
                  "any_typedef_tdef sub_scope_sname_c_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST( "any_typedef__ast", type_for_ast );
      DUMP_SNAME( "sub_scope_sname_c_opt", (yyvsp[0].sname) );

      if ( c_sname_empty( &(yyvsp[0].sname) ) ) {
ttntd:  (yyval.ast) = c_ast_new_gc( K_TYPEDEF, &(yyloc) );
        (yyval.ast)->type.btids = TB_typedef;
        (yyval.ast)->tdef.for_ast = type_for_ast;
      }
      else {
        c_sname_t temp_sname = c_sname_dup( &(yyvsp[-1].tdef)->ast->sname );
        c_sname_append_sname( &temp_sname, &(yyvsp[0].sname) );

        if ( type_ast == NULL ) {
          //
          // This is for a case like:
          //
          //      define S as struct S
          //      explain S::T x
          //
          // that is: a typedef'd type followed by ::T where T is an unknown
          // name used as a type. Just assume the T is some type, say int, and
          // create a name for it.
          //
          type_ast = c_ast_new_gc( K_BUILTIN, &(yyloc) );
          type_ast->type.btids = TB_int;
          c_sname_set( &type_ast->sname, &temp_sname );
          type_for_ast = type_ast;
          goto ttntd;
        }

        //
        // Otherwise, this is for cases like:
        //
        //  1. A typedef'd type used for a scope:
        //
        //          define S as struct S
        //          explain int S::x
        //
        //  2. A typedef'd type used for an intermediate scope:
        //
        //          define S as struct S
        //          define T as struct T
        //          explain int S::T::x
        //
        (yyval.ast) = type_ast;
        c_sname_set( &(yyval.ast)->sname, &temp_sname );
      }

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11098 "parser.c"
    break;

  case 565: /* sub_scope_sname_c_opt: %empty  */
#line 6909 "parser.y"
                                  { c_sname_init( &(yyval.sname) ); }
#line 11104 "parser.c"
    break;

  case 566: /* sub_scope_sname_c_opt: Y_COLON_COLON any_sname_c  */
#line 6911 "parser.y"
    {
      (yyval.sname) = (yyvsp[0].sname);
    }
#line 11112 "parser.c"
    break;

  case 567: /* $@40: %empty  */
#line 6920 "parser.y"
    {
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 11120 "parser.c"
    break;

  case 568: /* typeof_type_c_ast: typeof lparen_exp type_c_ast $@40 cast_c_astp_opt rparen_exp  */
#line 6924 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "typeof_type_c_ast",
                  "TYPEOF '(' type_c_ast cast_c_astp_opt ')'" );
      DUMP_BOOL( "is_unqual", (yyvsp[-5].flag) );
      DUMP_AST( "type_c_ast", (yyvsp[-3].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-1].ast_pair) );

      if ( (yyvsp[-5].flag) ) {
        c_ast_t const *const raw_ast = c_ast_untypedef( (yyvsp[-3].ast) );
        if ( raw_ast != (yyvsp[-3].ast) &&
             c_tid_is_any( raw_ast->type.stids, TS__Atomic | TS_CVR ) ) {
          //
          // The type is a typedef and the type that it's for is ACVR-qualified
          // so we need to dup _that_ type before un-ACVR-qualifying it because
          // we don't want to modify it.
          //
          c_loc_t const *const orig_loc = &(yyvsp[-3].ast)->loc;
          (yyvsp[-3].ast) = c_ast_dup_gc( raw_ast );
          (yyvsp[-3].ast)->loc = *orig_loc;
        }
        (yyvsp[-3].ast)->type.stids &= c_tid_compl( TS__Atomic | TS_CVR );
      }

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-3].ast), (yyvsp[-1].ast_pair).ast );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();

      //
      // Overwrite type_spec_ast to be the typeof type since _that_ is the base
      // type for one or more declarators, e.g.:
      //
      //      typeof(int*) p, a[2], f(char)
      //
      in_attr.type_spec_ast = (yyval.ast);
    }
#line 11163 "parser.c"
    break;

  case 569: /* typeof_type_c_ast: typeof lparen_exp error  */
#line 6964 "parser.y"
    {
      elaborate_error(
        "typeof(expression) declarations not supported by " CDECL
      );
    }
#line 11173 "parser.c"
    break;

  case 570: /* typeof: Y_typeof  */
#line 6972 "parser.y"
                                  { (yyval.flag) = /*is_unqual=*/false; }
#line 11179 "parser.c"
    break;

  case 571: /* typeof: Y_typeof_unqual  */
#line 6973 "parser.y"
                                  { (yyval.flag) = /*is_unqual=*/true;  }
#line 11185 "parser.c"
    break;

  case 574: /* class_struct_union_c_ast: class_struct_union_btid attribute_specifier_list_c_atid_opt any_sname_c_exp  */
#line 6986 "parser.y"
    {
      DUMP_START( "enum_class_struct_union_c_ast",
                  "class_struct_union_btid "
                  "attribute_specifier_list_c_atid_opt any_sname_c_exp" );
      DUMP_TID( "class_struct_union_btid", (yyvsp[-2].tid) );
      DUMP_TID( "attribute_specifier_list_c_atid_opt", (yyvsp[-1].tid) );
      DUMP_SNAME( "any_sname_c_exp", (yyvsp[0].sname) );

      (yyval.ast) = c_ast_new_gc( K_CLASS_STRUCT_UNION, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[-2].tid), C_TPID_BASE );
      (yyval.ast)->type.atids = c_tid_check( (yyvsp[-1].tid), C_TPID_ATTR );
      (yyval.ast)->csu.csu_sname = c_sname_move( &(yyvsp[0].sname) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11206 "parser.c"
    break;

  case 575: /* class_struct_union_c_ast: class_struct_union_btid attribute_specifier_list_c_atid_opt any_sname_c_opt '{'  */
#line 7005 "parser.y"
    {
      c_sname_cleanup( &(yyvsp[-1].sname) );
      UNSUPPORTED( &(yylsp[0]),
        "explaining %s declarations", c_tid_gibberish( (yyvsp[-3].tid) )
      );
    }
#line 11217 "parser.c"
    break;

  case 576: /* enum_c_ast: enum_btids attribute_specifier_list_c_atid_opt any_sname_c_exp enum_fixed_type_c_ast_opt  */
#line 7016 "parser.y"
    {
      DUMP_START( "enum_c_ast",
                  "enum_btids attribute_specifier_list_c_atid_opt "
                  "any_sname_c_exp enum_fixed_type_c_ast_opt" );
      DUMP_TID( "enum_btids", (yyvsp[-3].tid) );
      DUMP_TID( "attribute_specifier_list_c_atid_opt", (yyvsp[-2].tid) );
      DUMP_SNAME( "any_sname_c_exp", (yyvsp[-1].sname) );
      DUMP_AST( "enum_fixed_type_c_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_ENUM, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[-3].tid), C_TPID_BASE );
      (yyval.ast)->type.atids = c_tid_check( (yyvsp[-2].tid), C_TPID_ATTR );
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );
      (yyval.ast)->enum_.enum_sname = c_sname_move( &(yyvsp[-1].sname) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11240 "parser.c"
    break;

  case 577: /* enum_c_ast: enum_btids attribute_specifier_list_c_atid_opt any_sname_c_opt '{'  */
#line 7037 "parser.y"
    {
      c_sname_cleanup( &(yyvsp[-1].sname) );
      UNSUPPORTED( &(yylsp[0]),
        "explaining %s declarations", c_tid_gibberish( (yyvsp[-3].tid) )
      );
    }
#line 11251 "parser.c"
    break;

  case 578: /* enum_btids: Y_enum class_struct_btid_opt  */
#line 7048 "parser.y"
                                  { (yyval.tid) = (yyvsp[-1].tid) | (yyvsp[0].tid); }
#line 11257 "parser.c"
    break;

  case 579: /* enum_fixed_type_c_ast_opt: %empty  */
#line 7052 "parser.y"
                                  { (yyval.ast) = NULL; }
#line 11263 "parser.c"
    break;

  case 580: /* enum_fixed_type_c_ast_opt: ':' enum_fixed_type_c_ast  */
#line 7053 "parser.y"
                                  { (yyval.ast) = (yyvsp[0].ast); }
#line 11269 "parser.c"
    break;

  case 581: /* enum_fixed_type_c_ast_opt: ':' error  */
#line 7055 "parser.y"
    {
      elaborate_error( "type name expected" );
    }
#line 11277 "parser.c"
    break;

  case 582: /* enum_fixed_type_c_ast: enum_fixed_type_modifier_list_btid  */
#line 7071 "parser.y"
    {
      DUMP_START( "enum_fixed_type_c_ast",
                  "enum_fixed_type_modifier_list_btid" );
      DUMP_TID( "enum_fixed_type_modifier_list_btid", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[0].tid), C_TPID_BASE );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11293 "parser.c"
    break;

  case 583: /* enum_fixed_type_c_ast: enum_fixed_type_modifier_list_btid enum_unmodified_fixed_type_c_ast enum_fixed_type_modifier_list_btid_opt  */
#line 7091 "parser.y"
    {
      DUMP_START( "enum_fixed_type_c_ast",
                  "enum_fixed_type_modifier_list_btid "
                  "enum_unmodified_fixed_type_c_ast "
                  "enum_fixed_type_modifier_list_btid_opt" );
      DUMP_TID( "enum_fixed_type_modifier_list_btid", (yyvsp[-2].tid) );
      DUMP_AST( "enum_unmodified_fixed_type_c_ast", (yyvsp[-1].ast) );
      DUMP_TID( "enum_fixed_type_modifier_list_btid_opt", (yyvsp[0].tid) );

      (yyval.ast) = (yyvsp[-1].ast);
      (yyval.ast)->loc = (yyloc);
      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[-2].tid), &(yylsp[-2]) ) );
      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11315 "parser.c"
    break;

  case 584: /* enum_fixed_type_c_ast: enum_unmodified_fixed_type_c_ast enum_fixed_type_modifier_list_btid_opt  */
#line 7116 "parser.y"
    {
      DUMP_START( "enum_fixed_type_c_ast",
                  "enum_unmodified_fixed_type_c_ast "
                  "enum_fixed_type_modifier_list_btid_opt" );
      DUMP_AST( "enum_unmodified_fixed_type_c_ast", (yyvsp[-1].ast) );
      DUMP_TID( "enum_fixed_type_modifier_list_btid_opt", (yyvsp[0].tid) );

      (yyval.ast) = (yyvsp[-1].ast);
      (yyval.ast)->loc = (yyloc);
      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11334 "parser.c"
    break;

  case 585: /* enum_fixed_type_modifier_list_btid_opt: %empty  */
#line 7133 "parser.y"
                                  { (yyval.tid) = TB_NONE; }
#line 11340 "parser.c"
    break;

  case 587: /* enum_fixed_type_modifier_list_btid: enum_fixed_type_modifier_list_btid enum_fixed_type_modifier_btid  */
#line 7140 "parser.y"
    {
      DUMP_START( "enum_fixed_type_modifier_list_btid",
                  "enum_fixed_type_modifier_list_btid "
                  "enum_fixed_type_modifier_btid" );
      DUMP_TID( "enum_fixed_type_modifier_list_btid", (yyvsp[-1].tid) );
      DUMP_TID( "enum_fixed_type_modifier_btid", (yyvsp[0].tid) );

      (yyval.tid) = (yyvsp[-1].tid);
      PARSE_ASSERT( c_tid_add( &(yyval.tid), (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_TID( "$$_btids", (yyval.tid) );
      DUMP_END();
    }
#line 11358 "parser.c"
    break;

  case 596: /* class_struct_btid_opt: %empty  */
#line 7173 "parser.y"
                                  { (yyval.tid) = TB_NONE; }
#line 11364 "parser.c"
    break;

  case 602: /* type_qualifier_list_c_stid_opt: %empty  */
#line 7190 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 11370 "parser.c"
    break;

  case 604: /* type_qualifier_list_c_stid: type_qualifier_list_c_stid type_qualifier_c_stid gnu_or_msc_attribute_specifier_list_c_opt  */
#line 7197 "parser.y"
    {
      DUMP_START( "type_qualifier_list_c_stid",
                  "type_qualifier_list_c_stid type_qualifier_c_stid" );
      DUMP_TID( "type_qualifier_list_c_stid", (yyvsp[-2].tid) );
      DUMP_TID( "type_qualifier_c_stid", (yyvsp[-1].tid) );

      (yyval.tid) = (yyvsp[-2].tid);
      PARSE_ASSERT( c_tid_add( &(yyval.tid), (yyvsp[-1].tid), &(yylsp[-1]) ) );

      DUMP_TID( "$$_stids", (yyval.tid) );
      DUMP_END();
    }
#line 11387 "parser.c"
    break;

  case 605: /* type_qualifier_list_c_stid: gnu_or_msc_attribute_specifier_list_c type_qualifier_c_stid  */
#line 7211 "parser.y"
    {
      (yyval.tid) = (yyvsp[0].tid);
    }
#line 11395 "parser.c"
    break;

  case 606: /* type_qualifier_list_c_stid: type_qualifier_c_stid gnu_or_msc_attribute_specifier_list_c_opt  */
#line 7216 "parser.y"
    {
      (yyval.tid) = (yyvsp[-1].tid);
    }
#line 11403 "parser.c"
    break;

  case 616: /* cv_qualifier_list_stid_opt: %empty  */
#line 7237 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 11409 "parser.c"
    break;

  case 617: /* cv_qualifier_list_stid_opt: cv_qualifier_list_stid_opt cv_qualifier_stid  */
#line 7239 "parser.y"
    {
      DUMP_START( "cv_qualifier_list_stid_opt",
                  "cv_qualifier_list_stid_opt cv_qualifier_stid" );
      DUMP_TID( "cv_qualifier_list_stid_opt", (yyvsp[-1].tid) );
      DUMP_TID( "cv_qualifier_stid", (yyvsp[0].tid) );

      (yyval.tid) = (yyvsp[-1].tid);
      PARSE_ASSERT( c_tid_add( &(yyval.tid), (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_TID( "$$_stids", (yyval.tid) );
      DUMP_END();
    }
#line 11426 "parser.c"
    break;

  case 618: /* restrict_qualifier_c_stid: Y_restrict  */
#line 7255 "parser.y"
    { //
      // This check has to be done now in the parser rather than later in the
      // AST since both "restrict" and "__restrict" map to TS_restrict and the
      // AST has no "memory" of which it was.
      //
      if ( OPT_LANG_IS( CPP_ANY ) ) {
        print_error( &(yylsp[0]),
          "\"restrict\" not supported in C++; use \"%s\" instead\n",
          L_GNU___restrict
        );
        PARSE_ABORT();
      }
    }
#line 11444 "parser.c"
    break;

  case 623: /* upc_layout_qualifier_c: '[' error ']'  */
#line 7276 "parser.y"
    {
      elaborate_error( "one of nothing, integer, or '*' expected" );
    }
#line 11452 "parser.c"
    break;

  case 624: /* storage_class_c_type: Y_auto_STORAGE  */
#line 7284 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11458 "parser.c"
    break;

  case 625: /* storage_class_c_type: Y_Apple___block  */
#line 7285 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11464 "parser.c"
    break;

  case 626: /* storage_class_c_type: Y_consteval  */
#line 7286 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11470 "parser.c"
    break;

  case 627: /* storage_class_c_type: Y_constexpr  */
#line 7287 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11476 "parser.c"
    break;

  case 628: /* storage_class_c_type: Y_constinit  */
#line 7288 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11482 "parser.c"
    break;

  case 629: /* storage_class_c_type: Y_explicit  */
#line 7289 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11488 "parser.c"
    break;

  case 630: /* storage_class_c_type: Y_export  */
#line 7290 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11494 "parser.c"
    break;

  case 631: /* storage_class_c_type: Y_extern  */
#line 7291 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11500 "parser.c"
    break;

  case 632: /* storage_class_c_type: extern_linkage_c_stid  */
#line 7292 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11506 "parser.c"
    break;

  case 633: /* storage_class_c_type: Y_final  */
#line 7293 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11512 "parser.c"
    break;

  case 634: /* storage_class_c_type: Y_friend  */
#line 7294 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11518 "parser.c"
    break;

  case 635: /* storage_class_c_type: Y_inline  */
#line 7295 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11524 "parser.c"
    break;

  case 636: /* storage_class_c_type: Y_mutable  */
#line 7296 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11530 "parser.c"
    break;

  case 637: /* storage_class_c_type: _Noreturn_atid  */
#line 7298 "parser.y"
    {
      //
      // These checks have to be done now in the parser rather than later in
      // the AST because the _Noreturn keyword is mapped to the [[noreturn]]
      // attribute and the AST has no "memory" that it was _Noreturn.
      //
      if ( !IS_SUPPORTED( _Noreturn ) ) {
        print_error( &(yylsp[0]),
          "\"%s\" keyword not supported%s",
          yytext, C_LANG_WHICH( _Noreturn )
        );
        print_hint(
          "%snoreturn%s", other_token_c( "[[" ), other_token_c( "]]" )
        );
        PARSE_ABORT();
      }
      if ( !OPT_LANG_IS( _Noreturn_NOT_DEPRECATED ) ) {
        print_warning( &(yylsp[0]),
          "\"%s\" is deprecated%s",
          yytext, C_LANG_WHICH( _Noreturn_NOT_DEPRECATED )
        );
        print_hint(
          "%snoreturn%s", other_token_c( "[[" ), other_token_c( "]]" )
        );
      }

      (yyval.type) = C_TYPE_LIT_A( (yyvsp[0].tid) );
    }
#line 11563 "parser.c"
    break;

  case 638: /* storage_class_c_type: Y_override  */
#line 7326 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11569 "parser.c"
    break;

  case 639: /* storage_class_c_type: Y_static  */
#line 7328 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11575 "parser.c"
    break;

  case 640: /* storage_class_c_type: Y_typedef  */
#line 7329 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11581 "parser.c"
    break;

  case 641: /* storage_class_c_type: Y__Thread_local  */
#line 7330 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11587 "parser.c"
    break;

  case 642: /* storage_class_c_type: Y_thread_local  */
#line 7331 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11593 "parser.c"
    break;

  case 643: /* storage_class_c_type: Y_virtual  */
#line 7332 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11599 "parser.c"
    break;

  case 646: /* attribute_specifier_list_c_atid_opt: %empty  */
#line 7343 "parser.y"
                                  { (yyval.tid) = TA_NONE; }
#line 11605 "parser.c"
    break;

  case 648: /* $@41: %empty  */
#line 7349 "parser.y"
    {
      if ( !IS_SUPPORTED( ATTRIBUTES ) ) {
        print_error( &(yylsp[-1]),
          "\"%s\" attribute syntax not supported%s\n",
          other_token_c( "[[" ),
          C_LANG_WHICH( ATTRIBUTES )
        );
        PARSE_ABORT();
      }
      lexer_keyword_ctx = C_KW_CTX_ATTRIBUTE;
    }
#line 11621 "parser.c"
    break;

  case 649: /* attribute_specifier_list_c_atid: Y_ATTR_BEGIN '[' $@41 using_opt attribute_list_c_atid_opt ']' rbracket_exp  */
#line 7361 "parser.y"
    {
      lexer_keyword_ctx = C_KW_CTX_DEFAULT;

      DUMP_START( "attribute_specifier_list_c_atid",
                  "'[[' using_opt attribute_list_c_atid_opt ']]'" );
      DUMP_TID( "attribute_list_c_atid_opt", (yyvsp[-2].tid) );

      (yyval.tid) = (yyvsp[-2].tid);

      DUMP_END();
    }
#line 11637 "parser.c"
    break;

  case 650: /* attribute_specifier_list_c_atid: gnu_or_msc_attribute_specifier_list_c  */
#line 7374 "parser.y"
    {
      (yyval.tid) = TA_NONE;
    }
#line 11645 "parser.c"
    break;

  case 652: /* using_opt: Y_using name_exp colon_exp  */
#line 7382 "parser.y"
    {
      IGNORING( &(yylsp[-2]), "\"using\" in attributes" );
      free( (yyvsp[-1].name) );
    }
#line 11654 "parser.c"
    break;

  case 653: /* attribute_list_c_atid_opt: %empty  */
#line 7389 "parser.y"
                                  { (yyval.tid) = TA_NONE; }
#line 11660 "parser.c"
    break;

  case 655: /* attribute_list_c_atid: attribute_list_c_atid comma_exp attribute_c_atid_exp  */
#line 7395 "parser.y"
    {
      DUMP_START( "attribute_list_c_atid",
                  "attribute_list_c_atid ',' attribute_c_atid" );
      DUMP_TID( "attribute_list_c_atid", (yyvsp[-2].tid) );
      DUMP_TID( "attribute_c_atid_exp", (yyvsp[0].tid) );

      (yyval.tid) = (yyvsp[-2].tid);
      PARSE_ASSERT( c_tid_add( &(yyval.tid), (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_TID( "$$_atids", (yyval.tid) );
      DUMP_END();
    }
#line 11677 "parser.c"
    break;

  case 665: /* attribute_c_atid_exp: sname_c  */
#line 7421 "parser.y"
    {
      if ( c_sname_count( &(yyvsp[0].sname) ) > 1 ) {
        IGNORING( &(yylsp[0]),
          "\"%s\": namespaced attributes", c_sname_gibberish( &(yyvsp[0].sname) )
        );
      }
      else {
        char const *adj = "unknown";
        c_lang_id_t lang_ids = LANG_NONE;

        char const *const name = c_sname_local_name( &(yyvsp[0].sname) );
        c_keyword_t const *const ck = c_keyword_find(
          name, c_lang_newer( opt_lang_id ), C_KW_CTX_ATTRIBUTE
        );
        if ( ck != NULL && c_tid_tpid( ck->tid ) == C_TPID_ATTR ) {
          adj = "unsupported";
          lang_ids = ck->lang_ids;
        }
        print_warning( &(yylsp[0]),
          "\"%s\": %s attribute%s",
          name, adj, c_lang_which( lang_ids )
        );

        print_suggestions( DYM_C_ATTRIBUTES, name );
        EPUTC( '\n' );
      }

      (yyval.tid) = TA_NONE;
      c_sname_cleanup( &(yyvsp[0].sname) );
    }
#line 11712 "parser.c"
    break;

  case 666: /* attribute_c_atid_exp: error  */
#line 7452 "parser.y"
    {
      elaborate_error_dym( DYM_C_ATTRIBUTES, "attribute name expected" );
    }
#line 11720 "parser.c"
    break;

  case 668: /* attribute_str_arg_c_opt: '(' str_lit_exp rparen_exp  */
#line 7460 "parser.y"
    {
      IGNORING( &(yylsp[-2]), "attribute arguments" );
      free( (yyvsp[-1].str_val) );
    }
#line 11729 "parser.c"
    break;

  case 677: /* $@42: %empty  */
#line 7488 "parser.y"
    {
      attr_syntax_not_supported( L_GNU___attribute__, &(yylsp[0]) );
      //
      // Temporariy disabling finding keywords allows GNU attributes that are C
      // keywords (e.g., const) to be found as ordinary string literals.
      //
      lexer_find &= ~LEXER_FIND_C_KEYWORDS;
    }
#line 11742 "parser.c"
    break;

  case 678: /* gnu_attribute_specifier_c: Y_GNU___attribute__ $@42 lparen_exp lparen_exp gnu_attribute_list_c_opt ')' rparen_exp  */
#line 7497 "parser.y"
    {
      lexer_find |= LEXER_FIND_C_KEYWORDS;
    }
#line 11750 "parser.c"
    break;

  case 683: /* gnu_attribute_c_exp: Y_NAME gnu_attribute_decl_arg_list_c_opt  */
#line 7514 "parser.y"
    {
      free( (yyvsp[-1].name) );
    }
#line 11758 "parser.c"
    break;

  case 684: /* gnu_attribute_c_exp: error  */
#line 7518 "parser.y"
    {
      elaborate_error( "attribute name expected" );
    }
#line 11766 "parser.c"
    break;

  case 691: /* gnu_attribute_arg_c: Y_NAME  */
#line 7539 "parser.y"
                                  { free( (yyvsp[0].name) ); }
#line 11772 "parser.c"
    break;

  case 692: /* gnu_attribute_arg_c: Y_CHAR_LIT  */
#line 7540 "parser.y"
                                  { free( (yyvsp[0].str_val) ); }
#line 11778 "parser.c"
    break;

  case 694: /* gnu_attribute_arg_c: Y_STR_LIT  */
#line 7542 "parser.y"
                                  { free( (yyvsp[0].str_val) ); }
#line 11784 "parser.c"
    break;

  case 696: /* gnu_attribute_arg_c: Y_LEXER_ERROR  */
#line 7545 "parser.y"
    {
      PARSE_ABORT();
    }
#line 11792 "parser.c"
    break;

  case 699: /* $@43: %empty  */
#line 7557 "parser.y"
    {
      attr_syntax_not_supported( L_MSC___declspec, &(yylsp[0]) );
      // See comment in gnu_attribute_specifier_c.
      lexer_find &= ~LEXER_FIND_C_KEYWORDS;
    }
#line 11802 "parser.c"
    break;

  case 700: /* msc_attribute_specifier_c: Y_MSC___declspec $@43 lparen_exp msc_attribute_list_c_opt ')'  */
#line 7563 "parser.y"
    {
      lexer_find |= LEXER_FIND_C_KEYWORDS;
    }
#line 11810 "parser.c"
    break;

  case 708: /* array_decl_english_ast: Y_array array_size_decl_ast of_exp decl_english_ast  */
#line 7599 "parser.y"
    {
      DUMP_START( "array_decl_english_ast",
                  "ARRAY array_size_num_opt OF decl_english_ast" );
      DUMP_AST( "array_size_decl_ast", (yyvsp[-2].ast) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[-2].ast);
      (yyval.ast)->loc = (yylsp[-3]);
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11828 "parser.c"
    break;

  case 709: /* array_decl_english_ast: Y_variable length_opt array_exp name_opt of_exp decl_english_ast  */
#line 7615 "parser.y"
    {
      DUMP_START( "array_decl_english_ast",
                  "VARIABLE LENGTH ARRAY name_opt OF decl_english_ast" );
      DUMP_STR( "name_opt", (yyvsp[-2].name) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      if ( (yyvsp[-2].name) == NULL ) {
        (yyval.ast)->array.kind = C_ARRAY_SIZE_VLA;
      } else {
        (yyval.ast)->array.kind = C_ARRAY_SIZE_NAME;
        (yyval.ast)->array.size_name = (yyvsp[-2].name);
      }
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11851 "parser.c"
    break;

  case 710: /* array_size_decl_ast: %empty  */
#line 7637 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_SIZE_NONE;
    }
#line 11860 "parser.c"
    break;

  case 711: /* array_size_decl_ast: uint_lit  */
#line 7642 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_SIZE_INT;
      (yyval.ast)->array.size_int = (yyvsp[0].uint_val);
    }
#line 11870 "parser.c"
    break;

  case 712: /* array_size_decl_ast: Y_NAME  */
#line 7648 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_SIZE_NAME;
      (yyval.ast)->array.size_name = (yyvsp[0].name);
    }
#line 11880 "parser.c"
    break;

  case 713: /* array_size_decl_ast: '*'  */
#line 7654 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_SIZE_VLA;
    }
#line 11889 "parser.c"
    break;

  case 716: /* block_decl_english_ast: Y_Apple_block paren_param_decl_list_english_opt returning_english_ast_opt  */
#line 7671 "parser.y"
    {
      DUMP_START( "block_decl_english_ast",
                  "BLOCK paren_param_decl_list_english_opt "
                  "returning_english_ast_opt" );
      DUMP_AST_LIST( "paren_param_decl_list_english_opt", (yyvsp[-1].ast_list) );
      DUMP_AST( "returning_english_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_APPLE_BLOCK, &(yyloc) );
      c_ast_list_set_param_of( &(yyvsp[-1].ast_list), (yyval.ast) );
      (yyval.ast)->block.param_ast_list = slist_move( &(yyvsp[-1].ast_list) );
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11909 "parser.c"
    break;

  case 717: /* constructor_decl_english_ast: Y_constructor paren_param_decl_list_english_opt  */
#line 7692 "parser.y"
    {
      DUMP_START( "constructor_decl_english_ast",
                  "CONSTRUCTOR paren_param_decl_list_english_opt" );
      DUMP_AST_LIST( "paren_param_decl_list_english_opt", (yyvsp[0].ast_list) );

      (yyval.ast) = c_ast_new_gc( K_CONSTRUCTOR, &(yyloc) );
      c_ast_list_set_param_of( &(yyvsp[0].ast_list), (yyval.ast) );
      (yyval.ast)->ctor.param_ast_list = slist_move( &(yyvsp[0].ast_list) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11926 "parser.c"
    break;

  case 718: /* destructor_decl_english_ast: Y_destructor destructor_parens_opt  */
#line 7710 "parser.y"
    {
      DUMP_START( "destructor_decl_english_ast", "DESTRUCTOR ['(' ')']" );

      (yyval.ast) = c_ast_new_gc( K_DESTRUCTOR, &(yyloc) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11939 "parser.c"
    break;

  case 721: /* func_decl_english_ast: func_qualifier_english_type_opt member_or_non_member_opt Y_function paren_param_decl_list_english_opt returning_english_ast_opt  */
#line 7732 "parser.y"
    {
      DUMP_START( "func_decl_english_ast",
                  "ref_qualifier_english_stid_opt "
                  "member_or_non_member_opt "
                  "FUNCTION paren_param_decl_list_english_opt "
                  "returning_english_ast_opt" );
      DUMP_TYPE( "func_qualifier_english_type_opt", (yyvsp[-4].type) );
      DUMP_INT( "member_or_non_member_opt", (yyvsp[-3].member) );
      DUMP_AST_LIST( "paren_param_decl_list_english_opt", (yyvsp[-1].ast_list) );
      DUMP_AST( "returning_english_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_FUNCTION, &(yyloc) );
      (yyval.ast)->type = (yyvsp[-4].type);
      c_ast_list_set_param_of( &(yyvsp[-1].ast_list), (yyval.ast) );
      (yyval.ast)->func.param_ast_list = slist_move( &(yyvsp[-1].ast_list) );
      (yyval.ast)->func.member = (yyvsp[-3].member);
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11965 "parser.c"
    break;

  case 722: /* func_qualifier_english_type_opt: ref_qualifier_english_stid_opt  */
#line 7757 "parser.y"
    {
      (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) );
    }
#line 11973 "parser.c"
    break;

  case 723: /* func_qualifier_english_type_opt: msc_calling_convention_atid  */
#line 7761 "parser.y"
    {
      (yyval.type) = C_TYPE_LIT_A( (yyvsp[0].tid) );
    }
#line 11981 "parser.c"
    break;

  case 730: /* paren_param_decl_list_english_opt: %empty  */
#line 7778 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 11987 "parser.c"
    break;

  case 732: /* paren_param_decl_list_english: '(' param_decl_list_english_opt ')'  */
#line 7784 "parser.y"
    {
      DUMP_START( "paren_param_decl_list_english",
                  "'(' param_decl_list_english_opt ')'" );
      DUMP_AST_LIST( "param_decl_list_english_opt", (yyvsp[-1].ast_list) );

      (yyval.ast_list) = (yyvsp[-1].ast_list);

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 12002 "parser.c"
    break;

  case 733: /* param_decl_list_english_opt: %empty  */
#line 7797 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 12008 "parser.c"
    break;

  case 735: /* param_decl_list_english: param_decl_list_english comma_exp decl_english_ast_exp  */
#line 7804 "parser.y"
    {
      DUMP_START( "param_decl_list_english",
                  "param_decl_list_english ',' decl_english_ast" );
      DUMP_AST_LIST( "param_decl_list_english", (yyvsp[-2].ast_list) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast_list) = (yyvsp[-2].ast_list);
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 12025 "parser.c"
    break;

  case 736: /* param_decl_list_english: decl_english_ast  */
#line 7818 "parser.y"
    {
      DUMP_START( "param_decl_list_english", "decl_english_ast" );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      if ( (yyvsp[0].ast)->kind == K_FUNCTION ) // see the comment in param_c_ast
        (yyvsp[0].ast) = c_ast_pointer( (yyvsp[0].ast), &gc_ast_list );

      slist_init( &(yyval.ast_list) );
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 12043 "parser.c"
    break;

  case 738: /* decl_english_ast_exp: error  */
#line 7836 "parser.y"
    {
      elaborate_error( "declaration expected" );
    }
#line 12051 "parser.c"
    break;

  case 739: /* ref_qualifier_english_stid_opt: %empty  */
#line 7844 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 12057 "parser.c"
    break;

  case 740: /* ref_qualifier_english_stid_opt: Y_reference  */
#line 7845 "parser.y"
                                  { (yyval.tid) = TS_REFERENCE; }
#line 12063 "parser.c"
    break;

  case 741: /* ref_qualifier_english_stid_opt: Y_rvalue reference_exp  */
#line 7846 "parser.y"
                                  { (yyval.tid) = TS_RVALUE_REFERENCE; }
#line 12069 "parser.c"
    break;

  case 742: /* returning_english_ast_opt: %empty  */
#line 7853 "parser.y"
    {
      DUMP_START( "returning_english_ast_opt", "<empty>" );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      // see the comment in "type_c_ast"
      (yyval.ast)->type.btids = OPT_LANG_IS( IMPLICIT_int ) ? TB_int : TB_void;

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12084 "parser.c"
    break;

  case 744: /* returning_english_ast: returning decl_english_ast  */
#line 7869 "parser.y"
    {
      DUMP_START( "returning_english_ast", "RETURNING decl_english_ast" );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[0].ast);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12098 "parser.c"
    break;

  case 745: /* returning_english_ast: returning error  */
#line 7880 "parser.y"
    {
      elaborate_error( "English expected after \"returning\"" );
    }
#line 12106 "parser.c"
    break;

  case 746: /* qualified_decl_english_ast: type_qualifier_list_english_type_opt qualifiable_decl_english_ast  */
#line 7890 "parser.y"
    {
      DUMP_START( "qualified_decl_english_ast",
                  "type_qualifier_list_english_type_opt "
                  "qualifiable_decl_english_ast" );
      DUMP_TYPE( "type_qualifier_list_english_type_opt", (yyvsp[-1].type) );
      DUMP_AST( "qualifiable_decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[0].ast);
      if ( !c_type_is_none( &(yyvsp[-1].type) ) )
        (yyval.ast)->loc = (yyloc);
      PARSE_ASSERT( c_type_add( &(yyval.ast)->type, &(yyvsp[-1].type), &(yylsp[-1]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12126 "parser.c"
    break;

  case 747: /* type_qualifier_list_english_type_opt: %empty  */
#line 7908 "parser.y"
                                  { (yyval.type) = T_NONE; }
#line 12132 "parser.c"
    break;

  case 749: /* type_qualifier_list_english_type: type_qualifier_list_english_type type_qualifier_english_type  */
#line 7915 "parser.y"
    {
      DUMP_START( "type_qualifier_list_english_type",
                  "type_qualifier_list_english_type "
                  "type_qualifier_english_type" );
      DUMP_TYPE( "type_qualifier_list_english_type", (yyvsp[-1].type) );
      DUMP_TYPE( "type_qualifier_english_type", (yyvsp[0].type) );

      (yyval.type) = (yyvsp[-1].type);
      PARSE_ASSERT( c_type_add( &(yyval.type), &(yyvsp[0].type), &(yylsp[0]) ) );

      DUMP_TYPE( "$$_type", (yyval.type) );
      DUMP_END();
    }
#line 12150 "parser.c"
    break;

  case 751: /* type_qualifier_english_type: attribute_english_atid  */
#line 7933 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_A( (yyvsp[0].tid) ); }
#line 12156 "parser.c"
    break;

  case 752: /* type_qualifier_english_type: storage_class_english_stid  */
#line 7934 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 12162 "parser.c"
    break;

  case 753: /* type_qualifier_english_type: type_qualifier_english_stid  */
#line 7935 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 12168 "parser.c"
    break;

  case 754: /* attribute_english_atid: Y_carries dependency_exp  */
#line 7939 "parser.y"
                                  { (yyval.tid) = TA_carries_dependency; }
#line 12174 "parser.c"
    break;

  case 757: /* attribute_english_atid: Y_maybe unused_exp  */
#line 7942 "parser.y"
                                  { (yyval.tid) = TA_maybe_unused; }
#line 12180 "parser.c"
    break;

  case 759: /* attribute_english_atid: Y_no Y_discard  */
#line 7944 "parser.y"
                                  { (yyval.tid) = TA_nodiscard; }
#line 12186 "parser.c"
    break;

  case 761: /* attribute_english_atid: Y_no Y_return  */
#line 7946 "parser.y"
                                  { (yyval.tid) = TA_noreturn; }
#line 12192 "parser.c"
    break;

  case 764: /* attribute_english_atid: Y_no Y_unique address_exp  */
#line 7949 "parser.y"
                                  { (yyval.tid) = TA_no_unique_address; }
#line 12198 "parser.c"
    break;

  case 770: /* storage_class_english_stid: Y_constant eval_expr_init_stid  */
#line 7959 "parser.y"
    {
      (yyval.tid) = (yyvsp[0].tid);
    }
#line 12206 "parser.c"
    break;

  case 779: /* storage_class_english_stid: Y_extern linkage_stid linkage_opt  */
#line 7971 "parser.y"
    {
      (yyval.tid) = (yyvsp[-1].tid);
    }
#line 12214 "parser.c"
    break;

  case 784: /* storage_class_english_stid: Y_no Y_except  */
#line 7978 "parser.y"
                                  { (yyval.tid) = TS_noexcept; }
#line 12220 "parser.c"
    break;

  case 786: /* storage_class_english_stid: Y_non_empty  */
#line 7980 "parser.y"
                                  { (yyval.tid) = TS_NON_EMPTY_ARRAY; }
#line 12226 "parser.c"
    break;

  case 790: /* storage_class_english_stid: Y_thread local_exp  */
#line 7985 "parser.y"
                                  { (yyval.tid) = TS_thread_local; }
#line 12232 "parser.c"
    break;

  case 796: /* storage_class_english_stid: Y_pure virtual_stid_exp  */
#line 7991 "parser.y"
                                  { (yyval.tid) = TS_PURE_virtual | (yyvsp[0].tid); }
#line 12238 "parser.c"
    break;

  case 797: /* eval_expr_init_stid: Y_evaluation  */
#line 7995 "parser.y"
                                  { (yyval.tid) = TS_consteval; }
#line 12244 "parser.c"
    break;

  case 798: /* eval_expr_init_stid: Y_expression  */
#line 7996 "parser.y"
                                  { (yyval.tid) = TS_constexpr; }
#line 12250 "parser.c"
    break;

  case 799: /* eval_expr_init_stid: Y_initialization  */
#line 7997 "parser.y"
                                  { (yyval.tid) = TS_constinit; }
#line 12256 "parser.c"
    break;

  case 800: /* linkage_stid: str_lit  */
#line 8009 "parser.y"
    {
      bool ok = true;

      if ( strcmp( (yyvsp[0].str_val), "C" ) == 0 )
        (yyval.tid) = TS_extern_C;
      else if ( strcmp( (yyvsp[0].str_val), "C++" ) == 0 )
        (yyval.tid) = TS_NONE;
      else {
        print_error( &(yylsp[0]), "\"%s\": unknown linkage language", (yyvsp[0].str_val) );
        print_hint( "\"C\" or \"C++\"" );
        ok = false;
      }

      free( (yyvsp[0].str_val) );
      PARSE_ASSERT( ok );
    }
#line 12277 "parser.c"
    break;

  case 821: /* pointer_decl_english_ast: Y_pointer to_exp decl_english_ast  */
#line 8067 "parser.y"
    {
      DUMP_START( "pointer_decl_english_ast", "POINTER TO decl_english_ast" );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      // see the comment in "declare_command"
      PARSE_ASSERT( !c_ast_is_name_error( (yyvsp[0].ast) ) );

      (yyval.ast) = c_ast_new_gc( K_POINTER, &(yyloc) );
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12295 "parser.c"
    break;

  case 822: /* pointer_decl_english_ast: Y_pointer to_exp Y_member of_exp class_struct_union_btid_exp sname_english_exp decl_english_ast  */
#line 8087 "parser.y"
    {
      DUMP_START( "pointer_to_member_decl_english",
                  "POINTER TO MEMBER OF "
                  "class_struct_union_btid_exp "
                  "sname_english decl_english_ast" );
      DUMP_TID( "class_struct_union_btid_exp", (yyvsp[-2].tid) );
      DUMP_SNAME( "sname_english_exp", (yyvsp[-1].sname) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      // see the comment in "declare_command"
      if ( c_ast_is_name_error( (yyvsp[0].ast) ) ) {
        c_sname_cleanup( &(yyvsp[-1].sname) );
        PARSE_ABORT();
      }

      (yyval.ast) = c_ast_new_gc( K_POINTER_TO_MEMBER, &(yyloc) );
      (yyval.ast)->ptr_mbr.class_sname = c_sname_move( &(yyvsp[-1].sname) );
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );
      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[-2].tid), &(yylsp[-2]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12323 "parser.c"
    break;

  case 823: /* pointer_decl_english_ast: Y_pointer to_exp error  */
#line 8112 "parser.y"
    {
      if ( OPT_LANG_IS( POINTERS_TO_MEMBER ) )
        elaborate_error( "type name or \"member\" expected" );
      else
        elaborate_error( "type name expected" );
    }
#line 12334 "parser.c"
    break;

  case 824: /* reference_decl_english_ast: reference_english_ast to_exp decl_english_ast  */
#line 8125 "parser.y"
    {
      DUMP_START( "reference_decl_english_ast",
                  "reference_english_ast TO decl_english_ast" );
      DUMP_AST( "reference_english_ast", (yyvsp[-2].ast) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      // see the comment in "declare_command"
      PARSE_ASSERT( !c_ast_is_name_error( (yyvsp[0].ast) ) );

      (yyval.ast) = (yyvsp[-2].ast);
      (yyval.ast)->loc = (yyloc);
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12355 "parser.c"
    break;

  case 825: /* reference_english_ast: Y_reference  */
#line 8145 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_REFERENCE, &(yyloc) );
    }
#line 12363 "parser.c"
    break;

  case 826: /* reference_english_ast: Y_rvalue reference_exp  */
#line 8150 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_RVALUE_REFERENCE, &(yyloc) );
    }
#line 12371 "parser.c"
    break;

  case 827: /* structured_binding_decl_english_ast: Y_structured binding_exp  */
#line 8159 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_STRUCTURED_BINDING, &(yyloc) );
    }
#line 12379 "parser.c"
    break;

  case 828: /* user_defined_literal_decl_english_ast: user_defined literal_exp lparen_exp param_decl_list_english_opt ')' returning_english_ast_opt  */
#line 8170 "parser.y"
    { //
      // User-defined literals are supported only in C++11 and later.
      // (However, we always allow them in configuration files.)
      //
      // This check is better to do now in the parser rather than later in the
      // AST because it has to be done in fewer places in the code plus gives a
      // better error location.
      //
      if ( !IS_SUPPORTED( USER_DEF_LITS ) ) {
        print_error( &(yylsp[-5]),
          "user-defined literals not supported%s\n",
          C_LANG_WHICH( USER_DEF_LITS )
        );
        PARSE_ABORT();
      }

      DUMP_START( "user_defined_literal_decl_english_ast",
                  "USER-DEFINED LITERAL '(' param_decl_list_english_opt ')' "
                  "returning_english_ast_opt" );
      DUMP_AST_LIST( "param_decl_list_english_opt", (yyvsp[-2].ast_list) );
      DUMP_AST( "returning_english_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_UDEF_LIT, &(yyloc) );
      c_ast_list_set_param_of( &(yyvsp[-2].ast_list), (yyval.ast) );
      (yyval.ast)->udef_lit.param_ast_list = slist_move( &(yyvsp[-2].ast_list) );
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12414 "parser.c"
    break;

  case 829: /* var_decl_english_ast: sname_c Y_as decl_english_ast  */
#line 8209 "parser.y"
    {
      DUMP_START( "var_decl_english_ast", "sname_c AS decl_english_ast" );
      DUMP_SNAME( "sname_c", (yyvsp[-2].sname) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      // see the comment in "declare_command"
      if ( c_ast_is_name_error( (yyvsp[0].ast) ) ) {
        c_sname_cleanup( &(yyvsp[-2].sname) );
        PARSE_ABORT();
      }

      (yyval.ast) = (yyvsp[0].ast);
      (yyval.ast)->loc = (yyloc);
      c_sname_set( &(yyval.ast)->sname, &(yyvsp[-2].sname) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12437 "parser.c"
    break;

  case 831: /* var_decl_english_ast: "..."  */
#line 8237 "parser.y"
    {
      DUMP_START( "var_decl_english_ast", "..." );

      (yyval.ast) = c_ast_new_gc( K_VARIADIC, &(yyloc) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12450 "parser.c"
    break;

  case 832: /* type_english_ast: type_modifier_list_english_type_opt unmodified_type_english_ast  */
#line 8254 "parser.y"
    {
      DUMP_START( "type_english_ast",
                  "type_modifier_list_english_type_opt "
                  "unmodified_type_english_ast" );
      DUMP_TYPE( "type_modifier_list_english_type_opt", (yyvsp[-1].type) );
      DUMP_AST( "unmodified_type_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[0].ast);
      if ( !c_type_is_none( &(yyvsp[-1].type) ) ) {
        // Set the AST's location to the entire rule only if the leading
        // optional rule is actually present, otherwise @$ refers to a column
        // before $ast.
        (yyval.ast)->loc = (yyloc);
        PARSE_ASSERT( c_type_add( &(yyval.ast)->type, &(yyvsp[-1].type), &(yylsp[-1]) ) );
      }

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12474 "parser.c"
    break;

  case 833: /* type_english_ast: type_modifier_list_english_type  */
#line 8276 "parser.y"
    {
      DUMP_START( "type_english_ast", "type_modifier_list_english_type" );
      DUMP_TYPE( "type_modifier_list_english_type", (yyvsp[0].type) );

      // see the comment in "type_c_ast"
      c_type_t new_type =
        C_TYPE_LIT_B( OPT_LANG_IS( IMPLICIT_int ) ? TB_int : TB_NONE );

      PARSE_ASSERT( c_type_add( &new_type, &(yyvsp[0].type), &(yylsp[0]) ) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type = new_type;

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12495 "parser.c"
    break;

  case 834: /* type_modifier_list_english_type_opt: %empty  */
#line 8295 "parser.y"
                                  { (yyval.type) = T_NONE; }
#line 12501 "parser.c"
    break;

  case 836: /* type_modifier_list_english_type: type_modifier_list_english_type type_modifier_english_type  */
#line 8302 "parser.y"
    {
      DUMP_START( "type_modifier_list_english_type",
                  "type_modifier_list_english_type "
                  "type_modifier_english_type" );
      DUMP_TYPE( "type_modifier_list_english_type", (yyvsp[-1].type) );
      DUMP_TYPE( "type_modifier_english_type", (yyvsp[0].type) );

      (yyval.type) = (yyvsp[-1].type);
      PARSE_ASSERT( c_type_add( &(yyval.type), &(yyvsp[0].type), &(yylsp[0]) ) );

      DUMP_TYPE( "$$_type", (yyval.type) );
      DUMP_END();
    }
#line 12519 "parser.c"
    break;

  case 845: /* builtin_type_english_ast: builtin_no_BitInt_english_btid  */
#line 8334 "parser.y"
    {
      DUMP_START( "builtin_type_english_ast",
                  "builtin_no_BitInt_english_btid" );
      DUMP_TID( "builtin_no_BitInt_english_btid", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[0].tid), C_TPID_BASE );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12535 "parser.c"
    break;

  case 846: /* builtin_type_english_ast: BitInt_english_int  */
#line 8346 "parser.y"
    {
      DUMP_START( "builtin_type_english_ast", "BitInt_english_int" );
      DUMP_INT( "BitInt_english_int", (yyvsp[0].uint_val) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type.btids = TB__BitInt;
      (yyval.ast)->builtin.BitInt.width = (yyvsp[0].uint_val);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12551 "parser.c"
    break;

  case 851: /* builtin_no_BitInt_english_btid: Y_char uint_lit_opt  */
#line 8365 "parser.y"
    {
      switch ( (yyvsp[0].uint_val) ) {
        case  0: (yyval.tid) = TB_char    ; break;
        case  8: (yyval.tid) = TB_char8_t ; break;
        case 16: (yyval.tid) = TB_char16_t; break;
        case 32: (yyval.tid) = TB_char32_t; break;
        default:
          print_error( &(yylsp[0]), "bits must be one of 8, 16, or 32\n" );
          PARSE_ABORT();
      } // switch
    }
#line 12567 "parser.c"
    break;

  case 855: /* builtin_no_BitInt_english_btid: Y_decltype  */
#line 8380 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "decltype() declarations" );
    }
#line 12575 "parser.c"
    break;

  case 857: /* builtin_no_BitInt_english_btid: Y_wide char_exp  */
#line 8384 "parser.y"
                                  { (yyval.tid) = TB_wchar_t; }
#line 12581 "parser.c"
    break;

  case 860: /* builtin_no_BitInt_english_btid: Y_floating point_exp  */
#line 8387 "parser.y"
                                  { (yyval.tid) = TB_float; }
#line 12587 "parser.c"
    break;

  case 861: /* builtin_no_BitInt_english_btid: Y_double precision_opt  */
#line 8388 "parser.y"
                                  { (yyval.tid) = TB_double; }
#line 12593 "parser.c"
    break;

  case 864: /* BitInt_english_int: BitInt_english uint_lit bits_opt  */
#line 8395 "parser.y"
    {
      (yyval.uint_val) = (yyvsp[-1].uint_val);
    }
#line 12601 "parser.c"
    break;

  case 865: /* BitInt_english_int: BitInt_english '(' uint_lit_exp rparen_exp  */
#line 8399 "parser.y"
    {
      (yyval.uint_val) = (yyvsp[-1].uint_val);
    }
#line 12609 "parser.c"
    break;

  case 866: /* BitInt_english_int: BitInt_english Y_width uint_lit_exp bits_opt  */
#line 8403 "parser.y"
    {
      (yyval.uint_val) = (yyvsp[-1].uint_val);
    }
#line 12617 "parser.c"
    break;

  case 867: /* BitInt_english_int: BitInt_english error  */
#line 8407 "parser.y"
    {
      elaborate_error( "integer literal, '(', or \"width\" expected" );
    }
#line 12625 "parser.c"
    break;

  case 871: /* concept_type_english_ast: Y_concept sname_english_exp  */
#line 8420 "parser.y"
    {
      DUMP_START( "concept_type_english_ast", "CONCEPT sname_english_exp" );
      DUMP_SNAME( "sname_english_exp", (yyvsp[0].sname) );

      c_sname_set_all_types( &(yyvsp[0].sname) );

      (yyval.ast) = c_ast_new_gc( K_CONCEPT, &(yyloc) );
      (yyval.ast)->concept.concept_sname = c_sname_move( &(yyvsp[0].sname) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12642 "parser.c"
    break;

  case 872: /* concept_type_english_ast: Y_concept sname_english_exp Y_parameter pack_exp  */
#line 8434 "parser.y"
    {
      DUMP_START( "concept_type_english_ast",
                  "CONCEPT sname_english_exp PARAMTER PACK" );
      DUMP_SNAME( "sname_english_exp", (yyvsp[-2].sname) );

      c_sname_set_all_types( &(yyvsp[-2].sname) );

      (yyval.ast) = c_ast_new_gc( K_CONCEPT, &(yyloc) );
      (yyval.ast)->is_param_pack = true;
      (yyval.ast)->concept.concept_sname = c_sname_move( &(yyvsp[-2].sname) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12661 "parser.c"
    break;

  case 873: /* parameter_pack_english_ast: Y_parameter pack_exp  */
#line 8452 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->is_param_pack = true;
      (yyval.ast)->type.btids = TB_auto;         // for consistency with C++ case
    }
#line 12671 "parser.c"
    break;

  case 875: /* pack_exp: error  */
#line 8462 "parser.y"
    {
      keyword_expected( L_pack );
    }
#line 12679 "parser.c"
    break;

  case 878: /* class_struct_union_english_ast: class_struct_union_btid any_sname_c_exp  */
#line 8474 "parser.y"
    {
      DUMP_START( "class_struct_union_english_ast",
                  "class_struct_union_btid any_sname_c_exp" );
      DUMP_TID( "class_struct_union_btid", (yyvsp[-1].tid) );
      DUMP_SNAME( "any_sname_c_exp", (yyvsp[0].sname) );

      (yyval.ast) = c_ast_new_gc( K_CLASS_STRUCT_UNION, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[-1].tid), C_TPID_BASE );
      (yyval.ast)->csu.csu_sname = c_sname_move( &(yyvsp[0].sname) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12697 "parser.c"
    break;

  case 879: /* enum_english_ast: enum_btids any_sname_c_exp of_type_enum_fixed_type_english_ast_opt  */
#line 8492 "parser.y"
    {
      DUMP_START( "enum_english_ast",
                  "enum_btids any_sname_c_exp "
                  "of_type_enum_fixed_type_english_ast_opt" );
      DUMP_TID( "enum_btids", (yyvsp[-2].tid) );
      DUMP_SNAME( "any_sname_c_exp", (yyvsp[-1].sname) );
      DUMP_AST( "enum_fixed_type_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_ENUM, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[-2].tid), C_TPID_BASE );
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );
      (yyval.ast)->enum_.enum_sname = c_sname_move( &(yyvsp[-1].sname) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12718 "parser.c"
    break;

  case 880: /* of_type_enum_fixed_type_english_ast_opt: %empty  */
#line 8511 "parser.y"
                                        { (yyval.ast) = NULL; }
#line 12724 "parser.c"
    break;

  case 881: /* of_type_enum_fixed_type_english_ast_opt: Y_of type_opt enum_fixed_type_english_ast  */
#line 8513 "parser.y"
    {
      (yyval.ast) = (yyvsp[0].ast);
    }
#line 12732 "parser.c"
    break;

  case 882: /* enum_fixed_type_english_ast: enum_fixed_type_modifier_list_english_btid_opt enum_unmodified_fixed_type_english_ast  */
#line 8521 "parser.y"
    {
      DUMP_START( "enum_fixed_type_english_ast",
                  "enum_fixed_type_modifier_list_stid" );
      DUMP_TID( "enum_fixed_type_modifier_list_stid", (yyvsp[-1].tid) );
      DUMP_AST( "enum_unmodified_fixed_type_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[0].ast);
      if ( (yyvsp[-1].tid) != TB_NONE ) {        // See comment in type_english_ast.
        (yyval.ast)->loc = (yyloc);
        PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[-1].tid), &(yylsp[-1]) ) );
      }

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12752 "parser.c"
    break;

  case 883: /* enum_fixed_type_english_ast: enum_fixed_type_modifier_list_english_btid  */
#line 8538 "parser.y"
    {
      DUMP_START( "enum_fixed_type_english_ast",
                  "enum_fixed_type_modifier_list_english_btid" );
      DUMP_TID( "enum_fixed_type_modifier_list_english_btid", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[0].tid), C_TPID_BASE );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12768 "parser.c"
    break;

  case 884: /* enum_fixed_type_modifier_list_english_btid_opt: %empty  */
#line 8552 "parser.y"
                                  { (yyval.tid) = TB_NONE; }
#line 12774 "parser.c"
    break;

  case 886: /* enum_fixed_type_modifier_list_english_btid: enum_fixed_type_modifier_list_english_btid enum_fixed_type_modifier_btid  */
#line 8559 "parser.y"
    {
      DUMP_START( "enum_fixed_type_modifier_list_english_btid",
                  "enum_fixed_type_modifier_list_english_btid "
                  "enum_fixed_type_modifier_btid" );
      DUMP_TID( "enum_fixed_type_modifier_list_english_btid", (yyvsp[-1].tid) );
      DUMP_TID( "enum_fixed_type_modifier_btid", (yyvsp[0].tid) );

      (yyval.tid) = (yyvsp[-1].tid);
      PARSE_ASSERT( c_tid_add( &(yyval.tid), (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_TID( "$$_btids", (yyval.tid) );
      DUMP_END();
    }
#line 12792 "parser.c"
    break;

  case 891: /* any_name: Y_TYPEDEF_NAME_TDEF  */
#line 8588 "parser.y"
    {
      assert( c_sname_count( &(yyvsp[0].tdef)->ast->sname ) == 1 );
      (yyval.name) = check_strdup( c_sname_local_name( &(yyvsp[0].tdef)->ast->sname ) );
    }
#line 12801 "parser.c"
    break;

  case 893: /* any_name_exp: error  */
#line 8597 "parser.y"
    {
      (yyval.name) = NULL;
      elaborate_error( "name expected" );
    }
#line 12810 "parser.c"
    break;

  case 897: /* any_sname_c_exp: error  */
#line 8611 "parser.y"
    {
      c_sname_init( &(yyval.sname) );
      elaborate_error( "name expected" );
    }
#line 12819 "parser.c"
    break;

  case 898: /* any_sname_c_opt: %empty  */
#line 8618 "parser.y"
                                  { c_sname_init( &(yyval.sname) ); }
#line 12825 "parser.c"
    break;

  case 902: /* name_ast: Y_NAME  */
#line 8629 "parser.y"
    {
      DUMP_START( "name_ast", "NAME" );
      DUMP_STR( "NAME", (yyvsp[0].name) );

      (yyval.ast) = c_ast_new_gc( K_NAME, &(yyloc) );
      c_sname_init_name( &(yyval.ast)->sname, (yyvsp[0].name) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12840 "parser.c"
    break;

  case 904: /* name_exp: error  */
#line 8644 "parser.y"
    {
      (yyval.name) = NULL;
      elaborate_error( "name expected" );
    }
#line 12849 "parser.c"
    break;

  case 905: /* name_cat: name_cat Y_NAME  */
#line 8652 "parser.y"
    {
      (yyval.name) = str_realloc_cat( (yyvsp[-1].name), " ", (yyvsp[0].name) );
      free( (yyvsp[0].name) );
    }
#line 12858 "parser.c"
    break;

  case 907: /* name_opt: %empty  */
#line 8660 "parser.y"
                                  { (yyval.name) = NULL; }
#line 12864 "parser.c"
    break;

  case 909: /* oper_sname_c_opt: %empty  */
#line 8665 "parser.y"
                                  { c_sname_init( &(yyval.sname) ); }
#line 12870 "parser.c"
    break;

  case 910: /* oper_sname_c_opt: Y_OPERATOR_SNAME Y_COLON_COLON  */
#line 8668 "parser.y"
    {
      (yyval.sname) = (yyvsp[-1].sname);
      if ( c_type_is_none( c_sname_local_type( &(yyval.sname) ) ) )
        c_sname_local_data( &(yyval.sname) )->type = C_TYPE_LIT_B( TB_SCOPE );
    }
#line 12880 "parser.c"
    break;

  case 911: /* sname_c: sname_c Y_COLON_COLON Y_NAME  */
#line 8677 "parser.y"
    {
      // see the comment in "of_scope_english"
      if ( !IS_SUPPORTED( SCOPED_NAMES ) ) {
        print_error( &(yylsp[-1]),
          "scoped names not supported%s\n",
          C_LANG_WHICH( SCOPED_NAMES )
        );
        c_sname_cleanup( &(yyvsp[-2].sname) );
        free( (yyvsp[0].name) );
        PARSE_ABORT();
      }

      DUMP_START( "sname_c", "sname_c '::' NAME" );
      DUMP_SNAME( "sname_c", (yyvsp[-2].sname) );
      DUMP_STR( "name", (yyvsp[0].name) );

      (yyval.sname) = (yyvsp[-2].sname);
      c_sname_local_data( &(yyval.sname) )->type = C_TYPE_LIT_B( TB_SCOPE );
      c_sname_append_name( &(yyval.sname), (yyvsp[0].name) );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 12908 "parser.c"
    break;

  case 912: /* sname_c: sname_c Y_COLON_COLON any_typedef_tdef  */
#line 8702 "parser.y"
    { //
      // This is for a case like:
      //
      //      define S::int8_t as char
      //
      // that is: the type int8_t is an existing type in no scope being defined
      // as a distinct type in a new scope.
      //
      DUMP_START( "sname_c", "sname_c '::' any_typedef_tdef" );
      DUMP_SNAME( "sname_c", (yyvsp[-2].sname) );
      DUMP_AST( "any_typedef__ast", (yyvsp[0].tdef)->ast );

      (yyval.sname) = (yyvsp[-2].sname);
      c_sname_local_data( &(yyval.sname) )->type = C_TYPE_LIT_B( TB_SCOPE );
      c_sname_t temp_sname = c_sname_dup( &(yyvsp[0].tdef)->ast->sname );
      c_sname_append_sname( &(yyval.sname), &temp_sname );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 12933 "parser.c"
    break;

  case 913: /* sname_c: Y_NAME  */
#line 8724 "parser.y"
    {
      DUMP_START( "sname_c", "NAME" );
      DUMP_STR( "NAME", (yyvsp[0].name) );

      c_sname_init_name( &(yyval.sname), (yyvsp[0].name) );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 12947 "parser.c"
    break;

  case 914: /* sname_c_ast: sname_c bit_field_c_uint_opt  */
#line 8738 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "sname_c_ast", "sname_c" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_SNAME( "sname_c", (yyvsp[-1].sname) );
      DUMP_INT( "bit_field_c_uint_opt", (yyvsp[0].uint_val) );

      (yyval.ast) = ia_type_spec_ast( type_ast );
      c_sname_set( &(yyval.ast)->sname, &(yyvsp[-1].sname) );
      PARSE_ASSERT( c_ast_set_bit_field_width( (yyval.ast), (yyvsp[0].uint_val) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12967 "parser.c"
    break;

  case 915: /* bit_field_c_uint_opt: %empty  */
#line 8756 "parser.y"
                                  { (yyval.uint_val) = 0; }
#line 12973 "parser.c"
    break;

  case 916: /* bit_field_c_uint_opt: ':' uint_lit_exp  */
#line 8758 "parser.y"
    { //
      // This check has to be done now in the parser rather than later in the
      // AST since we use 0 to mean "no bit-field."
      //
      if ( (yyvsp[0].uint_val) == 0 ) {
        print_error( &(yylsp[0]), "bit-field width must be > 0\n" );
        PARSE_ABORT();
      }
      (yyval.uint_val) = (yyvsp[0].uint_val);
    }
#line 12988 "parser.c"
    break;

  case 918: /* sname_c_exp: error  */
#line 8773 "parser.y"
    {
      c_sname_init( &(yyval.sname) );
      elaborate_error( "name expected" );
    }
#line 12997 "parser.c"
    break;

  case 919: /* sname_c_opt: %empty  */
#line 8780 "parser.y"
                                  { c_sname_init( &(yyval.sname) ); }
#line 13003 "parser.c"
    break;

  case 921: /* sname_english: any_sname_c of_scope_list_english_opt  */
#line 8786 "parser.y"
    {
      DUMP_START( "sname_english", "any_sname_c of_scope_list_english_opt" );
      DUMP_SNAME( "any_sname_c", (yyvsp[-1].sname) );
      DUMP_SNAME( "of_scope_list_english_opt", (yyvsp[0].sname) );

      c_type_t const *local_type = c_sname_local_type( &(yyvsp[0].sname) );
      if ( c_type_is_none( local_type ) )
        local_type = c_sname_local_type( &(yyvsp[-1].sname) );
      (yyval.sname) = (yyvsp[0].sname);
      c_sname_append_sname( &(yyval.sname), &(yyvsp[-1].sname) );
      c_sname_local_data( &(yyval.sname) )->type = *local_type;

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 13023 "parser.c"
    break;

  case 922: /* sname_english_ast: Y_NAME of_scope_list_english_opt  */
#line 8805 "parser.y"
    {
      DUMP_START( "sname_english_ast", "NAME of_scope_list_english_opt" );
      DUMP_STR( "NAME", (yyvsp[-1].name) );
      DUMP_SNAME( "of_scope_list_english_opt", (yyvsp[0].sname) );

      c_sname_t sname = c_sname_move( &(yyvsp[0].sname) );
      c_sname_append_name( &sname, (yyvsp[-1].name) );

      c_typedef_t const *const tdef = c_typedef_find_sname( &sname );
      if ( tdef != NULL ) {
        //
        // The sname is the name of a typedef'd type: create a new K_TYPEDEF
        // node and point it at the typedef's AST.
        //
        (yyval.ast) = c_ast_new_gc( K_TYPEDEF, &(yyloc) );
        (yyval.ast)->type.btids = TB_typedef;
        (yyval.ast)->tdef.for_ast = tdef->ast;
        c_sname_cleanup( &sname );
      }
      else {
        (yyval.ast) = c_ast_new_gc( K_NAME, &(yyloc) );
        (yyval.ast)->sname = sname;
        //
        // Set the c_name_ast's sname also in case it's used as a type name.
        //
        c_sname_t temp_sname = c_sname_dup( &(yyval.ast)->sname );
        c_sname_set( &(yyval.ast)->name.sname, &temp_sname );
      }

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 13060 "parser.c"
    break;

  case 924: /* sname_english_exp: error  */
#line 8842 "parser.y"
    {
      c_sname_init( &(yyval.sname) );
      elaborate_error( "name expected" );
    }
#line 13069 "parser.c"
    break;

  case 925: /* sname_english_opt: %empty  */
#line 8849 "parser.y"
                                  { c_sname_init( &(yyval.sname) ); }
#line 13075 "parser.c"
    break;

  case 927: /* sname_list_c: sname_list_c ',' sname_c  */
#line 8855 "parser.y"
    {
      DUMP_START( "sname_list_c",
                  "sname_list_c ',' sname_c" );
      DUMP_SNAME_LIST( "sname_list_c", (yyvsp[-2].sname_list) );
      DUMP_SNAME( "sname_c", (yyvsp[0].sname) );

      (yyval.sname_list) = (yyvsp[-2].sname_list);
      c_sname_t *const temp_sname = MALLOC( c_sname_t, 1 );
      *temp_sname = c_sname_move( &(yyvsp[0].sname) );
      slist_push_back( &(yyval.sname_list), temp_sname );

      DUMP_SNAME_LIST( "$$_sname_list", (yyval.sname_list) );
      DUMP_END();
    }
#line 13094 "parser.c"
    break;

  case 928: /* sname_list_c: sname_c  */
#line 8870 "parser.y"
    {
      DUMP_START( "sname_list_c", "sname_c" );
      DUMP_SNAME( "sname_c", (yyvsp[0].sname) );

      c_sname_t *const temp_sname = MALLOC( c_sname_t, 1 );
      *temp_sname = c_sname_move( &(yyvsp[0].sname) );
      slist_init( &(yyval.sname_list) );
      slist_push_back( &(yyval.sname_list), temp_sname );

      DUMP_SNAME_LIST( "$$_sname_list", (yyval.sname_list) );
      DUMP_END();
    }
#line 13111 "parser.c"
    break;

  case 929: /* sname_list_english: sname_list_english ',' sname_english_exp  */
#line 8886 "parser.y"
    {
      DUMP_START( "sname_list_english",
                  "sname_list_english ',' sname_english" );
      DUMP_SNAME_LIST( "sname_list_english", (yyvsp[-2].sname_list) );
      DUMP_SNAME( "sname_english_exp", (yyvsp[0].sname) );

      (yyval.sname_list) = (yyvsp[-2].sname_list);
      c_sname_t *const temp_sname = MALLOC( c_sname_t, 1 );
      *temp_sname = c_sname_move( &(yyvsp[0].sname) );
      slist_push_back( &(yyval.sname_list), temp_sname );

      DUMP_SNAME_LIST( "$$_sname_list", (yyval.sname_list) );
      DUMP_END();
    }
#line 13130 "parser.c"
    break;

  case 930: /* sname_list_english: sname_english  */
#line 8902 "parser.y"
    {
      DUMP_START( "sname_list_english", "sname_english" );
      DUMP_SNAME( "sname_english", (yyvsp[0].sname) );

      c_sname_t *const temp_sname = MALLOC( c_sname_t, 1 );
      *temp_sname = c_sname_move( &(yyvsp[0].sname) );
      slist_init( &(yyval.sname_list) );
      slist_push_back( &(yyval.sname_list), temp_sname );

      DUMP_SNAME_LIST( "$$_sname_list", (yyval.sname_list) );
      DUMP_END();
    }
#line 13147 "parser.c"
    break;

  case 931: /* typedef_sname_c: typedef_sname_c Y_COLON_COLON sname_c  */
#line 8918 "parser.y"
    {
      DUMP_START( "typedef_sname_c", "typedef_sname_c '::' sname_c" );
      DUMP_SNAME( "typedef_sname_c", (yyvsp[-2].sname) );
      DUMP_SNAME( "sname_c", (yyvsp[0].sname) );

      //
      // This is for a case like:
      //
      //      define S as struct S
      //      define S::T as struct T
      //
      (yyval.sname) = c_sname_move( &(yyvsp[-2].sname) );
      c_sname_append_sname( &(yyval.sname), &(yyvsp[0].sname) );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 13169 "parser.c"
    break;

  case 932: /* typedef_sname_c: typedef_sname_c Y_COLON_COLON any_typedef_tdef  */
#line 8937 "parser.y"
    {
      DUMP_START( "typedef_sname_c", "typedef_sname_c '::' any_typedef_tdef" );
      DUMP_SNAME( "typedef_sname_c", (yyvsp[-2].sname) );
      DUMP_AST( "any_typedef__ast", (yyvsp[0].tdef)->ast );

      //
      // This is for a case like:
      //
      //      define S as struct S
      //      define T as struct T
      //      define S::T as struct S_T
      //
      (yyval.sname) = c_sname_move( &(yyvsp[-2].sname) );
      c_sname_local_data( &(yyval.sname) )->type =
        *c_sname_local_type( &(yyvsp[0].tdef)->ast->sname );
      c_sname_t temp_sname = c_sname_dup( &(yyvsp[0].tdef)->ast->sname );
      c_sname_append_sname( &(yyval.sname), &temp_sname );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 13195 "parser.c"
    break;

  case 933: /* typedef_sname_c: any_typedef_tdef  */
#line 8959 "parser.y"
                                  { (yyval.sname) = c_sname_dup( &(yyvsp[0].tdef)->ast->sname ); }
#line 13201 "parser.c"
    break;

  case 935: /* address_exp: error  */
#line 8969 "parser.y"
    {
      keyword_expected( L_address );
    }
#line 13209 "parser.c"
    break;

  case 937: /* array_exp: error  */
#line 8977 "parser.y"
    {
      keyword_expected( L_array );
    }
#line 13217 "parser.c"
    break;

  case 938: /* as_exp: Y_as  */
#line 8984 "parser.y"
    {
      if ( OPT_LANG_IS( MEMBER_FUNCTIONS ) ) {
        //
        // For either "declare" or "define", neither "override" nor "final"
        // must be matched initially to allow for cases like:
        //
        //      c++decl> declare final as int
        //      int final;
        //
        // (which is legal).  However, in C++, after parsing "as", the keyword
        // context has to be set to C_KW_CTX_MBR_FUNC to be able to match
        // "override" and "final", e.g.:
        //
        //      c++decl> declare f as final function
        //      void f() final;
        //
        lexer_keyword_ctx = C_KW_CTX_MBR_FUNC;
      }
    }
#line 13241 "parser.c"
    break;

  case 939: /* as_exp: error  */
#line 9004 "parser.y"
    {
      keyword_expected( L_as );
    }
#line 13249 "parser.c"
    break;

  case 943: /* as_into_to_exp: error  */
#line 9014 "parser.y"
    {
      elaborate_error( "\"as\", \"into\", or \"to\" expected" );
    }
#line 13257 "parser.c"
    break;

  case 948: /* auto_TYPE_exp: error  */
#line 9028 "parser.y"
    {
      keyword_expected( L_auto );
    }
#line 13265 "parser.c"
    break;

  case 950: /* binding_exp: error  */
#line 9036 "parser.y"
    {
      keyword_expected( L_binding );
    }
#line 13273 "parser.c"
    break;

  case 957: /* cast_exp: error  */
#line 9055 "parser.y"
    {
      keyword_expected( L_cast );
    }
#line 13281 "parser.c"
    break;

  case 959: /* char_exp: error  */
#line 9063 "parser.y"
    {
      keyword_expected( L_char );
    }
#line 13289 "parser.c"
    break;

  case 961: /* class_struct_union_btid_exp: error  */
#line 9071 "parser.y"
    {
      elaborate_error( "\"class\", \"struct\", or \"union\" expected" );
    }
#line 13297 "parser.c"
    break;

  case 963: /* colon_exp: error  */
#line 9079 "parser.y"
    {
      punct_expected( ':' );
    }
#line 13305 "parser.c"
    break;

  case 965: /* comma_exp: error  */
#line 9087 "parser.y"
    {
      punct_expected( ',' );
    }
#line 13313 "parser.c"
    break;

  case 967: /* conversion_exp: error  */
#line 9095 "parser.y"
    {
      keyword_expected( L_conversion );
    }
#line 13321 "parser.c"
    break;

  case 968: /* c_operator: Y_co_await  */
#line 9101 "parser.y"
                                  { (yyval.op_id) = C_OP_CO_AWAIT              ; }
#line 13327 "parser.c"
    break;

  case 969: /* c_operator: Y_new  */
#line 9102 "parser.y"
                                  { (yyval.op_id) = C_OP_NEW                   ; }
#line 13333 "parser.c"
    break;

  case 970: /* c_operator: Y_new '[' rbracket_exp  */
#line 9103 "parser.y"
                                  { (yyval.op_id) = C_OP_NEW_ARRAY             ; }
#line 13339 "parser.c"
    break;

  case 971: /* c_operator: Y_delete  */
#line 9104 "parser.y"
                                  { (yyval.op_id) = C_OP_DELETE                ; }
#line 13345 "parser.c"
    break;

  case 972: /* c_operator: Y_delete '[' rbracket_exp  */
#line 9105 "parser.y"
                                  { (yyval.op_id) = C_OP_DELETE_ARRAY          ; }
#line 13351 "parser.c"
    break;

  case 973: /* c_operator: '!'  */
#line 9106 "parser.y"
                                  { (yyval.op_id) = C_OP_EXCLAMATION           ; }
#line 13357 "parser.c"
    break;

  case 974: /* c_operator: Y_EXCLAM_EQUAL  */
#line 9107 "parser.y"
                                  { (yyval.op_id) = C_OP_EXCLAMATION_EQUAL     ; }
#line 13363 "parser.c"
    break;

  case 975: /* c_operator: '%'  */
#line 9108 "parser.y"
                                  { (yyval.op_id) = C_OP_PERCENT               ; }
#line 13369 "parser.c"
    break;

  case 976: /* c_operator: Y_PERCENT_EQUAL  */
#line 9109 "parser.y"
                                  { (yyval.op_id) = C_OP_PERCENT_EQUAL         ; }
#line 13375 "parser.c"
    break;

  case 977: /* c_operator: '&'  */
#line 9110 "parser.y"
                                  { (yyval.op_id) = C_OP_AMPERSAND             ; }
#line 13381 "parser.c"
    break;

  case 978: /* c_operator: Y_AMPER_AMPER  */
#line 9111 "parser.y"
                                  { (yyval.op_id) = C_OP_AMPERSAND_AMPERSAND   ; }
#line 13387 "parser.c"
    break;

  case 979: /* c_operator: Y_AMPER_EQUAL  */
#line 9112 "parser.y"
                                  { (yyval.op_id) = C_OP_AMPER_EQUAL           ; }
#line 13393 "parser.c"
    break;

  case 980: /* c_operator: '(' rparen_exp  */
#line 9113 "parser.y"
                                  { (yyval.op_id) = C_OP_PARENTHESES           ; }
#line 13399 "parser.c"
    break;

  case 981: /* c_operator: '*'  */
#line 9114 "parser.y"
                                  { (yyval.op_id) = C_OP_STAR                  ; }
#line 13405 "parser.c"
    break;

  case 982: /* c_operator: Y_STAR_EQUAL  */
#line 9115 "parser.y"
                                  { (yyval.op_id) = C_OP_STAR_EQUAL            ; }
#line 13411 "parser.c"
    break;

  case 983: /* c_operator: '+'  */
#line 9116 "parser.y"
                                  { (yyval.op_id) = C_OP_PLUS                  ; }
#line 13417 "parser.c"
    break;

  case 984: /* c_operator: "++"  */
#line 9117 "parser.y"
                                  { (yyval.op_id) = C_OP_PLUS_PLUS             ; }
#line 13423 "parser.c"
    break;

  case 985: /* c_operator: Y_PLUS_EQUAL  */
#line 9118 "parser.y"
                                  { (yyval.op_id) = C_OP_PLUS_EQUAL            ; }
#line 13429 "parser.c"
    break;

  case 986: /* c_operator: ','  */
#line 9119 "parser.y"
                                  { (yyval.op_id) = C_OP_COMMA                 ; }
#line 13435 "parser.c"
    break;

  case 987: /* c_operator: '-'  */
#line 9120 "parser.y"
                                  { (yyval.op_id) = C_OP_MINUS                 ; }
#line 13441 "parser.c"
    break;

  case 988: /* c_operator: "--"  */
#line 9121 "parser.y"
                                  { (yyval.op_id) = C_OP_MINUS_MINUS           ; }
#line 13447 "parser.c"
    break;

  case 989: /* c_operator: Y_MINUS_EQUAL  */
#line 9122 "parser.y"
                                  { (yyval.op_id) = C_OP_MINUS_EQUAL           ; }
#line 13453 "parser.c"
    break;

  case 990: /* c_operator: Y_MINUS_GREATER  */
#line 9123 "parser.y"
                                  { (yyval.op_id) = C_OP_MINUS_GREATER         ; }
#line 13459 "parser.c"
    break;

  case 991: /* c_operator: Y_MINUS_GREATER_STAR  */
#line 9124 "parser.y"
                                  { (yyval.op_id) = C_OP_MINUS_GREATER_STAR    ; }
#line 13465 "parser.c"
    break;

  case 992: /* c_operator: '.'  */
#line 9125 "parser.y"
                                  { (yyval.op_id) = C_OP_DOT                   ; }
#line 13471 "parser.c"
    break;

  case 993: /* c_operator: Y_DOT_STAR  */
#line 9126 "parser.y"
                                  { (yyval.op_id) = C_OP_DOT_STAR              ; }
#line 13477 "parser.c"
    break;

  case 994: /* c_operator: '/'  */
#line 9127 "parser.y"
                                  { (yyval.op_id) = C_OP_SLASH                 ; }
#line 13483 "parser.c"
    break;

  case 995: /* c_operator: Y_SLASH_EQUAL  */
#line 9128 "parser.y"
                                  { (yyval.op_id) = C_OP_SLASH_EQUAL           ; }
#line 13489 "parser.c"
    break;

  case 996: /* c_operator: Y_COLON_COLON  */
#line 9129 "parser.y"
                                  { (yyval.op_id) = C_OP_COLON_COLON           ; }
#line 13495 "parser.c"
    break;

  case 997: /* c_operator: '<'  */
#line 9130 "parser.y"
                                  { (yyval.op_id) = C_OP_LESS                  ; }
#line 13501 "parser.c"
    break;

  case 998: /* c_operator: Y_LESS_LESS  */
#line 9131 "parser.y"
                                  { (yyval.op_id) = C_OP_LESS_LESS             ; }
#line 13507 "parser.c"
    break;

  case 999: /* c_operator: Y_LESS_LESS_EQUAL  */
#line 9132 "parser.y"
                                  { (yyval.op_id) = C_OP_LESS_LESS_EQUAL       ; }
#line 13513 "parser.c"
    break;

  case 1000: /* c_operator: Y_LESS_EQUAL  */
#line 9133 "parser.y"
                                  { (yyval.op_id) = C_OP_LESS_EQUAL            ; }
#line 13519 "parser.c"
    break;

  case 1001: /* c_operator: Y_LESS_EQUAL_GREATER  */
#line 9134 "parser.y"
                                  { (yyval.op_id) = C_OP_LESS_EQUAL_GREATER    ; }
#line 13525 "parser.c"
    break;

  case 1002: /* c_operator: '='  */
#line 9135 "parser.y"
                                  { (yyval.op_id) = C_OP_EQUAL                 ; }
#line 13531 "parser.c"
    break;

  case 1003: /* c_operator: Y_EQUAL_EQUAL  */
#line 9136 "parser.y"
                                  { (yyval.op_id) = C_OP_EQUAL_EQUAL           ; }
#line 13537 "parser.c"
    break;

  case 1004: /* c_operator: '>'  */
#line 9137 "parser.y"
                                  { (yyval.op_id) = C_OP_GREATER               ; }
#line 13543 "parser.c"
    break;

  case 1005: /* c_operator: Y_GREATER_GREATER  */
#line 9138 "parser.y"
                                  { (yyval.op_id) = C_OP_GREATER_GREATER       ; }
#line 13549 "parser.c"
    break;

  case 1006: /* c_operator: Y_GREATER_GREATER_EQUAL  */
#line 9139 "parser.y"
                                  { (yyval.op_id) = C_OP_GREATER_GREATER_EQUAL ; }
#line 13555 "parser.c"
    break;

  case 1007: /* c_operator: Y_GREATER_EQUAL  */
#line 9140 "parser.y"
                                  { (yyval.op_id) = C_OP_GREATER_EQUAL         ; }
#line 13561 "parser.c"
    break;

  case 1008: /* c_operator: Y_QMARK_COLON  */
#line 9141 "parser.y"
                                  { (yyval.op_id) = C_OP_QUESTION_MARK_COLON   ; }
#line 13567 "parser.c"
    break;

  case 1009: /* c_operator: '[' rbracket_exp  */
#line 9142 "parser.y"
                                  { (yyval.op_id) = C_OP_BRACKETS              ; }
#line 13573 "parser.c"
    break;

  case 1010: /* c_operator: '^'  */
#line 9143 "parser.y"
                                  { (yyval.op_id) = C_OP_CARET                 ; }
#line 13579 "parser.c"
    break;

  case 1011: /* c_operator: Y_CARET_EQUAL  */
#line 9144 "parser.y"
                                  { (yyval.op_id) = C_OP_CARET_EQUAL           ; }
#line 13585 "parser.c"
    break;

  case 1012: /* c_operator: '|'  */
#line 9145 "parser.y"
                                  { (yyval.op_id) = C_OP_PIPE                  ; }
#line 13591 "parser.c"
    break;

  case 1013: /* c_operator: Y_PIPE_PIPE  */
#line 9146 "parser.y"
                                  { (yyval.op_id) = C_OP_PIPE_PIPE             ; }
#line 13597 "parser.c"
    break;

  case 1014: /* c_operator: Y_PIPE_EQUAL  */
#line 9147 "parser.y"
                                  { (yyval.op_id) = C_OP_PIPE_EQUAL            ; }
#line 13603 "parser.c"
    break;

  case 1015: /* c_operator: '~'  */
#line 9148 "parser.y"
                                  { (yyval.op_id) = C_OP_TILDE                 ; }
#line 13609 "parser.c"
    break;

  case 1017: /* default_exp: error  */
#line 9154 "parser.y"
    {
      keyword_expected( L_default );
    }
#line 13617 "parser.c"
    break;

  case 1019: /* defined_exp: error  */
#line 9162 "parser.y"
    {
      keyword_expected( L_defined );
    }
#line 13625 "parser.c"
    break;

  case 1021: /* dependency_exp: error  */
#line 9170 "parser.y"
    {
      keyword_expected( L_dependency );
    }
#line 13633 "parser.c"
    break;

  case 1023: /* destructor_sname: Y_LEXER_ERROR  */
#line 9178 "parser.y"
    {
      c_sname_init( &(yyval.sname) );
      PARSE_ABORT();
    }
#line 13642 "parser.c"
    break;

  case 1024: /* empty_str_lit_exp: str_lit_exp  */
#line 9186 "parser.y"
    { //
      // This check is done now in the parser rather than later in the AST so
      // we don't have to keep the string literal around.
      //
      bool const is_empty = (yyvsp[0].str_val) == NULL || (yyvsp[0].str_val)[0] == '\0';
      free( (yyvsp[0].str_val) );
      if ( !is_empty ) {
        print_error( &(yylsp[0]), "empty string literal expected\n" );
        PARSE_ABORT();
      }
    }
#line 13658 "parser.c"
    break;

  case 1026: /* equals_exp: error  */
#line 9202 "parser.y"
    {
      punct_expected( '=' );
    }
#line 13666 "parser.c"
    break;

  case 1027: /* extern_linkage_c_stid: Y_extern linkage_stid  */
#line 9208 "parser.y"
                                  { (yyval.tid) = (yyvsp[0].tid); }
#line 13672 "parser.c"
    break;

  case 1028: /* extern_linkage_c_stid: Y_extern linkage_stid '{'  */
#line 9210 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "scoped linkage declarations" );
    }
#line 13680 "parser.c"
    break;

  case 1029: /* extern_linkage_c_stid_opt: %empty  */
#line 9216 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 13686 "parser.c"
    break;

  case 1031: /* glob: Y_GLOB  */
#line 9222 "parser.y"
    {
      if ( !OPT_LANG_IS( SCOPED_NAMES ) && strchr( (yyvsp[0].name), ':' ) != NULL ) {
        print_error( &(yylsp[0]),
          "scoped names not supported%s\n",
          C_LANG_WHICH( SCOPED_NAMES )
        );
        free( (yyvsp[0].name) );
        PARSE_ABORT();
      }
      (yyval.name) = (yyvsp[0].name);
    }
#line 13702 "parser.c"
    break;

  case 1032: /* glob_opt: %empty  */
#line 9236 "parser.y"
                                  { (yyval.name) = NULL; }
#line 13708 "parser.c"
    break;

  case 1035: /* gt_exp: error  */
#line 9243 "parser.y"
    {
      punct_expected( '>' );
    }
#line 13716 "parser.c"
    break;

  case 1036: /* inline_stid_opt: %empty  */
#line 9249 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 13722 "parser.c"
    break;

  case 1039: /* int_exp: error  */
#line 9256 "parser.y"
    {
      elaborate_error( "\"int[eger]\" expected" );
    }
#line 13730 "parser.c"
    break;

  case 1041: /* lbracket_exp: error  */
#line 9264 "parser.y"
    {
      punct_expected( '[' );
    }
#line 13738 "parser.c"
    break;

  case 1043: /* literal_exp: error  */
#line 9272 "parser.y"
    {
      keyword_expected( L_literal );
    }
#line 13746 "parser.c"
    break;

  case 1045: /* local_exp: error  */
#line 9280 "parser.y"
    {
      keyword_expected( L_local );
    }
#line 13754 "parser.c"
    break;

  case 1047: /* lparen_exp: error  */
#line 9288 "parser.y"
    {
      punct_expected( '(' );
    }
#line 13762 "parser.c"
    break;

  case 1049: /* lt_exp: error  */
#line 9296 "parser.y"
    {
      punct_expected( '<' );
    }
#line 13770 "parser.c"
    break;

  case 1050: /* member_or_non_member_opt: %empty  */
#line 9302 "parser.y"
                                  { (yyval.member) = C_FUNC_UNSPECIFIED; }
#line 13776 "parser.c"
    break;

  case 1051: /* member_or_non_member_opt: Y_member  */
#line 9303 "parser.y"
                                  { (yyval.member) = C_FUNC_MEMBER     ; }
#line 13782 "parser.c"
    break;

  case 1052: /* member_or_non_member_opt: Y_non_member  */
#line 9304 "parser.y"
                                  { (yyval.member) = C_FUNC_NON_MEMBER ; }
#line 13788 "parser.c"
    break;

  case 1054: /* namespace_btid_exp: error  */
#line 9310 "parser.y"
    {
      keyword_expected( L_namespace );
    }
#line 13796 "parser.c"
    break;

  case 1055: /* namespace_type: Y_namespace  */
#line 9316 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 13802 "parser.c"
    break;

  case 1056: /* namespace_type: Y_inline namespace_btid_exp  */
#line 9317 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT( (yyvsp[0].tid), (yyvsp[-1].tid), TA_NONE ); }
#line 13808 "parser.c"
    break;

  case 1058: /* of_exp: error  */
#line 9323 "parser.y"
    {
      keyword_expected( L_of );
    }
#line 13816 "parser.c"
    break;

  case 1059: /* of_scope_english: Y_of scope_english_type_exp any_sname_c_exp  */
#line 9330 "parser.y"
    { //
      // Scoped names are supported only in C++.  (However, we always allow
      // them in configuration files.)
      //
      // This check is better to do now in the parser rather than later in the
      // AST because it has to be done in fewer places in the code plus gives a
      // better error location.
      //
      if ( !IS_SUPPORTED( SCOPED_NAMES ) ) {
        print_error( &(yylsp[-1]),
          "scoped names not supported%s\n",
          C_LANG_WHICH( SCOPED_NAMES )
        );
        c_sname_cleanup( &(yyvsp[0].sname) );
        PARSE_ABORT();
      }
      (yyval.sname) = c_sname_move( &(yyvsp[0].sname) );
      c_sname_local_data( &(yyval.sname) )->type = (yyvsp[-1].type);
    }
#line 13840 "parser.c"
    break;

  case 1060: /* of_scope_list_english: of_scope_list_english of_scope_english  */
#line 9353 "parser.y"
    {
      // "of scope X of scope Y" means Y::X
      (yyval.sname) = c_sname_move( &(yyvsp[0].sname) );
      c_sname_append_sname( &(yyval.sname), &(yyvsp[-1].sname) );
      c_sname_set_all_types( &(yyval.sname) );
      if ( !c_sname_check( &(yyval.sname), &(yylsp[-1]) ) ) {
        c_sname_cleanup( &(yyval.sname) );
        PARSE_ABORT();
      }
    }
#line 13855 "parser.c"
    break;

  case 1062: /* of_scope_list_english_opt: %empty  */
#line 9367 "parser.y"
                                  { c_sname_init( &(yyval.sname) ); }
#line 13861 "parser.c"
    break;

  case 1065: /* operator_exp: error  */
#line 9374 "parser.y"
    {
      keyword_expected( L_operator );
    }
#line 13869 "parser.c"
    break;

  case 1069: /* point_exp: error  */
#line 9387 "parser.y"
    {
      keyword_expected( L_point );
    }
#line 13877 "parser.c"
    break;

  case 1073: /* rbrace_exp: error  */
#line 9399 "parser.y"
    {
      punct_expected( '}' );
    }
#line 13885 "parser.c"
    break;

  case 1075: /* rbracket_exp: error  */
#line 9407 "parser.y"
    {
      punct_expected( ']' );
    }
#line 13893 "parser.c"
    break;

  case 1076: /* ref_qualifier_c_stid_opt: %empty  */
#line 9413 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 13899 "parser.c"
    break;

  case 1077: /* ref_qualifier_c_stid_opt: '&'  */
#line 9414 "parser.y"
                                  { (yyval.tid) = TS_REFERENCE; }
#line 13905 "parser.c"
    break;

  case 1078: /* ref_qualifier_c_stid_opt: Y_AMPER_AMPER  */
#line 9415 "parser.y"
                                  { (yyval.tid) = TS_RVALUE_REFERENCE; }
#line 13911 "parser.c"
    break;

  case 1080: /* reference_exp: error  */
#line 9421 "parser.y"
    {
      keyword_expected( L_reference );
    }
#line 13919 "parser.c"
    break;

  case 1084: /* returning_exp: error  */
#line 9434 "parser.y"
    {
      keyword_expected( L_returning );
    }
#line 13927 "parser.c"
    break;

  case 1086: /* rparen_exp: error  */
#line 9442 "parser.y"
    {
      punct_expected( ')' );
    }
#line 13935 "parser.c"
    break;

  case 1087: /* scope_english_type: class_struct_union_btid  */
#line 9448 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 13941 "parser.c"
    break;

  case 1089: /* scope_english_type: Y_scope  */
#line 9450 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( TB_SCOPE ); }
#line 13947 "parser.c"
    break;

  case 1091: /* scope_english_type_exp: error  */
#line 9456 "parser.y"
    {
      elaborate_error(
        "\"class\", \"namespace\", \"scope\", \"struct\", or \"union\" expected"
      );
    }
#line 13957 "parser.c"
    break;

  case 1093: /* semi_exp: error  */
#line 9466 "parser.y"
    {
      punct_expected( ';' );
    }
#line 13965 "parser.c"
    break;

  case 1098: /* static_stid_opt: %empty  */
#line 9482 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 13971 "parser.c"
    break;

  case 1099: /* static_stid_opt: Y_static  */
#line 9483 "parser.y"
                                  { (yyval.tid) = TS_NON_EMPTY_ARRAY; }
#line 13977 "parser.c"
    break;

  case 1101: /* str_lit: Y_LEXER_ERROR  */
#line 9489 "parser.y"
    {
      (yyval.str_val) = NULL;
      PARSE_ABORT();
    }
#line 13986 "parser.c"
    break;

  case 1103: /* str_lit_exp: error  */
#line 9498 "parser.y"
    {
      (yyval.str_val) = NULL;
      elaborate_error( "string literal expected" );
    }
#line 13995 "parser.c"
    break;

  case 1105: /* this_exp: error  */
#line 9507 "parser.y"
    {
      keyword_expected( L_this );
    }
#line 14003 "parser.c"
    break;

  case 1106: /* this_stid_opt: %empty  */
#line 9513 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 14009 "parser.c"
    break;

  case 1109: /* to_exp: error  */
#line 9520 "parser.y"
    {
      keyword_expected( L_to );
    }
#line 14017 "parser.c"
    break;

  case 1112: /* typename_flag_opt: %empty  */
#line 9531 "parser.y"
                                  { (yyval.flag) = false; }
#line 14023 "parser.c"
    break;

  case 1113: /* typename_flag_opt: Y_typename  */
#line 9532 "parser.y"
                                  { (yyval.flag) = true; }
#line 14029 "parser.c"
    break;

  case 1114: /* uint_lit: Y_INT_LIT  */
#line 9537 "parser.y"
    {
      if ( (yyvsp[0].int_val) < 0 ) {
        //
        // This check is better to do now in the parser rather than later in
        // the AST because we can store the value as unsigned plus gives a
        // better error location.
        //
        print_error( &(yylsp[0]), "non-negative integer expected\n" );
        PARSE_ABORT();
      }
      (yyval.uint_val) = STATIC_CAST( unsigned, (yyvsp[0].int_val) );
    }
#line 14046 "parser.c"
    break;

  case 1116: /* uint_lit_exp: error  */
#line 9554 "parser.y"
    {
      elaborate_error( "integer literal expected" );
    }
#line 14054 "parser.c"
    break;

  case 1117: /* uint_lit_opt: %empty  */
#line 9560 "parser.y"
                                  { (yyval.uint_val) = 0; }
#line 14060 "parser.c"
    break;

  case 1120: /* unused_exp: error  */
#line 9567 "parser.y"
    {
      keyword_expected( L_unused );
    }
#line 14068 "parser.c"
    break;

  case 1124: /* virtual_stid_exp: error  */
#line 9580 "parser.y"
    {
      keyword_expected( L_virtual );
    }
#line 14076 "parser.c"
    break;

  case 1125: /* virtual_stid_opt: %empty  */
#line 9586 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 14082 "parser.c"
    break;


#line 14086 "parser.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 9590 "parser.y"


/// @endcond

// Re-enable warnings.
#ifdef __GNUC__
# pragma GCC diagnostic pop
#endif /* __GNUC__ */

/**
 * @addtogroup parser-group
 * @{
 */

////////// local functions ////////////////////////////////////////////////////

/**
 * Prints an additional parsing error message including a newline to standard
 * error that continues from where yyerror() left off.  Additionally:
 *
 * + If the printable_yytext() isn't NULL:
 *     + Checks to see if it's a keyword: if it is, mentions that it's a
 *       keyword in the error message.
 *     + May print "did you mean ...?" \a dym_kinds suggestions.
 *
 * + In debug mode, also prints the file & line where the function was called
 *   from as well as the ID of the lookahead token, if any.
 *
 * @note A newline _is_ printed.
 * @note This function isn't normally called directly; use the
 * #elaborate_error() or #elaborate_error_dym() macros instead.
 *
 * @param line The line number within this file where this function was called
 * from.
 * @param dym_kinds The bitwise-or of the kind(s) of things possibly meant.
 * @param format A `printf()` style format string.  It _must not_ end in a
 * newline since this function prints its own newline.
 * @param ... Arguments to print.
 *
 * @sa #elaborate_error()
 * @sa #elaborate_error_dym()
 * @sa l_keyword_expected()
 * @sa l_punct_expected()
 * @sa yyerror()
 */
PJL_PRINTF_LIKE_FUNC(3)
static void l_elaborate_error( int line, dym_kind_t dym_kinds,
                               char const *format, ... ) {
  assert( format != NULL );

  EPUTS( ": " );
  print_debug_file_line( __FILE__, line );

  char const *const error_token = printable_yytext();
  if ( print_error_token( error_token ) )
    EPUTS( ": " );

  va_list args;
  va_start( args, format );
  vfprintf( stderr, format, args );
  va_end( args );

  if ( error_token != NULL ) {
    print_error_token_is_a( error_token );
    print_suggestions( dym_kinds, error_token );
  }

  EPUTC( '\n' );
}

/**
 * Cleans up global parser data at program termination.
 */
static void parser_cleanup( void ) {
  c_ast_list_cleanup_gc( &typedef_ast_list );
}

/**
 * Prints \a token, quoted; if \ref opt_cdecl_debug `!=` #CDECL_DEBUG_NO, also
 * prints the look-ahead character within `[]`.
 *
 * @param token The error token to print, if any.
 * @return Returns `true` only if anything was printed.
 */
static bool print_error_token( char const *token ) {
  if ( token == NULL )
    return false;
  EPRINTF( "\"%s\"", token );
  if ( opt_cdecl_debug != CDECL_DEBUG_NO ) {
    // LCOV_EXCL_START
    switch ( yychar ) {
      case YYEMPTY:
        EPUTS( " [<EMPTY>]" );
        break;
      case YYEOF:
        EPUTS( " [<EOF>]" );
        break;
      case YYerror:
        EPUTS( " [<error>]" );
        break;
      case YYUNDEF:
        EPUTS( " [<UNDEF>]" );
        break;
      default:
        EPRINTF( isprint( yychar ) ? " ['%c']" : " [%d]", yychar );
    } // switch
    // LCOV_EXCL_STOP
  }
  return true;
}

////////// extern functions ///////////////////////////////////////////////////

void parser_init( void ) {
  ASSERT_RUN_ONCE();
  ATEXIT( &parser_cleanup );
}

bool yyparse_sn( char const *s, size_t s_len ) {
  assert( s != NULL );

  FILE *const s_file = fmemopen( CONST_CAST( void*, s ), s_len, "r" );
  PERROR_EXIT_IF( s_file == NULL, EX_IOERR );
  yyrestart( s_file );

  int const bison_rv = yyparse();
  fclose( s_file );
  if ( unlikely( bison_rv == 2 ) ) {
    //
    // Bison has already printed "memory exhausted" via yyerror() that doesn't
    // print a newline, so print one now.
    //
    // LCOV_EXCL_START
    EPUTC( '\n' );
    _Exit( EX_SOFTWARE );
    // LCOV_EXCL_STOP
  }

  return bison_rv == 0;
}

///////////////////////////////////////////////////////////////////////////////

/** @} */

/* vim:set et sw=2 ts=2: */
